// Version 3.0.1 3d-force-graph-vr - https://github.com/vasturiano/3d-force-graph-vr
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('aframe'), require('three')) :
  typeof define === 'function' && define.amd ? define(['aframe', 'three'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.ForceGraphVR = factory(global.AFRAME, global.THREE));
})(this, (function (aframe, three$2) { 'use strict';

  function styleInject(css, ref) {
    if ( ref === void 0 ) ref = {};
    var insertAt = ref.insertAt;

    if (typeof document === 'undefined') { return; }

    var head = document.head || document.getElementsByTagName('head')[0];
    var style = document.createElement('style');
    style.type = 'text/css';

    if (insertAt === 'top') {
      if (head.firstChild) {
        head.insertBefore(style, head.firstChild);
      } else {
        head.appendChild(style);
      }
    } else {
      head.appendChild(style);
    }

    if (style.styleSheet) {
      style.styleSheet.cssText = css;
    } else {
      style.appendChild(document.createTextNode(css));
    }
  }

  var css_248z = ".graph-nav-info {\n  position: absolute;\n  bottom: 5px;\n  width: 100%;\n  text-align: center;\n  color: slategrey;\n  opacity: 0.7;\n  font-size: 10px;\n  font-family: Sans-serif;\n  z-index: 1000;\n}";
  styleInject(css_248z);

  function _arrayLikeToArray$3(r, a) {
    (null == a || a > r.length) && (a = r.length);
    for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
    return n;
  }
  function _arrayWithHoles$3(r) {
    if (Array.isArray(r)) return r;
  }
  function _arrayWithoutHoles$2(r) {
    if (Array.isArray(r)) return _arrayLikeToArray$3(r);
  }
  function _defineProperty$1(e, r, t) {
    return (r = _toPropertyKey$2(r)) in e ? Object.defineProperty(e, r, {
      value: t,
      enumerable: true,
      configurable: true,
      writable: true
    }) : e[r] = t, e;
  }
  function _iterableToArray$2(r) {
    if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r);
  }
  function _iterableToArrayLimit$3(r, l) {
    var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
    if (null != t) {
      var e,
        n,
        i,
        u,
        a = [],
        f = true,
        o = false;
      try {
        if (i = (t = t.call(r)).next, 0 === l) ; else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
      } catch (r) {
        o = true, n = r;
      } finally {
        try {
          if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
        } finally {
          if (o) throw n;
        }
      }
      return a;
    }
  }
  function _nonIterableRest$3() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _nonIterableSpread$2() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function ownKeys$1(e, r) {
    var t = Object.keys(e);
    if (Object.getOwnPropertySymbols) {
      var o = Object.getOwnPropertySymbols(e);
      r && (o = o.filter(function (r) {
        return Object.getOwnPropertyDescriptor(e, r).enumerable;
      })), t.push.apply(t, o);
    }
    return t;
  }
  function _objectSpread2$1(e) {
    for (var r = 1; r < arguments.length; r++) {
      var t = null != arguments[r] ? arguments[r] : {};
      r % 2 ? ownKeys$1(Object(t), true).forEach(function (r) {
        _defineProperty$1(e, r, t[r]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$1(Object(t)).forEach(function (r) {
        Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r));
      });
    }
    return e;
  }
  function _slicedToArray$3(r, e) {
    return _arrayWithHoles$3(r) || _iterableToArrayLimit$3(r, e) || _unsupportedIterableToArray$3(r, e) || _nonIterableRest$3();
  }
  function _toConsumableArray$2(r) {
    return _arrayWithoutHoles$2(r) || _iterableToArray$2(r) || _unsupportedIterableToArray$3(r) || _nonIterableSpread$2();
  }
  function _toPrimitive$2(t, r) {
    if ("object" != typeof t || !t) return t;
    var e = t[Symbol.toPrimitive];
    if (void 0 !== e) {
      var i = e.call(t, r);
      if ("object" != typeof i) return i;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return ("string" === r ? String : Number)(t);
  }
  function _toPropertyKey$2(t) {
    var i = _toPrimitive$2(t, "string");
    return "symbol" == typeof i ? i : i + "";
  }
  function _unsupportedIterableToArray$3(r, a) {
    if (r) {
      if ("string" == typeof r) return _arrayLikeToArray$3(r, a);
      var t = {}.toString.call(r).slice(8, -1);
      return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$3(r, a) : void 0;
    }
  }

  function getDefaultExportFromCjs (x) {
  	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
  }

  function getAugmentedNamespace(n) {
    if (n.__esModule) return n;
    var f = n.default;
  	if (typeof f == "function") {
  		var a = function a () {
  			if (this instanceof a) {
          return Reflect.construct(f, arguments, this.constructor);
  			}
  			return f.apply(this, arguments);
  		};
  		a.prototype = f.prototype;
    } else a = {};
    Object.defineProperty(a, '__esModule', {value: true});
  	Object.keys(n).forEach(function (k) {
  		var d = Object.getOwnPropertyDescriptor(n, k);
  		Object.defineProperty(a, k, d.get ? d : {
  			enumerable: true,
  			get: function () {
  				return n[k];
  			}
  		});
  	});
  	return a;
  }

  var aframeExtras = {};

  var controls = {};

  var checkpointControls;
  var hasRequiredCheckpointControls;

  function requireCheckpointControls () {
  	if (hasRequiredCheckpointControls) return checkpointControls;
  	hasRequiredCheckpointControls = 1;
  	const EPS = 0.1;

  	checkpointControls = AFRAME.registerComponent('checkpoint-controls', {
  	  schema: {
  	    enabled: {default: true},
  	    mode: {default: 'teleport', oneOf: ['teleport', 'animate']},
  	    animateSpeed: {default: 3.0}
  	  },

  	  init: function () {
  	    this.active = true;
  	    this.checkpoint = null;

  	    this.isNavMeshConstrained = false;

  	    this.offset = new THREE.Vector3();
  	    this.position = new THREE.Vector3();
  	    this.targetPosition = new THREE.Vector3();
  	  },

  	  play: function () { this.active = true; },
  	  pause: function () { this.active = false; },

  	  setCheckpoint: function (checkpoint) {
  	    const el = this.el;

  	    if (!this.active) return;
  	    if (this.checkpoint === checkpoint) return;

  	    if (this.checkpoint) {
  	      el.emit('navigation-end', {checkpoint: this.checkpoint});
  	    }

  	    this.checkpoint = checkpoint;
  	    this.sync();

  	    // Ignore new checkpoint if we're already there.
  	    if (this.position.distanceTo(this.targetPosition) < EPS) {
  	      this.checkpoint = null;
  	      return;
  	    }

  	    el.emit('navigation-start', {checkpoint: checkpoint});

  	    if (this.data.mode === 'teleport') {
  	      this.el.setAttribute('position', this.targetPosition);
  	      this.checkpoint = null;
  	      el.emit('navigation-end', {checkpoint: checkpoint});
  	      el.components['movement-controls'].updateNavLocation();
  	    }
  	  },

  	  isVelocityActive: function () {
  	    return !!(this.active && this.checkpoint);
  	  },

  	  getVelocity: function () {
  	    if (!this.active) return;

  	    const data = this.data;
  	    const offset = this.offset;
  	    const position = this.position;
  	    const targetPosition = this.targetPosition;
  	    const checkpoint = this.checkpoint;

  	    this.sync();
  	    if (position.distanceTo(targetPosition) < EPS) {
  	      this.checkpoint = null;
  	      this.el.emit('navigation-end', {checkpoint: checkpoint});
  	      return offset.set(0, 0, 0);
  	    }
  	    offset.setLength(data.animateSpeed);
  	    return offset;
  	  },

  	  sync: function () {
  	    const offset = this.offset;
  	    const position = this.position;
  	    const targetPosition = this.targetPosition;

  	    position.copy(this.el.getAttribute('position'));
  	    this.checkpoint.object3D.getWorldPosition(targetPosition);
  	    targetPosition.add(this.checkpoint.components.checkpoint.getOffset());
  	    offset.copy(targetPosition).sub(position);
  	  }
  	});
  	return checkpointControls;
  }

  var GamepadButton;
  var hasRequiredGamepadButton;

  function requireGamepadButton () {
  	if (hasRequiredGamepadButton) return GamepadButton;
  	hasRequiredGamepadButton = 1;
  	GamepadButton = Object.assign(function GamepadButton () {}, {
  		FACE_1: 0,
  		FACE_2: 1,
  		FACE_3: 2,
  		FACE_4: 3,

  		L_SHOULDER_1: 4,
  		R_SHOULDER_1: 5,
  		L_SHOULDER_2: 6,
  		R_SHOULDER_2: 7,

  		SELECT: 8,
  		START: 9,

  		DPAD_UP: 12,
  		DPAD_DOWN: 13,
  		DPAD_LEFT: 14,
  		DPAD_RIGHT: 15,

  		VENDOR: 16,
  	});
  	return GamepadButton;
  }

  var GamepadButtonEvent_1;
  var hasRequiredGamepadButtonEvent;

  function requireGamepadButtonEvent () {
  	if (hasRequiredGamepadButtonEvent) return GamepadButtonEvent_1;
  	hasRequiredGamepadButtonEvent = 1;
  	function GamepadButtonEvent (type, index, details) {
  	  this.type = type;
  	  this.index = index;
  	  this.pressed = details.pressed;
  	  this.value = details.value;
  	}

  	GamepadButtonEvent_1 = GamepadButtonEvent;
  	return GamepadButtonEvent_1;
  }

  /**
   * Gamepad controls for A-Frame.
   *
   * Stripped-down version of: https://github.com/donmccurdy/aframe-gamepad-controls
   *
   * For more information about the Gamepad API, see:
   * https://developer.mozilla.org/en-US/docs/Web/API/Gamepad_API/Using_the_Gamepad_API
   */

  var gamepadControls;
  var hasRequiredGamepadControls;

  function requireGamepadControls () {
  	if (hasRequiredGamepadControls) return gamepadControls;
  	hasRequiredGamepadControls = 1;
  	const GamepadButton = requireGamepadButton(),
  	    GamepadButtonEvent = requireGamepadButtonEvent();

  	const JOYSTICK_EPS = 0.2;

  	const Hand = {
  	  LEFT: 'left',
  	  RIGHT: 'right'
  	};

  	const Joystick = {
  	  MOVEMENT: 1,
  	  ROTATION: 2
  	};

  	gamepadControls = AFRAME.registerComponent('gamepad-controls', {

  	  /*******************************************************************
  	   * Statics
  	   */

  	  GamepadButton: GamepadButton,

  	  /*******************************************************************
  	   * Schema
  	   */

  	  schema: {
  	    // Enable/disable gamepad-controls
  	    enabled: { default: true },

  	    // Rotation sensitivity
  	    rotationSensitivity: { default: 2.0 },
  	  },

  	  /*******************************************************************
  	   * Core
  	   */

  	  /**
  	   * Called once when component is attached. Generally for initial setup.
  	   */
  	  init: function () {
  	    const sceneEl = this.el.sceneEl;

  	    // tracked-controls-webxr was renamed to tracked-controls in aframe 1.7.0
  	    // tracked-controls-webxr is for aframe 1.6.0 and below
  	    this.system = sceneEl.systems['tracked-controls'] || sceneEl.systems['tracked-controls-webxr'] || {controllers: []};

  	    this.prevTime = window.performance.now();

  	    // Button state
  	    this.buttons = {};

  	    // Rotation
  	    const rotation = this.el.object3D.rotation;
  	    this.pitch = new THREE.Object3D();
  	    this.pitch.rotation.x = rotation.x;
  	    this.yaw = new THREE.Object3D();
  	    this.yaw.position.y = 10;
  	    this.yaw.rotation.y = rotation.y;
  	    this.yaw.add(this.pitch);

  	    this._lookVector = new THREE.Vector2();
  	    this._moveVector = new THREE.Vector2();
  	    this._dpadVector = new THREE.Vector2();

  	    sceneEl.addBehavior(this);
  	  },

  	  /**
  	   * Called when component is attached and when component data changes.
  	   * Generally modifies the entity based on the data.
  	   */
  	  update: function () { this.tick(); },

  	  /**
  	   * Called on each iteration of main render loop.
  	   */
  	  tick: function (t, dt) {
  	    this.updateButtonState();
  	    this.updateRotation(dt);
  	  },

  	  /**
  	   * Called when a component is removed (e.g., via removeAttribute).
  	   * Generally undoes all modifications to the entity.
  	   */
  	  remove: function () { },

  	  /*******************************************************************
  	   * Movement
  	   */

  	  isVelocityActive: function () {
  	    if (!this.data.enabled || !this.isConnected()) return false;

  	    const dpad = this._dpadVector;
  	    const joystick = this._moveVector;

  	    this.getDpad(dpad);
  	    this.getJoystick(Joystick.MOVEMENT, joystick);

  	    const inputX = dpad.x || joystick.x;
  	    const inputY = dpad.y || joystick.y;

  	    return Math.abs(inputX) > JOYSTICK_EPS || Math.abs(inputY) > JOYSTICK_EPS;
  	  },

  	  getVelocityDelta: function () {
  	    const dpad = this._dpadVector;
  	    const joystick = this._moveVector;

  	    this.getDpad(dpad);
  	    this.getJoystick(Joystick.MOVEMENT, joystick);

  	    const inputX = dpad.x || joystick.x;
  	    const inputY = dpad.y || joystick.y;
  	    const dVelocity = new THREE.Vector3();

  	    if (Math.abs(inputX) > JOYSTICK_EPS) {
  	      dVelocity.x += inputX;
  	    }
  	    if (Math.abs(inputY) > JOYSTICK_EPS) {
  	      dVelocity.z += inputY;
  	    }

  	    return dVelocity;
  	  },

  	  /*******************************************************************
  	   * Rotation
  	   */

  	  isRotationActive: function () {
  	    if (!this.data.enabled || !this.isConnected()) return false;

  	    const joystick = this._lookVector;

  	    this.getJoystick(Joystick.ROTATION, joystick);

  	    return Math.abs(joystick.x) > JOYSTICK_EPS || Math.abs(joystick.y) > JOYSTICK_EPS;
  	  },

  	  updateRotation: function (dt) {
  	    if (!this.isRotationActive()) return;

  	    const data = this.data;
  	    const yaw = this.yaw;
  	    const pitch = this.pitch;

  	    // First copy camera rig pitch/yaw, it may have been changed from
  	    // another component.
  	    yaw.rotation.y = this.el.object3D.rotation.y;
  	    pitch.rotation.x = this.el.object3D.rotation.x;

  	    const lookVector = this._lookVector;

  	    this.getJoystick(Joystick.ROTATION, lookVector);

  	    if (Math.abs(lookVector.x) <= JOYSTICK_EPS) lookVector.x = 0;
  	    if (Math.abs(lookVector.y) <= JOYSTICK_EPS) lookVector.y = 0;

  	    lookVector.multiplyScalar(data.rotationSensitivity * dt / 1000);
  	    yaw.rotation.y -= lookVector.x;
  	    pitch.rotation.x -= lookVector.y;
  	    pitch.rotation.x = Math.max(- Math.PI / 2, Math.min(Math.PI / 2, pitch.rotation.x));
  	    this.el.object3D.rotation.set(pitch.rotation.x, yaw.rotation.y, 0);
  	  },

  	  /*******************************************************************
  	   * Button events
  	   */

  	  updateButtonState: function () {
  	    const gamepad = this.getGamepad(Hand.RIGHT);
  	    if (this.data.enabled && gamepad) {

  	      // Fire DOM events for button state changes.
  	      for (var i = 0; i < gamepad.buttons.length; i++) {
  	        if (gamepad.buttons[i].pressed && !this.buttons[i]) {
  	          this.emit(new GamepadButtonEvent('gamepadbuttondown', i, gamepad.buttons[i]));
  	        } else if (!gamepad.buttons[i].pressed && this.buttons[i]) {
  	          this.emit(new GamepadButtonEvent('gamepadbuttonup', i, gamepad.buttons[i]));
  	        }
  	        this.buttons[i] = gamepad.buttons[i].pressed;
  	      }

  	    } else {
  	      // Reset state if controls are disabled or controller is lost.
  	      for (const key in this.buttons) { this.buttons[key] = false; }
  	    }
  	  },

  	  emit: function (event) {
  	    // Emit original event.
  	    this.el.emit(event.type, event);

  	    // Emit convenience event, identifying button index.
  	    this.el.emit(
  	      event.type + ':' + event.index,
  	      new GamepadButtonEvent(event.type, event.index, event)
  	    );
  	  },

  	  /*******************************************************************
  	   * Gamepad state
  	   */

  	  /**
  	   * Returns the Gamepad instance attached to the component. If connected,
  	   * a proxy-controls component may provide access to Gamepad input from a
  	   * remote device.
  	   *
  	   * @param {string} handPreference
  	   * @return {Gamepad}
  	   */
  	  getGamepad: (function () {
  	    const _xrGamepads = [];
  	    const _empty = [];

  	    return function (handPreference) {
  	      // https://github.com/donmccurdy/aframe-proxy-controls
  	      const proxyControls = this.el.sceneEl.components['proxy-controls'];
  	      const proxyGamepad = proxyControls && proxyControls.isConnected()
  	        && proxyControls.getGamepad(0);
  	      if (proxyGamepad) return proxyGamepad;

  	      // https://www.w3.org/TR/webxr/#dom-xrinputsource-handedness
  	      _xrGamepads.length = 0;
  	      for (let i = 0; i < this.system.controllers.length; i++) {
  	        const xrController = this.system.controllers[i];
  	        const xrGamepad = xrController ? xrController.gamepad : null;
  	        _xrGamepads.push(xrGamepad);
  	        if (xrGamepad && xrController.handedness === handPreference) return xrGamepad;
  	      }

  	      // https://developer.mozilla.org/en-US/docs/Web/API/Gamepad/hand
  	      const navGamepads = navigator.getGamepads ? navigator.getGamepads() : _empty;
  	      for (let i = 0; i < navGamepads.length; i++) {
  	        const navGamepad = navGamepads[i];
  	        if (navGamepad && navGamepad.hand === handPreference) return navGamepad;
  	      }

  	      return _xrGamepads[0] || navGamepads[0];
  	    };
  	  })(),

  	  /**
  	   * Returns the state of the given button.
  	   * @param  {number} index The button (0-N) for which to find state.
  	   * @return {GamepadButton}
  	   */
  	  getButton: function (index) {
  	    return this.getGamepad(Hand.RIGHT).buttons[index];
  	  },

  	  /**
  	   * Returns state of the given axis. Axes are labelled 0-N, where 0-1 will
  	   * represent X/Y on the first joystick, and 2-3 X/Y on the second.
  	   * @param  {number} index The axis (0-N) for which to find state.
  	   * @return {number} On the interval [-1,1].
  	   */
  	  getAxis: function (index) {
  	    return this.getGamepad(index > 1 ? Hand.RIGHT : Hand.LEFT).axes[index];
  	  },

  	  /**
  	   * Returns the state of the specified joystick as a THREE.Vector2.
  	   * @param  {Joystick} role
  	   * @param  {THREE.Vector2} target
  	   * @return {THREE.Vector2}
  	   */
  	  getJoystick: function (index, target) {
  	    const gamepad = this.getGamepad(index === Joystick.MOVEMENT ? Hand.LEFT : Hand.RIGHT);
  	    // gamepad can be null here if it becomes disconnected even if isConnected() was called
  	    // in the same tick before calling getJoystick.
  	    if (!gamepad) {
  	      return target.set(0, 0);
  	    }
  	    if (gamepad.mapping === 'xr-standard') {
  	      // See: https://github.com/donmccurdy/aframe-extras/issues/307
  	      switch (index) {
  	        case Joystick.MOVEMENT: return target.set(gamepad.axes[2], gamepad.axes[3]);
  	        case Joystick.ROTATION: return target.set(gamepad.axes[2], 0);
  	      }
  	    } else {
  	      switch (index) {
  	        case Joystick.MOVEMENT: return target.set(gamepad.axes[0], gamepad.axes[1]);
  	        case Joystick.ROTATION: return target.set(gamepad.axes[2], gamepad.axes[3]);
  	      }
  	    }
  	    throw new Error('Unexpected joystick index "%d".', index);
  	  },

  	  /**
  	   * Returns the state of the dpad as a THREE.Vector2.
  	   * @param {THREE.Vector2} target
  	   * @return {THREE.Vector2}
  	   */
  	  getDpad: function (target) {
  	    const gamepad = this.getGamepad(Hand.LEFT);
  	    if (!gamepad) {
  	      return target.set(0, 0);
  	    }
  	    if (!gamepad.buttons[GamepadButton.DPAD_RIGHT]) {
  	      return target.set(0, 0);
  	    }
  	    return target.set(
  	      (gamepad.buttons[GamepadButton.DPAD_RIGHT].pressed ? 1 : 0)
  	      + (gamepad.buttons[GamepadButton.DPAD_LEFT].pressed ? -1 : 0),
  	      (gamepad.buttons[GamepadButton.DPAD_UP].pressed ? -1 : 0)
  	      + (gamepad.buttons[GamepadButton.DPAD_DOWN].pressed ? 1 : 0)
  	    );
  	  },

  	  /**
  	   * Returns true if the gamepad is currently connected to the system.
  	   * @return {boolean}
  	   */
  	  isConnected: function () {
  	    const gamepad = this.getGamepad(Hand.LEFT);
  	    return !!(gamepad && gamepad.connected);
  	  },

  	  /**
  	   * Returns a string containing some information about the controller. Result
  	   * may vary across browsers, for a given controller.
  	   * @return {string}
  	   */
  	  getID: function () {
  	    return this.getGamepad(Hand.LEFT).id;
  	  }
  	});
  	return gamepadControls;
  }

  var keyboard_polyfill = {};

  /**
   * Polyfill for the additional KeyboardEvent properties defined in the D3E and
   * D4E draft specifications, by @inexorabletash.
   *
   * See: https://github.com/inexorabletash/polyfill
   */

  var hasRequiredKeyboard_polyfill;

  function requireKeyboard_polyfill () {
  	if (hasRequiredKeyboard_polyfill) return keyboard_polyfill;
  	hasRequiredKeyboard_polyfill = 1;
  	(function(global) {
  	  var nativeKeyboardEvent = ('KeyboardEvent' in global);
  	  if (!nativeKeyboardEvent)
  	    global.KeyboardEvent = function KeyboardEvent() { throw TypeError('Illegal constructor'); };

  	  if (!('DOM_KEY_LOCATION_STANDARD' in global.KeyboardEvent)) global.KeyboardEvent.DOM_KEY_LOCATION_STANDARD = 0x00; // Default or unknown location
  	  if (!('DOM_KEY_LOCATION_LEFT' in global.KeyboardEvent)) global.KeyboardEvent.DOM_KEY_LOCATION_LEFT          = 0x01; // e.g. Left Alt key
  	  if (!('DOM_KEY_LOCATION_RIGHT' in global.KeyboardEvent)) global.KeyboardEvent.DOM_KEY_LOCATION_RIGHT         = 0x02; // e.g. Right Alt key
  	  if (!('DOM_KEY_LOCATION_NUMPAD' in global.KeyboardEvent)) global.KeyboardEvent.DOM_KEY_LOCATION_NUMPAD        = 0x03; // e.g. Numpad 0 or +

  	  var STANDARD = window.KeyboardEvent.DOM_KEY_LOCATION_STANDARD,
  	      LEFT = window.KeyboardEvent.DOM_KEY_LOCATION_LEFT,
  	      RIGHT = window.KeyboardEvent.DOM_KEY_LOCATION_RIGHT,
  	      NUMPAD = window.KeyboardEvent.DOM_KEY_LOCATION_NUMPAD;

  	  //--------------------------------------------------------------------
  	  //
  	  // Utilities
  	  //
  	  //--------------------------------------------------------------------

  	  function contains(s, ss) { return String(s).indexOf(ss) !== -1; }

  	  var os = (function() {
  	    if (contains(navigator.platform, 'Win')) { return 'win'; }
  	    if (contains(navigator.platform, 'Mac')) { return 'mac'; }
  	    if (contains(navigator.platform, 'CrOS')) { return 'cros'; }
  	    if (contains(navigator.platform, 'Linux')) { return 'linux'; }
  	    if (contains(navigator.userAgent, 'iPad') || contains(navigator.platform, 'iPod') || contains(navigator.platform, 'iPhone')) { return 'ios'; }
  	    return '';
  	  } ());

  	  var browser = (function() {
  	    if (contains(navigator.userAgent, 'Chrome/')) { return 'chrome'; }
  	    if (contains(navigator.vendor, 'Apple')) { return 'safari'; }
  	    if (contains(navigator.userAgent, 'MSIE')) { return 'ie'; }
  	    if (contains(navigator.userAgent, 'Gecko/')) { return 'moz'; }
  	    if (contains(navigator.userAgent, 'Opera/')) { return 'opera'; }
  	    return '';
  	  } ());

  	  var browser_os = browser + '-' + os;

  	  function mergeIf(baseTable, select, table) {
  	    if (browser_os === select || browser === select || os === select) {
  	      Object.keys(table).forEach(function(keyCode) {
  	        baseTable[keyCode] = table[keyCode];
  	      });
  	    }
  	  }

  	  function remap(o, key) {
  	    var r = {};
  	    Object.keys(o).forEach(function(k) {
  	      var item = o[k];
  	      if (key in item) {
  	        r[item[key]] = item;
  	      }
  	    });
  	    return r;
  	  }

  	  //--------------------------------------------------------------------
  	  //
  	  // Generic Mappings
  	  //
  	  //--------------------------------------------------------------------

  	  // "keyInfo" is a dictionary:
  	  //   code: string - name from DOM Level 3 KeyboardEvent code Values
  	  //     https://dvcs.w3.org/hg/dom3events/raw-file/tip/html/DOM3Events-code.html
  	  //   location (optional): number - one of the DOM_KEY_LOCATION values
  	  //   keyCap (optional): string - keyboard label in en-US locale
  	  // USB code Usage ID from page 0x07 unless otherwise noted (Informative)

  	  // Map of keyCode to keyInfo
  	  var keyCodeToInfoTable = {
  	    // 0x01 - VK_LBUTTON
  	    // 0x02 - VK_RBUTTON
  	    0x03: { code: 'Cancel' }, // [USB: 0x9b] char \x0018 ??? (Not in D3E)
  	    // 0x04 - VK_MBUTTON
  	    // 0x05 - VK_XBUTTON1
  	    // 0x06 - VK_XBUTTON2
  	    0x06: { code: 'Help' }, // [USB: 0x75] ???
  	    // 0x07 - undefined
  	    0x08: { code: 'Backspace' }, // [USB: 0x2a] Labelled Delete on Macintosh keyboards.
  	    0x09: { code: 'Tab' }, // [USB: 0x2b]
  	    // 0x0A-0x0B - reserved
  	    0X0C: { code: 'Clear' }, // [USB: 0x9c] NumPad Center (Not in D3E)
  	    0X0D: { code: 'Enter' }, // [USB: 0x28]
  	    // 0x0E-0x0F - undefined

  	    0x10: { code: 'Shift' },
  	    0x11: { code: 'Control' },
  	    0x12: { code: 'Alt' },
  	    0x13: { code: 'Pause' }, // [USB: 0x48]
  	    0x14: { code: 'CapsLock' }, // [USB: 0x39]
  	    0x15: { code: 'KanaMode' }, // [USB: 0x88] - "HangulMode" for Korean layout
  	    0x16: { code: 'HangulMode' }, // [USB: 0x90] 0x15 as well in MSDN VK table ???
  	    0x17: { code: 'JunjaMode' }, // (Not in D3E)
  	    0x18: { code: 'FinalMode' }, // (Not in D3E)
  	    0x19: { code: 'KanjiMode' }, // [USB: 0x91] - "HanjaMode" for Korean layout
  	    // 0x1A - undefined
  	    0x1B: { code: 'Escape' }, // [USB: 0x29]
  	    0x1C: { code: 'Convert' }, // [USB: 0x8a]
  	    0x1D: { code: 'NonConvert' }, // [USB: 0x8b]
  	    0x1E: { code: 'Accept' }, // (Not in D3E)
  	    0x1F: { code: 'ModeChange' }, // (Not in D3E)

  	    0x20: { code: 'Space' }, // [USB: 0x2c]
  	    0x21: { code: 'PageUp' }, // [USB: 0x4b]
  	    0x22: { code: 'PageDown' }, // [USB: 0x4e]
  	    0x23: { code: 'End' }, // [USB: 0x4d]
  	    0x24: { code: 'Home' }, // [USB: 0x4a]
  	    0x25: { code: 'ArrowLeft' }, // [USB: 0x50]
  	    0x26: { code: 'ArrowUp' }, // [USB: 0x52]
  	    0x27: { code: 'ArrowRight' }, // [USB: 0x4f]
  	    0x28: { code: 'ArrowDown' }, // [USB: 0x51]
  	    0x29: { code: 'Select' }, // (Not in D3E)
  	    0x2A: { code: 'Print' }, // (Not in D3E)
  	    0x2B: { code: 'Execute' }, // [USB: 0x74] (Not in D3E)
  	    0x2C: { code: 'PrintScreen' }, // [USB: 0x46]
  	    0x2D: { code: 'Insert' }, // [USB: 0x49]
  	    0x2E: { code: 'Delete' }, // [USB: 0x4c]
  	    0x2F: { code: 'Help' }, // [USB: 0x75] ???

  	    0x30: { code: 'Digit0', keyCap: '0' }, // [USB: 0x27] 0)
  	    0x31: { code: 'Digit1', keyCap: '1' }, // [USB: 0x1e] 1!
  	    0x32: { code: 'Digit2', keyCap: '2' }, // [USB: 0x1f] 2@
  	    0x33: { code: 'Digit3', keyCap: '3' }, // [USB: 0x20] 3#
  	    0x34: { code: 'Digit4', keyCap: '4' }, // [USB: 0x21] 4$
  	    0x35: { code: 'Digit5', keyCap: '5' }, // [USB: 0x22] 5%
  	    0x36: { code: 'Digit6', keyCap: '6' }, // [USB: 0x23] 6^
  	    0x37: { code: 'Digit7', keyCap: '7' }, // [USB: 0x24] 7&
  	    0x38: { code: 'Digit8', keyCap: '8' }, // [USB: 0x25] 8*
  	    0x39: { code: 'Digit9', keyCap: '9' }, // [USB: 0x26] 9(
  	    // 0x3A-0x40 - undefined

  	    0x41: { code: 'KeyA', keyCap: 'a' }, // [USB: 0x04]
  	    0x42: { code: 'KeyB', keyCap: 'b' }, // [USB: 0x05]
  	    0x43: { code: 'KeyC', keyCap: 'c' }, // [USB: 0x06]
  	    0x44: { code: 'KeyD', keyCap: 'd' }, // [USB: 0x07]
  	    0x45: { code: 'KeyE', keyCap: 'e' }, // [USB: 0x08]
  	    0x46: { code: 'KeyF', keyCap: 'f' }, // [USB: 0x09]
  	    0x47: { code: 'KeyG', keyCap: 'g' }, // [USB: 0x0a]
  	    0x48: { code: 'KeyH', keyCap: 'h' }, // [USB: 0x0b]
  	    0x49: { code: 'KeyI', keyCap: 'i' }, // [USB: 0x0c]
  	    0x4A: { code: 'KeyJ', keyCap: 'j' }, // [USB: 0x0d]
  	    0x4B: { code: 'KeyK', keyCap: 'k' }, // [USB: 0x0e]
  	    0x4C: { code: 'KeyL', keyCap: 'l' }, // [USB: 0x0f]
  	    0x4D: { code: 'KeyM', keyCap: 'm' }, // [USB: 0x10]
  	    0x4E: { code: 'KeyN', keyCap: 'n' }, // [USB: 0x11]
  	    0x4F: { code: 'KeyO', keyCap: 'o' }, // [USB: 0x12]

  	    0x50: { code: 'KeyP', keyCap: 'p' }, // [USB: 0x13]
  	    0x51: { code: 'KeyQ', keyCap: 'q' }, // [USB: 0x14]
  	    0x52: { code: 'KeyR', keyCap: 'r' }, // [USB: 0x15]
  	    0x53: { code: 'KeyS', keyCap: 's' }, // [USB: 0x16]
  	    0x54: { code: 'KeyT', keyCap: 't' }, // [USB: 0x17]
  	    0x55: { code: 'KeyU', keyCap: 'u' }, // [USB: 0x18]
  	    0x56: { code: 'KeyV', keyCap: 'v' }, // [USB: 0x19]
  	    0x57: { code: 'KeyW', keyCap: 'w' }, // [USB: 0x1a]
  	    0x58: { code: 'KeyX', keyCap: 'x' }, // [USB: 0x1b]
  	    0x59: { code: 'KeyY', keyCap: 'y' }, // [USB: 0x1c]
  	    0x5A: { code: 'KeyZ', keyCap: 'z' }, // [USB: 0x1d]
  	    0x5B: { code: 'OSLeft', location: LEFT }, // [USB: 0xe3]
  	    0x5C: { code: 'OSRight', location: RIGHT }, // [USB: 0xe7]
  	    0x5D: { code: 'ContextMenu' }, // [USB: 0x65] Context Menu
  	    // 0x5E - reserved
  	    0x5F: { code: 'Standby' }, // [USB: 0x82] Sleep

  	    0x60: { code: 'Numpad0', keyCap: '0', location: NUMPAD }, // [USB: 0x62]
  	    0x61: { code: 'Numpad1', keyCap: '1', location: NUMPAD }, // [USB: 0x59]
  	    0x62: { code: 'Numpad2', keyCap: '2', location: NUMPAD }, // [USB: 0x5a]
  	    0x63: { code: 'Numpad3', keyCap: '3', location: NUMPAD }, // [USB: 0x5b]
  	    0x64: { code: 'Numpad4', keyCap: '4', location: NUMPAD }, // [USB: 0x5c]
  	    0x65: { code: 'Numpad5', keyCap: '5', location: NUMPAD }, // [USB: 0x5d]
  	    0x66: { code: 'Numpad6', keyCap: '6', location: NUMPAD }, // [USB: 0x5e]
  	    0x67: { code: 'Numpad7', keyCap: '7', location: NUMPAD }, // [USB: 0x5f]
  	    0x68: { code: 'Numpad8', keyCap: '8', location: NUMPAD }, // [USB: 0x60]
  	    0x69: { code: 'Numpad9', keyCap: '9', location: NUMPAD }, // [USB: 0x61]
  	    0x6A: { code: 'NumpadMultiply', keyCap: '*', location: NUMPAD }, // [USB: 0x55]
  	    0x6B: { code: 'NumpadAdd', keyCap: '+', location: NUMPAD }, // [USB: 0x57]
  	    0x6C: { code: 'NumpadComma', keyCap: ',', location: NUMPAD }, // [USB: 0x85]
  	    0x6D: { code: 'NumpadSubtract', keyCap: '-', location: NUMPAD }, // [USB: 0x56]
  	    0x6E: { code: 'NumpadDecimal', keyCap: '.', location: NUMPAD }, // [USB: 0x63]
  	    0x6F: { code: 'NumpadDivide', keyCap: '/', location: NUMPAD }, // [USB: 0x54]

  	    0x70: { code: 'F1' }, // [USB: 0x3a]
  	    0x71: { code: 'F2' }, // [USB: 0x3b]
  	    0x72: { code: 'F3' }, // [USB: 0x3c]
  	    0x73: { code: 'F4' }, // [USB: 0x3d]
  	    0x74: { code: 'F5' }, // [USB: 0x3e]
  	    0x75: { code: 'F6' }, // [USB: 0x3f]
  	    0x76: { code: 'F7' }, // [USB: 0x40]
  	    0x77: { code: 'F8' }, // [USB: 0x41]
  	    0x78: { code: 'F9' }, // [USB: 0x42]
  	    0x79: { code: 'F10' }, // [USB: 0x43]
  	    0x7A: { code: 'F11' }, // [USB: 0x44]
  	    0x7B: { code: 'F12' }, // [USB: 0x45]
  	    0x7C: { code: 'F13' }, // [USB: 0x68]
  	    0x7D: { code: 'F14' }, // [USB: 0x69]
  	    0x7E: { code: 'F15' }, // [USB: 0x6a]
  	    0x7F: { code: 'F16' }, // [USB: 0x6b]

  	    0x80: { code: 'F17' }, // [USB: 0x6c]
  	    0x81: { code: 'F18' }, // [USB: 0x6d]
  	    0x82: { code: 'F19' }, // [USB: 0x6e]
  	    0x83: { code: 'F20' }, // [USB: 0x6f]
  	    0x84: { code: 'F21' }, // [USB: 0x70]
  	    0x85: { code: 'F22' }, // [USB: 0x71]
  	    0x86: { code: 'F23' }, // [USB: 0x72]
  	    0x87: { code: 'F24' }, // [USB: 0x73]
  	    // 0x88-0x8F - unassigned

  	    0x90: { code: 'NumLock', location: NUMPAD }, // [USB: 0x53]
  	    0x91: { code: 'ScrollLock' }, // [USB: 0x47]
  	    // 0x92-0x96 - OEM specific
  	    // 0x97-0x9F - unassigned

  	    // NOTE: 0xA0-0xA5 usually mapped to 0x10-0x12 in browsers
  	    0xA0: { code: 'ShiftLeft', location: LEFT }, // [USB: 0xe1]
  	    0xA1: { code: 'ShiftRight', location: RIGHT }, // [USB: 0xe5]
  	    0xA2: { code: 'ControlLeft', location: LEFT }, // [USB: 0xe0]
  	    0xA3: { code: 'ControlRight', location: RIGHT }, // [USB: 0xe4]
  	    0xA4: { code: 'AltLeft', location: LEFT }, // [USB: 0xe2]
  	    0xA5: { code: 'AltRight', location: RIGHT }, // [USB: 0xe6]

  	    0xA6: { code: 'BrowserBack' }, // [USB: 0x0c/0x0224]
  	    0xA7: { code: 'BrowserForward' }, // [USB: 0x0c/0x0225]
  	    0xA8: { code: 'BrowserRefresh' }, // [USB: 0x0c/0x0227]
  	    0xA9: { code: 'BrowserStop' }, // [USB: 0x0c/0x0226]
  	    0xAA: { code: 'BrowserSearch' }, // [USB: 0x0c/0x0221]
  	    0xAB: { code: 'BrowserFavorites' }, // [USB: 0x0c/0x0228]
  	    0xAC: { code: 'BrowserHome' }, // [USB: 0x0c/0x0222]
  	    0xAD: { code: 'VolumeMute' }, // [USB: 0x7f]
  	    0xAE: { code: 'VolumeDown' }, // [USB: 0x81]
  	    0xAF: { code: 'VolumeUp' }, // [USB: 0x80]

  	    0xB0: { code: 'MediaTrackNext' }, // [USB: 0x0c/0x00b5]
  	    0xB1: { code: 'MediaTrackPrevious' }, // [USB: 0x0c/0x00b6]
  	    0xB2: { code: 'MediaStop' }, // [USB: 0x0c/0x00b7]
  	    0xB3: { code: 'MediaPlayPause' }, // [USB: 0x0c/0x00cd]
  	    0xB4: { code: 'LaunchMail' }, // [USB: 0x0c/0x018a]
  	    0xB5: { code: 'MediaSelect' },
  	    0xB6: { code: 'LaunchApp1' },
  	    0xB7: { code: 'LaunchApp2' },
  	    // 0xB8-0xB9 - reserved
  	    0xBA: { code: 'Semicolon',  keyCap: ';' }, // [USB: 0x33] ;: (US Standard 101)
  	    0xBB: { code: 'Equal', keyCap: '=' }, // [USB: 0x2e] =+
  	    0xBC: { code: 'Comma', keyCap: ',' }, // [USB: 0x36] ,<
  	    0xBD: { code: 'Minus', keyCap: '-' }, // [USB: 0x2d] -_
  	    0xBE: { code: 'Period', keyCap: '.' }, // [USB: 0x37] .>
  	    0xBF: { code: 'Slash', keyCap: '/' }, // [USB: 0x38] /? (US Standard 101)

  	    0xC0: { code: 'Backquote', keyCap: '`' }, // [USB: 0x35] `~ (US Standard 101)
  	    // 0xC1-0xCF - reserved

  	    // 0xD0-0xD7 - reserved
  	    // 0xD8-0xDA - unassigned
  	    0xDB: { code: 'BracketLeft', keyCap: '[' }, // [USB: 0x2f] [{ (US Standard 101)
  	    0xDC: { code: 'Backslash',  keyCap: '\\' }, // [USB: 0x31] \| (US Standard 101)
  	    0xDD: { code: 'BracketRight', keyCap: ']' }, // [USB: 0x30] ]} (US Standard 101)
  	    0xDE: { code: 'Quote', keyCap: '\'' }, // [USB: 0x34] '" (US Standard 101)
  	    // 0xDF - miscellaneous/varies

  	    // 0xE0 - reserved
  	    // 0xE1 - OEM specific
  	    0xE2: { code: 'IntlBackslash',  keyCap: '\\' }, // [USB: 0x64] \| (UK Standard 102)
  	    // 0xE3-0xE4 - OEM specific
  	    0xE5: { code: 'Process' }, // (Not in D3E)
  	    // 0xE6 - OEM specific
  	    // 0xE7 - VK_PACKET
  	    // 0xE8 - unassigned
  	    // 0xE9-0xEF - OEM specific

  	    // 0xF0-0xF5 - OEM specific
  	    0xF6: { code: 'Attn' }, // [USB: 0x9a] (Not in D3E)
  	    0xF7: { code: 'CrSel' }, // [USB: 0xa3] (Not in D3E)
  	    0xF8: { code: 'ExSel' }, // [USB: 0xa4] (Not in D3E)
  	    0xF9: { code: 'EraseEof' }, // (Not in D3E)
  	    0xFA: { code: 'Play' }, // (Not in D3E)
  	    0xFB: { code: 'ZoomToggle' }, // (Not in D3E)
  	    // 0xFC - VK_NONAME - reserved
  	    // 0xFD - VK_PA1
  	    0xFE: { code: 'Clear' } // [USB: 0x9c] (Not in D3E)
  	  };

  	  // No legacy keyCode, but listed in D3E:

  	  // code: usb
  	  // 'IntlHash': 0x070032,
  	  // 'IntlRo': 0x070087,
  	  // 'IntlYen': 0x070089,
  	  // 'NumpadBackspace': 0x0700bb,
  	  // 'NumpadClear': 0x0700d8,
  	  // 'NumpadClearEntry': 0x0700d9,
  	  // 'NumpadMemoryAdd': 0x0700d3,
  	  // 'NumpadMemoryClear': 0x0700d2,
  	  // 'NumpadMemoryRecall': 0x0700d1,
  	  // 'NumpadMemoryStore': 0x0700d0,
  	  // 'NumpadMemorySubtract': 0x0700d4,
  	  // 'NumpadParenLeft': 0x0700b6,
  	  // 'NumpadParenRight': 0x0700b7,

  	  //--------------------------------------------------------------------
  	  //
  	  // Browser/OS Specific Mappings
  	  //
  	  //--------------------------------------------------------------------

  	  mergeIf(keyCodeToInfoTable,
  	          'moz', {
  	            0x3B: { code: 'Semicolon', keyCap: ';' }, // [USB: 0x33] ;: (US Standard 101)
  	            0x3D: { code: 'Equal', keyCap: '=' }, // [USB: 0x2e] =+
  	            0x6B: { code: 'Equal', keyCap: '=' }, // [USB: 0x2e] =+
  	            0x6D: { code: 'Minus', keyCap: '-' }, // [USB: 0x2d] -_
  	            0xBB: { code: 'NumpadAdd', keyCap: '+', location: NUMPAD }, // [USB: 0x57]
  	            0xBD: { code: 'NumpadSubtract', keyCap: '-', location: NUMPAD } // [USB: 0x56]
  	          });

  	  mergeIf(keyCodeToInfoTable,
  	          'moz-mac', {
  	            0x0C: { code: 'NumLock', location: NUMPAD }, // [USB: 0x53]
  	            0xAD: { code: 'Minus', keyCap: '-' } // [USB: 0x2d] -_
  	          });

  	  mergeIf(keyCodeToInfoTable,
  	          'moz-win', {
  	            0xAD: { code: 'Minus', keyCap: '-' } // [USB: 0x2d] -_
  	          });

  	  mergeIf(keyCodeToInfoTable,
  	          'chrome-mac', {
  	            0x5D: { code: 'OSRight', location: RIGHT } // [USB: 0xe7]
  	          });

  	  mergeIf(keyCodeToInfoTable,
  	          'safari', {
  	            0x03: { code: 'Enter' }, // [USB: 0x28] old Safari
  	            0x19: { code: 'Tab' } // [USB: 0x2b] old Safari for Shift+Tab
  	          });

  	  mergeIf(keyCodeToInfoTable,
  	          'ios', {
  	            0x0A: { code: 'Enter', location: STANDARD } // [USB: 0x28]
  	          });

  	  mergeIf(keyCodeToInfoTable,
  	          'safari-mac', {
  	            0x5B: { code: 'OSLeft', location: LEFT }, // [USB: 0xe3]
  	            0x5D: { code: 'OSRight', location: RIGHT }, // [USB: 0xe7]
  	            0xE5: { code: 'KeyQ', keyCap: 'Q' } // [USB: 0x14] On alternate presses, Ctrl+Q sends this
  	          });

  	  //--------------------------------------------------------------------
  	  //
  	  // Identifier Mappings
  	  //
  	  //--------------------------------------------------------------------

  	  // Cases where newer-ish browsers send keyIdentifier which can be
  	  // used to disambiguate keys.

  	  // keyIdentifierTable[keyIdentifier] -> keyInfo

  	  var keyIdentifierTable = {};
  	  if ('cros' === os) {
  	    keyIdentifierTable['U+00A0'] = { code: 'ShiftLeft', location: LEFT };
  	    keyIdentifierTable['U+00A1'] = { code: 'ShiftRight', location: RIGHT };
  	    keyIdentifierTable['U+00A2'] = { code: 'ControlLeft', location: LEFT };
  	    keyIdentifierTable['U+00A3'] = { code: 'ControlRight', location: RIGHT };
  	    keyIdentifierTable['U+00A4'] = { code: 'AltLeft', location: LEFT };
  	    keyIdentifierTable['U+00A5'] = { code: 'AltRight', location: RIGHT };
  	  }
  	  if ('chrome-mac' === browser_os) {
  	    keyIdentifierTable['U+0010'] = { code: 'ContextMenu' };
  	  }
  	  if ('safari-mac' === browser_os) {
  	    keyIdentifierTable['U+0010'] = { code: 'ContextMenu' };
  	  }
  	  if ('ios' === os) {
  	    // These only generate keyup events
  	    keyIdentifierTable['U+0010'] = { code: 'Function' };

  	    keyIdentifierTable['U+001C'] = { code: 'ArrowLeft' };
  	    keyIdentifierTable['U+001D'] = { code: 'ArrowRight' };
  	    keyIdentifierTable['U+001E'] = { code: 'ArrowUp' };
  	    keyIdentifierTable['U+001F'] = { code: 'ArrowDown' };

  	    keyIdentifierTable['U+0001'] = { code: 'Home' }; // [USB: 0x4a] Fn + ArrowLeft
  	    keyIdentifierTable['U+0004'] = { code: 'End' }; // [USB: 0x4d] Fn + ArrowRight
  	    keyIdentifierTable['U+000B'] = { code: 'PageUp' }; // [USB: 0x4b] Fn + ArrowUp
  	    keyIdentifierTable['U+000C'] = { code: 'PageDown' }; // [USB: 0x4e] Fn + ArrowDown
  	  }

  	  //--------------------------------------------------------------------
  	  //
  	  // Location Mappings
  	  //
  	  //--------------------------------------------------------------------

  	  // Cases where newer-ish browsers send location/keyLocation which
  	  // can be used to disambiguate keys.

  	  // locationTable[location][keyCode] -> keyInfo
  	  var locationTable = [];
  	  locationTable[LEFT] = {
  	    0x10: { code: 'ShiftLeft', location: LEFT }, // [USB: 0xe1]
  	    0x11: { code: 'ControlLeft', location: LEFT }, // [USB: 0xe0]
  	    0x12: { code: 'AltLeft', location: LEFT } // [USB: 0xe2]
  	  };
  	  locationTable[RIGHT] = {
  	    0x10: { code: 'ShiftRight', location: RIGHT }, // [USB: 0xe5]
  	    0x11: { code: 'ControlRight', location: RIGHT }, // [USB: 0xe4]
  	    0x12: { code: 'AltRight', location: RIGHT } // [USB: 0xe6]
  	  };
  	  locationTable[NUMPAD] = {
  	    0x0D: { code: 'NumpadEnter', location: NUMPAD } // [USB: 0x58]
  	  };

  	  mergeIf(locationTable[NUMPAD], 'moz', {
  	    0x6D: { code: 'NumpadSubtract', location: NUMPAD }, // [USB: 0x56]
  	    0x6B: { code: 'NumpadAdd', location: NUMPAD } // [USB: 0x57]
  	  });
  	  mergeIf(locationTable[LEFT], 'moz-mac', {
  	    0xE0: { code: 'OSLeft', location: LEFT } // [USB: 0xe3]
  	  });
  	  mergeIf(locationTable[RIGHT], 'moz-mac', {
  	    0xE0: { code: 'OSRight', location: RIGHT } // [USB: 0xe7]
  	  });
  	  mergeIf(locationTable[RIGHT], 'moz-win', {
  	    0x5B: { code: 'OSRight', location: RIGHT } // [USB: 0xe7]
  	  });


  	  mergeIf(locationTable[RIGHT], 'mac', {
  	    0x5D: { code: 'OSRight', location: RIGHT } // [USB: 0xe7]
  	  });

  	  mergeIf(locationTable[NUMPAD], 'chrome-mac', {
  	    0x0C: { code: 'NumLock', location: NUMPAD } // [USB: 0x53]
  	  });

  	  mergeIf(locationTable[NUMPAD], 'safari-mac', {
  	    0x0C: { code: 'NumLock', location: NUMPAD }, // [USB: 0x53]
  	    0xBB: { code: 'NumpadAdd', location: NUMPAD }, // [USB: 0x57]
  	    0xBD: { code: 'NumpadSubtract', location: NUMPAD }, // [USB: 0x56]
  	    0xBE: { code: 'NumpadDecimal', location: NUMPAD }, // [USB: 0x63]
  	    0xBF: { code: 'NumpadDivide', location: NUMPAD } // [USB: 0x54]
  	  });


  	  //--------------------------------------------------------------------
  	  //
  	  // Key Values
  	  //
  	  //--------------------------------------------------------------------

  	  // Mapping from `code` values to `key` values. Values defined at:
  	  // https://dvcs.w3.org/hg/dom3events/raw-file/tip/html/DOM3Events-key.html
  	  // Entries are only provided when `key` differs from `code`. If
  	  // printable, `shiftKey` has the shifted printable character. This
  	  // assumes US Standard 101 layout

  	  var codeToKeyTable = {
  	    // Modifier Keys
  	    ShiftLeft: { key: 'Shift' },
  	    ShiftRight: { key: 'Shift' },
  	    ControlLeft: { key: 'Control' },
  	    ControlRight: { key: 'Control' },
  	    AltLeft: { key: 'Alt' },
  	    AltRight: { key: 'Alt' },
  	    OSLeft: { key: 'OS' },
  	    OSRight: { key: 'OS' },

  	    // Whitespace Keys
  	    NumpadEnter: { key: 'Enter' },
  	    Space: { key: ' ' },

  	    // Printable Keys
  	    Digit0: { key: '0', shiftKey: ')' },
  	    Digit1: { key: '1', shiftKey: '!' },
  	    Digit2: { key: '2', shiftKey: '@' },
  	    Digit3: { key: '3', shiftKey: '#' },
  	    Digit4: { key: '4', shiftKey: '$' },
  	    Digit5: { key: '5', shiftKey: '%' },
  	    Digit6: { key: '6', shiftKey: '^' },
  	    Digit7: { key: '7', shiftKey: '&' },
  	    Digit8: { key: '8', shiftKey: '*' },
  	    Digit9: { key: '9', shiftKey: '(' },
  	    KeyA: { key: 'a', shiftKey: 'A' },
  	    KeyB: { key: 'b', shiftKey: 'B' },
  	    KeyC: { key: 'c', shiftKey: 'C' },
  	    KeyD: { key: 'd', shiftKey: 'D' },
  	    KeyE: { key: 'e', shiftKey: 'E' },
  	    KeyF: { key: 'f', shiftKey: 'F' },
  	    KeyG: { key: 'g', shiftKey: 'G' },
  	    KeyH: { key: 'h', shiftKey: 'H' },
  	    KeyI: { key: 'i', shiftKey: 'I' },
  	    KeyJ: { key: 'j', shiftKey: 'J' },
  	    KeyK: { key: 'k', shiftKey: 'K' },
  	    KeyL: { key: 'l', shiftKey: 'L' },
  	    KeyM: { key: 'm', shiftKey: 'M' },
  	    KeyN: { key: 'n', shiftKey: 'N' },
  	    KeyO: { key: 'o', shiftKey: 'O' },
  	    KeyP: { key: 'p', shiftKey: 'P' },
  	    KeyQ: { key: 'q', shiftKey: 'Q' },
  	    KeyR: { key: 'r', shiftKey: 'R' },
  	    KeyS: { key: 's', shiftKey: 'S' },
  	    KeyT: { key: 't', shiftKey: 'T' },
  	    KeyU: { key: 'u', shiftKey: 'U' },
  	    KeyV: { key: 'v', shiftKey: 'V' },
  	    KeyW: { key: 'w', shiftKey: 'W' },
  	    KeyX: { key: 'x', shiftKey: 'X' },
  	    KeyY: { key: 'y', shiftKey: 'Y' },
  	    KeyZ: { key: 'z', shiftKey: 'Z' },
  	    Numpad0: { key: '0' },
  	    Numpad1: { key: '1' },
  	    Numpad2: { key: '2' },
  	    Numpad3: { key: '3' },
  	    Numpad4: { key: '4' },
  	    Numpad5: { key: '5' },
  	    Numpad6: { key: '6' },
  	    Numpad7: { key: '7' },
  	    Numpad8: { key: '8' },
  	    Numpad9: { key: '9' },
  	    NumpadMultiply: { key: '*' },
  	    NumpadAdd: { key: '+' },
  	    NumpadComma: { key: ',' },
  	    NumpadSubtract: { key: '-' },
  	    NumpadDecimal: { key: '.' },
  	    NumpadDivide: { key: '/' },
  	    Semicolon: { key: ';', shiftKey: ':' },
  	    Equal: { key: '=', shiftKey: '+' },
  	    Comma: { key: ',', shiftKey: '<' },
  	    Minus: { key: '-', shiftKey: '_' },
  	    Period: { key: '.', shiftKey: '>' },
  	    Slash: { key: '/', shiftKey: '?' },
  	    Backquote: { key: '`', shiftKey: '~' },
  	    BracketLeft: { key: '[', shiftKey: '{' },
  	    Backslash: { key: '\\', shiftKey: '|' },
  	    BracketRight: { key: ']', shiftKey: '}' },
  	    Quote: { key: '\'', shiftKey: '"' },
  	    IntlBackslash: { key: '\\', shiftKey: '|' }
  	  };

  	  mergeIf(codeToKeyTable, 'mac', {
  	    OSLeft: { key: 'Meta' },
  	    OSRight: { key: 'Meta' }
  	  });

  	  // Corrections for 'key' names in older browsers (e.g. FF36-)
  	  // https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent.key#Key_values
  	  var keyFixTable = {
  	    Esc: 'Escape',
  	    Nonconvert: 'NonConvert',
  	    Left: 'ArrowLeft',
  	    Up: 'ArrowUp',
  	    Right: 'ArrowRight',
  	    Down: 'ArrowDown',
  	    Del: 'Delete',
  	    Menu: 'ContextMenu',
  	    MediaNextTrack: 'MediaTrackNext',
  	    MediaPreviousTrack: 'MediaTrackPrevious',
  	    SelectMedia: 'MediaSelect',
  	    HalfWidth: 'Hankaku',
  	    FullWidth: 'Zenkaku',
  	    RomanCharacters: 'Romaji',
  	    Crsel: 'CrSel',
  	    Exsel: 'ExSel',
  	    Zoom: 'ZoomToggle'
  	  };

  	  //--------------------------------------------------------------------
  	  //
  	  // Exported Functions
  	  //
  	  //--------------------------------------------------------------------


  	  var codeTable = remap(keyCodeToInfoTable, 'code');

  	  try {
  	    var nativeLocation = nativeKeyboardEvent && ('location' in new KeyboardEvent(''));
  	  } catch (_) {}

  	  function keyInfoForEvent(event) {
  	    var keyCode = 'keyCode' in event ? event.keyCode : 'which' in event ? event.which : 0;

  	    var keyInfo = (function(){
  	      if (nativeLocation || 'keyLocation' in event) {
  	        var location = nativeLocation ? event.location : event.keyLocation;
  	        if (location && keyCode in locationTable[location]) {
  	          return locationTable[location][keyCode];
  	        }
  	      }
  	      if ('keyIdentifier' in event && event.keyIdentifier in keyIdentifierTable) {
  	        return keyIdentifierTable[event.keyIdentifier];
  	      }
  	      if (keyCode in keyCodeToInfoTable) {
  	        return keyCodeToInfoTable[keyCode];
  	      }
  	      return null;
  	    }());

  	    if (!keyInfo)
  	      return null;

  	    var key = (function() {
  	      var entry = codeToKeyTable[keyInfo.code];
  	      if (!entry) return keyInfo.code;
  	      return (event.shiftKey && 'shiftKey' in entry) ? entry.shiftKey : entry.key;
  	    }());

  	    return {
  	      code: keyInfo.code,
  	      key: key,
  	      location: keyInfo.location,
  	      keyCap: keyInfo.keyCap
  	    };
  	  }

  	  function queryKeyCap(code, locale) {
  	    code = String(code);
  	    if (!codeTable.hasOwnProperty(code)) return 'Undefined';
  	    if (locale && String(locale).toLowerCase() !== 'en-us') throw Error('Unsupported locale');
  	    var keyInfo = codeTable[code];
  	    return keyInfo.keyCap || keyInfo.code || 'Undefined';
  	  }

  	  if ('KeyboardEvent' in global && 'defineProperty' in Object) {
  	    (function() {
  	      function define(o, p, v) {
  	        if (p in o) return;
  	        Object.defineProperty(o, p, v);
  	      }

  	      define(KeyboardEvent.prototype, 'code', { get: function() {
  	        var keyInfo = keyInfoForEvent(this);
  	        return keyInfo ? keyInfo.code : '';
  	      }});

  	      // Fix for nonstandard `key` values (FF36-)
  	      if ('key' in KeyboardEvent.prototype) {
  	        var desc = Object.getOwnPropertyDescriptor(KeyboardEvent.prototype, 'key');
  	        Object.defineProperty(KeyboardEvent.prototype, 'key', { get: function() {
  	          var key = desc.get.call(this);
  	          return keyFixTable.hasOwnProperty(key) ? keyFixTable[key] : key;
  	        }});
  	      }

  	      define(KeyboardEvent.prototype, 'key', { get: function() {
  	        var keyInfo = keyInfoForEvent(this);
  	        return (keyInfo && 'key' in keyInfo) ? keyInfo.key : 'Unidentified';
  	      }});

  	      define(KeyboardEvent.prototype, 'location', { get: function() {
  	        var keyInfo = keyInfoForEvent(this);
  	        return (keyInfo && 'location' in keyInfo) ? keyInfo.location : STANDARD;
  	      }});

  	      define(KeyboardEvent.prototype, 'locale', { get: function() {
  	        return '';
  	      }});
  	    }());
  	  }

  	  if (!('queryKeyCap' in global.KeyboardEvent))
  	    global.KeyboardEvent.queryKeyCap = queryKeyCap;

  	  // Helper for IE8-
  	  global.identifyKey = function(event) {
  	    if ('code' in event)
  	      return;

  	    var keyInfo = keyInfoForEvent(event);
  	    event.code = keyInfo ? keyInfo.code : '';
  	    event.key = (keyInfo && 'key' in keyInfo) ? keyInfo.key : 'Unidentified';
  	    event.location = ('location' in event) ? event.location :
  	      ('keyLocation' in event) ? event.keyLocation :
  	      (keyInfo && 'location' in keyInfo) ? keyInfo.location : STANDARD;
  	    event.locale = '';
  	  };

  	} (window));
  	return keyboard_polyfill;
  }

  /* global AFRAME, THREE */

  var keyboardControls;
  var hasRequiredKeyboardControls;

  function requireKeyboardControls () {
  	if (hasRequiredKeyboardControls) return keyboardControls;
  	hasRequiredKeyboardControls = 1;
  	/* eslint-disable no-prototype-builtins */
  	requireKeyboard_polyfill();

  	const PROXY_FLAG = '__keyboard-controls-proxy';

  	const KeyboardEvent = window.KeyboardEvent;

  	/**
  	 * Keyboard Controls component.
  	 *
  	 * Stripped-down version of: https://github.com/donmccurdy/aframe-keyboard-controls
  	 *
  	 * Bind keyboard events to components, or control your entities with the WASD keys.
  	 *
  	 * Why use KeyboardEvent.code? "This is set to a string representing the key that was pressed to
  	 * generate the KeyboardEvent, without taking the current keyboard layout (e.g., QWERTY vs.
  	 * Dvorak), locale (e.g., English vs. French), or any modifier keys into account. This is useful
  	 * when you care about which physical key was pressed, rather thanwhich character it corresponds
  	 * to. For example, if you’re a writing a game, you might want a certain set of keys to move the
  	 * player in different directions, and that mapping should ideally be independent of keyboard
  	 * layout. See: https://developers.google.com/web/updates/2016/04/keyboardevent-keys-codes
  	 *
  	 * @namespace wasd-controls
  	 * keys the entity moves and if you release it will stop. Easing simulates friction.
  	 * to the entity when pressing the keys.
  	 * @param {bool} [enabled=true] - To completely enable or disable the controls
  	 */
  	keyboardControls = AFRAME.registerComponent('keyboard-controls', {
  	  schema: {
  	    enabled:           { default: true },
  	    debug:             { default: false }
  	  },

  	  init: function () {
  	    this.dVelocity = new THREE.Vector3();
  	    this.localKeys = {};
  	    this.listeners = {
  	      keydown: this.onKeyDown.bind(this),
  	      keyup: this.onKeyUp.bind(this),
  	      blur: this.onBlur.bind(this),
  	      onContextMenu: this.onContextMenu.bind(this),
  	    };
  	  },

  	  /*******************************************************************
  	  * Movement
  	  */

  	  isVelocityActive: function () {
  	    return this.data.enabled && !!Object.keys(this.getKeys()).length;
  	  },

  	  getVelocityDelta: function () {
  	    const data = this.data;
  	    const keys = this.getKeys();

  	    this.dVelocity.set(0, 0, 0);
  	    if (data.enabled) {
  	      if (keys.KeyW || keys.ArrowUp)    { this.dVelocity.z -= 1; }
  	      if (keys.KeyA || keys.ArrowLeft)  { this.dVelocity.x -= 1; }
  	      if (keys.KeyS || keys.ArrowDown)  { this.dVelocity.z += 1; }
  	      if (keys.KeyD || keys.ArrowRight) { this.dVelocity.x += 1; }

  	      // Move faster when the shift key is down.
  	      if (keys.ShiftLeft) { this.dVelocity = this.dVelocity.multiplyScalar(2); }
  	    }

  	    return this.dVelocity.clone();
  	  },

  	  /*******************************************************************
  	  * Events
  	  */

  	  play: function () {
  	    this.attachEventListeners();
  	  },

  	  pause: function () {
  	    this.removeEventListeners();
  	  },

  	  attachEventListeners: function () {
  	    window.addEventListener("contextmenu", this.listeners.onContextMenu, false);
  	    window.addEventListener("keydown", this.listeners.keydown, false);
  	    window.addEventListener("keyup", this.listeners.keyup, false);
  	    window.addEventListener("blur", this.listeners.blur, false);
  	  },

  	  onContextMenu: function () {
  	    for (const code in this.localKeys) {
  	      if (this.localKeys.hasOwnProperty(code)) {
  	        delete this.localKeys[code];
  	      }
  	    }
  	  },

  	  removeEventListeners: function () {
  	    window.removeEventListener('keydown', this.listeners.keydown);
  	    window.removeEventListener('keyup', this.listeners.keyup);
  	    window.removeEventListener('blur', this.listeners.blur);
  	  },

  	  onKeyDown: function (event) {
  	    if (AFRAME.utils.shouldCaptureKeyEvent(event)) {
  	      this.localKeys[event.code] = true;
  	      this.emit(event);
  	    }
  	  },

  	  onKeyUp: function (event) {
  	    if (AFRAME.utils.shouldCaptureKeyEvent(event)) {
  	      delete this.localKeys[event.code];
  	      this.emit(event);
  	    }
  	  },

  	  onBlur: function () {
  	    for (const code in this.localKeys) {
  	      if (this.localKeys.hasOwnProperty(code)) {
  	        delete this.localKeys[code];
  	      }
  	    }
  	  },

  	  emit: function (event) {
  	    // TODO - keydown only initially?
  	    // TODO - where the f is the spacebar

  	    // Emit original event.
  	    if (PROXY_FLAG in event) {
  	      // TODO - Method never triggered.
  	      this.el.emit(event.type, event);
  	    }

  	    // Emit convenience event, identifying key.
  	    this.el.emit(event.type + ':' + event.code, new KeyboardEvent(event.type, event));
  	    if (this.data.debug) console.log(event.type + ':' + event.code);
  	  },

  	  /*******************************************************************
  	  * Accessors
  	  */

  	  isPressed: function (code) {
  	    return code in this.getKeys();
  	  },

  	  getKeys: function () {
  	    if (this.isProxied()) {
  	      return this.el.sceneEl.components['proxy-controls'].getKeyboard();
  	    }
  	    return this.localKeys;
  	  },

  	  isProxied: function () {
  	    const proxyControls = this.el.sceneEl.components['proxy-controls'];
  	    return proxyControls && proxyControls.isConnected();
  	  }

  	});
  	return keyboardControls;
  }

  /**
   * Touch-to-move-forward controls for mobile.
   */

  var touchControls;
  var hasRequiredTouchControls;

  function requireTouchControls () {
  	if (hasRequiredTouchControls) return touchControls;
  	hasRequiredTouchControls = 1;
  	touchControls = AFRAME.registerComponent('touch-controls', {
  	  schema: {
  	    enabled: { default: true },
  	    reverseEnabled: { default: true }
  	  },

  	  init: function () {
  	    this.dVelocity = new THREE.Vector3();
  	    this.bindMethods();
  	    this.direction = 0;
  	  },

  	  play: function () {
  	    this.addEventListeners();
  	  },

  	  pause: function () {
  	    this.removeEventListeners();
  	    this.dVelocity.set(0, 0, 0);
  	  },

  	  remove: function () {
  	    this.pause();
  	  },

  	  addEventListeners: function () {
  	    const sceneEl = this.el.sceneEl;
  	    const canvasEl = sceneEl.canvas;

  	    if (!canvasEl) {
  	      sceneEl.addEventListener('render-target-loaded', this.addEventListeners.bind(this));
  	      return;
  	    }

  	    canvasEl.addEventListener('touchstart', this.onTouchStart, {passive: true});
  	    canvasEl.addEventListener('touchend', this.onTouchEnd, {passive: true});
  	    const vrModeUI = sceneEl.getAttribute('vr-mode-ui');
  	    if (vrModeUI && vrModeUI.cardboardModeEnabled) {
  	      sceneEl.addEventListener('enter-vr', this.onEnterVR);
  	    }
  	  },

  	  removeEventListeners: function () {
  	    const canvasEl = this.el.sceneEl && this.el.sceneEl.canvas;
  	    if (!canvasEl) { return; }

  	    canvasEl.removeEventListener('touchstart', this.onTouchStart);
  	    canvasEl.removeEventListener('touchend', this.onTouchEnd);
  	    this.el.sceneEl.removeEventListener('enter-vr', this.onEnterVR);
  	  },

  	  isVelocityActive: function () {
  	    return this.data.enabled && !!this.direction;
  	  },

  	  getVelocityDelta: function () {
  	    this.dVelocity.z = this.direction;
  	    return this.dVelocity.clone();
  	  },

  	  bindMethods: function () {
  	    this.onTouchStart = this.onTouchStart.bind(this);
  	    this.onTouchEnd = this.onTouchEnd.bind(this);
  	    this.onEnterVR = this.onEnterVR.bind(this);
  	  },

  	  onTouchStart: function (e) {
  	    this.direction = -1;
  	    if (this.data.reverseEnabled && e.touches && e.touches.length === 2) {
  	      this.direction = 1;
  	    }
  	    e.preventDefault();
  	  },

  	  onTouchEnd: function (e) {
  	    this.direction = 0;
  	    e.preventDefault();
  	  },

  	  onEnterVR: function () {
  	    // This is to make the Cardboard button on Chrome Android working
  	    const xrSession = this.el.sceneEl.xrSession;
  	    if (!xrSession) { return; }
  	    xrSession.addEventListener('selectstart', this.onTouchStart);
  	    xrSession.addEventListener('selectend', this.onTouchEnd);
  	  }
  	});
  	return touchControls;
  }

  /**
   * Movement Controls
   *
   * @author Don McCurdy <dm@donmccurdy.com>
   */

  var movementControls;
  var hasRequiredMovementControls;

  function requireMovementControls () {
  	if (hasRequiredMovementControls) return movementControls;
  	hasRequiredMovementControls = 1;
  	const COMPONENT_SUFFIX = '-controls';
  	const MAX_DELTA = 0.2; // ms
  	const EPS = 10e-6;
  	const MOVED = 'moved';

  	movementControls = AFRAME.registerComponent('movement-controls', {

  	  /*******************************************************************
  	   * Schema
  	   */

  	  dependencies: ['rotation'],

  	  schema: {
  	    enabled:            { default: true },
  	    controls:           { default: ['gamepad', 'trackpad', 'keyboard', 'touch'] },
  	    speed:              { default: 0.3, min: 0 },
  	    fly:                { default: false },
  	    constrainToNavMesh: { default: false },
  	    camera:             { default: '[movement-controls] [camera]', type: 'selector' }
  	  },

  	  /*******************************************************************
  	   * Lifecycle
  	   */

  	  init: function () {
  	    const el = this.el;
  	    if (!this.data.camera) {
  	      this.data.camera = el.querySelector('[camera]');
  	    }
  	    this.velocityCtrl = null;

  	    this.velocity = new THREE.Vector3();
  	    this.heading = new THREE.Quaternion();
  	    this.eventDetail = {};

  	    // Navigation
  	    this.navGroup = null;
  	    this.navNode = null;

  	    if (el.sceneEl.hasLoaded) {
  	      this.injectControls();
  	    } else {
  	      el.sceneEl.addEventListener('loaded', this.injectControls.bind(this));
  	    }
  	  },

  	  update: function (prevData) {
  	    const el = this.el;
  	    const data = this.data;
  	    const nav = el.sceneEl.systems.nav;
  	    if (el.sceneEl.hasLoaded) {
  	      this.injectControls();
  	    }
  	    if (nav && data.constrainToNavMesh !== prevData.constrainToNavMesh) {
  	      data.constrainToNavMesh
  	        ? nav.addAgent(this)
  	        : nav.removeAgent(this);
  	    }
  	    if (data.enabled !== prevData.enabled) {
  	      // Propagate the enabled change to all controls
  	      for (let i = 0; i < data.controls.length; i++) {
  	        const name = data.controls[i] + COMPONENT_SUFFIX;
  	        this.el.setAttribute(name, { enabled: this.data.enabled });
  	      }
  	    }
  	  },

  	  injectControls: function () {
  	    const data = this.data;

  	    for (let i = 0; i < data.controls.length; i++) {
  	      const name = data.controls[i] + COMPONENT_SUFFIX;
  	      this.el.setAttribute(name, { enabled: this.data.enabled });
  	    }
  	  },

  	  updateNavLocation: function () {
  	    this.navGroup = null;
  	    this.navNode = null;
  	  },

  	  /*******************************************************************
  	   * Tick
  	   */

  	  tick: (function () {
  	    const start = new THREE.Vector3();
  	    const end = new THREE.Vector3();
  	    const clampedEnd = new THREE.Vector3();

  	    return function (t, dt) {
  	      if (!dt) return;

  	      const el = this.el;
  	      const data = this.data;

  	      if (!data.enabled) return;

  	      this.updateVelocityCtrl();
  	      const velocityCtrl = this.velocityCtrl;
  	      const velocity = this.velocity;

  	      if (!velocityCtrl) return;

  	      // Update velocity. If FPS is too low, reset.
  	      if (dt / 1000 > MAX_DELTA) {
  	        velocity.set(0, 0, 0);
  	      } else {
  	        this.updateVelocity(dt);
  	      }

  	      if (data.constrainToNavMesh
  	          && velocityCtrl.isNavMeshConstrained !== false) {

  	        if (velocity.lengthSq() < EPS) return;

  	        start.copy(el.object3D.position);
  	        end
  	          .copy(velocity)
  	          .multiplyScalar(dt / 1000)
  	          .add(start);

  	        const nav = el.sceneEl.systems.nav;
  	        this.navGroup = this.navGroup === null ? nav.getGroup(start) : this.navGroup;
  	        this.navNode = this.navNode || nav.getNode(start, this.navGroup);
  	        this.navNode = nav.clampStep(start, end, this.navGroup, this.navNode, clampedEnd);
  	        el.object3D.position.copy(clampedEnd);
  	      } else if (el.hasAttribute('velocity')) {
  	        el.setAttribute('velocity', velocity);
  	      } else {
  	        el.object3D.position.x += velocity.x * dt / 1000;
  	        el.object3D.position.y += velocity.y * dt / 1000;
  	        el.object3D.position.z += velocity.z * dt / 1000;
  	      }

  	    };
  	  }()),

  	  /*******************************************************************
  	   * Movement
  	   */

  	  updateVelocityCtrl: function () {
  	    const data = this.data;
  	    if (data.enabled) {
  	      for (let i = 0, l = data.controls.length; i < l; i++) {
  	        const control = this.el.components[data.controls[i] + COMPONENT_SUFFIX];
  	        if (control && control.isVelocityActive()) {
  	          this.velocityCtrl = control;
  	          return;
  	        }
  	      }
  	      this.velocityCtrl = null;
  	    }
  	  },

  	  updateVelocity: (function () {
  	    const vector2 = new THREE.Vector2();
  	    const quaternion = new THREE.Quaternion();

  	    return function (dt) {
  	      let dVelocity;
  	      const el = this.el;
  	      const control = this.velocityCtrl;
  	      const velocity = this.velocity;
  	      const data = this.data;

  	      if (control) {
  	        if (control.getVelocityDelta) {
  	          dVelocity = control.getVelocityDelta(dt);
  	        } else if (control.getVelocity) {
  	          velocity.copy(control.getVelocity());
  	          return;
  	        } else if (control.getPositionDelta) {
  	          velocity.copy(control.getPositionDelta(dt).multiplyScalar(1000 / dt));
  	          return;
  	        } else {
  	          throw new Error('Incompatible movement controls: ', control);
  	        }
  	      }

  	      if (el.hasAttribute('velocity') && !data.constrainToNavMesh) {
  	        velocity.copy(this.el.getAttribute('velocity'));
  	      }

  	      if (dVelocity && data.enabled) {
  	        const cameraEl = data.camera;

  	        // Rotate to heading
  	        quaternion.copy(cameraEl.object3D.quaternion);
  	        quaternion.premultiply(el.object3D.quaternion);
  	        dVelocity.applyQuaternion(quaternion);

  	        const factor = dVelocity.length();
  	        if (data.fly) {
  	          velocity.copy(dVelocity);
  	          velocity.multiplyScalar(this.data.speed * 16.66667);
  	        } else {
  	          vector2.set(dVelocity.x, dVelocity.z);
  	          vector2.setLength(factor * this.data.speed * 16.66667);
  	          velocity.x = vector2.x;
  	          velocity.y = 0;
  	          velocity.z = vector2.y;
  	        }
  	        if (velocity.x !== 0 || velocity.y !== 0 || velocity.z !== 0) {
  	          this.eventDetail.velocity = velocity;
  	          this.el.emit(MOVED, this.eventDetail);
  	        }
  	      }
  	    };

  	  }())
  	});
  	return movementControls;
  }

  /**
   * 3dof (Gear VR, Daydream) controls for mobile.
   */

  var trackpadControls;
  var hasRequiredTrackpadControls;

  function requireTrackpadControls () {
  	if (hasRequiredTrackpadControls) return trackpadControls;
  	hasRequiredTrackpadControls = 1;
  	trackpadControls = AFRAME.registerComponent('trackpad-controls', {
  	  schema: {
  	    enabled: { default: true },
  	    enableNegX: { default: true },
  	    enablePosX: { default: true },
  	    enableNegZ: { default: true },
  	    enablePosZ: { default: true },
  	    mode: { default: 'touch', oneOf: ['swipe', 'touch', 'press'] }

  	  },

  	  init: function () {
  	    this.dVelocity = new THREE.Vector3();
  	    this.zVel      = 0;
  	    this.xVel      = 0;
  	    this.bindMethods();
  	  },

  	  play: function () {
  	    this.addEventListeners();
  	  },

  	  pause: function () {
  	    this.removeEventListeners();
  	    this.dVelocity.set(0, 0, 0);
  	  },

  	  remove: function () {
  	    this.pause();
  	  },

  	  addEventListeners: function () {
  	    const data = this.data;
  	    const sceneEl = this.el.sceneEl;

  	    sceneEl.addEventListener('axismove', this.onAxisMove);

  	    switch (data.mode) {
  	      case 'swipe':
  	      case 'touch':
  	        sceneEl.addEventListener('trackpadtouchstart', this.onTouchStart);
  	        sceneEl.addEventListener('trackpadtouchend', this.onTouchEnd);
  	        break;

  	      case 'press':
  	        sceneEl.addEventListener('trackpaddown', this.onTouchStart);
  	        sceneEl.addEventListener('trackpadup', this.onTouchEnd);
  	        break;
  	    }

  	  },

  	  removeEventListeners: function () {
  	    const sceneEl = this.el.sceneEl;

  	    sceneEl.removeEventListener('axismove', this.onAxisMove);
  	    sceneEl.removeEventListener('trackpadtouchstart', this.onTouchStart);
  	    sceneEl.removeEventListener('trackpadtouchend', this.onTouchEnd);
  	    sceneEl.removeEventListener('trackpaddown', this.onTouchStart);
  	    sceneEl.removeEventListener('trackpadup', this.onTouchEnd);
  	  },

  	  isVelocityActive: function () {
  	    return this.data.enabled && this.isMoving;
  	  },

  	  getVelocityDelta: function () {
  	    this.dVelocity.z = this.isMoving ? -this.zVel : 1;
  	    this.dVelocity.x = this.isMoving ? this.xVel : 1;
  	    return this.dVelocity.clone();
  	  },

  	  bindMethods: function () {
  	    this.onTouchStart = this.onTouchStart.bind(this);
  	    this.onTouchEnd = this.onTouchEnd.bind(this);
  	    this.onAxisMove = this.onAxisMove.bind(this);
  	  },

  	  onTouchStart: function (e) {
  	    switch(this.data.mode){
  	      case 'swipe':
  	        this.canRecordAxis = true;
  	        this.startingAxisData = [];
  	        break;
  	      case 'touch':
  	        this.isMoving = true;
  	        break;
  	      case 'press':
  	        this.isMoving = true;
  	        break;
  	    }

  	    e.preventDefault();
  	  },

  	  onTouchEnd: function (e) {
  	    if(this.data.mode == 'swipe') {
  	        this.startingAxisData = [];
  	    }

  	    this.isMoving = false;
  	    e.preventDefault();
  	  },

  	  onAxisMove: function(e){
  	    switch (this.data.mode) {
  	      case 'swipe':
  	        return this.handleSwipeAxis(e);
  	      case 'touch':
  	      case 'press':
  	        return this.handleTouchAxis(e);
  	    }
  	  },

  	  handleSwipeAxis: function(e) {
  	    const data = this.data;
  	    const axisData = e.detail.axis;

  	    if(this.startingAxisData.length === 0 && this.canRecordAxis){
  	      this.canRecordAxis = false;
  	      this.startingAxisData[0] = axisData[0];
  	      this.startingAxisData[1] = axisData[1];
  	    }

  	    if(this.startingAxisData.length > 0){
  	      let velX = 0;
  	      let velZ = 0;

  	      if (data.enableNegX && axisData[0] < this.startingAxisData[0]) {
  	        velX = -1;
  	      }

  	      if (data.enablePosX && axisData[0] > this.startingAxisData[0]) {
  	        velX = 1;
  	      }

  	      if (data.enablePosZ && axisData[1] > this.startingAxisData[1]) {
  	        velZ = -1;
  	      }

  	      if (data.enableNegZ && axisData[1] < this.startingAxisData[1]) {
  	        velZ = 1;
  	      }

  	      const absChangeZ  = Math.abs(this.startingAxisData[1] - axisData[1]);
  	      const absChangeX  = Math.abs(this.startingAxisData[0] - axisData[0]);

  	      if (absChangeX > absChangeZ) {
  	        this.zVel = 0;
  	        this.xVel = velX;
  	        this.isMoving = true;
  	      } else {
  	        this.xVel = 0;
  	        this.zVel = velZ;
  	        this.isMoving = true;
  	      }

  	    }
  	  },

  	  handleTouchAxis: function(e) {
  	    const data = this.data;
  	    const axisData = e.detail.axis;

  	    let velX = 0;
  	    let velZ = 0;

  	    if (data.enableNegX && axisData[0] < 0) {
  	      velX = -1;
  	    }

  	    if (data.enablePosX && axisData[0] > 0) {
  	      velX = 1;
  	    }

  	    if (data.enablePosZ && axisData[1] > 0) {
  	      velZ = -1;
  	    }

  	    if (data.enableNegZ && axisData[1] < 0) {
  	      velZ = 1;
  	    }

  	    if (Math.abs(axisData[0]) > Math.abs(axisData[1])) {
  	      this.zVel = 0;
  	      this.xVel = velX;
  	    } else {
  	      this.xVel = 0;
  	      this.zVel = velZ;
  	    }

  	  }

  	});
  	return trackpadControls;
  }

  ///////////////////////
  ///      UTILS      ///
  ///////////////////////

  const distance$1 = (p1, p2) => {
      const dx = p2.x - p1.x;
      const dy = p2.y - p1.y;

      return Math.sqrt((dx * dx) + (dy * dy));
  };

  const angle = (p1, p2) => {
      const dx = p2.x - p1.x;
      const dy = p2.y - p1.y;

      return degrees(Math.atan2(dy, dx));
  };

  const findCoord = (p, d, a) => {
      const b = {x: 0, y: 0};
      a = radians(a);
      b.x = p.x - d * Math.cos(a);
      b.y = p.y - d * Math.sin(a);
      return b;
  };

  const radians = (a) => {
      return a * (Math.PI / 180);
  };

  const degrees = (a) => {
      return a * (180 / Math.PI);
  };

  const isPressed = (evt) => {
      if (isNaN(evt.buttons)) {
          return evt.pressure !== 0;
      }
      return evt.buttons !== 0;
  };

  const timers = new Map();
  const throttle = (cb) => {
      if (timers.has(cb)) {
          clearTimeout(timers.get(cb));
      }
      timers.set(cb, setTimeout(cb, 100));
  };

  const bindEvt = (el, arg, handler) => {
      const types = arg.split(/[ ,]+/g);
      let type;
      for (let i = 0; i < types.length; i += 1) {
          type = types[i];
          if (el.addEventListener) {
              el.addEventListener(type, handler, false);
          } else if (el.attachEvent) {
              el.attachEvent(type, handler);
          }
      }
  };

  const unbindEvt = (el, arg, handler) => {
      const types = arg.split(/[ ,]+/g);
      let type;
      for (let i = 0; i < types.length; i += 1) {
          type = types[i];
          if (el.removeEventListener) {
              el.removeEventListener(type, handler);
          } else if (el.detachEvent) {
              el.detachEvent(type, handler);
          }
      }
  };

  const prepareEvent = (evt) => {
      evt.preventDefault();
      return evt.type.match(/^touch/) ? evt.changedTouches : evt;
  };

  const getScroll = () => {
      const x = (window.pageXOffset !== undefined) ?
          window.pageXOffset :
          (document.documentElement || document.body.parentNode || document.body)
              .scrollLeft;

      const y = (window.pageYOffset !== undefined) ?
          window.pageYOffset :
          (document.documentElement || document.body.parentNode || document.body)
              .scrollTop;
      return {
          x: x,
          y: y
      };
  };

  const applyPosition = (el, pos) => {
      if (pos.top || pos.right || pos.bottom || pos.left) {
          el.style.top = pos.top;
          el.style.right = pos.right;
          el.style.bottom = pos.bottom;
          el.style.left = pos.left;
      } else {
          el.style.left = pos.x + 'px';
          el.style.top = pos.y + 'px';
      }
  };

  const getTransitionStyle = (property, values, time) => {
      const obj = configStylePropertyObject(property);
      for (let i in obj) {
          if (obj.hasOwnProperty(i)) {
              if (typeof values === 'string') {
                  obj[i] = values + ' ' + time;
              } else {
                  let st = '';
                  for (let j = 0, max = values.length; j < max; j += 1) {
                      st += values[j] + ' ' + time + ', ';
                  }
                  obj[i] = st.slice(0, -2);
              }
          }
      }
      return obj;
  };

  const getVendorStyle = (property, value) => {
      const obj = configStylePropertyObject(property);
      for (let i in obj) {
          if (obj.hasOwnProperty(i)) {
              obj[i] = value;
          }
      }
      return obj;
  };

  const configStylePropertyObject = (prop) => {
      const obj = {};
      obj[prop] = '';
      const vendors = ['webkit', 'Moz', 'o'];
      vendors.forEach(function (vendor) {
          obj[vendor + prop.charAt(0).toUpperCase() + prop.slice(1)] = '';
      });
      return obj;
  };

  const extend = (objA, objB) => {
      for (let i in objB) {
          if (objB.hasOwnProperty(i)) {
              objA[i] = objB[i];
          }
      }
      return objA;
  };

  // Overwrite only what's already present
  const safeExtend = (objA, objB) => {
      const obj = {};
      for (let i in objA) {
          if (objA.hasOwnProperty(i) && objB.hasOwnProperty(i)) {
              obj[i] = objB[i];
          } else if (objA.hasOwnProperty(i)) {
              obj[i] = objA[i];
          }
      }
      return obj;
  };

  // Map for array or unique item.
  const map = (ar, fn) => {
      if (ar.length) {
          for (let i = 0, max = ar.length; i < max; i += 1) {
              fn(ar[i]);
          }
      } else {
          fn(ar);
      }
  };

  // Clamp position within the range
  const clamp = (pos, nipplePos, size) => ({
      //                          left-clamping        right-clamping
      x: Math.min(Math.max(pos.x, nipplePos.x - size), nipplePos.x + size),
      //                          top-clamping         bottom-clamping
      y: Math.min(Math.max(pos.y, nipplePos.y - size), nipplePos.y + size)
  });

  ///////////////////////
  ///   SUPER CLASS   ///
  ///////////////////////

  // Constants
  var isTouch = !!('ontouchstart' in window);
  var isPointer = window.PointerEvent ? true : false;
  var isMSPointer = window.MSPointerEvent ? true : false;
  var events = {
      touch: {
          start: 'touchstart',
          move: 'touchmove',
          end: 'touchend, touchcancel'
      },
      mouse: {
          start: 'mousedown',
          move: 'mousemove',
          end: 'mouseup'
      },
      pointer: {
          start: 'pointerdown',
          move: 'pointermove',
          end: 'pointerup, pointercancel'
      },
      MSPointer: {
          start: 'MSPointerDown',
          move: 'MSPointerMove',
          end: 'MSPointerUp'
      }
  };
  var toBind;
  var secondBind = {};
  if (isPointer) {
      toBind = events.pointer;
  } else if (isMSPointer) {
      toBind = events.MSPointer;
  } else if (isTouch) {
      toBind = events.touch;
      secondBind = events.mouse;
  } else {
      toBind = events.mouse;
  }

  function Super () {}

  // Basic event system.
  Super.prototype.on = function (arg, cb) {
      var self = this;
      var types = arg.split(/[ ,]+/g);
      var type;
      self._handlers_ = self._handlers_ || {};

      for (var i = 0; i < types.length; i += 1) {
          type = types[i];
          self._handlers_[type] = self._handlers_[type] || [];
          self._handlers_[type].push(cb);
      }
      return self;
  };

  Super.prototype.off = function (type, cb) {
      var self = this;
      self._handlers_ = self._handlers_ || {};

      if (type === undefined) {
          self._handlers_ = {};
      } else if (cb === undefined) {
          self._handlers_[type] = null;
      } else if (self._handlers_[type] &&
              self._handlers_[type].indexOf(cb) >= 0) {
          self._handlers_[type].splice(self._handlers_[type].indexOf(cb), 1);
      }

      return self;
  };

  Super.prototype.trigger = function (arg, data) {
      var self = this;
      var types = arg.split(/[ ,]+/g);
      var type;
      self._handlers_ = self._handlers_ || {};

      for (var i = 0; i < types.length; i += 1) {
          type = types[i];
          if (self._handlers_[type] && self._handlers_[type].length) {
              self._handlers_[type].forEach(function (handler) {
                  handler.call(self, {
                      type: type,
                      target: self
                  }, data);
              });
          }
      }
  };

  // Configuration
  Super.prototype.config = function (options) {
      var self = this;
      self.options = self.defaults || {};
      if (options) {
          self.options = safeExtend(self.options, options);
      }
  };

  // Bind internal events.
  Super.prototype.bindEvt = function (el, type) {
      var self = this;
      self._domHandlers_ = self._domHandlers_ || {};

      self._domHandlers_[type] = function () {
          if (typeof self['on' + type] === 'function') {
              self['on' + type].apply(self, arguments);
          } else {
              // eslint-disable-next-line no-console
              console.warn('[WARNING] : Missing "on' + type + '" handler.');
          }
      };

      bindEvt(el, toBind[type], self._domHandlers_[type]);

      if (secondBind[type]) {
          // Support for both touch and mouse at the same time.
          bindEvt(el, secondBind[type], self._domHandlers_[type]);
      }

      return self;
  };

  // Unbind dom events.
  Super.prototype.unbindEvt = function (el, type) {
      var self = this;
      self._domHandlers_ = self._domHandlers_ || {};

      unbindEvt(el, toBind[type], self._domHandlers_[type]);

      if (secondBind[type]) {
          // Support for both touch and mouse at the same time.
          unbindEvt(el, secondBind[type], self._domHandlers_[type]);
      }

      delete self._domHandlers_[type];

      return this;
  };

  ///////////////////////
  ///   THE NIPPLE    ///
  ///////////////////////

  function Nipple (collection, options) {
      this.identifier = options.identifier;
      this.position = options.position;
      this.frontPosition = options.frontPosition;
      this.collection = collection;

      // Defaults
      this.defaults = {
          size: 100,
          threshold: 0.1,
          color: 'white',
          fadeTime: 250,
          dataOnly: false,
          restJoystick: true,
          restOpacity: 0.5,
          mode: 'dynamic',
          zone: document.body,
          lockX: false,
          lockY: false,
          shape: 'circle'
      };

      this.config(options);

      // Overwrites
      if (this.options.mode === 'dynamic') {
          this.options.restOpacity = 0;
      }

      this.id = Nipple.id;
      Nipple.id += 1;
      this.buildEl()
          .stylize();

      // Nipple's API.
      this.instance = {
          el: this.ui.el,
          on: this.on.bind(this),
          off: this.off.bind(this),
          show: this.show.bind(this),
          hide: this.hide.bind(this),
          add: this.addToDom.bind(this),
          remove: this.removeFromDom.bind(this),
          destroy: this.destroy.bind(this),
          setPosition:this.setPosition.bind(this),
          resetDirection: this.resetDirection.bind(this),
          computeDirection: this.computeDirection.bind(this),
          trigger: this.trigger.bind(this),
          position: this.position,
          frontPosition: this.frontPosition,
          ui: this.ui,
          identifier: this.identifier,
          id: this.id,
          options: this.options
      };

      return this.instance;
  }

  Nipple.prototype = new Super();
  Nipple.constructor = Nipple;
  Nipple.id = 0;

  // Build the dom element of the Nipple instance.
  Nipple.prototype.buildEl = function (options) {
      this.ui = {};

      if (this.options.dataOnly) {
          return this;
      }

      this.ui.el = document.createElement('div');
      this.ui.back = document.createElement('div');
      this.ui.front = document.createElement('div');

      this.ui.el.className = 'nipple collection_' + this.collection.id;
      this.ui.back.className = 'back';
      this.ui.front.className = 'front';

      this.ui.el.setAttribute('id', 'nipple_' + this.collection.id +
          '_' + this.id);

      this.ui.el.appendChild(this.ui.back);
      this.ui.el.appendChild(this.ui.front);

      return this;
  };

  // Apply CSS to the Nipple instance.
  Nipple.prototype.stylize = function () {
      if (this.options.dataOnly) {
          return this;
      }
      var animTime = this.options.fadeTime + 'ms';
      var borderStyle = getVendorStyle('borderRadius', '50%');
      var transitStyle = getTransitionStyle('transition', 'opacity', animTime);
      var styles = {};
      styles.el = {
          position: 'absolute',
          opacity: this.options.restOpacity,
          display: 'block',
          'zIndex': 999
      };

      styles.back = {
          position: 'absolute',
          display: 'block',
          width: this.options.size + 'px',
          height: this.options.size + 'px',
          left: 0,
          marginLeft: -this.options.size / 2 + 'px',
          marginTop: -this.options.size / 2 + 'px',
          background: this.options.color,
          'opacity': '.5'
      };

      styles.front = {
          width: this.options.size / 2 + 'px',
          height: this.options.size / 2 + 'px',
          position: 'absolute',
          display: 'block',
          left: 0,
          marginLeft: -this.options.size / 4 + 'px',
          marginTop: -this.options.size / 4 + 'px',
          background: this.options.color,
          'opacity': '.5',
          transform: 'translate(0px, 0px)'
      };

      extend(styles.el, transitStyle);
      if(this.options.shape === 'circle'){
          extend(styles.back, borderStyle);
      }
      extend(styles.front, borderStyle);

      this.applyStyles(styles);

      return this;
  };

  Nipple.prototype.applyStyles = function (styles) {
      // Apply styles
      for (var i in this.ui) {
          if (this.ui.hasOwnProperty(i)) {
              for (var j in styles[i]) {
                  this.ui[i].style[j] = styles[i][j];
              }
          }
      }

      return this;
  };

  // Inject the Nipple instance into DOM.
  Nipple.prototype.addToDom = function () {
      // We're not adding it if we're dataOnly or already in dom.
      if (this.options.dataOnly || document.body.contains(this.ui.el)) {
          return this;
      }
      this.options.zone.appendChild(this.ui.el);
      return this;
  };

  // Remove the Nipple instance from DOM.
  Nipple.prototype.removeFromDom = function () {
      if (this.options.dataOnly || !document.body.contains(this.ui.el)) {
          return this;
      }
      this.options.zone.removeChild(this.ui.el);
      return this;
  };

  // Entirely destroy this nipple
  Nipple.prototype.destroy = function () {
      clearTimeout(this.removeTimeout);
      clearTimeout(this.showTimeout);
      clearTimeout(this.restTimeout);
      this.trigger('destroyed', this.instance);
      this.removeFromDom();
      this.off();
  };

  // Fade in the Nipple instance.
  Nipple.prototype.show = function (cb) {
      var self = this;

      if (self.options.dataOnly) {
          return self;
      }

      clearTimeout(self.removeTimeout);
      clearTimeout(self.showTimeout);
      clearTimeout(self.restTimeout);

      self.addToDom();

      self.restCallback();

      setTimeout(function () {
          self.ui.el.style.opacity = 1;
      }, 0);

      self.showTimeout = setTimeout(function () {
          self.trigger('shown', self.instance);
          if (typeof cb === 'function') {
              cb.call(this);
          }
      }, self.options.fadeTime);

      return self;
  };

  // Fade out the Nipple instance.
  Nipple.prototype.hide = function (cb) {
      var self = this;

      if (self.options.dataOnly) {
          return self;
      }

      self.ui.el.style.opacity = self.options.restOpacity;

      clearTimeout(self.removeTimeout);
      clearTimeout(self.showTimeout);
      clearTimeout(self.restTimeout);

      self.removeTimeout = setTimeout(
          function () {
              var display = self.options.mode === 'dynamic' ? 'none' : 'block';
              self.ui.el.style.display = display;
              if (typeof cb === 'function') {
                  cb.call(self);
              }

              self.trigger('hidden', self.instance);
          },
          self.options.fadeTime
      );

      if (self.options.restJoystick) {
          const rest = self.options.restJoystick;
          const newPosition = {};

          newPosition.x = rest === true || rest.x !== false ? 0 : self.instance.frontPosition.x;
          newPosition.y = rest === true || rest.y !== false ? 0 : self.instance.frontPosition.y;

          self.setPosition(cb, newPosition);
      }

      return self;
  };

  // Set the nipple to the specified position
  Nipple.prototype.setPosition = function (cb, position) {
      var self = this;
      self.frontPosition = {
          x: position.x,
          y: position.y
      };
      var animTime = self.options.fadeTime + 'ms';

      var transitStyle = {};
      transitStyle.front = getTransitionStyle('transition',
          ['transform'], animTime);

      var styles = {front: {}};
      styles.front = {
          transform: 'translate(' + self.frontPosition.x + 'px,' + self.frontPosition.y + 'px)'
      };

      self.applyStyles(transitStyle);
      self.applyStyles(styles);

      self.restTimeout = setTimeout(
          function () {
              if (typeof cb === 'function') {
                  cb.call(self);
              }
              self.restCallback();
          },
          self.options.fadeTime
      );
  };

  Nipple.prototype.restCallback = function () {
      var self = this;
      var transitStyle = {};
      transitStyle.front = getTransitionStyle('transition', 'none', '');
      self.applyStyles(transitStyle);
      self.trigger('rested', self.instance);
  };

  Nipple.prototype.resetDirection = function () {
      // Fully rebuild the object to let the iteration possible.
      this.direction = {
          x: false,
          y: false,
          angle: false
      };
  };

  Nipple.prototype.computeDirection = function (obj) {
      var rAngle = obj.angle.radian;
      var angle45 = Math.PI / 4;
      var angle90 = Math.PI / 2;
      var direction, directionX, directionY;

      // Angular direction
      //     \  UP /
      //      \   /
      // LEFT       RIGHT
      //      /   \
      //     /DOWN \
      //
      if (
          rAngle > angle45 &&
          rAngle < (angle45 * 3) &&
          !obj.lockX
      ) {
          direction = 'up';
      } else if (
          rAngle > -angle45 &&
          rAngle <= angle45 &&
          !obj.lockY
      ) {
          direction = 'left';
      } else if (
          rAngle > (-angle45 * 3) &&
          rAngle <= -angle45 &&
          !obj.lockX
      ) {
          direction = 'down';
      } else if (!obj.lockY) {
          direction = 'right';
      }

      // Plain direction
      //    UP                 |
      // _______               | RIGHT
      //                  LEFT |
      //   DOWN                |
      if (!obj.lockY) {
          if (rAngle > -angle90 && rAngle < angle90) {
              directionX = 'left';
          } else {
              directionX = 'right';
          }
      }

      if (!obj.lockX) {
          if (rAngle > 0) {
              directionY = 'up';
          } else {
              directionY = 'down';
          }
      }

      if (obj.force > this.options.threshold) {
          var oldDirection = {};
          var i;
          for (i in this.direction) {
              if (this.direction.hasOwnProperty(i)) {
                  oldDirection[i] = this.direction[i];
              }
          }

          var same = {};

          this.direction = {
              x: directionX,
              y: directionY,
              angle: direction
          };

          obj.direction = this.direction;

          for (i in oldDirection) {
              if (oldDirection[i] === this.direction[i]) {
                  same[i] = true;
              }
          }

          // If all 3 directions are the same, we don't trigger anything.
          if (same.x && same.y && same.angle) {
              return obj;
          }

          if (!same.x || !same.y) {
              this.trigger('plain', obj);
          }

          if (!same.x) {
              this.trigger('plain:' + directionX, obj);
          }

          if (!same.y) {
              this.trigger('plain:' + directionY, obj);
          }

          if (!same.angle) {
              this.trigger('dir dir:' + direction, obj);
          }
      } else {
          this.resetDirection();
      }

      return obj;
  };

  ///////////////////////////
  ///   THE COLLECTION    ///
  ///////////////////////////

  function Collection (manager, options) {
      var self = this;
      self.nipples = [];
      self.idles = [];
      self.actives = [];
      self.ids = [];
      self.pressureIntervals = {};
      self.manager = manager;
      self.id = Collection.id;
      Collection.id += 1;

      // Defaults
      self.defaults = {
          zone: document.body,
          multitouch: false,
          maxNumberOfNipples: 10,
          mode: 'dynamic',
          position: {top: 0, left: 0},
          catchDistance: 200,
          size: 100,
          threshold: 0.1,
          color: 'white',
          fadeTime: 250,
          dataOnly: false,
          restJoystick: true,
          restOpacity: 0.5,
          lockX: false,
          lockY: false,
          shape: 'circle',
          dynamicPage: false,
          follow: false
      };

      self.config(options);

      // Overwrites
      if (self.options.mode === 'static' || self.options.mode === 'semi') {
          self.options.multitouch = false;
      }

      if (!self.options.multitouch) {
          self.options.maxNumberOfNipples = 1;
      }
      const computedStyle = getComputedStyle(self.options.zone.parentElement);
      if (computedStyle && computedStyle.display === 'flex') {
          self.parentIsFlex = true;
      }

      self.updateBox();
      self.prepareNipples();
      self.bindings();
      self.begin();

      return self.nipples;
  }

  Collection.prototype = new Super();
  Collection.constructor = Collection;
  Collection.id = 0;

  Collection.prototype.prepareNipples = function () {
      var self = this;
      var nips = self.nipples;

      // Public API Preparation.
      nips.on = self.on.bind(self);
      nips.off = self.off.bind(self);
      nips.options = self.options;
      nips.destroy = self.destroy.bind(self);
      nips.ids = self.ids;
      nips.id = self.id;
      nips.processOnMove = self.processOnMove.bind(self);
      nips.processOnEnd = self.processOnEnd.bind(self);
      nips.get = function (id) {
          if (id === undefined) {
              return nips[0];
          }
          for (var i = 0, max = nips.length; i < max; i += 1) {
              if (nips[i].identifier === id) {
                  return nips[i];
              }
          }
          return false;
      };
  };

  Collection.prototype.bindings = function () {
      var self = this;
      // Touch start event.
      self.bindEvt(self.options.zone, 'start');
      // Avoid native touch actions (scroll, zoom etc...) on the zone.
      self.options.zone.style.touchAction = 'none';
      self.options.zone.style.msTouchAction = 'none';
  };

  Collection.prototype.begin = function () {
      var self = this;
      var opts = self.options;

      // We place our static nipple
      // if needed.
      if (opts.mode === 'static') {
          var nipple = self.createNipple(
              opts.position,
              self.manager.getIdentifier()
          );
          // Add it to the dom.
          nipple.add();
          // Store it in idles.
          self.idles.push(nipple);
      }
  };

  // Nipple Factory
  Collection.prototype.createNipple = function (position, identifier) {
      var self = this;
      var scroll = self.manager.scroll;
      var toPutOn = {};
      var opts = self.options;
      var offset = {
          x: self.parentIsFlex ? scroll.x : (scroll.x + self.box.left),
          y: self.parentIsFlex ? scroll.y : (scroll.y + self.box.top)
      };

      if (position.x && position.y) {
          toPutOn = {
              x: position.x - offset.x,
              y: position.y - offset.y
          };
      } else if (
          position.top ||
          position.right ||
          position.bottom ||
          position.left
      ) {

          // We need to compute the position X / Y of the joystick.
          var dumb = document.createElement('DIV');
          dumb.style.display = 'hidden';
          dumb.style.top = position.top;
          dumb.style.right = position.right;
          dumb.style.bottom = position.bottom;
          dumb.style.left = position.left;
          dumb.style.position = 'absolute';

          opts.zone.appendChild(dumb);
          var dumbBox = dumb.getBoundingClientRect();
          opts.zone.removeChild(dumb);

          toPutOn = position;
          position = {
              x: dumbBox.left + scroll.x,
              y: dumbBox.top + scroll.y
          };
      }

      var nipple = new Nipple(self, {
          color: opts.color,
          size: opts.size,
          threshold: opts.threshold,
          fadeTime: opts.fadeTime,
          dataOnly: opts.dataOnly,
          restJoystick: opts.restJoystick,
          restOpacity: opts.restOpacity,
          mode: opts.mode,
          identifier: identifier,
          position: position,
          zone: opts.zone,
          frontPosition: {
              x: 0,
              y: 0
          },
          shape: opts.shape
      });

      if (!opts.dataOnly) {
          applyPosition(nipple.ui.el, toPutOn);
          applyPosition(nipple.ui.front, nipple.frontPosition);
      }
      self.nipples.push(nipple);
      self.trigger('added ' + nipple.identifier + ':added', nipple);
      self.manager.trigger('added ' + nipple.identifier + ':added', nipple);

      self.bindNipple(nipple);

      return nipple;
  };

  Collection.prototype.updateBox = function () {
      var self = this;
      self.box = self.options.zone.getBoundingClientRect();
  };

  Collection.prototype.bindNipple = function (nipple) {
      var self = this;
      var type;
      // Bubble up identified events.
      var handler = function (evt, data) {
          // Identify the event type with the nipple's id.
          type = evt.type + ' ' + data.id + ':' + evt.type;
          self.trigger(type, data);
      };

      // When it gets destroyed.
      nipple.on('destroyed', self.onDestroyed.bind(self));

      // Other events that will get bubbled up.
      nipple.on('shown hidden rested dir plain', handler);
      nipple.on('dir:up dir:right dir:down dir:left', handler);
      nipple.on('plain:up plain:right plain:down plain:left', handler);
  };

  Collection.prototype.pressureFn = function (touch, nipple, identifier) {
      var self = this;
      var previousPressure = 0;
      clearInterval(self.pressureIntervals[identifier]);
      // Create an interval that will read the pressure every 100ms
      self.pressureIntervals[identifier] = setInterval(function () {
          var pressure = touch.force || touch.pressure ||
              touch.webkitForce || 0;
          if (pressure !== previousPressure) {
              nipple.trigger('pressure', pressure);
              self.trigger('pressure ' +
                  nipple.identifier + ':pressure', pressure);
              previousPressure = pressure;
          }
      }.bind(self), 100);
  };

  Collection.prototype.onstart = function (evt) {
      var self = this;
      var opts = self.options;
      var origEvt = evt;
      evt = prepareEvent(evt);

      // Update the box position
      self.updateBox();

      var process = function (touch) {
          // If we can create new nipples
          // meaning we don't have more active nipples than we should.
          if (self.actives.length < opts.maxNumberOfNipples) {
              self.processOnStart(touch);
          }
          else if(origEvt.type.match(/^touch/)){
              // zombies occur when end event is not received on Safari
              // first touch removed before second touch, we need to catch up...
              // so remove where touches in manager that no longer exist
              Object.keys(self.manager.ids).forEach(function(k){
                  if(Object.values(origEvt.touches).findIndex(function(t){return t.identifier===k;}) < 0){
                      // manager has id that doesn't exist in touches
                      var e = [evt[0]];
                      e.identifier = k;
                      self.processOnEnd(e);
                  }
              });
              if(self.actives.length < opts.maxNumberOfNipples){
                  self.processOnStart(touch);
              }
          }
      };

      map(evt, process);

      // We ask upstream to bind the document
      // on 'move' and 'end'
      self.manager.bindDocument();
      return false;
  };

  Collection.prototype.processOnStart = function (evt) {
      var self = this;
      var opts = self.options;
      var indexInIdles;
      var identifier = self.manager.getIdentifier(evt);
      var pressure = evt.force || evt.pressure || evt.webkitForce || 0;
      var position = {
          x: evt.pageX,
          y: evt.pageY
      };

      var nipple = self.getOrCreate(identifier, position);

      // Update its touch identifier
      if (nipple.identifier !== identifier) {
          self.manager.removeIdentifier(nipple.identifier);
      }
      nipple.identifier = identifier;

      var process = function (nip) {
          // Trigger the start.
          nip.trigger('start', nip);
          self.trigger('start ' + nip.id + ':start', nip);

          nip.show();
          if (pressure > 0) {
              self.pressureFn(evt, nip, nip.identifier);
          }
          // Trigger the first move event.
          self.processOnMove(evt);
      };

      // Transfer it from idles to actives.
      if ((indexInIdles = self.idles.indexOf(nipple)) >= 0) {
          self.idles.splice(indexInIdles, 1);
      }

      // Store the nipple in the actives array
      self.actives.push(nipple);
      self.ids.push(nipple.identifier);

      if (opts.mode !== 'semi') {
          process(nipple);
      } else {
          // In semi we check the distance of the touch
          // to decide if we have to reset the nipple
          var distance = distance$1(position, nipple.position);
          if (distance <= opts.catchDistance) {
              process(nipple);
          } else {
              nipple.destroy();
              self.processOnStart(evt);
              return;
          }
      }

      return nipple;
  };

  Collection.prototype.getOrCreate = function (identifier, position) {
      var self = this;
      var opts = self.options;
      var nipple;

      // If we're in static or semi, we might already have an active.
      if (/(semi|static)/.test(opts.mode)) {
          // Get the active one.
          // TODO: Multi-touche for semi and static will start here.
          // Return the nearest one.
          nipple = self.idles[0];
          if (nipple) {
              self.idles.splice(0, 1);
              return nipple;
          }

          if (opts.mode === 'semi') {
              // If we're in semi mode, we need to create one.
              return self.createNipple(position, identifier);
          }

          // eslint-disable-next-line no-console
          console.warn('Coudln\'t find the needed nipple.');
          return false;
      }
      // In dynamic, we create a new one.
      nipple = self.createNipple(position, identifier);
      return nipple;
  };

  Collection.prototype.processOnMove = function (evt) {
      var self = this;
      var opts = self.options;
      var identifier = self.manager.getIdentifier(evt);
      var nipple = self.nipples.get(identifier);
      var scroll = self.manager.scroll;

      // If we're moving without pressing
      // it's that we went out the active zone
      if (!isPressed(evt)) {
          this.processOnEnd(evt);
          return;
      }

      if (!nipple) {
          // This is here just for safety.
          // It shouldn't happen.
          // eslint-disable-next-line no-console
          console.error('Found zombie joystick with ID ' + identifier);
          self.manager.removeIdentifier(identifier);
          return;
      }

      if (opts.dynamicPage) {
          var elBox = nipple.el.getBoundingClientRect();
          nipple.position = {
              x: scroll.x + elBox.left,
              y: scroll.y + elBox.top
          };
      }

      nipple.identifier = identifier;

      var size = nipple.options.size / 2;
      var pos = {
          x: evt.pageX,
          y: evt.pageY
      };

      if (opts.lockX){
          pos.y = nipple.position.y;
      }
      if (opts.lockY) {
          pos.x = nipple.position.x;
      }

      var dist = distance$1(pos, nipple.position);
      var angle$1 = angle(pos, nipple.position);
      var rAngle = radians(angle$1);
      var force = dist / size;

      var raw = {
          distance: dist,
          position: pos
      };

      // Clamp the position
      var clamped_dist;
      var clamped_pos;
      if (nipple.options.shape === 'circle') {
          // Clamp to a circle
          clamped_dist = Math.min(dist, size);
          clamped_pos = findCoord(nipple.position, clamped_dist, angle$1);
      } else {
          // Clamp to a square
          clamped_pos = clamp(pos, nipple.position, size);
          clamped_dist = distance$1(clamped_pos, nipple.position);
      }

      if (opts.follow) {
          // follow behaviour
          if (dist > size) {
              let delta_x = pos.x - clamped_pos.x;
              let delta_y = pos.y - clamped_pos.y;
              nipple.position.x += delta_x;
              nipple.position.y += delta_y;
              nipple.el.style.top = (nipple.position.y - (self.box.top + scroll.y)) + 'px';
              nipple.el.style.left = (nipple.position.x - (self.box.left + scroll.x)) + 'px';

              dist = distance$1(pos, nipple.position);
          }
      } else {
          // clamp behaviour
          pos = clamped_pos;
          dist = clamped_dist;
      }

      var xPosition = pos.x - nipple.position.x;
      var yPosition = pos.y - nipple.position.y;

      nipple.frontPosition = {
          x: xPosition,
          y: yPosition
      };

      if (!opts.dataOnly) {
          nipple.ui.front.style.transform = 'translate(' + xPosition + 'px,' + yPosition + 'px)';
      }

      // Prepare event's datas.
      var toSend = {
          identifier: nipple.identifier,
          position: pos,
          force: force,
          pressure: evt.force || evt.pressure || evt.webkitForce || 0,
          distance: dist,
          angle: {
              radian: rAngle,
              degree: angle$1
          },
          vector: {
              x: xPosition / size,
              y: - yPosition / size
          },
          raw: raw,
          instance: nipple,
          lockX: opts.lockX,
          lockY: opts.lockY
      };

      // Compute the direction's datas.
      toSend = nipple.computeDirection(toSend);

      // Offset angles to follow units circle.
      toSend.angle = {
          radian: radians(180 - angle$1),
          degree: 180 - angle$1
      };

      // Send everything to everyone.
      nipple.trigger('move', toSend);
      self.trigger('move ' + nipple.id + ':move', toSend);
  };

  Collection.prototype.processOnEnd = function (evt) {
      var self = this;
      var opts = self.options;
      var identifier = self.manager.getIdentifier(evt);
      var nipple = self.nipples.get(identifier);
      var removedIdentifier = self.manager.removeIdentifier(nipple.identifier);

      if (!nipple) {
          return;
      }

      if (!opts.dataOnly) {
          nipple.hide(function () {
              if (opts.mode === 'dynamic') {
                  nipple.trigger('removed', nipple);
                  self.trigger('removed ' + nipple.id + ':removed', nipple);
                  self.manager
                      .trigger('removed ' + nipple.id + ':removed', nipple);
                  nipple.destroy();
              }
          });
      }

      // Clear the pressure interval reader
      clearInterval(self.pressureIntervals[nipple.identifier]);

      // Reset the direciton of the nipple, to be able to trigger a new direction
      // on start.
      nipple.resetDirection();

      nipple.trigger('end', nipple);
      self.trigger('end ' + nipple.id + ':end', nipple);

      // Remove identifier from our bank.
      if (self.ids.indexOf(nipple.identifier) >= 0) {
          self.ids.splice(self.ids.indexOf(nipple.identifier), 1);
      }

      // Clean our actives array.
      if (self.actives.indexOf(nipple) >= 0) {
          self.actives.splice(self.actives.indexOf(nipple), 1);
      }

      if (/(semi|static)/.test(opts.mode)) {
          // Transfer nipple from actives to idles
          // if we're in semi or static mode.
          self.idles.push(nipple);
      } else if (self.nipples.indexOf(nipple) >= 0) {
          // Only if we're not in semi or static mode
          // we can remove the instance.
          self.nipples.splice(self.nipples.indexOf(nipple), 1);
      }

      // We unbind move and end.
      self.manager.unbindDocument();

      // We add back the identifier of the idle nipple;
      if (/(semi|static)/.test(opts.mode)) {
          self.manager.ids[removedIdentifier.id] = removedIdentifier.identifier;
      }
  };

  // Remove destroyed nipple from the lists
  Collection.prototype.onDestroyed = function(evt, nipple) {
      var self = this;
      if (self.nipples.indexOf(nipple) >= 0) {
          self.nipples.splice(self.nipples.indexOf(nipple), 1);
      }
      if (self.actives.indexOf(nipple) >= 0) {
          self.actives.splice(self.actives.indexOf(nipple), 1);
      }
      if (self.idles.indexOf(nipple) >= 0) {
          self.idles.splice(self.idles.indexOf(nipple), 1);
      }
      if (self.ids.indexOf(nipple.identifier) >= 0) {
          self.ids.splice(self.ids.indexOf(nipple.identifier), 1);
      }

      // Remove the identifier from our bank
      self.manager.removeIdentifier(nipple.identifier);

      // We unbind move and end.
      self.manager.unbindDocument();
  };

  // Cleanly destroy the manager
  Collection.prototype.destroy = function () {
      var self = this;
      self.unbindEvt(self.options.zone, 'start');

      // Destroy nipples.
      self.nipples.forEach(function(nipple) {
          nipple.destroy();
      });

      // Clean 3DTouch intervals.
      for (var i in self.pressureIntervals) {
          if (self.pressureIntervals.hasOwnProperty(i)) {
              clearInterval(self.pressureIntervals[i]);
          }
      }

      // Notify the manager passing the instance
      self.trigger('destroyed', self.nipples);
      // We unbind move and end.
      self.manager.unbindDocument();
      // Unbind everything.
      self.off();
  };

  ///////////////////////
  ///     MANAGER     ///
  ///////////////////////

  function Manager (options) {
      var self = this;
      self.ids = {};
      self.index = 0;
      self.collections = [];
      self.scroll = getScroll();

      self.config(options);
      self.prepareCollections();

      // Listen for resize, to reposition every joysticks
      var resizeHandler = function () {
          var pos;
          self.collections.forEach(function (collection) {
              collection.forEach(function (nipple) {
                  pos = nipple.el.getBoundingClientRect();
                  nipple.position = {
                      x: self.scroll.x + pos.left,
                      y: self.scroll.y + pos.top
                  };
              });
          });
      };
      bindEvt(window, 'resize', function () {
          throttle(resizeHandler);
      });

      // Listen for scrolls, so we have a global scroll value
      // without having to request it all the time.
      var scrollHandler = function () {
          self.scroll = getScroll();
      };
      bindEvt(window, 'scroll', function () {
          throttle(scrollHandler);
      });

      return self.collections;
  }

  Manager.prototype = new Super();
  Manager.constructor = Manager;

  Manager.prototype.prepareCollections = function () {
      var self = this;
      // Public API Preparation.
      self.collections.create = self.create.bind(self);
      // Listen to anything
      self.collections.on = self.on.bind(self);
      // Unbind general events
      self.collections.off = self.off.bind(self);
      // Destroy everything
      self.collections.destroy = self.destroy.bind(self);
      // Get any nipple
      self.collections.get = function (id) {
          var nipple;
          // Use .every() to break the loop as soon as found.
          self.collections.every(function (collection) {
              nipple = collection.get(id);
              return nipple ? false : true;
          });
          return nipple;
      };
  };

  Manager.prototype.create = function (options) {
      return this.createCollection(options);
  };

  // Collection Factory
  Manager.prototype.createCollection = function (options) {
      var self = this;
      var collection = new Collection(self, options);

      self.bindCollection(collection);
      self.collections.push(collection);

      return collection;
  };

  Manager.prototype.bindCollection = function (collection) {
      var self = this;
      var type;
      // Bubble up identified events.
      var handler = function (evt, data) {
          // Identify the event type with the nipple's identifier.
          type = evt.type + ' ' + data.id + ':' + evt.type;
          self.trigger(type, data);
      };

      // When it gets destroyed we clean.
      collection.on('destroyed', self.onDestroyed.bind(self));

      // Other events that will get bubbled up.
      collection.on('shown hidden rested dir plain', handler);
      collection.on('dir:up dir:right dir:down dir:left', handler);
      collection.on('plain:up plain:right plain:down plain:left', handler);
  };

  Manager.prototype.bindDocument = function () {
      var self = this;
      // Bind only if not already binded
      if (!self.binded) {
          self.bindEvt(document, 'move')
              .bindEvt(document, 'end');
          self.binded = true;
      }
  };

  Manager.prototype.unbindDocument = function (force) {
      var self = this;
      // If there are no touch left
      // unbind the document.
      if (!Object.keys(self.ids).length || force === true) {
          self.unbindEvt(document, 'move')
              .unbindEvt(document, 'end');
          self.binded = false;
      }
  };

  Manager.prototype.getIdentifier = function (evt) {
      var id;
      // If no event, simple increment
      if (!evt) {
          id = this.index;
      } else {
          // Extract identifier from event object.
          // Unavailable in mouse events so replaced by latest increment.
          id = evt.identifier === undefined ? evt.pointerId : evt.identifier;
          if (id === undefined) {
              id = this.latest || 0;
          }
      }

      if (this.ids[id] === undefined) {
          this.ids[id] = this.index;
          this.index += 1;
      }

      // Keep the latest id used in case we're using an unidentified mouseEvent
      this.latest = id;
      return this.ids[id];
  };

  Manager.prototype.removeIdentifier = function (identifier) {
      var removed = {};
      for (var id in this.ids) {
          if (this.ids[id] === identifier) {
              removed.id = id;
              removed.identifier = this.ids[id];
              delete this.ids[id];
              break;
          }
      }
      return removed;
  };

  Manager.prototype.onmove = function (evt) {
      var self = this;
      self.onAny('move', evt);
      return false;
  };

  Manager.prototype.onend = function (evt) {
      var self = this;
      self.onAny('end', evt);
      return false;
  };

  Manager.prototype.oncancel = function (evt) {
      var self = this;
      self.onAny('end', evt);
      return false;
  };

  Manager.prototype.onAny = function (which, evt) {
      var self = this;
      var id;
      var processFn = 'processOn' + which.charAt(0).toUpperCase() +
          which.slice(1);
      evt = prepareEvent(evt);
      var processColl = function (e, id, coll) {
          if (coll.ids.indexOf(id) >= 0) {
              coll[processFn](e);
              // Mark the event to avoid cleaning it later.
              e._found_ = true;
          }
      };
      var processEvt = function (e) {
          id = self.getIdentifier(e);
          map(self.collections, processColl.bind(null, e, id));
          // If the event isn't handled by any collection,
          // we need to clean its identifier.
          if (!e._found_) {
              self.removeIdentifier(id);
          }
      };

      map(evt, processEvt);

      return false;
  };

  // Cleanly destroy the manager
  Manager.prototype.destroy = function () {
      var self = this;
      self.unbindDocument(true);
      self.ids = {};
      self.index = 0;
      self.collections.forEach(function(collection) {
          collection.destroy();
      });
      self.off();
  };

  // When a collection gets destroyed
  // we clean behind.
  Manager.prototype.onDestroyed = function (evt, coll) {
      var self = this;
      if (self.collections.indexOf(coll) < 0) {
          return false;
      }
      self.collections.splice(self.collections.indexOf(coll), 1);
  };

  const factory = new Manager();
  var nipplejs = {
      create: function (options) {
          return factory.create(options);
      },
      factory: factory
  };

  /* global AFRAME, THREE */

  AFRAME.registerComponent("nipple-controls", {
    schema: {
      enabled: { default: true },
      mode: { default: "dynamic", oneOf: ["static", "semi", "dynamic"] },
      rotationSensitivity: { default: 1.0 },
      moveJoystickEnabled: { default: true },
      lookJoystickEnabled: { default: true },
      sideMargin: { default: "30px" },
      bottomMargin: { default: "70px" },
      moveJoystickPosition: { default: "left", oneOf: ["left", "right"] },
      lookJoystickPosition: { default: "right", oneOf: ["left", "right"] },
    },

    init() {
      this.dVelocity = new THREE.Vector3();
      this.lookVector = new THREE.Vector2();
      const lookControls = this.el.querySelector("[look-controls]").components["look-controls"];
      this.pitchObject = lookControls.pitchObject;
      this.yawObject = lookControls.yawObject;
      this.rigRotation = this.el.object3D.rotation;
      this.moveData = undefined;
      this.lookData = undefined;
      this.moving = false;
      this.rotating = false;
    },

    update(oldData) {
      if (
        this.data.moveJoystickPosition !== oldData.moveJoystickPosition ||
        this.data.sideMargin !== oldData.sideMargin ||
        this.data.bottomMargin !== oldData.bottomMargin ||
        this.data.mode !== oldData.mode
      ) {
        this.removeMoveJoystick();
      }
      if (
        this.data.lookJoystickPosition !== oldData.lookJoystickPosition ||
        this.data.sideMargin !== oldData.sideMargin ||
        this.data.bottomMargin !== oldData.bottomMargin ||
        this.data.mode !== oldData.mode
      ) {
        this.removeLookJoystick();
      }
      if (this.data.enabled && this.data.moveJoystickEnabled) {
        this.createMoveJoystick();
      } else {
        this.removeMoveJoystick();
      }
      if (this.data.enabled && this.data.lookJoystickEnabled) {
        this.createLookJoystick();
      } else {
        this.removeLookJoystick();
      }
    },

    pause() {
      this.moving = false;
      this.rotating = false;
    },

    remove() {
      this.removeMoveJoystick();
      this.removeLookJoystick();
    },

    isVelocityActive() {
      return this.data.enabled && this.moving;
    },

    getVelocityDelta() {
      this.dVelocity.set(0, 0, 0);
      if (this.isVelocityActive()) {
        const force = this.moveData.force < 1 ? this.moveData.force : 1;
        const angle = this.moveData.angle.radian;
        const x = Math.cos(angle) * force;
        const z = -Math.sin(angle) * force;
        this.dVelocity.set(x, 0, z);
      }
      return this.dVelocity; // We don't do a clone() here, the Vector3 will be modified by the calling code but that's fine.
    },

    isRotationActive() {
      return this.data.enabled && this.rotating;
    },

    updateRotation(dt) {
      if (!this.isRotationActive()) return;

      const force = this.lookData.force < 1 ? this.lookData.force : 1;
      const angle = this.lookData.angle.radian;
      const lookVector = this.lookVector;
      lookVector.x = Math.cos(angle) * force;
      lookVector.y = Math.sin(angle) * force;
      lookVector.multiplyScalar((this.data.rotationSensitivity * dt) / 1000);

      this.yawObject.rotation.y -= lookVector.x;
      let x = this.pitchObject.rotation.x + lookVector.y;
      x = Math.max(-Math.PI / 2, Math.min(Math.PI / 2, x));
      this.pitchObject.rotation.x = x;
    },

    tick: function (t, dt) {
      this.updateRotation(dt);
    },

    initLeftZone() {
      const leftZone = document.createElement("div");
      leftZone.setAttribute("id", "joystickLeftZone");
      leftZone.setAttribute(
        "style",
        `position:absolute;${this.data.moveJoystickPosition}:${this.data.sideMargin};bottom:${this.data.bottomMargin};z-index:1`
      );
      document.body.appendChild(leftZone);
      this.leftZone = leftZone;
    },

    initRightZone() {
      const rightZone = document.createElement("div");
      rightZone.setAttribute("id", "joystickRightZone");
      rightZone.setAttribute(
        "style",
        `position:absolute;${this.data.lookJoystickPosition}:${this.data.sideMargin};bottom:${this.data.bottomMargin};z-index:1`
      );
      document.body.appendChild(rightZone);
      this.rightZone = rightZone;
    },

    createMoveJoystick() {
      if (this.moveJoystick) return;
      this.initLeftZone();
      const options = {
        mode: this.data.mode,
        zone: this.leftZone,
        color: "white",
        fadeTime: 0,
      };
      this.leftZone.style.width = "100px";
      if (this.data.mode === "static") {
        this.leftZone.style.height = "100px";
        options.position = { left: "50%", bottom: "50%" };
      } else {
        this.leftZone.style.height = "400px";
      }

      this.moveJoystick = nipplejs.create(options);
      this.moveJoystick.on("move", (evt, data) => {
        this.moveData = data;
        this.moving = true;
      });
      this.moveJoystick.on("end", (evt, data) => {
        this.moving = false;
      });
    },

    createLookJoystick() {
      if (this.lookJoystick) return;
      this.initRightZone();
      const options = {
        mode: this.data.mode,
        zone: this.rightZone,
        color: "white",
        fadeTime: 0,
      };
      this.rightZone.style.width = "100px";
      if (this.data.mode === "static") {
        this.rightZone.style.height = "100px";
        options.position = { left: "50%", bottom: "50%" };
      } else {
        this.rightZone.style.height = "400px";
      }

      this.lookJoystick = nipplejs.create(options);
      this.lookJoystick.on("move", (evt, data) => {
        this.lookData = data;
        this.rotating = true;
      });
      this.lookJoystick.on("end", (evt, data) => {
        this.rotating = false;
      });
    },

    removeMoveJoystick() {
      if (this.moveJoystick) {
        this.moveJoystick.destroy();
        this.moveJoystick = undefined;
      }

      this.moveData = undefined;

      if (this.leftZone && this.leftZone.parentNode) {
        this.leftZone.remove();
        this.leftZone = undefined;
      }
    },

    removeLookJoystick() {
      if (this.lookJoystick) {
        this.lookJoystick.destroy();
        this.lookJoystick = undefined;
      }

      this.lookData = undefined;

      if (this.rightZone && this.rightZone.parentNode) {
        this.rightZone.remove();
        this.rightZone = undefined;
      }
    },
  });

  var hasRequiredControls;

  function requireControls () {
  	if (hasRequiredControls) return controls;
  	hasRequiredControls = 1;
  	requireCheckpointControls();
  	requireGamepadControls();
  	requireKeyboardControls();
  	requireTouchControls();
  	requireMovementControls();
  	requireTrackpadControls();
  	return controls;
  }

  var loaders = {};

  var animationMixer;
  var hasRequiredAnimationMixer;

  function requireAnimationMixer () {
  	if (hasRequiredAnimationMixer) return animationMixer;
  	hasRequiredAnimationMixer = 1;
  	const LoopMode = {
  	  once: THREE.LoopOnce,
  	  repeat: THREE.LoopRepeat,
  	  pingpong: THREE.LoopPingPong
  	};

  	/**
  	 * animation-mixer
  	 *
  	 * Player for animation clips. Intended to be compatible with any model format that supports
  	 * skeletal or morph animations through THREE.AnimationMixer.
  	 * See: https://threejs.org/docs/?q=animation#Reference/Animation/AnimationMixer
  	 */
  	animationMixer = AFRAME.registerComponent('animation-mixer', {
  	  schema: {
  	    clip: { default: '*' },
  	    useRegExp: {default: false},
  	    duration: { default: 0 },
  	    clampWhenFinished: { default: false, type: 'boolean' },
  	    crossFadeDuration: { default: 0 },
  	    loop: { default: 'repeat', oneOf: Object.keys(LoopMode) },
  	    repetitions: { default: Infinity, min: 0 },
  	    timeScale: { default: 1 },
  	    startAt: { default: 0 }
  	  },

  	  init: function () {
  	    /** @type {THREE.Mesh} */
  	    this.model = null;
  	    /** @type {THREE.AnimationMixer} */
  	    this.mixer = null;
  	    /** @type {Array<THREE.AnimationAction>} */
  	    this.activeActions = [];

  	    const model = this.el.getObject3D('mesh');

  	    if (model) {
  	      this.load(model);
  	    } else {
  	      this.el.addEventListener('model-loaded', (e) => {
  	        this.load(e.detail.model);
  	      });
  	    }
  	  },

  	  load: function (model) {
  	    const el = this.el;
  	    this.model = model;
  	    this.mixer = new THREE.AnimationMixer(model);
  	    this.mixer.addEventListener('loop', (e) => {
  	      el.emit('animation-loop', { action: e.action, loopDelta: e.loopDelta });
  	    });
  	    this.mixer.addEventListener('finished', (e) => {
  	      el.emit('animation-finished', { action: e.action, direction: e.direction });
  	    });
  	    if (this.data.clip) this.update({});
  	  },

  	  remove: function () {
  	    if (this.mixer) this.mixer.stopAllAction();
  	  },

  	  update: function (prevData) {
  	    if (!prevData) return;

  	    const data = this.data;
  	    const changes = AFRAME.utils.diff(data, prevData);

  	    // If selected clips have changed, restart animation.
  	    if ('clip' in changes) {
  	      this.stopAction();
  	      if (data.clip) this.playAction();
  	      return;
  	    }

  	    // Otherwise, modify running actions.
  	    this.activeActions.forEach((action) => {
  	      if ('duration' in changes && data.duration) {
  	        action.setDuration(data.duration);
  	      }
  	      if ('clampWhenFinished' in changes) {
  	        action.clampWhenFinished = data.clampWhenFinished;
  	      }
  	      if ('loop' in changes || 'repetitions' in changes) {
  	        action.setLoop(LoopMode[data.loop], data.repetitions);
  	      }
  	      if ('timeScale' in changes) {
  	        action.setEffectiveTimeScale(data.timeScale);
  	      }
  	    });
  	  },

  	  stopAction: function () {
  	    const data = this.data;
  	    for (let i = 0; i < this.activeActions.length; i++) {
  	      data.crossFadeDuration
  	        ? this.activeActions[i].fadeOut(data.crossFadeDuration)
  	        : this.activeActions[i].stop();
  	    }
  	    this.activeActions.length = 0;
  	  },

  	  playAction: function () {
  	    if (!this.mixer) return;

  	    const model = this.model,
  	      data = this.data,
  	      clips = model.animations || (model.geometry || {}).animations || [];

  	    if (!clips.length) return;

  	    const re = data.useRegExp ? data.clip : wildcardToRegExp(data.clip);

  	    for (let clip, i = 0; (clip = clips[i]); i++) {
  	      if (clip.name.match(re)) {
  	        const action = this.mixer.clipAction(clip, model);

  	        action.enabled = true;
  	        action.clampWhenFinished = data.clampWhenFinished;
  	        if (data.duration) action.setDuration(data.duration);
  	        if (data.timeScale !== 1) action.setEffectiveTimeScale(data.timeScale);
  	        // animation-mixer.startAt and AnimationAction.startAt have very different meanings.
  	        // animation-mixer.startAt indicates which frame in the animation to start at, in msecs.
  	        // AnimationAction.startAt indicates when to start the animation (from the 1st frame),
  	        // measured in global mixer time, in seconds.
  	        action.startAt(this.mixer.time - data.startAt / 1000);
  	        action
  	          .setLoop(LoopMode[data.loop], data.repetitions)
  	          .fadeIn(data.crossFadeDuration)
  	          .play();
  	        this.activeActions.push(action);
  	      }
  	    }
  	  },

  	  tick: function (t, dt) {
  	    if (this.mixer && !isNaN(dt)) this.mixer.update(dt / 1000);
  	  }
  	});

  	/**
  	 * Creates a RegExp from the given string, converting asterisks to .* expressions,
  	 * and escaping all other characters.
  	 */
  	function wildcardToRegExp(s) {
  	  return new RegExp('^' + s.split(/\*+/).map(regExpEscape).join('.*') + '$');
  	}

  	/**
  	 * RegExp-escapes all characters in the given string.
  	 */
  	function regExpEscape(s) {
  	  return s.replace(/[|\\{}()[\]^$+*?.]/g, '\\$&');
  	}
  	return animationMixer;
  }

  class TGALoader extends three$2.DataTextureLoader {

  	constructor( manager ) {

  		super( manager );

  	}

  	parse( buffer ) {

  		// reference from vthibault, https://github.com/vthibault/roBrowser/blob/master/src/Loaders/Targa.js

  		function tgaCheckHeader( header ) {

  			switch ( header.image_type ) {

  				// check indexed type

  				case TGA_TYPE_INDEXED:
  				case TGA_TYPE_RLE_INDEXED:
  					if ( header.colormap_length > 256 || header.colormap_size !== 24 || header.colormap_type !== 1 ) {

  						throw new Error( 'THREE.TGALoader: Invalid type colormap data for indexed type.' );

  					}

  					break;

  					// check colormap type

  				case TGA_TYPE_RGB:
  				case TGA_TYPE_GREY:
  				case TGA_TYPE_RLE_RGB:
  				case TGA_TYPE_RLE_GREY:
  					if ( header.colormap_type ) {

  						throw new Error( 'THREE.TGALoader: Invalid type colormap data for colormap type.' );

  					}

  					break;

  					// What the need of a file without data ?

  				case TGA_TYPE_NO_DATA:
  					throw new Error( 'THREE.TGALoader: No data.' );

  					// Invalid type ?

  				default:
  					throw new Error( 'THREE.TGALoader: Invalid type ' + header.image_type );

  			}

  			// check image width and height

  			if ( header.width <= 0 || header.height <= 0 ) {

  				throw new Error( 'THREE.TGALoader: Invalid image size.' );

  			}

  			// check image pixel size

  			if ( header.pixel_size !== 8 && header.pixel_size !== 16 &&
  				header.pixel_size !== 24 && header.pixel_size !== 32 ) {

  				throw new Error( 'THREE.TGALoader: Invalid pixel size ' + header.pixel_size );

  			}

  		}

  		// parse tga image buffer

  		function tgaParse( use_rle, use_pal, header, offset, data ) {

  			let pixel_data,
  				palettes;

  			const pixel_size = header.pixel_size >> 3;
  			const pixel_total = header.width * header.height * pixel_size;

  			 // read palettes

  			 if ( use_pal ) {

  				 palettes = data.subarray( offset, offset += header.colormap_length * ( header.colormap_size >> 3 ) );

  			 }

  			 // read RLE

  			 if ( use_rle ) {

  				 pixel_data = new Uint8Array( pixel_total );

  				let c, count, i;
  				let shift = 0;
  				const pixels = new Uint8Array( pixel_size );

  				while ( shift < pixel_total ) {

  					c = data[ offset ++ ];
  					count = ( c & 0x7f ) + 1;

  					// RLE pixels

  					if ( c & 0x80 ) {

  						// bind pixel tmp array

  						for ( i = 0; i < pixel_size; ++ i ) {

  							pixels[ i ] = data[ offset ++ ];

  						}

  						// copy pixel array

  						for ( i = 0; i < count; ++ i ) {

  							pixel_data.set( pixels, shift + i * pixel_size );

  						}

  						shift += pixel_size * count;

  					} else {

  						// raw pixels

  						count *= pixel_size;

  						for ( i = 0; i < count; ++ i ) {

  							pixel_data[ shift + i ] = data[ offset ++ ];

  						}

  						shift += count;

  					}

  				}

  			 } else {

  				// raw pixels

  				pixel_data = data.subarray(
  					 offset, offset += ( use_pal ? header.width * header.height : pixel_total )
  				);

  			 }

  			 return {
  				pixel_data: pixel_data,
  				palettes: palettes
  			 };

  		}

  		function tgaGetImageData8bits( imageData, y_start, y_step, y_end, x_start, x_step, x_end, image, palettes ) {

  			const colormap = palettes;
  			let color, i = 0, x, y;
  			const width = header.width;

  			for ( y = y_start; y !== y_end; y += y_step ) {

  				for ( x = x_start; x !== x_end; x += x_step, i ++ ) {

  					color = image[ i ];
  					imageData[ ( x + width * y ) * 4 + 3 ] = 255;
  					imageData[ ( x + width * y ) * 4 + 2 ] = colormap[ ( color * 3 ) + 0 ];
  					imageData[ ( x + width * y ) * 4 + 1 ] = colormap[ ( color * 3 ) + 1 ];
  					imageData[ ( x + width * y ) * 4 + 0 ] = colormap[ ( color * 3 ) + 2 ];

  				}

  			}

  			return imageData;

  		}

  		function tgaGetImageData16bits( imageData, y_start, y_step, y_end, x_start, x_step, x_end, image ) {

  			let color, i = 0, x, y;
  			const width = header.width;

  			for ( y = y_start; y !== y_end; y += y_step ) {

  				for ( x = x_start; x !== x_end; x += x_step, i += 2 ) {

  					color = image[ i + 0 ] + ( image[ i + 1 ] << 8 );
  					imageData[ ( x + width * y ) * 4 + 0 ] = ( color & 0x7C00 ) >> 7;
  					imageData[ ( x + width * y ) * 4 + 1 ] = ( color & 0x03E0 ) >> 2;
  					imageData[ ( x + width * y ) * 4 + 2 ] = ( color & 0x001F ) << 3;
  					imageData[ ( x + width * y ) * 4 + 3 ] = ( color & 0x8000 ) ? 0 : 255;

  				}

  			}

  			return imageData;

  		}

  		function tgaGetImageData24bits( imageData, y_start, y_step, y_end, x_start, x_step, x_end, image ) {

  			let i = 0, x, y;
  			const width = header.width;

  			for ( y = y_start; y !== y_end; y += y_step ) {

  				for ( x = x_start; x !== x_end; x += x_step, i += 3 ) {

  					imageData[ ( x + width * y ) * 4 + 3 ] = 255;
  					imageData[ ( x + width * y ) * 4 + 2 ] = image[ i + 0 ];
  					imageData[ ( x + width * y ) * 4 + 1 ] = image[ i + 1 ];
  					imageData[ ( x + width * y ) * 4 + 0 ] = image[ i + 2 ];

  				}

  			}

  			return imageData;

  		}

  		function tgaGetImageData32bits( imageData, y_start, y_step, y_end, x_start, x_step, x_end, image ) {

  			let i = 0, x, y;
  			const width = header.width;

  			for ( y = y_start; y !== y_end; y += y_step ) {

  				for ( x = x_start; x !== x_end; x += x_step, i += 4 ) {

  					imageData[ ( x + width * y ) * 4 + 2 ] = image[ i + 0 ];
  					imageData[ ( x + width * y ) * 4 + 1 ] = image[ i + 1 ];
  					imageData[ ( x + width * y ) * 4 + 0 ] = image[ i + 2 ];
  					imageData[ ( x + width * y ) * 4 + 3 ] = image[ i + 3 ];

  				}

  			}

  			return imageData;

  		}

  		function tgaGetImageDataGrey8bits( imageData, y_start, y_step, y_end, x_start, x_step, x_end, image ) {

  			let color, i = 0, x, y;
  			const width = header.width;

  			for ( y = y_start; y !== y_end; y += y_step ) {

  				for ( x = x_start; x !== x_end; x += x_step, i ++ ) {

  					color = image[ i ];
  					imageData[ ( x + width * y ) * 4 + 0 ] = color;
  					imageData[ ( x + width * y ) * 4 + 1 ] = color;
  					imageData[ ( x + width * y ) * 4 + 2 ] = color;
  					imageData[ ( x + width * y ) * 4 + 3 ] = 255;

  				}

  			}

  			return imageData;

  		}

  		function tgaGetImageDataGrey16bits( imageData, y_start, y_step, y_end, x_start, x_step, x_end, image ) {

  			let i = 0, x, y;
  			const width = header.width;

  			for ( y = y_start; y !== y_end; y += y_step ) {

  				for ( x = x_start; x !== x_end; x += x_step, i += 2 ) {

  					imageData[ ( x + width * y ) * 4 + 0 ] = image[ i + 0 ];
  					imageData[ ( x + width * y ) * 4 + 1 ] = image[ i + 0 ];
  					imageData[ ( x + width * y ) * 4 + 2 ] = image[ i + 0 ];
  					imageData[ ( x + width * y ) * 4 + 3 ] = image[ i + 1 ];

  				}

  			}

  			return imageData;

  		}

  		function getTgaRGBA( data, width, height, image, palette ) {

  			let x_start,
  				y_start,
  				x_step,
  				y_step,
  				x_end,
  				y_end;

  			switch ( ( header.flags & TGA_ORIGIN_MASK ) >> TGA_ORIGIN_SHIFT ) {

  				default:
  				case TGA_ORIGIN_UL:
  					x_start = 0;
  					x_step = 1;
  					x_end = width;
  					y_start = 0;
  					y_step = 1;
  					y_end = height;
  					break;

  				case TGA_ORIGIN_BL:
  					x_start = 0;
  					x_step = 1;
  					x_end = width;
  					y_start = height - 1;
  					y_step = -1;
  					y_end = -1;
  					break;

  				case TGA_ORIGIN_UR:
  					x_start = width - 1;
  					x_step = -1;
  					x_end = -1;
  					y_start = 0;
  					y_step = 1;
  					y_end = height;
  					break;

  				case TGA_ORIGIN_BR:
  					x_start = width - 1;
  					x_step = -1;
  					x_end = -1;
  					y_start = height - 1;
  					y_step = -1;
  					y_end = -1;
  					break;

  			}

  			if ( use_grey ) {

  				switch ( header.pixel_size ) {

  					case 8:
  						tgaGetImageDataGrey8bits( data, y_start, y_step, y_end, x_start, x_step, x_end, image );
  						break;

  					case 16:
  						tgaGetImageDataGrey16bits( data, y_start, y_step, y_end, x_start, x_step, x_end, image );
  						break;

  					default:
  						throw new Error( 'THREE.TGALoader: Format not supported.' );

  				}

  			} else {

  				switch ( header.pixel_size ) {

  					case 8:
  						tgaGetImageData8bits( data, y_start, y_step, y_end, x_start, x_step, x_end, image, palette );
  						break;

  					case 16:
  						tgaGetImageData16bits( data, y_start, y_step, y_end, x_start, x_step, x_end, image );
  						break;

  					case 24:
  						tgaGetImageData24bits( data, y_start, y_step, y_end, x_start, x_step, x_end, image );
  						break;

  					case 32:
  						tgaGetImageData32bits( data, y_start, y_step, y_end, x_start, x_step, x_end, image );
  						break;

  					default:
  						throw new Error( 'THREE.TGALoader: Format not supported.' );

  				}

  			}

  			// Load image data according to specific method
  			// let func = 'tgaGetImageData' + (use_grey ? 'Grey' : '') + (header.pixel_size) + 'bits';
  			// func(data, y_start, y_step, y_end, x_start, x_step, x_end, width, image, palette );
  			return data;

  		}

  		// TGA constants

  		const TGA_TYPE_NO_DATA = 0,
  			TGA_TYPE_INDEXED = 1,
  			TGA_TYPE_RGB = 2,
  			TGA_TYPE_GREY = 3,
  			TGA_TYPE_RLE_INDEXED = 9,
  			TGA_TYPE_RLE_RGB = 10,
  			TGA_TYPE_RLE_GREY = 11,

  			TGA_ORIGIN_MASK = 0x30,
  			TGA_ORIGIN_SHIFT = 0x04,
  			TGA_ORIGIN_BL = 0x00,
  			TGA_ORIGIN_BR = 0x01,
  			TGA_ORIGIN_UL = 0x02,
  			TGA_ORIGIN_UR = 0x03;

  		if ( buffer.length < 19 ) throw new Error( 'THREE.TGALoader: Not enough data to contain header.' );

  		let offset = 0;

  		const content = new Uint8Array( buffer ),
  			header = {
  				id_length: content[ offset ++ ],
  				colormap_type: content[ offset ++ ],
  				image_type: content[ offset ++ ],
  				colormap_index: content[ offset ++ ] | content[ offset ++ ] << 8,
  				colormap_length: content[ offset ++ ] | content[ offset ++ ] << 8,
  				colormap_size: content[ offset ++ ],
  				origin: [
  					content[ offset ++ ] | content[ offset ++ ] << 8,
  					content[ offset ++ ] | content[ offset ++ ] << 8
  				],
  				width: content[ offset ++ ] | content[ offset ++ ] << 8,
  				height: content[ offset ++ ] | content[ offset ++ ] << 8,
  				pixel_size: content[ offset ++ ],
  				flags: content[ offset ++ ]
  			};

  		// check tga if it is valid format

  		tgaCheckHeader( header );

  		if ( header.id_length + offset > buffer.length ) {

  			throw new Error( 'THREE.TGALoader: No data.' );

  		}

  		// skip the needn't data

  		offset += header.id_length;

  		// get targa information about RLE compression and palette

  		let use_rle = false,
  			use_pal = false,
  			use_grey = false;

  		switch ( header.image_type ) {

  			case TGA_TYPE_RLE_INDEXED:
  				use_rle = true;
  				use_pal = true;
  				break;

  			case TGA_TYPE_INDEXED:
  				use_pal = true;
  				break;

  			case TGA_TYPE_RLE_RGB:
  				use_rle = true;
  				break;

  			case TGA_TYPE_RGB:
  				break;

  			case TGA_TYPE_RLE_GREY:
  				use_rle = true;
  				use_grey = true;
  				break;

  			case TGA_TYPE_GREY:
  				use_grey = true;
  				break;

  		}

  		//

  		const imageData = new Uint8Array( header.width * header.height * 4 );
  		const result = tgaParse( use_rle, use_pal, header, offset, content );
  		getTgaRGBA( imageData, header.width, header.height, result.pixel_data, result.palettes );

  		return {

  			data: imageData,
  			width: header.width,
  			height: header.height,
  			flipY: true,
  			generateMipmaps: true,
  			minFilter: three$2.LinearMipmapLinearFilter,

  		};

  	}

  }

  class ColladaLoader extends three$2.Loader {

  	load( url, onLoad, onProgress, onError ) {

  		const scope = this;

  		const path = ( scope.path === '' ) ? three$2.LoaderUtils.extractUrlBase( url ) : scope.path;

  		const loader = new three$2.FileLoader( scope.manager );
  		loader.setPath( scope.path );
  		loader.setRequestHeader( scope.requestHeader );
  		loader.setWithCredentials( scope.withCredentials );
  		loader.load( url, function ( text ) {

  			try {

  				onLoad( scope.parse( text, path ) );

  			} catch ( e ) {

  				if ( onError ) {

  					onError( e );

  				} else {

  					console.error( e );

  				}

  				scope.manager.itemError( url );

  			}

  		}, onProgress, onError );

  	}

  	parse( text, path ) {

  		function getElementsByTagName( xml, name ) {

  			// Non recursive xml.getElementsByTagName() ...

  			const array = [];
  			const childNodes = xml.childNodes;

  			for ( let i = 0, l = childNodes.length; i < l; i ++ ) {

  				const child = childNodes[ i ];

  				if ( child.nodeName === name ) {

  					array.push( child );

  				}

  			}

  			return array;

  		}

  		function parseStrings( text ) {

  			if ( text.length === 0 ) return [];

  			const parts = text.trim().split( /\s+/ );
  			const array = new Array( parts.length );

  			for ( let i = 0, l = parts.length; i < l; i ++ ) {

  				array[ i ] = parts[ i ];

  			}

  			return array;

  		}

  		function parseFloats( text ) {

  			if ( text.length === 0 ) return [];

  			const parts = text.trim().split( /\s+/ );
  			const array = new Array( parts.length );

  			for ( let i = 0, l = parts.length; i < l; i ++ ) {

  				array[ i ] = parseFloat( parts[ i ] );

  			}

  			return array;

  		}

  		function parseInts( text ) {

  			if ( text.length === 0 ) return [];

  			const parts = text.trim().split( /\s+/ );
  			const array = new Array( parts.length );

  			for ( let i = 0, l = parts.length; i < l; i ++ ) {

  				array[ i ] = parseInt( parts[ i ] );

  			}

  			return array;

  		}

  		function parseId( text ) {

  			return text.substring( 1 );

  		}

  		function generateId() {

  			return 'three_default_' + ( count ++ );

  		}

  		function isEmpty( object ) {

  			return Object.keys( object ).length === 0;

  		}

  		// asset

  		function parseAsset( xml ) {

  			return {
  				unit: parseAssetUnit( getElementsByTagName( xml, 'unit' )[ 0 ] ),
  				upAxis: parseAssetUpAxis( getElementsByTagName( xml, 'up_axis' )[ 0 ] )
  			};

  		}

  		function parseAssetUnit( xml ) {

  			if ( ( xml !== undefined ) && ( xml.hasAttribute( 'meter' ) === true ) ) {

  				return parseFloat( xml.getAttribute( 'meter' ) );

  			} else {

  				return 1; // default 1 meter

  			}

  		}

  		function parseAssetUpAxis( xml ) {

  			return xml !== undefined ? xml.textContent : 'Y_UP';

  		}

  		// library

  		function parseLibrary( xml, libraryName, nodeName, parser ) {

  			const library = getElementsByTagName( xml, libraryName )[ 0 ];

  			if ( library !== undefined ) {

  				const elements = getElementsByTagName( library, nodeName );

  				for ( let i = 0; i < elements.length; i ++ ) {

  					parser( elements[ i ] );

  				}

  			}

  		}

  		function buildLibrary( data, builder ) {

  			for ( const name in data ) {

  				const object = data[ name ];
  				object.build = builder( data[ name ] );

  			}

  		}

  		// get

  		function getBuild( data, builder ) {

  			if ( data.build !== undefined ) return data.build;

  			data.build = builder( data );

  			return data.build;

  		}

  		// animation

  		function parseAnimation( xml ) {

  			const data = {
  				sources: {},
  				samplers: {},
  				channels: {}
  			};

  			let hasChildren = false;

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				let id;

  				switch ( child.nodeName ) {

  					case 'source':
  						id = child.getAttribute( 'id' );
  						data.sources[ id ] = parseSource( child );
  						break;

  					case 'sampler':
  						id = child.getAttribute( 'id' );
  						data.samplers[ id ] = parseAnimationSampler( child );
  						break;

  					case 'channel':
  						id = child.getAttribute( 'target' );
  						data.channels[ id ] = parseAnimationChannel( child );
  						break;

  					case 'animation':
  						// hierarchy of related animations
  						parseAnimation( child );
  						hasChildren = true;
  						break;

  					default:
  						console.log( child );

  				}

  			}

  			if ( hasChildren === false ) {

  				// since 'id' attributes can be optional, it's necessary to generate a UUID for unqiue assignment

  				library.animations[ xml.getAttribute( 'id' ) || three$2.MathUtils.generateUUID() ] = data;

  			}

  		}

  		function parseAnimationSampler( xml ) {

  			const data = {
  				inputs: {},
  			};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'input':
  						const id = parseId( child.getAttribute( 'source' ) );
  						const semantic = child.getAttribute( 'semantic' );
  						data.inputs[ semantic ] = id;
  						break;

  				}

  			}

  			return data;

  		}

  		function parseAnimationChannel( xml ) {

  			const data = {};

  			const target = xml.getAttribute( 'target' );

  			// parsing SID Addressing Syntax

  			let parts = target.split( '/' );

  			const id = parts.shift();
  			let sid = parts.shift();

  			// check selection syntax

  			const arraySyntax = ( sid.indexOf( '(' ) !== -1 );
  			const memberSyntax = ( sid.indexOf( '.' ) !== -1 );

  			if ( memberSyntax ) {

  				//  member selection access

  				parts = sid.split( '.' );
  				sid = parts.shift();
  				data.member = parts.shift();

  			} else if ( arraySyntax ) {

  				// array-access syntax. can be used to express fields in one-dimensional vectors or two-dimensional matrices.

  				const indices = sid.split( '(' );
  				sid = indices.shift();

  				for ( let i = 0; i < indices.length; i ++ ) {

  					indices[ i ] = parseInt( indices[ i ].replace( /\)/, '' ) );

  				}

  				data.indices = indices;

  			}

  			data.id = id;
  			data.sid = sid;

  			data.arraySyntax = arraySyntax;
  			data.memberSyntax = memberSyntax;

  			data.sampler = parseId( xml.getAttribute( 'source' ) );

  			return data;

  		}

  		function buildAnimation( data ) {

  			const tracks = [];

  			const channels = data.channels;
  			const samplers = data.samplers;
  			const sources = data.sources;

  			for ( const target in channels ) {

  				if ( channels.hasOwnProperty( target ) ) {

  					const channel = channels[ target ];
  					const sampler = samplers[ channel.sampler ];

  					const inputId = sampler.inputs.INPUT;
  					const outputId = sampler.inputs.OUTPUT;

  					const inputSource = sources[ inputId ];
  					const outputSource = sources[ outputId ];

  					const animation = buildAnimationChannel( channel, inputSource, outputSource );

  					createKeyframeTracks( animation, tracks );

  				}

  			}

  			return tracks;

  		}

  		function getAnimation( id ) {

  			return getBuild( library.animations[ id ], buildAnimation );

  		}

  		function buildAnimationChannel( channel, inputSource, outputSource ) {

  			const node = library.nodes[ channel.id ];
  			const object3D = getNode( node.id );

  			const transform = node.transforms[ channel.sid ];
  			const defaultMatrix = node.matrix.clone().transpose();

  			let time, stride;
  			let i, il, j, jl;

  			const data = {};

  			// the collada spec allows the animation of data in various ways.
  			// depending on the transform type (matrix, translate, rotate, scale), we execute different logic

  			switch ( transform ) {

  				case 'matrix':

  					for ( i = 0, il = inputSource.array.length; i < il; i ++ ) {

  						time = inputSource.array[ i ];
  						stride = i * outputSource.stride;

  						if ( data[ time ] === undefined ) data[ time ] = {};

  						if ( channel.arraySyntax === true ) {

  							const value = outputSource.array[ stride ];
  							const index = channel.indices[ 0 ] + 4 * channel.indices[ 1 ];

  							data[ time ][ index ] = value;

  						} else {

  							for ( j = 0, jl = outputSource.stride; j < jl; j ++ ) {

  								data[ time ][ j ] = outputSource.array[ stride + j ];

  							}

  						}

  					}

  					break;

  				case 'translate':
  					console.warn( 'THREE.ColladaLoader: Animation transform type "%s" not yet implemented.', transform );
  					break;

  				case 'rotate':
  					console.warn( 'THREE.ColladaLoader: Animation transform type "%s" not yet implemented.', transform );
  					break;

  				case 'scale':
  					console.warn( 'THREE.ColladaLoader: Animation transform type "%s" not yet implemented.', transform );
  					break;

  			}

  			const keyframes = prepareAnimationData( data, defaultMatrix );

  			const animation = {
  				name: object3D.uuid,
  				keyframes: keyframes
  			};

  			return animation;

  		}

  		function prepareAnimationData( data, defaultMatrix ) {

  			const keyframes = [];

  			// transfer data into a sortable array

  			for ( const time in data ) {

  				keyframes.push( { time: parseFloat( time ), value: data[ time ] } );

  			}

  			// ensure keyframes are sorted by time

  			keyframes.sort( ascending );

  			// now we clean up all animation data, so we can use them for keyframe tracks

  			for ( let i = 0; i < 16; i ++ ) {

  				transformAnimationData( keyframes, i, defaultMatrix.elements[ i ] );

  			}

  			return keyframes;

  			// array sort function

  			function ascending( a, b ) {

  				return a.time - b.time;

  			}

  		}

  		const position = new three$2.Vector3();
  		const scale = new three$2.Vector3();
  		const quaternion = new three$2.Quaternion();

  		function createKeyframeTracks( animation, tracks ) {

  			const keyframes = animation.keyframes;
  			const name = animation.name;

  			const times = [];
  			const positionData = [];
  			const quaternionData = [];
  			const scaleData = [];

  			for ( let i = 0, l = keyframes.length; i < l; i ++ ) {

  				const keyframe = keyframes[ i ];

  				const time = keyframe.time;
  				const value = keyframe.value;

  				matrix.fromArray( value ).transpose();
  				matrix.decompose( position, quaternion, scale );

  				times.push( time );
  				positionData.push( position.x, position.y, position.z );
  				quaternionData.push( quaternion.x, quaternion.y, quaternion.z, quaternion.w );
  				scaleData.push( scale.x, scale.y, scale.z );

  			}

  			if ( positionData.length > 0 ) tracks.push( new three$2.VectorKeyframeTrack( name + '.position', times, positionData ) );
  			if ( quaternionData.length > 0 ) tracks.push( new three$2.QuaternionKeyframeTrack( name + '.quaternion', times, quaternionData ) );
  			if ( scaleData.length > 0 ) tracks.push( new three$2.VectorKeyframeTrack( name + '.scale', times, scaleData ) );

  			return tracks;

  		}

  		function transformAnimationData( keyframes, property, defaultValue ) {

  			let keyframe;

  			let empty = true;
  			let i, l;

  			// check, if values of a property are missing in our keyframes

  			for ( i = 0, l = keyframes.length; i < l; i ++ ) {

  				keyframe = keyframes[ i ];

  				if ( keyframe.value[ property ] === undefined ) {

  					keyframe.value[ property ] = null; // mark as missing

  				} else {

  					empty = false;

  				}

  			}

  			if ( empty === true ) {

  				// no values at all, so we set a default value

  				for ( i = 0, l = keyframes.length; i < l; i ++ ) {

  					keyframe = keyframes[ i ];

  					keyframe.value[ property ] = defaultValue;

  				}

  			} else {

  				// filling gaps

  				createMissingKeyframes( keyframes, property );

  			}

  		}

  		function createMissingKeyframes( keyframes, property ) {

  			let prev, next;

  			for ( let i = 0, l = keyframes.length; i < l; i ++ ) {

  				const keyframe = keyframes[ i ];

  				if ( keyframe.value[ property ] === null ) {

  					prev = getPrev( keyframes, i, property );
  					next = getNext( keyframes, i, property );

  					if ( prev === null ) {

  						keyframe.value[ property ] = next.value[ property ];
  						continue;

  					}

  					if ( next === null ) {

  						keyframe.value[ property ] = prev.value[ property ];
  						continue;

  					}

  					interpolate( keyframe, prev, next, property );

  				}

  			}

  		}

  		function getPrev( keyframes, i, property ) {

  			while ( i >= 0 ) {

  				const keyframe = keyframes[ i ];

  				if ( keyframe.value[ property ] !== null ) return keyframe;

  				i --;

  			}

  			return null;

  		}

  		function getNext( keyframes, i, property ) {

  			while ( i < keyframes.length ) {

  				const keyframe = keyframes[ i ];

  				if ( keyframe.value[ property ] !== null ) return keyframe;

  				i ++;

  			}

  			return null;

  		}

  		function interpolate( key, prev, next, property ) {

  			if ( ( next.time - prev.time ) === 0 ) {

  				key.value[ property ] = prev.value[ property ];
  				return;

  			}

  			key.value[ property ] = ( ( key.time - prev.time ) * ( next.value[ property ] - prev.value[ property ] ) / ( next.time - prev.time ) ) + prev.value[ property ];

  		}

  		// animation clips

  		function parseAnimationClip( xml ) {

  			const data = {
  				name: xml.getAttribute( 'id' ) || 'default',
  				start: parseFloat( xml.getAttribute( 'start' ) || 0 ),
  				end: parseFloat( xml.getAttribute( 'end' ) || 0 ),
  				animations: []
  			};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'instance_animation':
  						data.animations.push( parseId( child.getAttribute( 'url' ) ) );
  						break;

  				}

  			}

  			library.clips[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function buildAnimationClip( data ) {

  			const tracks = [];

  			const name = data.name;
  			const duration = ( data.end - data.start ) || -1;
  			const animations = data.animations;

  			for ( let i = 0, il = animations.length; i < il; i ++ ) {

  				const animationTracks = getAnimation( animations[ i ] );

  				for ( let j = 0, jl = animationTracks.length; j < jl; j ++ ) {

  					tracks.push( animationTracks[ j ] );

  				}

  			}

  			return new three$2.AnimationClip( name, duration, tracks );

  		}

  		function getAnimationClip( id ) {

  			return getBuild( library.clips[ id ], buildAnimationClip );

  		}

  		// controller

  		function parseController( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'skin':
  						// there is exactly one skin per controller
  						data.id = parseId( child.getAttribute( 'source' ) );
  						data.skin = parseSkin( child );
  						break;

  					case 'morph':
  						data.id = parseId( child.getAttribute( 'source' ) );
  						console.warn( 'THREE.ColladaLoader: Morph target animation not supported yet.' );
  						break;

  				}

  			}

  			library.controllers[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function parseSkin( xml ) {

  			const data = {
  				sources: {}
  			};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'bind_shape_matrix':
  						data.bindShapeMatrix = parseFloats( child.textContent );
  						break;

  					case 'source':
  						const id = child.getAttribute( 'id' );
  						data.sources[ id ] = parseSource( child );
  						break;

  					case 'joints':
  						data.joints = parseJoints( child );
  						break;

  					case 'vertex_weights':
  						data.vertexWeights = parseVertexWeights( child );
  						break;

  				}

  			}

  			return data;

  		}

  		function parseJoints( xml ) {

  			const data = {
  				inputs: {}
  			};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'input':
  						const semantic = child.getAttribute( 'semantic' );
  						const id = parseId( child.getAttribute( 'source' ) );
  						data.inputs[ semantic ] = id;
  						break;

  				}

  			}

  			return data;

  		}

  		function parseVertexWeights( xml ) {

  			const data = {
  				inputs: {}
  			};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'input':
  						const semantic = child.getAttribute( 'semantic' );
  						const id = parseId( child.getAttribute( 'source' ) );
  						const offset = parseInt( child.getAttribute( 'offset' ) );
  						data.inputs[ semantic ] = { id: id, offset: offset };
  						break;

  					case 'vcount':
  						data.vcount = parseInts( child.textContent );
  						break;

  					case 'v':
  						data.v = parseInts( child.textContent );
  						break;

  				}

  			}

  			return data;

  		}

  		function buildController( data ) {

  			const build = {
  				id: data.id
  			};

  			const geometry = library.geometries[ build.id ];

  			if ( data.skin !== undefined ) {

  				build.skin = buildSkin( data.skin );

  				// we enhance the 'sources' property of the corresponding geometry with our skin data

  				geometry.sources.skinIndices = build.skin.indices;
  				geometry.sources.skinWeights = build.skin.weights;

  			}

  			return build;

  		}

  		function buildSkin( data ) {

  			const BONE_LIMIT = 4;

  			const build = {
  				joints: [], // this must be an array to preserve the joint order
  				indices: {
  					array: [],
  					stride: BONE_LIMIT
  				},
  				weights: {
  					array: [],
  					stride: BONE_LIMIT
  				}
  			};

  			const sources = data.sources;
  			const vertexWeights = data.vertexWeights;

  			const vcount = vertexWeights.vcount;
  			const v = vertexWeights.v;
  			const jointOffset = vertexWeights.inputs.JOINT.offset;
  			const weightOffset = vertexWeights.inputs.WEIGHT.offset;

  			const jointSource = data.sources[ data.joints.inputs.JOINT ];
  			const inverseSource = data.sources[ data.joints.inputs.INV_BIND_MATRIX ];

  			const weights = sources[ vertexWeights.inputs.WEIGHT.id ].array;
  			let stride = 0;

  			let i, j, l;

  			// process skin data for each vertex

  			for ( i = 0, l = vcount.length; i < l; i ++ ) {

  				const jointCount = vcount[ i ]; // this is the amount of joints that affect a single vertex
  				const vertexSkinData = [];

  				for ( j = 0; j < jointCount; j ++ ) {

  					const skinIndex = v[ stride + jointOffset ];
  					const weightId = v[ stride + weightOffset ];
  					const skinWeight = weights[ weightId ];

  					vertexSkinData.push( { index: skinIndex, weight: skinWeight } );

  					stride += 2;

  				}

  				// we sort the joints in descending order based on the weights.
  				// this ensures, we only procced the most important joints of the vertex

  				vertexSkinData.sort( descending );

  				// now we provide for each vertex a set of four index and weight values.
  				// the order of the skin data matches the order of vertices

  				for ( j = 0; j < BONE_LIMIT; j ++ ) {

  					const d = vertexSkinData[ j ];

  					if ( d !== undefined ) {

  						build.indices.array.push( d.index );
  						build.weights.array.push( d.weight );

  					} else {

  						build.indices.array.push( 0 );
  						build.weights.array.push( 0 );

  					}

  				}

  			}

  			// setup bind matrix

  			if ( data.bindShapeMatrix ) {

  				build.bindMatrix = new three$2.Matrix4().fromArray( data.bindShapeMatrix ).transpose();

  			} else {

  				build.bindMatrix = new three$2.Matrix4().identity();

  			}

  			// process bones and inverse bind matrix data

  			for ( i = 0, l = jointSource.array.length; i < l; i ++ ) {

  				const name = jointSource.array[ i ];
  				const boneInverse = new three$2.Matrix4().fromArray( inverseSource.array, i * inverseSource.stride ).transpose();

  				build.joints.push( { name: name, boneInverse: boneInverse } );

  			}

  			return build;

  			// array sort function

  			function descending( a, b ) {

  				return b.weight - a.weight;

  			}

  		}

  		function getController( id ) {

  			return getBuild( library.controllers[ id ], buildController );

  		}

  		// image

  		function parseImage( xml ) {

  			const data = {
  				init_from: getElementsByTagName( xml, 'init_from' )[ 0 ].textContent
  			};

  			library.images[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function buildImage( data ) {

  			if ( data.build !== undefined ) return data.build;

  			return data.init_from;

  		}

  		function getImage( id ) {

  			const data = library.images[ id ];

  			if ( data !== undefined ) {

  				return getBuild( data, buildImage );

  			}

  			console.warn( 'THREE.ColladaLoader: Couldn\'t find image with ID:', id );

  			return null;

  		}

  		// effect

  		function parseEffect( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'profile_COMMON':
  						data.profile = parseEffectProfileCOMMON( child );
  						break;

  				}

  			}

  			library.effects[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function parseEffectProfileCOMMON( xml ) {

  			const data = {
  				surfaces: {},
  				samplers: {}
  			};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'newparam':
  						parseEffectNewparam( child, data );
  						break;

  					case 'technique':
  						data.technique = parseEffectTechnique( child );
  						break;

  					case 'extra':
  						data.extra = parseEffectExtra( child );
  						break;

  				}

  			}

  			return data;

  		}

  		function parseEffectNewparam( xml, data ) {

  			const sid = xml.getAttribute( 'sid' );

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'surface':
  						data.surfaces[ sid ] = parseEffectSurface( child );
  						break;

  					case 'sampler2D':
  						data.samplers[ sid ] = parseEffectSampler( child );
  						break;

  				}

  			}

  		}

  		function parseEffectSurface( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'init_from':
  						data.init_from = child.textContent;
  						break;

  				}

  			}

  			return data;

  		}

  		function parseEffectSampler( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'source':
  						data.source = child.textContent;
  						break;

  				}

  			}

  			return data;

  		}

  		function parseEffectTechnique( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'constant':
  					case 'lambert':
  					case 'blinn':
  					case 'phong':
  						data.type = child.nodeName;
  						data.parameters = parseEffectParameters( child );
  						break;

  					case 'extra':
  						data.extra = parseEffectExtra( child );
  						break;

  				}

  			}

  			return data;

  		}

  		function parseEffectParameters( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'emission':
  					case 'diffuse':
  					case 'specular':
  					case 'bump':
  					case 'ambient':
  					case 'shininess':
  					case 'transparency':
  						data[ child.nodeName ] = parseEffectParameter( child );
  						break;
  					case 'transparent':
  						data[ child.nodeName ] = {
  							opaque: child.hasAttribute( 'opaque' ) ? child.getAttribute( 'opaque' ) : 'A_ONE',
  							data: parseEffectParameter( child )
  						};
  						break;

  				}

  			}

  			return data;

  		}

  		function parseEffectParameter( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'color':
  						data[ child.nodeName ] = parseFloats( child.textContent );
  						break;

  					case 'float':
  						data[ child.nodeName ] = parseFloat( child.textContent );
  						break;

  					case 'texture':
  						data[ child.nodeName ] = { id: child.getAttribute( 'texture' ), extra: parseEffectParameterTexture( child ) };
  						break;

  				}

  			}

  			return data;

  		}

  		function parseEffectParameterTexture( xml ) {

  			const data = {
  				technique: {}
  			};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'extra':
  						parseEffectParameterTextureExtra( child, data );
  						break;

  				}

  			}

  			return data;

  		}

  		function parseEffectParameterTextureExtra( xml, data ) {

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'technique':
  						parseEffectParameterTextureExtraTechnique( child, data );
  						break;

  				}

  			}

  		}

  		function parseEffectParameterTextureExtraTechnique( xml, data ) {

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'repeatU':
  					case 'repeatV':
  					case 'offsetU':
  					case 'offsetV':
  						data.technique[ child.nodeName ] = parseFloat( child.textContent );
  						break;

  					case 'wrapU':
  					case 'wrapV':

  						// some files have values for wrapU/wrapV which become NaN via parseInt

  						if ( child.textContent.toUpperCase() === 'TRUE' ) {

  							data.technique[ child.nodeName ] = 1;

  						} else if ( child.textContent.toUpperCase() === 'FALSE' ) {

  							data.technique[ child.nodeName ] = 0;

  						} else {

  							data.technique[ child.nodeName ] = parseInt( child.textContent );

  						}

  						break;

  					case 'bump':
  						data[ child.nodeName ] = parseEffectExtraTechniqueBump( child );
  						break;

  				}

  			}

  		}

  		function parseEffectExtra( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'technique':
  						data.technique = parseEffectExtraTechnique( child );
  						break;

  				}

  			}

  			return data;

  		}

  		function parseEffectExtraTechnique( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'double_sided':
  						data[ child.nodeName ] = parseInt( child.textContent );
  						break;

  					case 'bump':
  						data[ child.nodeName ] = parseEffectExtraTechniqueBump( child );
  						break;

  				}

  			}

  			return data;

  		}

  		function parseEffectExtraTechniqueBump( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'texture':
  						data[ child.nodeName ] = { id: child.getAttribute( 'texture' ), texcoord: child.getAttribute( 'texcoord' ), extra: parseEffectParameterTexture( child ) };
  						break;

  				}

  			}

  			return data;

  		}

  		function buildEffect( data ) {

  			return data;

  		}

  		function getEffect( id ) {

  			return getBuild( library.effects[ id ], buildEffect );

  		}

  		// material

  		function parseMaterial( xml ) {

  			const data = {
  				name: xml.getAttribute( 'name' )
  			};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'instance_effect':
  						data.url = parseId( child.getAttribute( 'url' ) );
  						break;

  				}

  			}

  			library.materials[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function getTextureLoader( image ) {

  			let loader;

  			let extension = image.slice( ( image.lastIndexOf( '.' ) - 1 >>> 0 ) + 2 ); // http://www.jstips.co/en/javascript/get-file-extension/
  			extension = extension.toLowerCase();

  			switch ( extension ) {

  				case 'tga':
  					loader = tgaLoader;
  					break;

  				default:
  					loader = textureLoader;

  			}

  			return loader;

  		}

  		function buildMaterial( data ) {

  			const effect = getEffect( data.url );
  			const technique = effect.profile.technique;

  			let material;

  			switch ( technique.type ) {

  				case 'phong':
  				case 'blinn':
  					material = new three$2.MeshPhongMaterial();
  					break;

  				case 'lambert':
  					material = new three$2.MeshLambertMaterial();
  					break;

  				default:
  					material = new three$2.MeshBasicMaterial();
  					break;

  			}

  			material.name = data.name || '';

  			function getTexture( textureObject, colorSpace = null ) {

  				const sampler = effect.profile.samplers[ textureObject.id ];
  				let image = null;

  				// get image

  				if ( sampler !== undefined ) {

  					const surface = effect.profile.surfaces[ sampler.source ];
  					image = getImage( surface.init_from );

  				} else {

  					console.warn( 'THREE.ColladaLoader: Undefined sampler. Access image directly (see #12530).' );
  					image = getImage( textureObject.id );

  				}

  				// create texture if image is avaiable

  				if ( image !== null ) {

  					const loader = getTextureLoader( image );

  					if ( loader !== undefined ) {

  						const texture = loader.load( image );

  						const extra = textureObject.extra;

  						if ( extra !== undefined && extra.technique !== undefined && isEmpty( extra.technique ) === false ) {

  							const technique = extra.technique;

  							texture.wrapS = technique.wrapU ? three$2.RepeatWrapping : three$2.ClampToEdgeWrapping;
  							texture.wrapT = technique.wrapV ? three$2.RepeatWrapping : three$2.ClampToEdgeWrapping;

  							texture.offset.set( technique.offsetU || 0, technique.offsetV || 0 );
  							texture.repeat.set( technique.repeatU || 1, technique.repeatV || 1 );

  						} else {

  							texture.wrapS = three$2.RepeatWrapping;
  							texture.wrapT = three$2.RepeatWrapping;

  						}

  						if ( colorSpace !== null ) {

  							texture.colorSpace = colorSpace;

  						}

  						return texture;

  					} else {

  						console.warn( 'THREE.ColladaLoader: Loader for texture %s not found.', image );

  						return null;

  					}

  				} else {

  					console.warn( 'THREE.ColladaLoader: Couldn\'t create texture with ID:', textureObject.id );

  					return null;

  				}

  			}

  			const parameters = technique.parameters;

  			for ( const key in parameters ) {

  				const parameter = parameters[ key ];

  				switch ( key ) {

  					case 'diffuse':
  						if ( parameter.color ) material.color.fromArray( parameter.color );
  						if ( parameter.texture ) material.map = getTexture( parameter.texture, three$2.SRGBColorSpace );
  						break;
  					case 'specular':
  						if ( parameter.color && material.specular ) material.specular.fromArray( parameter.color );
  						if ( parameter.texture ) material.specularMap = getTexture( parameter.texture );
  						break;
  					case 'bump':
  						if ( parameter.texture ) material.normalMap = getTexture( parameter.texture );
  						break;
  					case 'ambient':
  						if ( parameter.texture ) material.lightMap = getTexture( parameter.texture, three$2.SRGBColorSpace );
  						break;
  					case 'shininess':
  						if ( parameter.float && material.shininess ) material.shininess = parameter.float;
  						break;
  					case 'emission':
  						if ( parameter.color && material.emissive ) material.emissive.fromArray( parameter.color );
  						if ( parameter.texture ) material.emissiveMap = getTexture( parameter.texture, three$2.SRGBColorSpace );
  						break;

  				}

  			}

  			material.color.convertSRGBToLinear();
  			if ( material.specular ) material.specular.convertSRGBToLinear();
  			if ( material.emissive ) material.emissive.convertSRGBToLinear();

  			//

  			let transparent = parameters[ 'transparent' ];
  			let transparency = parameters[ 'transparency' ];

  			// <transparency> does not exist but <transparent>

  			if ( transparency === undefined && transparent ) {

  				transparency = {
  					float: 1
  				};

  			}

  			// <transparent> does not exist but <transparency>

  			if ( transparent === undefined && transparency ) {

  				transparent = {
  					opaque: 'A_ONE',
  					data: {
  						color: [ 1, 1, 1, 1 ]
  					} };

  			}

  			if ( transparent && transparency ) {

  				// handle case if a texture exists but no color

  				if ( transparent.data.texture ) {

  					// we do not set an alpha map (see #13792)

  					material.transparent = true;

  				} else {

  					const color = transparent.data.color;

  					switch ( transparent.opaque ) {

  						case 'A_ONE':
  							material.opacity = color[ 3 ] * transparency.float;
  							break;
  						case 'RGB_ZERO':
  							material.opacity = 1 - ( color[ 0 ] * transparency.float );
  							break;
  						case 'A_ZERO':
  							material.opacity = 1 - ( color[ 3 ] * transparency.float );
  							break;
  						case 'RGB_ONE':
  							material.opacity = color[ 0 ] * transparency.float;
  							break;
  						default:
  							console.warn( 'THREE.ColladaLoader: Invalid opaque type "%s" of transparent tag.', transparent.opaque );

  					}

  					if ( material.opacity < 1 ) material.transparent = true;

  				}

  			}

  			//


  			if ( technique.extra !== undefined && technique.extra.technique !== undefined ) {

  				const techniques = technique.extra.technique;

  				for ( const k in techniques ) {

  					const v = techniques[ k ];

  					switch ( k ) {

  						case 'double_sided':
  							material.side = ( v === 1 ? three$2.DoubleSide : three$2.FrontSide );
  							break;

  						case 'bump':
  							material.normalMap = getTexture( v.texture );
  							material.normalScale = new three$2.Vector2( 1, 1 );
  							break;

  					}

  				}

  			}

  			return material;

  		}

  		function getMaterial( id ) {

  			return getBuild( library.materials[ id ], buildMaterial );

  		}

  		// camera

  		function parseCamera( xml ) {

  			const data = {
  				name: xml.getAttribute( 'name' )
  			};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'optics':
  						data.optics = parseCameraOptics( child );
  						break;

  				}

  			}

  			library.cameras[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function parseCameraOptics( xml ) {

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				switch ( child.nodeName ) {

  					case 'technique_common':
  						return parseCameraTechnique( child );

  				}

  			}

  			return {};

  		}

  		function parseCameraTechnique( xml ) {

  			const data = {};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				switch ( child.nodeName ) {

  					case 'perspective':
  					case 'orthographic':

  						data.technique = child.nodeName;
  						data.parameters = parseCameraParameters( child );

  						break;

  				}

  			}

  			return data;

  		}

  		function parseCameraParameters( xml ) {

  			const data = {};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				switch ( child.nodeName ) {

  					case 'xfov':
  					case 'yfov':
  					case 'xmag':
  					case 'ymag':
  					case 'znear':
  					case 'zfar':
  					case 'aspect_ratio':
  						data[ child.nodeName ] = parseFloat( child.textContent );
  						break;

  				}

  			}

  			return data;

  		}

  		function buildCamera( data ) {

  			let camera;

  			switch ( data.optics.technique ) {

  				case 'perspective':
  					camera = new three$2.PerspectiveCamera(
  						data.optics.parameters.yfov,
  						data.optics.parameters.aspect_ratio,
  						data.optics.parameters.znear,
  						data.optics.parameters.zfar
  					);
  					break;

  				case 'orthographic':
  					let ymag = data.optics.parameters.ymag;
  					let xmag = data.optics.parameters.xmag;
  					const aspectRatio = data.optics.parameters.aspect_ratio;

  					xmag = ( xmag === undefined ) ? ( ymag * aspectRatio ) : xmag;
  					ymag = ( ymag === undefined ) ? ( xmag / aspectRatio ) : ymag;

  					xmag *= 0.5;
  					ymag *= 0.5;

  					camera = new three$2.OrthographicCamera(
  						- xmag, xmag, ymag, - ymag, // left, right, top, bottom
  						data.optics.parameters.znear,
  						data.optics.parameters.zfar
  					);
  					break;

  				default:
  					camera = new three$2.PerspectiveCamera();
  					break;

  			}

  			camera.name = data.name || '';

  			return camera;

  		}

  		function getCamera( id ) {

  			const data = library.cameras[ id ];

  			if ( data !== undefined ) {

  				return getBuild( data, buildCamera );

  			}

  			console.warn( 'THREE.ColladaLoader: Couldn\'t find camera with ID:', id );

  			return null;

  		}

  		// light

  		function parseLight( xml ) {

  			let data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'technique_common':
  						data = parseLightTechnique( child );
  						break;

  				}

  			}

  			library.lights[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function parseLightTechnique( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'directional':
  					case 'point':
  					case 'spot':
  					case 'ambient':

  						data.technique = child.nodeName;
  						data.parameters = parseLightParameters( child );

  				}

  			}

  			return data;

  		}

  		function parseLightParameters( xml ) {

  			const data = {};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'color':
  						const array = parseFloats( child.textContent );
  						data.color = new three$2.Color().fromArray( array ).convertSRGBToLinear();
  						break;

  					case 'falloff_angle':
  						data.falloffAngle = parseFloat( child.textContent );
  						break;

  					case 'quadratic_attenuation':
  						const f = parseFloat( child.textContent );
  						data.distance = f ? Math.sqrt( 1 / f ) : 0;
  						break;

  				}

  			}

  			return data;

  		}

  		function buildLight( data ) {

  			let light;

  			switch ( data.technique ) {

  				case 'directional':
  					light = new three$2.DirectionalLight();
  					break;

  				case 'point':
  					light = new three$2.PointLight();
  					break;

  				case 'spot':
  					light = new three$2.SpotLight();
  					break;

  				case 'ambient':
  					light = new three$2.AmbientLight();
  					break;

  			}

  			if ( data.parameters.color ) light.color.copy( data.parameters.color );
  			if ( data.parameters.distance ) light.distance = data.parameters.distance;

  			return light;

  		}

  		function getLight( id ) {

  			const data = library.lights[ id ];

  			if ( data !== undefined ) {

  				return getBuild( data, buildLight );

  			}

  			console.warn( 'THREE.ColladaLoader: Couldn\'t find light with ID:', id );

  			return null;

  		}

  		// geometry

  		function parseGeometry( xml ) {

  			const data = {
  				name: xml.getAttribute( 'name' ),
  				sources: {},
  				vertices: {},
  				primitives: []
  			};

  			const mesh = getElementsByTagName( xml, 'mesh' )[ 0 ];

  			// the following tags inside geometry are not supported yet (see https://github.com/mrdoob/three.js/pull/12606): convex_mesh, spline, brep
  			if ( mesh === undefined ) return;

  			for ( let i = 0; i < mesh.childNodes.length; i ++ ) {

  				const child = mesh.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				const id = child.getAttribute( 'id' );

  				switch ( child.nodeName ) {

  					case 'source':
  						data.sources[ id ] = parseSource( child );
  						break;

  					case 'vertices':
  						// data.sources[ id ] = data.sources[ parseId( getElementsByTagName( child, 'input' )[ 0 ].getAttribute( 'source' ) ) ];
  						data.vertices = parseGeometryVertices( child );
  						break;

  					case 'polygons':
  						console.warn( 'THREE.ColladaLoader: Unsupported primitive type: ', child.nodeName );
  						break;

  					case 'lines':
  					case 'linestrips':
  					case 'polylist':
  					case 'triangles':
  						data.primitives.push( parseGeometryPrimitive( child ) );
  						break;

  					default:
  						console.log( child );

  				}

  			}

  			library.geometries[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function parseSource( xml ) {

  			const data = {
  				array: [],
  				stride: 3
  			};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'float_array':
  						data.array = parseFloats( child.textContent );
  						break;

  					case 'Name_array':
  						data.array = parseStrings( child.textContent );
  						break;

  					case 'technique_common':
  						const accessor = getElementsByTagName( child, 'accessor' )[ 0 ];

  						if ( accessor !== undefined ) {

  							data.stride = parseInt( accessor.getAttribute( 'stride' ) );

  						}

  						break;

  				}

  			}

  			return data;

  		}

  		function parseGeometryVertices( xml ) {

  			const data = {};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				data[ child.getAttribute( 'semantic' ) ] = parseId( child.getAttribute( 'source' ) );

  			}

  			return data;

  		}

  		function parseGeometryPrimitive( xml ) {

  			const primitive = {
  				type: xml.nodeName,
  				material: xml.getAttribute( 'material' ),
  				count: parseInt( xml.getAttribute( 'count' ) ),
  				inputs: {},
  				stride: 0,
  				hasUV: false
  			};

  			for ( let i = 0, l = xml.childNodes.length; i < l; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'input':
  						const id = parseId( child.getAttribute( 'source' ) );
  						const semantic = child.getAttribute( 'semantic' );
  						const offset = parseInt( child.getAttribute( 'offset' ) );
  						const set = parseInt( child.getAttribute( 'set' ) );
  						const inputname = ( set > 0 ? semantic + set : semantic );
  						primitive.inputs[ inputname ] = { id: id, offset: offset };
  						primitive.stride = Math.max( primitive.stride, offset + 1 );
  						if ( semantic === 'TEXCOORD' ) primitive.hasUV = true;
  						break;

  					case 'vcount':
  						primitive.vcount = parseInts( child.textContent );
  						break;

  					case 'p':
  						primitive.p = parseInts( child.textContent );
  						break;

  				}

  			}

  			return primitive;

  		}

  		function groupPrimitives( primitives ) {

  			const build = {};

  			for ( let i = 0; i < primitives.length; i ++ ) {

  				const primitive = primitives[ i ];

  				if ( build[ primitive.type ] === undefined ) build[ primitive.type ] = [];

  				build[ primitive.type ].push( primitive );

  			}

  			return build;

  		}

  		function checkUVCoordinates( primitives ) {

  			let count = 0;

  			for ( let i = 0, l = primitives.length; i < l; i ++ ) {

  				const primitive = primitives[ i ];

  				if ( primitive.hasUV === true ) {

  					count ++;

  				}

  			}

  			if ( count > 0 && count < primitives.length ) {

  				primitives.uvsNeedsFix = true;

  			}

  		}

  		function buildGeometry( data ) {

  			const build = {};

  			const sources = data.sources;
  			const vertices = data.vertices;
  			const primitives = data.primitives;

  			if ( primitives.length === 0 ) return {};

  			// our goal is to create one buffer geometry for a single type of primitives
  			// first, we group all primitives by their type

  			const groupedPrimitives = groupPrimitives( primitives );

  			for ( const type in groupedPrimitives ) {

  				const primitiveType = groupedPrimitives[ type ];

  				// second, ensure consistent uv coordinates for each type of primitives (polylist,triangles or lines)

  				checkUVCoordinates( primitiveType );

  				// third, create a buffer geometry for each type of primitives

  				build[ type ] = buildGeometryType( primitiveType, sources, vertices );

  			}

  			return build;

  		}

  		function buildGeometryType( primitives, sources, vertices ) {

  			const build = {};

  			const position = { array: [], stride: 0 };
  			const normal = { array: [], stride: 0 };
  			const uv = { array: [], stride: 0 };
  			const uv1 = { array: [], stride: 0 };
  			const color = { array: [], stride: 0 };

  			const skinIndex = { array: [], stride: 4 };
  			const skinWeight = { array: [], stride: 4 };

  			const geometry = new three$2.BufferGeometry();

  			const materialKeys = [];

  			let start = 0;

  			for ( let p = 0; p < primitives.length; p ++ ) {

  				const primitive = primitives[ p ];
  				const inputs = primitive.inputs;

  				// groups

  				let count = 0;

  				switch ( primitive.type ) {

  					case 'lines':
  					case 'linestrips':
  						count = primitive.count * 2;
  						break;

  					case 'triangles':
  						count = primitive.count * 3;
  						break;

  					case 'polylist':

  						for ( let g = 0; g < primitive.count; g ++ ) {

  							const vc = primitive.vcount[ g ];

  							switch ( vc ) {

  								case 3:
  									count += 3; // single triangle
  									break;

  								case 4:
  									count += 6; // quad, subdivided into two triangles
  									break;

  								default:
  									count += ( vc - 2 ) * 3; // polylist with more than four vertices
  									break;

  							}

  						}

  						break;

  					default:
  						console.warn( 'THREE.ColladaLoader: Unknow primitive type:', primitive.type );

  				}

  				geometry.addGroup( start, count, p );
  				start += count;

  				// material

  				if ( primitive.material ) {

  					materialKeys.push( primitive.material );

  				}

  				// geometry data

  				for ( const name in inputs ) {

  					const input = inputs[ name ];

  					switch ( name )	{

  						case 'VERTEX':
  							for ( const key in vertices ) {

  								const id = vertices[ key ];

  								switch ( key ) {

  									case 'POSITION':
  										const prevLength = position.array.length;
  										buildGeometryData( primitive, sources[ id ], input.offset, position.array );
  										position.stride = sources[ id ].stride;

  										if ( sources.skinWeights && sources.skinIndices ) {

  											buildGeometryData( primitive, sources.skinIndices, input.offset, skinIndex.array );
  											buildGeometryData( primitive, sources.skinWeights, input.offset, skinWeight.array );

  										}

  										// see #3803

  										if ( primitive.hasUV === false && primitives.uvsNeedsFix === true ) {

  											const count = ( position.array.length - prevLength ) / position.stride;

  											for ( let i = 0; i < count; i ++ ) {

  												// fill missing uv coordinates

  												uv.array.push( 0, 0 );

  											}

  										}

  										break;

  									case 'NORMAL':
  										buildGeometryData( primitive, sources[ id ], input.offset, normal.array );
  										normal.stride = sources[ id ].stride;
  										break;

  									case 'COLOR':
  										buildGeometryData( primitive, sources[ id ], input.offset, color.array );
  										color.stride = sources[ id ].stride;
  										break;

  									case 'TEXCOORD':
  										buildGeometryData( primitive, sources[ id ], input.offset, uv.array );
  										uv.stride = sources[ id ].stride;
  										break;

  									case 'TEXCOORD1':
  										buildGeometryData( primitive, sources[ id ], input.offset, uv1.array );
  										uv.stride = sources[ id ].stride;
  										break;

  									default:
  										console.warn( 'THREE.ColladaLoader: Semantic "%s" not handled in geometry build process.', key );

  								}

  							}

  							break;

  						case 'NORMAL':
  							buildGeometryData( primitive, sources[ input.id ], input.offset, normal.array );
  							normal.stride = sources[ input.id ].stride;
  							break;

  						case 'COLOR':
  							buildGeometryData( primitive, sources[ input.id ], input.offset, color.array, true );
  							color.stride = sources[ input.id ].stride;
  							break;

  						case 'TEXCOORD':
  							buildGeometryData( primitive, sources[ input.id ], input.offset, uv.array );
  							uv.stride = sources[ input.id ].stride;
  							break;

  						case 'TEXCOORD1':
  							buildGeometryData( primitive, sources[ input.id ], input.offset, uv1.array );
  							uv1.stride = sources[ input.id ].stride;
  							break;

  					}

  				}

  			}

  			// build geometry

  			if ( position.array.length > 0 ) geometry.setAttribute( 'position', new three$2.Float32BufferAttribute( position.array, position.stride ) );
  			if ( normal.array.length > 0 ) geometry.setAttribute( 'normal', new three$2.Float32BufferAttribute( normal.array, normal.stride ) );
  			if ( color.array.length > 0 ) geometry.setAttribute( 'color', new three$2.Float32BufferAttribute( color.array, color.stride ) );
  			if ( uv.array.length > 0 ) geometry.setAttribute( 'uv', new three$2.Float32BufferAttribute( uv.array, uv.stride ) );
  			if ( uv1.array.length > 0 ) geometry.setAttribute( 'uv1', new three$2.Float32BufferAttribute( uv1.array, uv1.stride ) );

  			if ( skinIndex.array.length > 0 ) geometry.setAttribute( 'skinIndex', new three$2.Float32BufferAttribute( skinIndex.array, skinIndex.stride ) );
  			if ( skinWeight.array.length > 0 ) geometry.setAttribute( 'skinWeight', new three$2.Float32BufferAttribute( skinWeight.array, skinWeight.stride ) );

  			build.data = geometry;
  			build.type = primitives[ 0 ].type;
  			build.materialKeys = materialKeys;

  			return build;

  		}

  		function buildGeometryData( primitive, source, offset, array, isColor = false ) {

  			const indices = primitive.p;
  			const stride = primitive.stride;
  			const vcount = primitive.vcount;

  			function pushVector( i ) {

  				let index = indices[ i + offset ] * sourceStride;
  				const length = index + sourceStride;

  				for ( ; index < length; index ++ ) {

  					array.push( sourceArray[ index ] );

  				}

  				if ( isColor ) {

  					// convert the vertex colors from srgb to linear if present
  					const startIndex = array.length - sourceStride - 1;
  					tempColor.setRGB(
  						array[ startIndex + 0 ],
  						array[ startIndex + 1 ],
  						array[ startIndex + 2 ]
  					).convertSRGBToLinear();

  					array[ startIndex + 0 ] = tempColor.r;
  					array[ startIndex + 1 ] = tempColor.g;
  					array[ startIndex + 2 ] = tempColor.b;

  				}

  			}

  			const sourceArray = source.array;
  			const sourceStride = source.stride;

  			if ( primitive.vcount !== undefined ) {

  				let index = 0;

  				for ( let i = 0, l = vcount.length; i < l; i ++ ) {

  					const count = vcount[ i ];

  					if ( count === 4 ) {

  						const a = index + stride * 0;
  						const b = index + stride * 1;
  						const c = index + stride * 2;
  						const d = index + stride * 3;

  						pushVector( a ); pushVector( b ); pushVector( d );
  						pushVector( b ); pushVector( c ); pushVector( d );

  					} else if ( count === 3 ) {

  						const a = index + stride * 0;
  						const b = index + stride * 1;
  						const c = index + stride * 2;

  						pushVector( a ); pushVector( b ); pushVector( c );

  					} else if ( count > 4 ) {

  						for ( let k = 1, kl = ( count - 2 ); k <= kl; k ++ ) {

  							const a = index + stride * 0;
  							const b = index + stride * k;
  							const c = index + stride * ( k + 1 );

  							pushVector( a ); pushVector( b ); pushVector( c );

  						}

  					}

  					index += stride * count;

  				}

  			} else {

  				for ( let i = 0, l = indices.length; i < l; i += stride ) {

  					pushVector( i );

  				}

  			}

  		}

  		function getGeometry( id ) {

  			return getBuild( library.geometries[ id ], buildGeometry );

  		}

  		// kinematics

  		function parseKinematicsModel( xml ) {

  			const data = {
  				name: xml.getAttribute( 'name' ) || '',
  				joints: {},
  				links: []
  			};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'technique_common':
  						parseKinematicsTechniqueCommon( child, data );
  						break;

  				}

  			}

  			library.kinematicsModels[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function buildKinematicsModel( data ) {

  			if ( data.build !== undefined ) return data.build;

  			return data;

  		}

  		function getKinematicsModel( id ) {

  			return getBuild( library.kinematicsModels[ id ], buildKinematicsModel );

  		}

  		function parseKinematicsTechniqueCommon( xml, data ) {

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'joint':
  						data.joints[ child.getAttribute( 'sid' ) ] = parseKinematicsJoint( child );
  						break;

  					case 'link':
  						data.links.push( parseKinematicsLink( child ) );
  						break;

  				}

  			}

  		}

  		function parseKinematicsJoint( xml ) {

  			let data;

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'prismatic':
  					case 'revolute':
  						data = parseKinematicsJointParameter( child );
  						break;

  				}

  			}

  			return data;

  		}

  		function parseKinematicsJointParameter( xml ) {

  			const data = {
  				sid: xml.getAttribute( 'sid' ),
  				name: xml.getAttribute( 'name' ) || '',
  				axis: new three$2.Vector3(),
  				limits: {
  					min: 0,
  					max: 0
  				},
  				type: xml.nodeName,
  				static: false,
  				zeroPosition: 0,
  				middlePosition: 0
  			};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'axis':
  						const array = parseFloats( child.textContent );
  						data.axis.fromArray( array );
  						break;
  					case 'limits':
  						const max = child.getElementsByTagName( 'max' )[ 0 ];
  						const min = child.getElementsByTagName( 'min' )[ 0 ];

  						data.limits.max = parseFloat( max.textContent );
  						data.limits.min = parseFloat( min.textContent );
  						break;

  				}

  			}

  			// if min is equal to or greater than max, consider the joint static

  			if ( data.limits.min >= data.limits.max ) {

  				data.static = true;

  			}

  			// calculate middle position

  			data.middlePosition = ( data.limits.min + data.limits.max ) / 2.0;

  			return data;

  		}

  		function parseKinematicsLink( xml ) {

  			const data = {
  				sid: xml.getAttribute( 'sid' ),
  				name: xml.getAttribute( 'name' ) || '',
  				attachments: [],
  				transforms: []
  			};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'attachment_full':
  						data.attachments.push( parseKinematicsAttachment( child ) );
  						break;

  					case 'matrix':
  					case 'translate':
  					case 'rotate':
  						data.transforms.push( parseKinematicsTransform( child ) );
  						break;

  				}

  			}

  			return data;

  		}

  		function parseKinematicsAttachment( xml ) {

  			const data = {
  				joint: xml.getAttribute( 'joint' ).split( '/' ).pop(),
  				transforms: [],
  				links: []
  			};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'link':
  						data.links.push( parseKinematicsLink( child ) );
  						break;

  					case 'matrix':
  					case 'translate':
  					case 'rotate':
  						data.transforms.push( parseKinematicsTransform( child ) );
  						break;

  				}

  			}

  			return data;

  		}

  		function parseKinematicsTransform( xml ) {

  			const data = {
  				type: xml.nodeName
  			};

  			const array = parseFloats( xml.textContent );

  			switch ( data.type ) {

  				case 'matrix':
  					data.obj = new three$2.Matrix4();
  					data.obj.fromArray( array ).transpose();
  					break;

  				case 'translate':
  					data.obj = new three$2.Vector3();
  					data.obj.fromArray( array );
  					break;

  				case 'rotate':
  					data.obj = new three$2.Vector3();
  					data.obj.fromArray( array );
  					data.angle = three$2.MathUtils.degToRad( array[ 3 ] );
  					break;

  			}

  			return data;

  		}

  		// physics

  		function parsePhysicsModel( xml ) {

  			const data = {
  				name: xml.getAttribute( 'name' ) || '',
  				rigidBodies: {}
  			};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'rigid_body':
  						data.rigidBodies[ child.getAttribute( 'name' ) ] = {};
  						parsePhysicsRigidBody( child, data.rigidBodies[ child.getAttribute( 'name' ) ] );
  						break;

  				}

  			}

  			library.physicsModels[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function parsePhysicsRigidBody( xml, data ) {

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'technique_common':
  						parsePhysicsTechniqueCommon( child, data );
  						break;

  				}

  			}

  		}

  		function parsePhysicsTechniqueCommon( xml, data ) {

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'inertia':
  						data.inertia = parseFloats( child.textContent );
  						break;

  					case 'mass':
  						data.mass = parseFloats( child.textContent )[ 0 ];
  						break;

  				}

  			}

  		}

  		// scene

  		function parseKinematicsScene( xml ) {

  			const data = {
  				bindJointAxis: []
  			};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'bind_joint_axis':
  						data.bindJointAxis.push( parseKinematicsBindJointAxis( child ) );
  						break;

  				}

  			}

  			library.kinematicsScenes[ parseId( xml.getAttribute( 'url' ) ) ] = data;

  		}

  		function parseKinematicsBindJointAxis( xml ) {

  			const data = {
  				target: xml.getAttribute( 'target' ).split( '/' ).pop()
  			};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				switch ( child.nodeName ) {

  					case 'axis':
  						const param = child.getElementsByTagName( 'param' )[ 0 ];
  						data.axis = param.textContent;
  						const tmpJointIndex = data.axis.split( 'inst_' ).pop().split( 'axis' )[ 0 ];
  						data.jointIndex = tmpJointIndex.substring( 0, tmpJointIndex.length - 1 );
  						break;

  				}

  			}

  			return data;

  		}

  		function buildKinematicsScene( data ) {

  			if ( data.build !== undefined ) return data.build;

  			return data;

  		}

  		function getKinematicsScene( id ) {

  			return getBuild( library.kinematicsScenes[ id ], buildKinematicsScene );

  		}

  		function setupKinematics() {

  			const kinematicsModelId = Object.keys( library.kinematicsModels )[ 0 ];
  			const kinematicsSceneId = Object.keys( library.kinematicsScenes )[ 0 ];
  			const visualSceneId = Object.keys( library.visualScenes )[ 0 ];

  			if ( kinematicsModelId === undefined || kinematicsSceneId === undefined ) return;

  			const kinematicsModel = getKinematicsModel( kinematicsModelId );
  			const kinematicsScene = getKinematicsScene( kinematicsSceneId );
  			const visualScene = getVisualScene( visualSceneId );

  			const bindJointAxis = kinematicsScene.bindJointAxis;
  			const jointMap = {};

  			for ( let i = 0, l = bindJointAxis.length; i < l; i ++ ) {

  				const axis = bindJointAxis[ i ];

  				// the result of the following query is an element of type 'translate', 'rotate','scale' or 'matrix'

  				const targetElement = collada.querySelector( '[sid="' + axis.target + '"]' );

  				if ( targetElement ) {

  					// get the parent of the transform element

  					const parentVisualElement = targetElement.parentElement;

  					// connect the joint of the kinematics model with the element in the visual scene

  					connect( axis.jointIndex, parentVisualElement );

  				}

  			}

  			function connect( jointIndex, visualElement ) {

  				const visualElementName = visualElement.getAttribute( 'name' );
  				const joint = kinematicsModel.joints[ jointIndex ];

  				visualScene.traverse( function ( object ) {

  					if ( object.name === visualElementName ) {

  						jointMap[ jointIndex ] = {
  							object: object,
  							transforms: buildTransformList( visualElement ),
  							joint: joint,
  							position: joint.zeroPosition
  						};

  					}

  				} );

  			}

  			const m0 = new three$2.Matrix4();

  			kinematics = {

  				joints: kinematicsModel && kinematicsModel.joints,

  				getJointValue: function ( jointIndex ) {

  					const jointData = jointMap[ jointIndex ];

  					if ( jointData ) {

  						return jointData.position;

  					} else {

  						console.warn( 'THREE.ColladaLoader: Joint ' + jointIndex + ' doesn\'t exist.' );

  					}

  				},

  				setJointValue: function ( jointIndex, value ) {

  					const jointData = jointMap[ jointIndex ];

  					if ( jointData ) {

  						const joint = jointData.joint;

  						if ( value > joint.limits.max || value < joint.limits.min ) {

  							console.warn( 'THREE.ColladaLoader: Joint ' + jointIndex + ' value ' + value + ' outside of limits (min: ' + joint.limits.min + ', max: ' + joint.limits.max + ').' );

  						} else if ( joint.static ) {

  							console.warn( 'THREE.ColladaLoader: Joint ' + jointIndex + ' is static.' );

  						} else {

  							const object = jointData.object;
  							const axis = joint.axis;
  							const transforms = jointData.transforms;

  							matrix.identity();

  							// each update, we have to apply all transforms in the correct order

  							for ( let i = 0; i < transforms.length; i ++ ) {

  								const transform = transforms[ i ];

  								// if there is a connection of the transform node with a joint, apply the joint value

  								if ( transform.sid && transform.sid.indexOf( jointIndex ) !== -1 ) {

  									switch ( joint.type ) {

  										case 'revolute':
  											matrix.multiply( m0.makeRotationAxis( axis, three$2.MathUtils.degToRad( value ) ) );
  											break;

  										case 'prismatic':
  											matrix.multiply( m0.makeTranslation( axis.x * value, axis.y * value, axis.z * value ) );
  											break;

  										default:
  											console.warn( 'THREE.ColladaLoader: Unknown joint type: ' + joint.type );
  											break;

  									}

  								} else {

  									switch ( transform.type ) {

  										case 'matrix':
  											matrix.multiply( transform.obj );
  											break;

  										case 'translate':
  											matrix.multiply( m0.makeTranslation( transform.obj.x, transform.obj.y, transform.obj.z ) );
  											break;

  										case 'scale':
  											matrix.scale( transform.obj );
  											break;

  										case 'rotate':
  											matrix.multiply( m0.makeRotationAxis( transform.obj, transform.angle ) );
  											break;

  									}

  								}

  							}

  							object.matrix.copy( matrix );
  							object.matrix.decompose( object.position, object.quaternion, object.scale );

  							jointMap[ jointIndex ].position = value;

  						}

  					} else {

  						console.log( 'THREE.ColladaLoader: ' + jointIndex + ' does not exist.' );

  					}

  				}

  			};

  		}

  		function buildTransformList( node ) {

  			const transforms = [];

  			const xml = collada.querySelector( '[id="' + node.id + '"]' );

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				let array, vector;

  				switch ( child.nodeName ) {

  					case 'matrix':
  						array = parseFloats( child.textContent );
  						const matrix = new three$2.Matrix4().fromArray( array ).transpose();
  						transforms.push( {
  							sid: child.getAttribute( 'sid' ),
  							type: child.nodeName,
  							obj: matrix
  						} );
  						break;

  					case 'translate':
  					case 'scale':
  						array = parseFloats( child.textContent );
  						vector = new three$2.Vector3().fromArray( array );
  						transforms.push( {
  							sid: child.getAttribute( 'sid' ),
  							type: child.nodeName,
  							obj: vector
  						} );
  						break;

  					case 'rotate':
  						array = parseFloats( child.textContent );
  						vector = new three$2.Vector3().fromArray( array );
  						const angle = three$2.MathUtils.degToRad( array[ 3 ] );
  						transforms.push( {
  							sid: child.getAttribute( 'sid' ),
  							type: child.nodeName,
  							obj: vector,
  							angle: angle
  						} );
  						break;

  				}

  			}

  			return transforms;

  		}

  		// nodes

  		function prepareNodes( xml ) {

  			const elements = xml.getElementsByTagName( 'node' );

  			// ensure all node elements have id attributes

  			for ( let i = 0; i < elements.length; i ++ ) {

  				const element = elements[ i ];

  				if ( element.hasAttribute( 'id' ) === false ) {

  					element.setAttribute( 'id', generateId() );

  				}

  			}

  		}

  		const matrix = new three$2.Matrix4();
  		const vector = new three$2.Vector3();

  		function parseNode( xml ) {

  			const data = {
  				name: xml.getAttribute( 'name' ) || '',
  				type: xml.getAttribute( 'type' ),
  				id: xml.getAttribute( 'id' ),
  				sid: xml.getAttribute( 'sid' ),
  				matrix: new three$2.Matrix4(),
  				nodes: [],
  				instanceCameras: [],
  				instanceControllers: [],
  				instanceLights: [],
  				instanceGeometries: [],
  				instanceNodes: [],
  				transforms: {}
  			};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				if ( child.nodeType !== 1 ) continue;

  				let array;

  				switch ( child.nodeName ) {

  					case 'node':
  						data.nodes.push( child.getAttribute( 'id' ) );
  						parseNode( child );
  						break;

  					case 'instance_camera':
  						data.instanceCameras.push( parseId( child.getAttribute( 'url' ) ) );
  						break;

  					case 'instance_controller':
  						data.instanceControllers.push( parseNodeInstance( child ) );
  						break;

  					case 'instance_light':
  						data.instanceLights.push( parseId( child.getAttribute( 'url' ) ) );
  						break;

  					case 'instance_geometry':
  						data.instanceGeometries.push( parseNodeInstance( child ) );
  						break;

  					case 'instance_node':
  						data.instanceNodes.push( parseId( child.getAttribute( 'url' ) ) );
  						break;

  					case 'matrix':
  						array = parseFloats( child.textContent );
  						data.matrix.multiply( matrix.fromArray( array ).transpose() );
  						data.transforms[ child.getAttribute( 'sid' ) ] = child.nodeName;
  						break;

  					case 'translate':
  						array = parseFloats( child.textContent );
  						vector.fromArray( array );
  						data.matrix.multiply( matrix.makeTranslation( vector.x, vector.y, vector.z ) );
  						data.transforms[ child.getAttribute( 'sid' ) ] = child.nodeName;
  						break;

  					case 'rotate':
  						array = parseFloats( child.textContent );
  						const angle = three$2.MathUtils.degToRad( array[ 3 ] );
  						data.matrix.multiply( matrix.makeRotationAxis( vector.fromArray( array ), angle ) );
  						data.transforms[ child.getAttribute( 'sid' ) ] = child.nodeName;
  						break;

  					case 'scale':
  						array = parseFloats( child.textContent );
  						data.matrix.scale( vector.fromArray( array ) );
  						data.transforms[ child.getAttribute( 'sid' ) ] = child.nodeName;
  						break;

  					case 'extra':
  						break;

  					default:
  						console.log( child );

  				}

  			}

  			if ( hasNode( data.id ) ) {

  				console.warn( 'THREE.ColladaLoader: There is already a node with ID %s. Exclude current node from further processing.', data.id );

  			} else {

  				library.nodes[ data.id ] = data;

  			}

  			return data;

  		}

  		function parseNodeInstance( xml ) {

  			const data = {
  				id: parseId( xml.getAttribute( 'url' ) ),
  				materials: {},
  				skeletons: []
  			};

  			for ( let i = 0; i < xml.childNodes.length; i ++ ) {

  				const child = xml.childNodes[ i ];

  				switch ( child.nodeName ) {

  					case 'bind_material':
  						const instances = child.getElementsByTagName( 'instance_material' );

  						for ( let j = 0; j < instances.length; j ++ ) {

  							const instance = instances[ j ];
  							const symbol = instance.getAttribute( 'symbol' );
  							const target = instance.getAttribute( 'target' );

  							data.materials[ symbol ] = parseId( target );

  						}

  						break;

  					case 'skeleton':
  						data.skeletons.push( parseId( child.textContent ) );
  						break;

  				}

  			}

  			return data;

  		}

  		function buildSkeleton( skeletons, joints ) {

  			const boneData = [];
  			const sortedBoneData = [];

  			let i, j, data;

  			// a skeleton can have multiple root bones. collada expresses this
  			// situtation with multiple "skeleton" tags per controller instance

  			for ( i = 0; i < skeletons.length; i ++ ) {

  				const skeleton = skeletons[ i ];

  				let root;

  				if ( hasNode( skeleton ) ) {

  					root = getNode( skeleton );
  					buildBoneHierarchy( root, joints, boneData );

  				} else if ( hasVisualScene( skeleton ) ) {

  					// handle case where the skeleton refers to the visual scene (#13335)

  					const visualScene = library.visualScenes[ skeleton ];
  					const children = visualScene.children;

  					for ( let j = 0; j < children.length; j ++ ) {

  						const child = children[ j ];

  						if ( child.type === 'JOINT' ) {

  							const root = getNode( child.id );
  							buildBoneHierarchy( root, joints, boneData );

  						}

  					}

  				} else {

  					console.error( 'THREE.ColladaLoader: Unable to find root bone of skeleton with ID:', skeleton );

  				}

  			}

  			// sort bone data (the order is defined in the corresponding controller)

  			for ( i = 0; i < joints.length; i ++ ) {

  				for ( j = 0; j < boneData.length; j ++ ) {

  					data = boneData[ j ];

  					if ( data.bone.name === joints[ i ].name ) {

  						sortedBoneData[ i ] = data;
  						data.processed = true;
  						break;

  					}

  				}

  			}

  			// add unprocessed bone data at the end of the list

  			for ( i = 0; i < boneData.length; i ++ ) {

  				data = boneData[ i ];

  				if ( data.processed === false ) {

  					sortedBoneData.push( data );
  					data.processed = true;

  				}

  			}

  			// setup arrays for skeleton creation

  			const bones = [];
  			const boneInverses = [];

  			for ( i = 0; i < sortedBoneData.length; i ++ ) {

  				data = sortedBoneData[ i ];

  				bones.push( data.bone );
  				boneInverses.push( data.boneInverse );

  			}

  			return new three$2.Skeleton( bones, boneInverses );

  		}

  		function buildBoneHierarchy( root, joints, boneData ) {

  			// setup bone data from visual scene

  			root.traverse( function ( object ) {

  				if ( object.isBone === true ) {

  					let boneInverse;

  					// retrieve the boneInverse from the controller data

  					for ( let i = 0; i < joints.length; i ++ ) {

  						const joint = joints[ i ];

  						if ( joint.name === object.name ) {

  							boneInverse = joint.boneInverse;
  							break;

  						}

  					}

  					if ( boneInverse === undefined ) {

  						// Unfortunately, there can be joints in the visual scene that are not part of the
  						// corresponding controller. In this case, we have to create a dummy boneInverse matrix
  						// for the respective bone. This bone won't affect any vertices, because there are no skin indices
  						// and weights defined for it. But we still have to add the bone to the sorted bone list in order to
  						// ensure a correct animation of the model.

  						boneInverse = new three$2.Matrix4();

  					}

  					boneData.push( { bone: object, boneInverse: boneInverse, processed: false } );

  				}

  			} );

  		}

  		function buildNode( data ) {

  			const objects = [];

  			const matrix = data.matrix;
  			const nodes = data.nodes;
  			const type = data.type;
  			const instanceCameras = data.instanceCameras;
  			const instanceControllers = data.instanceControllers;
  			const instanceLights = data.instanceLights;
  			const instanceGeometries = data.instanceGeometries;
  			const instanceNodes = data.instanceNodes;

  			// nodes

  			for ( let i = 0, l = nodes.length; i < l; i ++ ) {

  				objects.push( getNode( nodes[ i ] ) );

  			}

  			// instance cameras

  			for ( let i = 0, l = instanceCameras.length; i < l; i ++ ) {

  				const instanceCamera = getCamera( instanceCameras[ i ] );

  				if ( instanceCamera !== null ) {

  					objects.push( instanceCamera.clone() );

  				}

  			}

  			// instance controllers

  			for ( let i = 0, l = instanceControllers.length; i < l; i ++ ) {

  				const instance = instanceControllers[ i ];
  				const controller = getController( instance.id );
  				const geometries = getGeometry( controller.id );
  				const newObjects = buildObjects( geometries, instance.materials );

  				const skeletons = instance.skeletons;
  				const joints = controller.skin.joints;

  				const skeleton = buildSkeleton( skeletons, joints );

  				for ( let j = 0, jl = newObjects.length; j < jl; j ++ ) {

  					const object = newObjects[ j ];

  					if ( object.isSkinnedMesh ) {

  						object.bind( skeleton, controller.skin.bindMatrix );
  						object.normalizeSkinWeights();

  					}

  					objects.push( object );

  				}

  			}

  			// instance lights

  			for ( let i = 0, l = instanceLights.length; i < l; i ++ ) {

  				const instanceLight = getLight( instanceLights[ i ] );

  				if ( instanceLight !== null ) {

  					objects.push( instanceLight.clone() );

  				}

  			}

  			// instance geometries

  			for ( let i = 0, l = instanceGeometries.length; i < l; i ++ ) {

  				const instance = instanceGeometries[ i ];

  				// a single geometry instance in collada can lead to multiple object3Ds.
  				// this is the case when primitives are combined like triangles and lines

  				const geometries = getGeometry( instance.id );
  				const newObjects = buildObjects( geometries, instance.materials );

  				for ( let j = 0, jl = newObjects.length; j < jl; j ++ ) {

  					objects.push( newObjects[ j ] );

  				}

  			}

  			// instance nodes

  			for ( let i = 0, l = instanceNodes.length; i < l; i ++ ) {

  				objects.push( getNode( instanceNodes[ i ] ).clone() );

  			}

  			let object;

  			if ( nodes.length === 0 && objects.length === 1 ) {

  				object = objects[ 0 ];

  			} else {

  				object = ( type === 'JOINT' ) ? new three$2.Bone() : new three$2.Group();

  				for ( let i = 0; i < objects.length; i ++ ) {

  					object.add( objects[ i ] );

  				}

  			}

  			object.name = ( type === 'JOINT' ) ? data.sid : data.name;
  			object.matrix.copy( matrix );
  			object.matrix.decompose( object.position, object.quaternion, object.scale );

  			return object;

  		}

  		const fallbackMaterial = new three$2.MeshBasicMaterial( {
  			name: three$2.Loader.DEFAULT_MATERIAL_NAME,
  			color: 0xff00ff
  		} );

  		function resolveMaterialBinding( keys, instanceMaterials ) {

  			const materials = [];

  			for ( let i = 0, l = keys.length; i < l; i ++ ) {

  				const id = instanceMaterials[ keys[ i ] ];

  				if ( id === undefined ) {

  					console.warn( 'THREE.ColladaLoader: Material with key %s not found. Apply fallback material.', keys[ i ] );
  					materials.push( fallbackMaterial );

  				} else {

  					materials.push( getMaterial( id ) );

  				}

  			}

  			return materials;

  		}

  		function buildObjects( geometries, instanceMaterials ) {

  			const objects = [];

  			for ( const type in geometries ) {

  				const geometry = geometries[ type ];

  				const materials = resolveMaterialBinding( geometry.materialKeys, instanceMaterials );

  				// handle case if no materials are defined

  				if ( materials.length === 0 ) {

  					if ( type === 'lines' || type === 'linestrips' ) {

  						materials.push( new three$2.LineBasicMaterial() );

  					} else {

  						materials.push( new three$2.MeshPhongMaterial() );

  					}

  				}

  				// Collada allows to use phong and lambert materials with lines. Replacing these cases with LineBasicMaterial.

  				if ( type === 'lines' || type === 'linestrips' ) {

  					for ( let i = 0, l = materials.length; i < l; i ++ ) {

  						const material = materials[ i ];

  						if ( material.isMeshPhongMaterial === true || material.isMeshLambertMaterial === true ) {

  							const lineMaterial = new three$2.LineBasicMaterial();

  							// copy compatible properties

  							lineMaterial.color.copy( material.color );
  							lineMaterial.opacity = material.opacity;
  							lineMaterial.transparent = material.transparent;

  							// replace material

  							materials[ i ] = lineMaterial;

  						}

  					}

  				}

  				// regard skinning

  				const skinning = ( geometry.data.attributes.skinIndex !== undefined );

  				// choose between a single or multi materials (material array)

  				const material = ( materials.length === 1 ) ? materials[ 0 ] : materials;

  				// now create a specific 3D object

  				let object;

  				switch ( type ) {

  					case 'lines':
  						object = new three$2.LineSegments( geometry.data, material );
  						break;

  					case 'linestrips':
  						object = new three$2.Line( geometry.data, material );
  						break;

  					case 'triangles':
  					case 'polylist':
  						if ( skinning ) {

  							object = new three$2.SkinnedMesh( geometry.data, material );

  						} else {

  							object = new three$2.Mesh( geometry.data, material );

  						}

  						break;

  				}

  				objects.push( object );

  			}

  			return objects;

  		}

  		function hasNode( id ) {

  			return library.nodes[ id ] !== undefined;

  		}

  		function getNode( id ) {

  			return getBuild( library.nodes[ id ], buildNode );

  		}

  		// visual scenes

  		function parseVisualScene( xml ) {

  			const data = {
  				name: xml.getAttribute( 'name' ),
  				children: []
  			};

  			prepareNodes( xml );

  			const elements = getElementsByTagName( xml, 'node' );

  			for ( let i = 0; i < elements.length; i ++ ) {

  				data.children.push( parseNode( elements[ i ] ) );

  			}

  			library.visualScenes[ xml.getAttribute( 'id' ) ] = data;

  		}

  		function buildVisualScene( data ) {

  			const group = new three$2.Group();
  			group.name = data.name;

  			const children = data.children;

  			for ( let i = 0; i < children.length; i ++ ) {

  				const child = children[ i ];

  				group.add( getNode( child.id ) );

  			}

  			return group;

  		}

  		function hasVisualScene( id ) {

  			return library.visualScenes[ id ] !== undefined;

  		}

  		function getVisualScene( id ) {

  			return getBuild( library.visualScenes[ id ], buildVisualScene );

  		}

  		// scenes

  		function parseScene( xml ) {

  			const instance = getElementsByTagName( xml, 'instance_visual_scene' )[ 0 ];
  			return getVisualScene( parseId( instance.getAttribute( 'url' ) ) );

  		}

  		function setupAnimations() {

  			const clips = library.clips;

  			if ( isEmpty( clips ) === true ) {

  				if ( isEmpty( library.animations ) === false ) {

  					// if there are animations but no clips, we create a default clip for playback

  					const tracks = [];

  					for ( const id in library.animations ) {

  						const animationTracks = getAnimation( id );

  						for ( let i = 0, l = animationTracks.length; i < l; i ++ ) {

  							tracks.push( animationTracks[ i ] );

  						}

  					}

  					animations.push( new three$2.AnimationClip( 'default', -1, tracks ) );

  				}

  			} else {

  				for ( const id in clips ) {

  					animations.push( getAnimationClip( id ) );

  				}

  			}

  		}

  		// convert the parser error element into text with each child elements text
  		// separated by new lines.

  		function parserErrorToText( parserError ) {

  			let result = '';
  			const stack = [ parserError ];

  			while ( stack.length ) {

  				const node = stack.shift();

  				if ( node.nodeType === Node.TEXT_NODE ) {

  					result += node.textContent;

  				} else {

  					result += '\n';
  					stack.push.apply( stack, node.childNodes );

  				}

  			}

  			return result.trim();

  		}

  		if ( text.length === 0 ) {

  			return { scene: new three$2.Scene() };

  		}

  		const xml = new DOMParser().parseFromString( text, 'application/xml' );

  		const collada = getElementsByTagName( xml, 'COLLADA' )[ 0 ];

  		const parserError = xml.getElementsByTagName( 'parsererror' )[ 0 ];
  		if ( parserError !== undefined ) {

  			// Chrome will return parser error with a div in it

  			const errorElement = getElementsByTagName( parserError, 'div' )[ 0 ];
  			let errorText;

  			if ( errorElement ) {

  				errorText = errorElement.textContent;

  			} else {

  				errorText = parserErrorToText( parserError );

  			}

  			console.error( 'THREE.ColladaLoader: Failed to parse collada file.\n', errorText );

  			return null;

  		}

  		// metadata

  		const version = collada.getAttribute( 'version' );
  		console.debug( 'THREE.ColladaLoader: File version', version );

  		const asset = parseAsset( getElementsByTagName( collada, 'asset' )[ 0 ] );
  		const textureLoader = new three$2.TextureLoader( this.manager );
  		textureLoader.setPath( this.resourcePath || path ).setCrossOrigin( this.crossOrigin );

  		let tgaLoader;

  		if ( TGALoader ) {

  			tgaLoader = new TGALoader( this.manager );
  			tgaLoader.setPath( this.resourcePath || path );

  		}

  		//

  		const tempColor = new three$2.Color();
  		const animations = [];
  		let kinematics = {};
  		let count = 0;

  		//

  		const library = {
  			animations: {},
  			clips: {},
  			controllers: {},
  			images: {},
  			effects: {},
  			materials: {},
  			cameras: {},
  			lights: {},
  			geometries: {},
  			nodes: {},
  			visualScenes: {},
  			kinematicsModels: {},
  			physicsModels: {},
  			kinematicsScenes: {}
  		};

  		parseLibrary( collada, 'library_animations', 'animation', parseAnimation );
  		parseLibrary( collada, 'library_animation_clips', 'animation_clip', parseAnimationClip );
  		parseLibrary( collada, 'library_controllers', 'controller', parseController );
  		parseLibrary( collada, 'library_images', 'image', parseImage );
  		parseLibrary( collada, 'library_effects', 'effect', parseEffect );
  		parseLibrary( collada, 'library_materials', 'material', parseMaterial );
  		parseLibrary( collada, 'library_cameras', 'camera', parseCamera );
  		parseLibrary( collada, 'library_lights', 'light', parseLight );
  		parseLibrary( collada, 'library_geometries', 'geometry', parseGeometry );
  		parseLibrary( collada, 'library_nodes', 'node', parseNode );
  		parseLibrary( collada, 'library_visual_scenes', 'visual_scene', parseVisualScene );
  		parseLibrary( collada, 'library_kinematics_models', 'kinematics_model', parseKinematicsModel );
  		parseLibrary( collada, 'library_physics_models', 'physics_model', parsePhysicsModel );
  		parseLibrary( collada, 'scene', 'instance_kinematics_scene', parseKinematicsScene );

  		buildLibrary( library.animations, buildAnimation );
  		buildLibrary( library.clips, buildAnimationClip );
  		buildLibrary( library.controllers, buildController );
  		buildLibrary( library.images, buildImage );
  		buildLibrary( library.effects, buildEffect );
  		buildLibrary( library.materials, buildMaterial );
  		buildLibrary( library.cameras, buildCamera );
  		buildLibrary( library.lights, buildLight );
  		buildLibrary( library.geometries, buildGeometry );
  		buildLibrary( library.visualScenes, buildVisualScene );

  		setupAnimations();
  		setupKinematics();

  		const scene = parseScene( getElementsByTagName( collada, 'scene' )[ 0 ] );
  		scene.animations = animations;

  		if ( asset.upAxis === 'Z_UP' ) {

  			console.warn( 'THREE.ColladaLoader: You are loading an asset with a Z-UP coordinate system. The loader just rotates the asset to transform it into Y-UP. The vertex data are not converted, see #24289.' );
  			scene.rotation.set( - Math.PI / 2, 0, 0 );

  		}

  		scene.scale.multiplyScalar( asset.unit );

  		return {
  			get animations() {

  				console.warn( 'THREE.ColladaLoader: Please access animations over scene.animations now.' );
  				return animations;

  			},
  			kinematics: kinematics,
  			library: library,
  			scene: scene
  		};

  	}

  }

  THREE.ColladaLoader = ColladaLoader;

  /**
   * collada-model-legacy
   *
   * Loader for COLLADA (.dae) format.
   */
  AFRAME.registerComponent('collada-model-legacy', {
    schema: {type: 'asset'},

    init: function () {
      this.model = null;
      this.loader = new THREE.ColladaLoader();
    },

    update: function () {
      var self = this;
      var el = this.el;
      var src = this.data;
      var rendererSystem = this.el.sceneEl.systems.renderer;

      if (!src) { return; }

      this.remove();

      this.loader.load(src, function (colladaModel) {
        self.model = colladaModel.scene;
        self.model.traverse(function (object) {
          if (object.isMesh) {
            var material = object.material;
            if (material.color) rendererSystem.applyColorCorrection(material.color);
            if (material.map) rendererSystem.applyColorCorrection(material.map);
            if (material.emissive) rendererSystem.applyColorCorrection(material.emissive);
            if (material.emissiveMap) rendererSystem.applyColorCorrection(material.emissiveMap);
          }
        });
        el.setObject3D('mesh', self.model);
        el.emit('model-loaded', {format: 'collada', model: self.model});
      });
    },

    remove: function () {
      if (!this.model) { return; }
      this.el.removeObject3D('mesh');
    }
  });

  /*!
  fflate - fast JavaScript compression/decompression
  <https://101arrowz.github.io/fflate>
  Licensed under MIT. https://github.com/101arrowz/fflate/blob/master/LICENSE
  version 0.8.2
  */


  // aliases for shorter compressed code (most minifers don't do this)
  var u8 = Uint8Array, u16 = Uint16Array, i32 = Int32Array;
  // fixed length extra bits
  var fleb = new u8([0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0, /* unused */ 0, 0, /* impossible */ 0]);
  // fixed distance extra bits
  var fdeb = new u8([0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13, /* unused */ 0, 0]);
  // code length index map
  var clim = new u8([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]);
  // get base, reverse index map from extra bits
  var freb = function (eb, start) {
      var b = new u16(31);
      for (var i = 0; i < 31; ++i) {
          b[i] = start += 1 << eb[i - 1];
      }
      // numbers here are at max 18 bits
      var r = new i32(b[30]);
      for (var i = 1; i < 30; ++i) {
          for (var j = b[i]; j < b[i + 1]; ++j) {
              r[j] = ((j - b[i]) << 5) | i;
          }
      }
      return { b: b, r: r };
  };
  var _a = freb(fleb, 2), fl = _a.b, revfl = _a.r;
  // we can ignore the fact that the other numbers are wrong; they never happen anyway
  fl[28] = 258, revfl[258] = 28;
  var _b = freb(fdeb, 0), fd = _b.b;
  // map of value to reverse (assuming 16 bits)
  var rev = new u16(32768);
  for (var i = 0; i < 32768; ++i) {
      // reverse table algorithm from SO
      var x$1 = ((i & 0xAAAA) >> 1) | ((i & 0x5555) << 1);
      x$1 = ((x$1 & 0xCCCC) >> 2) | ((x$1 & 0x3333) << 2);
      x$1 = ((x$1 & 0xF0F0) >> 4) | ((x$1 & 0x0F0F) << 4);
      rev[i] = (((x$1 & 0xFF00) >> 8) | ((x$1 & 0x00FF) << 8)) >> 1;
  }
  // create huffman tree from u8 "map": index -> code length for code index
  // mb (max bits) must be at most 15
  // TODO: optimize/split up?
  var hMap = (function (cd, mb, r) {
      var s = cd.length;
      // index
      var i = 0;
      // u16 "map": index -> # of codes with bit length = index
      var l = new u16(mb);
      // length of cd must be 288 (total # of codes)
      for (; i < s; ++i) {
          if (cd[i])
              ++l[cd[i] - 1];
      }
      // u16 "map": index -> minimum code for bit length = index
      var le = new u16(mb);
      for (i = 1; i < mb; ++i) {
          le[i] = (le[i - 1] + l[i - 1]) << 1;
      }
      var co;
      if (r) {
          // u16 "map": index -> number of actual bits, symbol for code
          co = new u16(1 << mb);
          // bits to remove for reverser
          var rvb = 15 - mb;
          for (i = 0; i < s; ++i) {
              // ignore 0 lengths
              if (cd[i]) {
                  // num encoding both symbol and bits read
                  var sv = (i << 4) | cd[i];
                  // free bits
                  var r_1 = mb - cd[i];
                  // start value
                  var v = le[cd[i] - 1]++ << r_1;
                  // m is end value
                  for (var m = v | ((1 << r_1) - 1); v <= m; ++v) {
                      // every 16 bit value starting with the code yields the same result
                      co[rev[v] >> rvb] = sv;
                  }
              }
          }
      }
      else {
          co = new u16(s);
          for (i = 0; i < s; ++i) {
              if (cd[i]) {
                  co[i] = rev[le[cd[i] - 1]++] >> (15 - cd[i]);
              }
          }
      }
      return co;
  });
  // fixed length tree
  var flt = new u8(288);
  for (var i = 0; i < 144; ++i)
      flt[i] = 8;
  for (var i = 144; i < 256; ++i)
      flt[i] = 9;
  for (var i = 256; i < 280; ++i)
      flt[i] = 7;
  for (var i = 280; i < 288; ++i)
      flt[i] = 8;
  // fixed distance tree
  var fdt = new u8(32);
  for (var i = 0; i < 32; ++i)
      fdt[i] = 5;
  // fixed length map
  var flrm = /*#__PURE__*/ hMap(flt, 9, 1);
  // fixed distance map
  var fdrm = /*#__PURE__*/ hMap(fdt, 5, 1);
  // find max of array
  var max$1 = function (a) {
      var m = a[0];
      for (var i = 1; i < a.length; ++i) {
          if (a[i] > m)
              m = a[i];
      }
      return m;
  };
  // read d, starting at bit p and mask with m
  var bits = function (d, p, m) {
      var o = (p / 8) | 0;
      return ((d[o] | (d[o + 1] << 8)) >> (p & 7)) & m;
  };
  // read d, starting at bit p continuing for at least 16 bits
  var bits16 = function (d, p) {
      var o = (p / 8) | 0;
      return ((d[o] | (d[o + 1] << 8) | (d[o + 2] << 16)) >> (p & 7));
  };
  // get end of byte
  var shft = function (p) { return ((p + 7) / 8) | 0; };
  // typed array slice - allows garbage collector to free original reference,
  // while being more compatible than .slice
  var slc = function (v, s, e) {
      if (e == null || e > v.length)
          e = v.length;
      // can't use .constructor in case user-supplied
      return new u8(v.subarray(s, e));
  };
  // error codes
  var ec = [
      'unexpected EOF',
      'invalid block type',
      'invalid length/literal',
      'invalid distance',
      'stream finished',
      'no stream handler',
      ,
      'no callback',
      'invalid UTF-8 data',
      'extra field too long',
      'date not in range 1980-2099',
      'filename too long',
      'stream finishing',
      'invalid zip data'
      // determined by unknown compression method
  ];
  var err = function (ind, msg, nt) {
      var e = new Error(msg || ec[ind]);
      e.code = ind;
      if (Error.captureStackTrace)
          Error.captureStackTrace(e, err);
      if (!nt)
          throw e;
      return e;
  };
  // expands raw DEFLATE data
  var inflt = function (dat, st, buf, dict) {
      // source length       dict length
      var sl = dat.length, dl = 0;
      if (!sl || st.f && !st.l)
          return buf || new u8(0);
      var noBuf = !buf;
      // have to estimate size
      var resize = noBuf || st.i != 2;
      // no state
      var noSt = st.i;
      // Assumes roughly 33% compression ratio average
      if (noBuf)
          buf = new u8(sl * 3);
      // ensure buffer can fit at least l elements
      var cbuf = function (l) {
          var bl = buf.length;
          // need to increase size to fit
          if (l > bl) {
              // Double or set to necessary, whichever is greater
              var nbuf = new u8(Math.max(bl * 2, l));
              nbuf.set(buf);
              buf = nbuf;
          }
      };
      //  last chunk         bitpos           bytes
      var final = st.f || 0, pos = st.p || 0, bt = st.b || 0, lm = st.l, dm = st.d, lbt = st.m, dbt = st.n;
      // total bits
      var tbts = sl * 8;
      do {
          if (!lm) {
              // BFINAL - this is only 1 when last chunk is next
              final = bits(dat, pos, 1);
              // type: 0 = no compression, 1 = fixed huffman, 2 = dynamic huffman
              var type = bits(dat, pos + 1, 3);
              pos += 3;
              if (!type) {
                  // go to end of byte boundary
                  var s = shft(pos) + 4, l = dat[s - 4] | (dat[s - 3] << 8), t = s + l;
                  if (t > sl) {
                      if (noSt)
                          err(0);
                      break;
                  }
                  // ensure size
                  if (resize)
                      cbuf(bt + l);
                  // Copy over uncompressed data
                  buf.set(dat.subarray(s, t), bt);
                  // Get new bitpos, update byte count
                  st.b = bt += l, st.p = pos = t * 8, st.f = final;
                  continue;
              }
              else if (type == 1)
                  lm = flrm, dm = fdrm, lbt = 9, dbt = 5;
              else if (type == 2) {
                  //  literal                            lengths
                  var hLit = bits(dat, pos, 31) + 257, hcLen = bits(dat, pos + 10, 15) + 4;
                  var tl = hLit + bits(dat, pos + 5, 31) + 1;
                  pos += 14;
                  // length+distance tree
                  var ldt = new u8(tl);
                  // code length tree
                  var clt = new u8(19);
                  for (var i = 0; i < hcLen; ++i) {
                      // use index map to get real code
                      clt[clim[i]] = bits(dat, pos + i * 3, 7);
                  }
                  pos += hcLen * 3;
                  // code lengths bits
                  var clb = max$1(clt), clbmsk = (1 << clb) - 1;
                  // code lengths map
                  var clm = hMap(clt, clb, 1);
                  for (var i = 0; i < tl;) {
                      var r = clm[bits(dat, pos, clbmsk)];
                      // bits read
                      pos += r & 15;
                      // symbol
                      var s = r >> 4;
                      // code length to copy
                      if (s < 16) {
                          ldt[i++] = s;
                      }
                      else {
                          //  copy   count
                          var c = 0, n = 0;
                          if (s == 16)
                              n = 3 + bits(dat, pos, 3), pos += 2, c = ldt[i - 1];
                          else if (s == 17)
                              n = 3 + bits(dat, pos, 7), pos += 3;
                          else if (s == 18)
                              n = 11 + bits(dat, pos, 127), pos += 7;
                          while (n--)
                              ldt[i++] = c;
                      }
                  }
                  //    length tree                 distance tree
                  var lt = ldt.subarray(0, hLit), dt = ldt.subarray(hLit);
                  // max length bits
                  lbt = max$1(lt);
                  // max dist bits
                  dbt = max$1(dt);
                  lm = hMap(lt, lbt, 1);
                  dm = hMap(dt, dbt, 1);
              }
              else
                  err(1);
              if (pos > tbts) {
                  if (noSt)
                      err(0);
                  break;
              }
          }
          // Make sure the buffer can hold this + the largest possible addition
          // Maximum chunk size (practically, theoretically infinite) is 2^17
          if (resize)
              cbuf(bt + 131072);
          var lms = (1 << lbt) - 1, dms = (1 << dbt) - 1;
          var lpos = pos;
          for (;; lpos = pos) {
              // bits read, code
              var c = lm[bits16(dat, pos) & lms], sym = c >> 4;
              pos += c & 15;
              if (pos > tbts) {
                  if (noSt)
                      err(0);
                  break;
              }
              if (!c)
                  err(2);
              if (sym < 256)
                  buf[bt++] = sym;
              else if (sym == 256) {
                  lpos = pos, lm = null;
                  break;
              }
              else {
                  var add = sym - 254;
                  // no extra bits needed if less
                  if (sym > 264) {
                      // index
                      var i = sym - 257, b = fleb[i];
                      add = bits(dat, pos, (1 << b) - 1) + fl[i];
                      pos += b;
                  }
                  // dist
                  var d = dm[bits16(dat, pos) & dms], dsym = d >> 4;
                  if (!d)
                      err(3);
                  pos += d & 15;
                  var dt = fd[dsym];
                  if (dsym > 3) {
                      var b = fdeb[dsym];
                      dt += bits16(dat, pos) & (1 << b) - 1, pos += b;
                  }
                  if (pos > tbts) {
                      if (noSt)
                          err(0);
                      break;
                  }
                  if (resize)
                      cbuf(bt + 131072);
                  var end = bt + add;
                  if (bt < dt) {
                      var shift = dl - dt, dend = Math.min(dt, end);
                      if (shift + bt < 0)
                          err(3);
                      for (; bt < dend; ++bt)
                          buf[bt] = dict[shift + bt];
                  }
                  for (; bt < end; ++bt)
                      buf[bt] = buf[bt - dt];
              }
          }
          st.l = lm, st.p = lpos, st.b = bt, st.f = final;
          if (lm)
              final = 1, st.m = lbt, st.d = dm, st.n = dbt;
      } while (!final);
      // don't reallocate for streams or user buffers
      return bt != buf.length && noBuf ? slc(buf, 0, bt) : buf.subarray(0, bt);
  };
  // empty
  var et = /*#__PURE__*/ new u8(0);
  // zlib start
  var zls = function (d, dict) {
      if ((d[0] & 15) != 8 || (d[0] >> 4) > 7 || ((d[0] << 8 | d[1]) % 31))
          err(6, 'invalid zlib data');
      if ((d[1] >> 5 & 1) == 1)
          err(6, 'invalid zlib data: ' + (d[1] & 32 ? 'need' : 'unexpected') + ' dictionary');
      return (d[1] >> 3 & 4) + 2;
  };
  /**
   * Expands Zlib data
   * @param data The data to decompress
   * @param opts The decompression options
   * @returns The decompressed version of the data
   */
  function unzlibSync(data, opts) {
      return inflt(data.subarray(zls(data), -4), { i: 2 }, opts, opts);
  }
  // text decoder
  var td = typeof TextDecoder != 'undefined' && /*#__PURE__*/ new TextDecoder();
  // text decoder stream
  var tds = 0;
  try {
      td.decode(et, { stream: true });
      tds = 1;
  }
  catch (e) { }

  /**
   * NURBS utils
   *
   * See NURBSCurve and NURBSSurface.
   **/


  /**************************************************************
   *	NURBS Utils
   **************************************************************/

  /*
  Finds knot vector span.

  p : degree
  u : parametric value
  U : knot vector

  returns the span
  */
  function findSpan( p, u, U ) {

  	const n = U.length - p - 1;

  	if ( u >= U[ n ] ) {

  		return n - 1;

  	}

  	if ( u <= U[ p ] ) {

  		return p;

  	}

  	let low = p;
  	let high = n;
  	let mid = Math.floor( ( low + high ) / 2 );

  	while ( u < U[ mid ] || u >= U[ mid + 1 ] ) {

  		if ( u < U[ mid ] ) {

  			high = mid;

  		} else {

  			low = mid;

  		}

  		mid = Math.floor( ( low + high ) / 2 );

  	}

  	return mid;

  }


  /*
  Calculate basis functions. See The NURBS Book, page 70, algorithm A2.2

  span : span in which u lies
  u    : parametric point
  p    : degree
  U    : knot vector

  returns array[p+1] with basis functions values.
  */
  function calcBasisFunctions( span, u, p, U ) {

  	const N = [];
  	const left = [];
  	const right = [];
  	N[ 0 ] = 1.0;

  	for ( let j = 1; j <= p; ++ j ) {

  		left[ j ] = u - U[ span + 1 - j ];
  		right[ j ] = U[ span + j ] - u;

  		let saved = 0.0;

  		for ( let r = 0; r < j; ++ r ) {

  			const rv = right[ r + 1 ];
  			const lv = left[ j - r ];
  			const temp = N[ r ] / ( rv + lv );
  			N[ r ] = saved + rv * temp;
  			saved = lv * temp;

  		}

  		N[ j ] = saved;

  	}

  	return N;

  }


  /*
  Calculate B-Spline curve points. See The NURBS Book, page 82, algorithm A3.1.

  p : degree of B-Spline
  U : knot vector
  P : control points (x, y, z, w)
  u : parametric point

  returns point for given u
  */
  function calcBSplinePoint( p, U, P, u ) {

  	const span = findSpan( p, u, U );
  	const N = calcBasisFunctions( span, u, p, U );
  	const C = new three$2.Vector4( 0, 0, 0, 0 );

  	for ( let j = 0; j <= p; ++ j ) {

  		const point = P[ span - p + j ];
  		const Nj = N[ j ];
  		const wNj = point.w * Nj;
  		C.x += point.x * wNj;
  		C.y += point.y * wNj;
  		C.z += point.z * wNj;
  		C.w += point.w * Nj;

  	}

  	return C;

  }


  /*
  Calculate basis functions derivatives. See The NURBS Book, page 72, algorithm A2.3.

  span : span in which u lies
  u    : parametric point
  p    : degree
  n    : number of derivatives to calculate
  U    : knot vector

  returns array[n+1][p+1] with basis functions derivatives
  */
  function calcBasisFunctionDerivatives( span, u, p, n, U ) {

  	const zeroArr = [];
  	for ( let i = 0; i <= p; ++ i )
  		zeroArr[ i ] = 0.0;

  	const ders = [];

  	for ( let i = 0; i <= n; ++ i )
  		ders[ i ] = zeroArr.slice( 0 );

  	const ndu = [];

  	for ( let i = 0; i <= p; ++ i )
  		ndu[ i ] = zeroArr.slice( 0 );

  	ndu[ 0 ][ 0 ] = 1.0;

  	const left = zeroArr.slice( 0 );
  	const right = zeroArr.slice( 0 );

  	for ( let j = 1; j <= p; ++ j ) {

  		left[ j ] = u - U[ span + 1 - j ];
  		right[ j ] = U[ span + j ] - u;

  		let saved = 0.0;

  		for ( let r = 0; r < j; ++ r ) {

  			const rv = right[ r + 1 ];
  			const lv = left[ j - r ];
  			ndu[ j ][ r ] = rv + lv;

  			const temp = ndu[ r ][ j - 1 ] / ndu[ j ][ r ];
  			ndu[ r ][ j ] = saved + rv * temp;
  			saved = lv * temp;

  		}

  		ndu[ j ][ j ] = saved;

  	}

  	for ( let j = 0; j <= p; ++ j ) {

  		ders[ 0 ][ j ] = ndu[ j ][ p ];

  	}

  	for ( let r = 0; r <= p; ++ r ) {

  		let s1 = 0;
  		let s2 = 1;

  		const a = [];
  		for ( let i = 0; i <= p; ++ i ) {

  			a[ i ] = zeroArr.slice( 0 );

  		}

  		a[ 0 ][ 0 ] = 1.0;

  		for ( let k = 1; k <= n; ++ k ) {

  			let d = 0.0;
  			const rk = r - k;
  			const pk = p - k;

  			if ( r >= k ) {

  				a[ s2 ][ 0 ] = a[ s1 ][ 0 ] / ndu[ pk + 1 ][ rk ];
  				d = a[ s2 ][ 0 ] * ndu[ rk ][ pk ];

  			}

  			const j1 = ( rk >= -1 ) ? 1 : - rk;
  			const j2 = ( r - 1 <= pk ) ? k - 1 : p - r;

  			for ( let j = j1; j <= j2; ++ j ) {

  				a[ s2 ][ j ] = ( a[ s1 ][ j ] - a[ s1 ][ j - 1 ] ) / ndu[ pk + 1 ][ rk + j ];
  				d += a[ s2 ][ j ] * ndu[ rk + j ][ pk ];

  			}

  			if ( r <= pk ) {

  				a[ s2 ][ k ] = - a[ s1 ][ k - 1 ] / ndu[ pk + 1 ][ r ];
  				d += a[ s2 ][ k ] * ndu[ r ][ pk ];

  			}

  			ders[ k ][ r ] = d;

  			const j = s1;
  			s1 = s2;
  			s2 = j;

  		}

  	}

  	let r = p;

  	for ( let k = 1; k <= n; ++ k ) {

  		for ( let j = 0; j <= p; ++ j ) {

  			ders[ k ][ j ] *= r;

  		}

  		r *= p - k;

  	}

  	return ders;

  }


  /*
  	Calculate derivatives of a B-Spline. See The NURBS Book, page 93, algorithm A3.2.

  	p  : degree
  	U  : knot vector
  	P  : control points
  	u  : Parametric points
  	nd : number of derivatives

  	returns array[d+1] with derivatives
  	*/
  function calcBSplineDerivatives( p, U, P, u, nd ) {

  	const du = nd < p ? nd : p;
  	const CK = [];
  	const span = findSpan( p, u, U );
  	const nders = calcBasisFunctionDerivatives( span, u, p, du, U );
  	const Pw = [];

  	for ( let i = 0; i < P.length; ++ i ) {

  		const point = P[ i ].clone();
  		const w = point.w;

  		point.x *= w;
  		point.y *= w;
  		point.z *= w;

  		Pw[ i ] = point;

  	}

  	for ( let k = 0; k <= du; ++ k ) {

  		const point = Pw[ span - p ].clone().multiplyScalar( nders[ k ][ 0 ] );

  		for ( let j = 1; j <= p; ++ j ) {

  			point.add( Pw[ span - p + j ].clone().multiplyScalar( nders[ k ][ j ] ) );

  		}

  		CK[ k ] = point;

  	}

  	for ( let k = du + 1; k <= nd + 1; ++ k ) {

  		CK[ k ] = new three$2.Vector4( 0, 0, 0 );

  	}

  	return CK;

  }


  /*
  Calculate "K over I"

  returns k!/(i!(k-i)!)
  */
  function calcKoverI( k, i ) {

  	let nom = 1;

  	for ( let j = 2; j <= k; ++ j ) {

  		nom *= j;

  	}

  	let denom = 1;

  	for ( let j = 2; j <= i; ++ j ) {

  		denom *= j;

  	}

  	for ( let j = 2; j <= k - i; ++ j ) {

  		denom *= j;

  	}

  	return nom / denom;

  }


  /*
  Calculate derivatives (0-nd) of rational curve. See The NURBS Book, page 127, algorithm A4.2.

  Pders : result of function calcBSplineDerivatives

  returns array with derivatives for rational curve.
  */
  function calcRationalCurveDerivatives( Pders ) {

  	const nd = Pders.length;
  	const Aders = [];
  	const wders = [];

  	for ( let i = 0; i < nd; ++ i ) {

  		const point = Pders[ i ];
  		Aders[ i ] = new three$2.Vector3( point.x, point.y, point.z );
  		wders[ i ] = point.w;

  	}

  	const CK = [];

  	for ( let k = 0; k < nd; ++ k ) {

  		const v = Aders[ k ].clone();

  		for ( let i = 1; i <= k; ++ i ) {

  			v.sub( CK[ k - i ].clone().multiplyScalar( calcKoverI( k, i ) * wders[ i ] ) );

  		}

  		CK[ k ] = v.divideScalar( wders[ 0 ] );

  	}

  	return CK;

  }


  /*
  Calculate NURBS curve derivatives. See The NURBS Book, page 127, algorithm A4.2.

  p  : degree
  U  : knot vector
  P  : control points in homogeneous space
  u  : parametric points
  nd : number of derivatives

  returns array with derivatives.
  */
  function calcNURBSDerivatives( p, U, P, u, nd ) {

  	const Pders = calcBSplineDerivatives( p, U, P, u, nd );
  	return calcRationalCurveDerivatives( Pders );

  }

  /**
   * NURBS curve object
   *
   * Derives from Curve, overriding getPoint and getTangent.
   *
   * Implementation is based on (x, y [, z=0 [, w=1]]) control points with w=weight.
   *
   **/

  class NURBSCurve extends three$2.Curve {

  	constructor(
  		degree,
  		knots /* array of reals */,
  		controlPoints /* array of Vector(2|3|4) */,
  		startKnot /* index in knots */,
  		endKnot /* index in knots */
  	) {

  		super();

  		this.degree = degree;
  		this.knots = knots;
  		this.controlPoints = [];
  		// Used by periodic NURBS to remove hidden spans
  		this.startKnot = startKnot || 0;
  		this.endKnot = endKnot || ( this.knots.length - 1 );

  		for ( let i = 0; i < controlPoints.length; ++ i ) {

  			// ensure Vector4 for control points
  			const point = controlPoints[ i ];
  			this.controlPoints[ i ] = new three$2.Vector4( point.x, point.y, point.z, point.w );

  		}

  	}

  	getPoint( t, optionalTarget = new three$2.Vector3() ) {

  		const point = optionalTarget;

  		const u = this.knots[ this.startKnot ] + t * ( this.knots[ this.endKnot ] - this.knots[ this.startKnot ] ); // linear mapping t->u

  		// following results in (wx, wy, wz, w) homogeneous point
  		const hpoint = calcBSplinePoint( this.degree, this.knots, this.controlPoints, u );

  		if ( hpoint.w !== 1.0 ) {

  			// project to 3D space: (wx, wy, wz, w) -> (x, y, z, 1)
  			hpoint.divideScalar( hpoint.w );

  		}

  		return point.set( hpoint.x, hpoint.y, hpoint.z );

  	}

  	getTangent( t, optionalTarget = new three$2.Vector3() ) {

  		const tangent = optionalTarget;

  		const u = this.knots[ 0 ] + t * ( this.knots[ this.knots.length - 1 ] - this.knots[ 0 ] );
  		const ders = calcNURBSDerivatives( this.degree, this.knots, this.controlPoints, u, 1 );
  		tangent.copy( ders[ 1 ] ).normalize();

  		return tangent;

  	}

  }

  /**
   * Loader loads FBX file and generates Group representing FBX scene.
   * Requires FBX file to be >= 7.0 and in ASCII or >= 6400 in Binary format
   * Versions lower than this may load but will probably have errors
   *
   * Needs Support:
   *  Morph normals / blend shape normals
   *
   * FBX format references:
   * 	https://help.autodesk.com/view/FBX/2017/ENU/?guid=__cpp_ref_index_html (C++ SDK reference)
   *
   * Binary format specification:
   *	https://code.blender.org/2013/08/fbx-binary-file-format-specification/
   */


  let fbxTree;
  let connections;
  let sceneGraph;

  class FBXLoader extends three$2.Loader {

  	constructor( manager ) {

  		super( manager );

  	}

  	load( url, onLoad, onProgress, onError ) {

  		const scope = this;

  		const path = ( scope.path === '' ) ? three$2.LoaderUtils.extractUrlBase( url ) : scope.path;

  		const loader = new three$2.FileLoader( this.manager );
  		loader.setPath( scope.path );
  		loader.setResponseType( 'arraybuffer' );
  		loader.setRequestHeader( scope.requestHeader );
  		loader.setWithCredentials( scope.withCredentials );

  		loader.load( url, function ( buffer ) {

  			try {

  				onLoad( scope.parse( buffer, path ) );

  			} catch ( e ) {

  				if ( onError ) {

  					onError( e );

  				} else {

  					console.error( e );

  				}

  				scope.manager.itemError( url );

  			}

  		}, onProgress, onError );

  	}

  	parse( FBXBuffer, path ) {

  		if ( isFbxFormatBinary( FBXBuffer ) ) {

  			fbxTree = new BinaryParser().parse( FBXBuffer );

  		} else {

  			const FBXText = convertArrayBufferToString( FBXBuffer );

  			if ( ! isFbxFormatASCII( FBXText ) ) {

  				throw new Error( 'THREE.FBXLoader: Unknown format.' );

  			}

  			if ( getFbxVersion( FBXText ) < 7000 ) {

  				throw new Error( 'THREE.FBXLoader: FBX version not supported, FileVersion: ' + getFbxVersion( FBXText ) );

  			}

  			fbxTree = new TextParser().parse( FBXText );

  		}

  		// console.log( fbxTree );

  		const textureLoader = new three$2.TextureLoader( this.manager ).setPath( this.resourcePath || path ).setCrossOrigin( this.crossOrigin );

  		return new FBXTreeParser( textureLoader, this.manager ).parse( fbxTree );

  	}

  }

  // Parse the FBXTree object returned by the BinaryParser or TextParser and return a Group
  class FBXTreeParser {

  	constructor( textureLoader, manager ) {

  		this.textureLoader = textureLoader;
  		this.manager = manager;

  	}

  	parse() {

  		connections = this.parseConnections();

  		const images = this.parseImages();
  		const textures = this.parseTextures( images );
  		const materials = this.parseMaterials( textures );
  		const deformers = this.parseDeformers();
  		const geometryMap = new GeometryParser().parse( deformers );

  		this.parseScene( deformers, geometryMap, materials );

  		return sceneGraph;

  	}

  	// Parses FBXTree.Connections which holds parent-child connections between objects (e.g. material -> texture, model->geometry )
  	// and details the connection type
  	parseConnections() {

  		const connectionMap = new Map();

  		if ( 'Connections' in fbxTree ) {

  			const rawConnections = fbxTree.Connections.connections;

  			rawConnections.forEach( function ( rawConnection ) {

  				const fromID = rawConnection[ 0 ];
  				const toID = rawConnection[ 1 ];
  				const relationship = rawConnection[ 2 ];

  				if ( ! connectionMap.has( fromID ) ) {

  					connectionMap.set( fromID, {
  						parents: [],
  						children: []
  					} );

  				}

  				const parentRelationship = { ID: toID, relationship: relationship };
  				connectionMap.get( fromID ).parents.push( parentRelationship );

  				if ( ! connectionMap.has( toID ) ) {

  					connectionMap.set( toID, {
  						parents: [],
  						children: []
  					} );

  				}

  				const childRelationship = { ID: fromID, relationship: relationship };
  				connectionMap.get( toID ).children.push( childRelationship );

  			} );

  		}

  		return connectionMap;

  	}

  	// Parse FBXTree.Objects.Video for embedded image data
  	// These images are connected to textures in FBXTree.Objects.Textures
  	// via FBXTree.Connections.
  	parseImages() {

  		const images = {};
  		const blobs = {};

  		if ( 'Video' in fbxTree.Objects ) {

  			const videoNodes = fbxTree.Objects.Video;

  			for ( const nodeID in videoNodes ) {

  				const videoNode = videoNodes[ nodeID ];

  				const id = parseInt( nodeID );

  				images[ id ] = videoNode.RelativeFilename || videoNode.Filename;

  				// raw image data is in videoNode.Content
  				if ( 'Content' in videoNode ) {

  					const arrayBufferContent = ( videoNode.Content instanceof ArrayBuffer ) && ( videoNode.Content.byteLength > 0 );
  					const base64Content = ( typeof videoNode.Content === 'string' ) && ( videoNode.Content !== '' );

  					if ( arrayBufferContent || base64Content ) {

  						const image = this.parseImage( videoNodes[ nodeID ] );

  						blobs[ videoNode.RelativeFilename || videoNode.Filename ] = image;

  					}

  				}

  			}

  		}

  		for ( const id in images ) {

  			const filename = images[ id ];

  			if ( blobs[ filename ] !== undefined ) images[ id ] = blobs[ filename ];
  			else images[ id ] = images[ id ].split( '\\' ).pop();

  		}

  		return images;

  	}

  	// Parse embedded image data in FBXTree.Video.Content
  	parseImage( videoNode ) {

  		const content = videoNode.Content;
  		const fileName = videoNode.RelativeFilename || videoNode.Filename;
  		const extension = fileName.slice( fileName.lastIndexOf( '.' ) + 1 ).toLowerCase();

  		let type;

  		switch ( extension ) {

  			case 'bmp':

  				type = 'image/bmp';
  				break;

  			case 'jpg':
  			case 'jpeg':

  				type = 'image/jpeg';
  				break;

  			case 'png':

  				type = 'image/png';
  				break;

  			case 'tif':

  				type = 'image/tiff';
  				break;

  			case 'tga':

  				if ( this.manager.getHandler( '.tga' ) === null ) {

  					console.warn( 'FBXLoader: TGA loader not found, skipping ', fileName );

  				}

  				type = 'image/tga';
  				break;

  			default:

  				console.warn( 'FBXLoader: Image type "' + extension + '" is not supported.' );
  				return;

  		}

  		if ( typeof content === 'string' ) { // ASCII format

  			return 'data:' + type + ';base64,' + content;

  		} else { // Binary Format

  			const array = new Uint8Array( content );
  			return window.URL.createObjectURL( new Blob( [ array ], { type: type } ) );

  		}

  	}

  	// Parse nodes in FBXTree.Objects.Texture
  	// These contain details such as UV scaling, cropping, rotation etc and are connected
  	// to images in FBXTree.Objects.Video
  	parseTextures( images ) {

  		const textureMap = new Map();

  		if ( 'Texture' in fbxTree.Objects ) {

  			const textureNodes = fbxTree.Objects.Texture;
  			for ( const nodeID in textureNodes ) {

  				const texture = this.parseTexture( textureNodes[ nodeID ], images );
  				textureMap.set( parseInt( nodeID ), texture );

  			}

  		}

  		return textureMap;

  	}

  	// Parse individual node in FBXTree.Objects.Texture
  	parseTexture( textureNode, images ) {

  		const texture = this.loadTexture( textureNode, images );

  		texture.ID = textureNode.id;

  		texture.name = textureNode.attrName;

  		const wrapModeU = textureNode.WrapModeU;
  		const wrapModeV = textureNode.WrapModeV;

  		const valueU = wrapModeU !== undefined ? wrapModeU.value : 0;
  		const valueV = wrapModeV !== undefined ? wrapModeV.value : 0;

  		// http://download.autodesk.com/us/fbx/SDKdocs/FBX_SDK_Help/files/fbxsdkref/class_k_fbx_texture.html#889640e63e2e681259ea81061b85143a
  		// 0: repeat(default), 1: clamp

  		texture.wrapS = valueU === 0 ? three$2.RepeatWrapping : three$2.ClampToEdgeWrapping;
  		texture.wrapT = valueV === 0 ? three$2.RepeatWrapping : three$2.ClampToEdgeWrapping;

  		if ( 'Scaling' in textureNode ) {

  			const values = textureNode.Scaling.value;

  			texture.repeat.x = values[ 0 ];
  			texture.repeat.y = values[ 1 ];

  		}

  		if ( 'Translation' in textureNode ) {

  			const values = textureNode.Translation.value;

  			texture.offset.x = values[ 0 ];
  			texture.offset.y = values[ 1 ];

  		}

  		return texture;

  	}

  	// load a texture specified as a blob or data URI, or via an external URL using TextureLoader
  	loadTexture( textureNode, images ) {

  		let fileName;

  		const currentPath = this.textureLoader.path;

  		const children = connections.get( textureNode.id ).children;

  		if ( children !== undefined && children.length > 0 && images[ children[ 0 ].ID ] !== undefined ) {

  			fileName = images[ children[ 0 ].ID ];

  			if ( fileName.indexOf( 'blob:' ) === 0 || fileName.indexOf( 'data:' ) === 0 ) {

  				this.textureLoader.setPath( undefined );

  			}

  		}

  		let texture;

  		const extension = textureNode.FileName.slice( -3 ).toLowerCase();

  		if ( extension === 'tga' ) {

  			const loader = this.manager.getHandler( '.tga' );

  			if ( loader === null ) {

  				console.warn( 'FBXLoader: TGA loader not found, creating placeholder texture for', textureNode.RelativeFilename );
  				texture = new three$2.Texture();

  			} else {

  				loader.setPath( this.textureLoader.path );
  				texture = loader.load( fileName );

  			}

  		} else if ( extension === 'dds' ) {

  			const loader = this.manager.getHandler( '.dds' );

  			if ( loader === null ) {

  				console.warn( 'FBXLoader: DDS loader not found, creating placeholder texture for', textureNode.RelativeFilename );
  				texture = new three$2.Texture();

  			} else {

  				loader.setPath( this.textureLoader.path );
  				texture = loader.load( fileName );

  			}

  		} else if ( extension === 'psd' ) {

  			console.warn( 'FBXLoader: PSD textures are not supported, creating placeholder texture for', textureNode.RelativeFilename );
  			texture = new three$2.Texture();

  		} else {

  			texture = this.textureLoader.load( fileName );

  		}

  		this.textureLoader.setPath( currentPath );

  		return texture;

  	}

  	// Parse nodes in FBXTree.Objects.Material
  	parseMaterials( textureMap ) {

  		const materialMap = new Map();

  		if ( 'Material' in fbxTree.Objects ) {

  			const materialNodes = fbxTree.Objects.Material;

  			for ( const nodeID in materialNodes ) {

  				const material = this.parseMaterial( materialNodes[ nodeID ], textureMap );

  				if ( material !== null ) materialMap.set( parseInt( nodeID ), material );

  			}

  		}

  		return materialMap;

  	}

  	// Parse single node in FBXTree.Objects.Material
  	// Materials are connected to texture maps in FBXTree.Objects.Textures
  	// FBX format currently only supports Lambert and Phong shading models
  	parseMaterial( materialNode, textureMap ) {

  		const ID = materialNode.id;
  		const name = materialNode.attrName;
  		let type = materialNode.ShadingModel;

  		// Case where FBX wraps shading model in property object.
  		if ( typeof type === 'object' ) {

  			type = type.value;

  		}

  		// Ignore unused materials which don't have any connections.
  		if ( ! connections.has( ID ) ) return null;

  		const parameters = this.parseParameters( materialNode, textureMap, ID );

  		let material;

  		switch ( type.toLowerCase() ) {

  			case 'phong':
  				material = new three$2.MeshPhongMaterial();
  				break;
  			case 'lambert':
  				material = new three$2.MeshLambertMaterial();
  				break;
  			default:
  				console.warn( 'THREE.FBXLoader: unknown material type "%s". Defaulting to MeshPhongMaterial.', type );
  				material = new three$2.MeshPhongMaterial();
  				break;

  		}

  		material.setValues( parameters );
  		material.name = name;

  		return material;

  	}

  	// Parse FBX material and return parameters suitable for a three.js material
  	// Also parse the texture map and return any textures associated with the material
  	parseParameters( materialNode, textureMap, ID ) {

  		const parameters = {};

  		if ( materialNode.BumpFactor ) {

  			parameters.bumpScale = materialNode.BumpFactor.value;

  		}

  		if ( materialNode.Diffuse ) {

  			parameters.color = new three$2.Color().fromArray( materialNode.Diffuse.value ).convertSRGBToLinear();

  		} else if ( materialNode.DiffuseColor && ( materialNode.DiffuseColor.type === 'Color' || materialNode.DiffuseColor.type === 'ColorRGB' ) ) {

  			// The blender exporter exports diffuse here instead of in materialNode.Diffuse
  			parameters.color = new three$2.Color().fromArray( materialNode.DiffuseColor.value ).convertSRGBToLinear();

  		}

  		if ( materialNode.DisplacementFactor ) {

  			parameters.displacementScale = materialNode.DisplacementFactor.value;

  		}

  		if ( materialNode.Emissive ) {

  			parameters.emissive = new three$2.Color().fromArray( materialNode.Emissive.value ).convertSRGBToLinear();

  		} else if ( materialNode.EmissiveColor && ( materialNode.EmissiveColor.type === 'Color' || materialNode.EmissiveColor.type === 'ColorRGB' ) ) {

  			// The blender exporter exports emissive color here instead of in materialNode.Emissive
  			parameters.emissive = new three$2.Color().fromArray( materialNode.EmissiveColor.value ).convertSRGBToLinear();

  		}

  		if ( materialNode.EmissiveFactor ) {

  			parameters.emissiveIntensity = parseFloat( materialNode.EmissiveFactor.value );

  		}

  		if ( materialNode.Opacity ) {

  			parameters.opacity = parseFloat( materialNode.Opacity.value );

  		}

  		if ( parameters.opacity < 1.0 ) {

  			parameters.transparent = true;

  		}

  		if ( materialNode.ReflectionFactor ) {

  			parameters.reflectivity = materialNode.ReflectionFactor.value;

  		}

  		if ( materialNode.Shininess ) {

  			parameters.shininess = materialNode.Shininess.value;

  		}

  		if ( materialNode.Specular ) {

  			parameters.specular = new three$2.Color().fromArray( materialNode.Specular.value ).convertSRGBToLinear();

  		} else if ( materialNode.SpecularColor && materialNode.SpecularColor.type === 'Color' ) {

  			// The blender exporter exports specular color here instead of in materialNode.Specular
  			parameters.specular = new three$2.Color().fromArray( materialNode.SpecularColor.value ).convertSRGBToLinear();

  		}

  		const scope = this;
  		connections.get( ID ).children.forEach( function ( child ) {

  			const type = child.relationship;

  			switch ( type ) {

  				case 'Bump':
  					parameters.bumpMap = scope.getTexture( textureMap, child.ID );
  					break;

  				case 'Maya|TEX_ao_map':
  					parameters.aoMap = scope.getTexture( textureMap, child.ID );
  					break;

  				case 'DiffuseColor':
  				case 'Maya|TEX_color_map':
  					parameters.map = scope.getTexture( textureMap, child.ID );
  					if ( parameters.map !== undefined ) {

  						parameters.map.colorSpace = three$2.SRGBColorSpace;

  					}

  					break;

  				case 'DisplacementColor':
  					parameters.displacementMap = scope.getTexture( textureMap, child.ID );
  					break;

  				case 'EmissiveColor':
  					parameters.emissiveMap = scope.getTexture( textureMap, child.ID );
  					if ( parameters.emissiveMap !== undefined ) {

  						parameters.emissiveMap.colorSpace = three$2.SRGBColorSpace;

  					}

  					break;

  				case 'NormalMap':
  				case 'Maya|TEX_normal_map':
  					parameters.normalMap = scope.getTexture( textureMap, child.ID );
  					break;

  				case 'ReflectionColor':
  					parameters.envMap = scope.getTexture( textureMap, child.ID );
  					if ( parameters.envMap !== undefined ) {

  						parameters.envMap.mapping = three$2.EquirectangularReflectionMapping;
  						parameters.envMap.colorSpace = three$2.SRGBColorSpace;

  					}

  					break;

  				case 'SpecularColor':
  					parameters.specularMap = scope.getTexture( textureMap, child.ID );
  					if ( parameters.specularMap !== undefined ) {

  						parameters.specularMap.colorSpace = three$2.SRGBColorSpace;

  					}

  					break;

  				case 'TransparentColor':
  				case 'TransparencyFactor':
  					parameters.alphaMap = scope.getTexture( textureMap, child.ID );
  					parameters.transparent = true;
  					break;

  				case 'AmbientColor':
  				case 'ShininessExponent': // AKA glossiness map
  				case 'SpecularFactor': // AKA specularLevel
  				case 'VectorDisplacementColor': // NOTE: Seems to be a copy of DisplacementColor
  				default:
  					console.warn( 'THREE.FBXLoader: %s map is not supported in three.js, skipping texture.', type );
  					break;

  			}

  		} );

  		return parameters;

  	}

  	// get a texture from the textureMap for use by a material.
  	getTexture( textureMap, id ) {

  		// if the texture is a layered texture, just use the first layer and issue a warning
  		if ( 'LayeredTexture' in fbxTree.Objects && id in fbxTree.Objects.LayeredTexture ) {

  			console.warn( 'THREE.FBXLoader: layered textures are not supported in three.js. Discarding all but first layer.' );
  			id = connections.get( id ).children[ 0 ].ID;

  		}

  		return textureMap.get( id );

  	}

  	// Parse nodes in FBXTree.Objects.Deformer
  	// Deformer node can contain skinning or Vertex Cache animation data, however only skinning is supported here
  	// Generates map of Skeleton-like objects for use later when generating and binding skeletons.
  	parseDeformers() {

  		const skeletons = {};
  		const morphTargets = {};

  		if ( 'Deformer' in fbxTree.Objects ) {

  			const DeformerNodes = fbxTree.Objects.Deformer;

  			for ( const nodeID in DeformerNodes ) {

  				const deformerNode = DeformerNodes[ nodeID ];

  				const relationships = connections.get( parseInt( nodeID ) );

  				if ( deformerNode.attrType === 'Skin' ) {

  					const skeleton = this.parseSkeleton( relationships, DeformerNodes );
  					skeleton.ID = nodeID;

  					if ( relationships.parents.length > 1 ) console.warn( 'THREE.FBXLoader: skeleton attached to more than one geometry is not supported.' );
  					skeleton.geometryID = relationships.parents[ 0 ].ID;

  					skeletons[ nodeID ] = skeleton;

  				} else if ( deformerNode.attrType === 'BlendShape' ) {

  					const morphTarget = {
  						id: nodeID,
  					};

  					morphTarget.rawTargets = this.parseMorphTargets( relationships, DeformerNodes );
  					morphTarget.id = nodeID;

  					if ( relationships.parents.length > 1 ) console.warn( 'THREE.FBXLoader: morph target attached to more than one geometry is not supported.' );

  					morphTargets[ nodeID ] = morphTarget;

  				}

  			}

  		}

  		return {

  			skeletons: skeletons,
  			morphTargets: morphTargets,

  		};

  	}

  	// Parse single nodes in FBXTree.Objects.Deformer
  	// The top level skeleton node has type 'Skin' and sub nodes have type 'Cluster'
  	// Each skin node represents a skeleton and each cluster node represents a bone
  	parseSkeleton( relationships, deformerNodes ) {

  		const rawBones = [];

  		relationships.children.forEach( function ( child ) {

  			const boneNode = deformerNodes[ child.ID ];

  			if ( boneNode.attrType !== 'Cluster' ) return;

  			const rawBone = {

  				ID: child.ID,
  				indices: [],
  				weights: [],
  				transformLink: new three$2.Matrix4().fromArray( boneNode.TransformLink.a ),
  				// transform: new Matrix4().fromArray( boneNode.Transform.a ),
  				// linkMode: boneNode.Mode,

  			};

  			if ( 'Indexes' in boneNode ) {

  				rawBone.indices = boneNode.Indexes.a;
  				rawBone.weights = boneNode.Weights.a;

  			}

  			rawBones.push( rawBone );

  		} );

  		return {

  			rawBones: rawBones,
  			bones: []

  		};

  	}

  	// The top level morph deformer node has type "BlendShape" and sub nodes have type "BlendShapeChannel"
  	parseMorphTargets( relationships, deformerNodes ) {

  		const rawMorphTargets = [];

  		for ( let i = 0; i < relationships.children.length; i ++ ) {

  			const child = relationships.children[ i ];

  			const morphTargetNode = deformerNodes[ child.ID ];

  			const rawMorphTarget = {

  				name: morphTargetNode.attrName,
  				initialWeight: morphTargetNode.DeformPercent,
  				id: morphTargetNode.id,
  				fullWeights: morphTargetNode.FullWeights.a

  			};

  			if ( morphTargetNode.attrType !== 'BlendShapeChannel' ) return;

  			rawMorphTarget.geoID = connections.get( parseInt( child.ID ) ).children.filter( function ( child ) {

  				return child.relationship === undefined;

  			} )[ 0 ].ID;

  			rawMorphTargets.push( rawMorphTarget );

  		}

  		return rawMorphTargets;

  	}

  	// create the main Group() to be returned by the loader
  	parseScene( deformers, geometryMap, materialMap ) {

  		sceneGraph = new three$2.Group();

  		const modelMap = this.parseModels( deformers.skeletons, geometryMap, materialMap );

  		const modelNodes = fbxTree.Objects.Model;

  		const scope = this;
  		modelMap.forEach( function ( model ) {

  			const modelNode = modelNodes[ model.ID ];
  			scope.setLookAtProperties( model, modelNode );

  			const parentConnections = connections.get( model.ID ).parents;

  			parentConnections.forEach( function ( connection ) {

  				const parent = modelMap.get( connection.ID );
  				if ( parent !== undefined ) parent.add( model );

  			} );

  			if ( model.parent === null ) {

  				sceneGraph.add( model );

  			}


  		} );

  		this.bindSkeleton( deformers.skeletons, geometryMap, modelMap );

  		this.addGlobalSceneSettings();

  		sceneGraph.traverse( function ( node ) {

  			if ( node.userData.transformData ) {

  				if ( node.parent ) {

  					node.userData.transformData.parentMatrix = node.parent.matrix;
  					node.userData.transformData.parentMatrixWorld = node.parent.matrixWorld;

  				}

  				const transform = generateTransform( node.userData.transformData );

  				node.applyMatrix4( transform );
  				node.updateWorldMatrix();

  			}

  		} );

  		const animations = new AnimationParser().parse();

  		// if all the models where already combined in a single group, just return that
  		if ( sceneGraph.children.length === 1 && sceneGraph.children[ 0 ].isGroup ) {

  			sceneGraph.children[ 0 ].animations = animations;
  			sceneGraph = sceneGraph.children[ 0 ];

  		}

  		sceneGraph.animations = animations;

  	}

  	// parse nodes in FBXTree.Objects.Model
  	parseModels( skeletons, geometryMap, materialMap ) {

  		const modelMap = new Map();
  		const modelNodes = fbxTree.Objects.Model;

  		for ( const nodeID in modelNodes ) {

  			const id = parseInt( nodeID );
  			const node = modelNodes[ nodeID ];
  			const relationships = connections.get( id );

  			let model = this.buildSkeleton( relationships, skeletons, id, node.attrName );

  			if ( ! model ) {

  				switch ( node.attrType ) {

  					case 'Camera':
  						model = this.createCamera( relationships );
  						break;
  					case 'Light':
  						model = this.createLight( relationships );
  						break;
  					case 'Mesh':
  						model = this.createMesh( relationships, geometryMap, materialMap );
  						break;
  					case 'NurbsCurve':
  						model = this.createCurve( relationships, geometryMap );
  						break;
  					case 'LimbNode':
  					case 'Root':
  						model = new three$2.Bone();
  						break;
  					case 'Null':
  					default:
  						model = new three$2.Group();
  						break;

  				}

  				model.name = node.attrName ? three$2.PropertyBinding.sanitizeNodeName( node.attrName ) : '';
  				model.userData.originalName = node.attrName;

  				model.ID = id;

  			}

  			this.getTransformData( model, node );
  			modelMap.set( id, model );

  		}

  		return modelMap;

  	}

  	buildSkeleton( relationships, skeletons, id, name ) {

  		let bone = null;

  		relationships.parents.forEach( function ( parent ) {

  			for ( const ID in skeletons ) {

  				const skeleton = skeletons[ ID ];

  				skeleton.rawBones.forEach( function ( rawBone, i ) {

  					if ( rawBone.ID === parent.ID ) {

  						const subBone = bone;
  						bone = new three$2.Bone();

  						bone.matrixWorld.copy( rawBone.transformLink );

  						// set name and id here - otherwise in cases where "subBone" is created it will not have a name / id

  						bone.name = name ? three$2.PropertyBinding.sanitizeNodeName( name ) : '';
  						bone.userData.originalName = name;
  						bone.ID = id;

  						skeleton.bones[ i ] = bone;

  						// In cases where a bone is shared between multiple meshes
  						// duplicate the bone here and and it as a child of the first bone
  						if ( subBone !== null ) {

  							bone.add( subBone );

  						}

  					}

  				} );

  			}

  		} );

  		return bone;

  	}

  	// create a PerspectiveCamera or OrthographicCamera
  	createCamera( relationships ) {

  		let model;
  		let cameraAttribute;

  		relationships.children.forEach( function ( child ) {

  			const attr = fbxTree.Objects.NodeAttribute[ child.ID ];

  			if ( attr !== undefined ) {

  				cameraAttribute = attr;

  			}

  		} );

  		if ( cameraAttribute === undefined ) {

  			model = new three$2.Object3D();

  		} else {

  			let type = 0;
  			if ( cameraAttribute.CameraProjectionType !== undefined && cameraAttribute.CameraProjectionType.value === 1 ) {

  				type = 1;

  			}

  			let nearClippingPlane = 1;
  			if ( cameraAttribute.NearPlane !== undefined ) {

  				nearClippingPlane = cameraAttribute.NearPlane.value / 1000;

  			}

  			let farClippingPlane = 1000;
  			if ( cameraAttribute.FarPlane !== undefined ) {

  				farClippingPlane = cameraAttribute.FarPlane.value / 1000;

  			}


  			let width = window.innerWidth;
  			let height = window.innerHeight;

  			if ( cameraAttribute.AspectWidth !== undefined && cameraAttribute.AspectHeight !== undefined ) {

  				width = cameraAttribute.AspectWidth.value;
  				height = cameraAttribute.AspectHeight.value;

  			}

  			const aspect = width / height;

  			let fov = 45;
  			if ( cameraAttribute.FieldOfView !== undefined ) {

  				fov = cameraAttribute.FieldOfView.value;

  			}

  			const focalLength = cameraAttribute.FocalLength ? cameraAttribute.FocalLength.value : null;

  			switch ( type ) {

  				case 0: // Perspective
  					model = new three$2.PerspectiveCamera( fov, aspect, nearClippingPlane, farClippingPlane );
  					if ( focalLength !== null ) model.setFocalLength( focalLength );
  					break;

  				case 1: // Orthographic
  					model = new three$2.OrthographicCamera( - width / 2, width / 2, height / 2, - height / 2, nearClippingPlane, farClippingPlane );
  					break;

  				default:
  					console.warn( 'THREE.FBXLoader: Unknown camera type ' + type + '.' );
  					model = new three$2.Object3D();
  					break;

  			}

  		}

  		return model;

  	}

  	// Create a DirectionalLight, PointLight or SpotLight
  	createLight( relationships ) {

  		let model;
  		let lightAttribute;

  		relationships.children.forEach( function ( child ) {

  			const attr = fbxTree.Objects.NodeAttribute[ child.ID ];

  			if ( attr !== undefined ) {

  				lightAttribute = attr;

  			}

  		} );

  		if ( lightAttribute === undefined ) {

  			model = new three$2.Object3D();

  		} else {

  			let type;

  			// LightType can be undefined for Point lights
  			if ( lightAttribute.LightType === undefined ) {

  				type = 0;

  			} else {

  				type = lightAttribute.LightType.value;

  			}

  			let color = 0xffffff;

  			if ( lightAttribute.Color !== undefined ) {

  				color = new three$2.Color().fromArray( lightAttribute.Color.value ).convertSRGBToLinear();

  			}

  			let intensity = ( lightAttribute.Intensity === undefined ) ? 1 : lightAttribute.Intensity.value / 100;

  			// light disabled
  			if ( lightAttribute.CastLightOnObject !== undefined && lightAttribute.CastLightOnObject.value === 0 ) {

  				intensity = 0;

  			}

  			let distance = 0;
  			if ( lightAttribute.FarAttenuationEnd !== undefined ) {

  				if ( lightAttribute.EnableFarAttenuation !== undefined && lightAttribute.EnableFarAttenuation.value === 0 ) {

  					distance = 0;

  				} else {

  					distance = lightAttribute.FarAttenuationEnd.value;

  				}

  			}

  			// TODO: could this be calculated linearly from FarAttenuationStart to FarAttenuationEnd?
  			const decay = 1;

  			switch ( type ) {

  				case 0: // Point
  					model = new three$2.PointLight( color, intensity, distance, decay );
  					break;

  				case 1: // Directional
  					model = new three$2.DirectionalLight( color, intensity );
  					break;

  				case 2: // Spot
  					let angle = Math.PI / 3;

  					if ( lightAttribute.InnerAngle !== undefined ) {

  						angle = three$2.MathUtils.degToRad( lightAttribute.InnerAngle.value );

  					}

  					let penumbra = 0;
  					if ( lightAttribute.OuterAngle !== undefined ) {

  						// TODO: this is not correct - FBX calculates outer and inner angle in degrees
  						// with OuterAngle > InnerAngle && OuterAngle <= Math.PI
  						// while three.js uses a penumbra between (0, 1) to attenuate the inner angle
  						penumbra = three$2.MathUtils.degToRad( lightAttribute.OuterAngle.value );
  						penumbra = Math.max( penumbra, 1 );

  					}

  					model = new three$2.SpotLight( color, intensity, distance, angle, penumbra, decay );
  					break;

  				default:
  					console.warn( 'THREE.FBXLoader: Unknown light type ' + lightAttribute.LightType.value + ', defaulting to a PointLight.' );
  					model = new three$2.PointLight( color, intensity );
  					break;

  			}

  			if ( lightAttribute.CastShadows !== undefined && lightAttribute.CastShadows.value === 1 ) {

  				model.castShadow = true;

  			}

  		}

  		return model;

  	}

  	createMesh( relationships, geometryMap, materialMap ) {

  		let model;
  		let geometry = null;
  		let material = null;
  		const materials = [];

  		// get geometry and materials(s) from connections
  		relationships.children.forEach( function ( child ) {

  			if ( geometryMap.has( child.ID ) ) {

  				geometry = geometryMap.get( child.ID );

  			}

  			if ( materialMap.has( child.ID ) ) {

  				materials.push( materialMap.get( child.ID ) );

  			}

  		} );

  		if ( materials.length > 1 ) {

  			material = materials;

  		} else if ( materials.length > 0 ) {

  			material = materials[ 0 ];

  		} else {

  			material = new three$2.MeshPhongMaterial( {
  				name: three$2.Loader.DEFAULT_MATERIAL_NAME,
  				color: 0xcccccc
  			} );
  			materials.push( material );

  		}

  		if ( 'color' in geometry.attributes ) {

  			materials.forEach( function ( material ) {

  				material.vertexColors = true;

  			} );

  		}

  		if ( geometry.FBX_Deformer ) {

  			model = new three$2.SkinnedMesh( geometry, material );
  			model.normalizeSkinWeights();

  		} else {

  			model = new three$2.Mesh( geometry, material );

  		}

  		return model;

  	}

  	createCurve( relationships, geometryMap ) {

  		const geometry = relationships.children.reduce( function ( geo, child ) {

  			if ( geometryMap.has( child.ID ) ) geo = geometryMap.get( child.ID );

  			return geo;

  		}, null );

  		// FBX does not list materials for Nurbs lines, so we'll just put our own in here.
  		const material = new three$2.LineBasicMaterial( {
  			name: three$2.Loader.DEFAULT_MATERIAL_NAME,
  			color: 0x3300ff,
  			linewidth: 1
  		} );
  		return new three$2.Line( geometry, material );

  	}

  	// parse the model node for transform data
  	getTransformData( model, modelNode ) {

  		const transformData = {};

  		if ( 'InheritType' in modelNode ) transformData.inheritType = parseInt( modelNode.InheritType.value );

  		if ( 'RotationOrder' in modelNode ) transformData.eulerOrder = getEulerOrder( modelNode.RotationOrder.value );
  		else transformData.eulerOrder = 'ZYX';

  		if ( 'Lcl_Translation' in modelNode ) transformData.translation = modelNode.Lcl_Translation.value;

  		if ( 'PreRotation' in modelNode ) transformData.preRotation = modelNode.PreRotation.value;
  		if ( 'Lcl_Rotation' in modelNode ) transformData.rotation = modelNode.Lcl_Rotation.value;
  		if ( 'PostRotation' in modelNode ) transformData.postRotation = modelNode.PostRotation.value;

  		if ( 'Lcl_Scaling' in modelNode ) transformData.scale = modelNode.Lcl_Scaling.value;

  		if ( 'ScalingOffset' in modelNode ) transformData.scalingOffset = modelNode.ScalingOffset.value;
  		if ( 'ScalingPivot' in modelNode ) transformData.scalingPivot = modelNode.ScalingPivot.value;

  		if ( 'RotationOffset' in modelNode ) transformData.rotationOffset = modelNode.RotationOffset.value;
  		if ( 'RotationPivot' in modelNode ) transformData.rotationPivot = modelNode.RotationPivot.value;

  		model.userData.transformData = transformData;

  	}

  	setLookAtProperties( model, modelNode ) {

  		if ( 'LookAtProperty' in modelNode ) {

  			const children = connections.get( model.ID ).children;

  			children.forEach( function ( child ) {

  				if ( child.relationship === 'LookAtProperty' ) {

  					const lookAtTarget = fbxTree.Objects.Model[ child.ID ];

  					if ( 'Lcl_Translation' in lookAtTarget ) {

  						const pos = lookAtTarget.Lcl_Translation.value;

  						// DirectionalLight, SpotLight
  						if ( model.target !== undefined ) {

  							model.target.position.fromArray( pos );
  							sceneGraph.add( model.target );

  						} else { // Cameras and other Object3Ds

  							model.lookAt( new three$2.Vector3().fromArray( pos ) );

  						}

  					}

  				}

  			} );

  		}

  	}

  	bindSkeleton( skeletons, geometryMap, modelMap ) {

  		const bindMatrices = this.parsePoseNodes();

  		for ( const ID in skeletons ) {

  			const skeleton = skeletons[ ID ];

  			const parents = connections.get( parseInt( skeleton.ID ) ).parents;

  			parents.forEach( function ( parent ) {

  				if ( geometryMap.has( parent.ID ) ) {

  					const geoID = parent.ID;
  					const geoRelationships = connections.get( geoID );

  					geoRelationships.parents.forEach( function ( geoConnParent ) {

  						if ( modelMap.has( geoConnParent.ID ) ) {

  							const model = modelMap.get( geoConnParent.ID );

  							model.bind( new three$2.Skeleton( skeleton.bones ), bindMatrices[ geoConnParent.ID ] );

  						}

  					} );

  				}

  			} );

  		}

  	}

  	parsePoseNodes() {

  		const bindMatrices = {};

  		if ( 'Pose' in fbxTree.Objects ) {

  			const BindPoseNode = fbxTree.Objects.Pose;

  			for ( const nodeID in BindPoseNode ) {

  				if ( BindPoseNode[ nodeID ].attrType === 'BindPose' && BindPoseNode[ nodeID ].NbPoseNodes > 0 ) {

  					const poseNodes = BindPoseNode[ nodeID ].PoseNode;

  					if ( Array.isArray( poseNodes ) ) {

  						poseNodes.forEach( function ( poseNode ) {

  							bindMatrices[ poseNode.Node ] = new three$2.Matrix4().fromArray( poseNode.Matrix.a );

  						} );

  					} else {

  						bindMatrices[ poseNodes.Node ] = new three$2.Matrix4().fromArray( poseNodes.Matrix.a );

  					}

  				}

  			}

  		}

  		return bindMatrices;

  	}

  	addGlobalSceneSettings() {

  		if ( 'GlobalSettings' in fbxTree ) {

  			if ( 'AmbientColor' in fbxTree.GlobalSettings ) {

  				// Parse ambient color - if it's not set to black (default), create an ambient light

  				const ambientColor = fbxTree.GlobalSettings.AmbientColor.value;
  				const r = ambientColor[ 0 ];
  				const g = ambientColor[ 1 ];
  				const b = ambientColor[ 2 ];

  				if ( r !== 0 || g !== 0 || b !== 0 ) {

  					const color = new three$2.Color( r, g, b ).convertSRGBToLinear();
  					sceneGraph.add( new three$2.AmbientLight( color, 1 ) );

  				}

  			}

  			if ( 'UnitScaleFactor' in fbxTree.GlobalSettings ) {

  				sceneGraph.userData.unitScaleFactor = fbxTree.GlobalSettings.UnitScaleFactor.value;

  			}

  		}

  	}

  }

  // parse Geometry data from FBXTree and return map of BufferGeometries
  class GeometryParser {

  	constructor() {

  		this.negativeMaterialIndices = false;

  	}

  	// Parse nodes in FBXTree.Objects.Geometry
  	parse( deformers ) {

  		const geometryMap = new Map();

  		if ( 'Geometry' in fbxTree.Objects ) {

  			const geoNodes = fbxTree.Objects.Geometry;

  			for ( const nodeID in geoNodes ) {

  				const relationships = connections.get( parseInt( nodeID ) );
  				const geo = this.parseGeometry( relationships, geoNodes[ nodeID ], deformers );

  				geometryMap.set( parseInt( nodeID ), geo );

  			}

  		}

  		// report warnings

  		if ( this.negativeMaterialIndices === true ) {

  			console.warn( 'THREE.FBXLoader: The FBX file contains invalid (negative) material indices. The asset might not render as expected.' );

  		}

  		return geometryMap;

  	}

  	// Parse single node in FBXTree.Objects.Geometry
  	parseGeometry( relationships, geoNode, deformers ) {

  		switch ( geoNode.attrType ) {

  			case 'Mesh':
  				return this.parseMeshGeometry( relationships, geoNode, deformers );

  			case 'NurbsCurve':
  				return this.parseNurbsGeometry( geoNode );

  		}

  	}

  	// Parse single node mesh geometry in FBXTree.Objects.Geometry
  	parseMeshGeometry( relationships, geoNode, deformers ) {

  		const skeletons = deformers.skeletons;
  		const morphTargets = [];

  		const modelNodes = relationships.parents.map( function ( parent ) {

  			return fbxTree.Objects.Model[ parent.ID ];

  		} );

  		// don't create geometry if it is not associated with any models
  		if ( modelNodes.length === 0 ) return;

  		const skeleton = relationships.children.reduce( function ( skeleton, child ) {

  			if ( skeletons[ child.ID ] !== undefined ) skeleton = skeletons[ child.ID ];

  			return skeleton;

  		}, null );

  		relationships.children.forEach( function ( child ) {

  			if ( deformers.morphTargets[ child.ID ] !== undefined ) {

  				morphTargets.push( deformers.morphTargets[ child.ID ] );

  			}

  		} );

  		// Assume one model and get the preRotation from that
  		// if there is more than one model associated with the geometry this may cause problems
  		const modelNode = modelNodes[ 0 ];

  		const transformData = {};

  		if ( 'RotationOrder' in modelNode ) transformData.eulerOrder = getEulerOrder( modelNode.RotationOrder.value );
  		if ( 'InheritType' in modelNode ) transformData.inheritType = parseInt( modelNode.InheritType.value );

  		if ( 'GeometricTranslation' in modelNode ) transformData.translation = modelNode.GeometricTranslation.value;
  		if ( 'GeometricRotation' in modelNode ) transformData.rotation = modelNode.GeometricRotation.value;
  		if ( 'GeometricScaling' in modelNode ) transformData.scale = modelNode.GeometricScaling.value;

  		const transform = generateTransform( transformData );

  		return this.genGeometry( geoNode, skeleton, morphTargets, transform );

  	}

  	// Generate a BufferGeometry from a node in FBXTree.Objects.Geometry
  	genGeometry( geoNode, skeleton, morphTargets, preTransform ) {

  		const geo = new three$2.BufferGeometry();
  		if ( geoNode.attrName ) geo.name = geoNode.attrName;

  		const geoInfo = this.parseGeoNode( geoNode, skeleton );
  		const buffers = this.genBuffers( geoInfo );

  		const positionAttribute = new three$2.Float32BufferAttribute( buffers.vertex, 3 );

  		positionAttribute.applyMatrix4( preTransform );

  		geo.setAttribute( 'position', positionAttribute );

  		if ( buffers.colors.length > 0 ) {

  			geo.setAttribute( 'color', new three$2.Float32BufferAttribute( buffers.colors, 3 ) );

  		}

  		if ( skeleton ) {

  			geo.setAttribute( 'skinIndex', new three$2.Uint16BufferAttribute( buffers.weightsIndices, 4 ) );

  			geo.setAttribute( 'skinWeight', new three$2.Float32BufferAttribute( buffers.vertexWeights, 4 ) );

  			// used later to bind the skeleton to the model
  			geo.FBX_Deformer = skeleton;

  		}

  		if ( buffers.normal.length > 0 ) {

  			const normalMatrix = new three$2.Matrix3().getNormalMatrix( preTransform );

  			const normalAttribute = new three$2.Float32BufferAttribute( buffers.normal, 3 );
  			normalAttribute.applyNormalMatrix( normalMatrix );

  			geo.setAttribute( 'normal', normalAttribute );

  		}

  		buffers.uvs.forEach( function ( uvBuffer, i ) {

  			const name = i === 0 ? 'uv' : `uv${ i }`;

  			geo.setAttribute( name, new three$2.Float32BufferAttribute( buffers.uvs[ i ], 2 ) );

  		} );

  		if ( geoInfo.material && geoInfo.material.mappingType !== 'AllSame' ) {

  			// Convert the material indices of each vertex into rendering groups on the geometry.
  			let prevMaterialIndex = buffers.materialIndex[ 0 ];
  			let startIndex = 0;

  			buffers.materialIndex.forEach( function ( currentIndex, i ) {

  				if ( currentIndex !== prevMaterialIndex ) {

  					geo.addGroup( startIndex, i - startIndex, prevMaterialIndex );

  					prevMaterialIndex = currentIndex;
  					startIndex = i;

  				}

  			} );

  			// the loop above doesn't add the last group, do that here.
  			if ( geo.groups.length > 0 ) {

  				const lastGroup = geo.groups[ geo.groups.length - 1 ];
  				const lastIndex = lastGroup.start + lastGroup.count;

  				if ( lastIndex !== buffers.materialIndex.length ) {

  					geo.addGroup( lastIndex, buffers.materialIndex.length - lastIndex, prevMaterialIndex );

  				}

  			}

  			// case where there are multiple materials but the whole geometry is only
  			// using one of them
  			if ( geo.groups.length === 0 ) {

  				geo.addGroup( 0, buffers.materialIndex.length, buffers.materialIndex[ 0 ] );

  			}

  		}

  		this.addMorphTargets( geo, geoNode, morphTargets, preTransform );

  		return geo;

  	}

  	parseGeoNode( geoNode, skeleton ) {

  		const geoInfo = {};

  		geoInfo.vertexPositions = ( geoNode.Vertices !== undefined ) ? geoNode.Vertices.a : [];
  		geoInfo.vertexIndices = ( geoNode.PolygonVertexIndex !== undefined ) ? geoNode.PolygonVertexIndex.a : [];

  		if ( geoNode.LayerElementColor ) {

  			geoInfo.color = this.parseVertexColors( geoNode.LayerElementColor[ 0 ] );

  		}

  		if ( geoNode.LayerElementMaterial ) {

  			geoInfo.material = this.parseMaterialIndices( geoNode.LayerElementMaterial[ 0 ] );

  		}

  		if ( geoNode.LayerElementNormal ) {

  			geoInfo.normal = this.parseNormals( geoNode.LayerElementNormal[ 0 ] );

  		}

  		if ( geoNode.LayerElementUV ) {

  			geoInfo.uv = [];

  			let i = 0;
  			while ( geoNode.LayerElementUV[ i ] ) {

  				if ( geoNode.LayerElementUV[ i ].UV ) {

  					geoInfo.uv.push( this.parseUVs( geoNode.LayerElementUV[ i ] ) );

  				}

  				i ++;

  			}

  		}

  		geoInfo.weightTable = {};

  		if ( skeleton !== null ) {

  			geoInfo.skeleton = skeleton;

  			skeleton.rawBones.forEach( function ( rawBone, i ) {

  				// loop over the bone's vertex indices and weights
  				rawBone.indices.forEach( function ( index, j ) {

  					if ( geoInfo.weightTable[ index ] === undefined ) geoInfo.weightTable[ index ] = [];

  					geoInfo.weightTable[ index ].push( {

  						id: i,
  						weight: rawBone.weights[ j ],

  					} );

  				} );

  			} );

  		}

  		return geoInfo;

  	}

  	genBuffers( geoInfo ) {

  		const buffers = {
  			vertex: [],
  			normal: [],
  			colors: [],
  			uvs: [],
  			materialIndex: [],
  			vertexWeights: [],
  			weightsIndices: [],
  		};

  		let polygonIndex = 0;
  		let faceLength = 0;
  		let displayedWeightsWarning = false;

  		// these will hold data for a single face
  		let facePositionIndexes = [];
  		let faceNormals = [];
  		let faceColors = [];
  		let faceUVs = [];
  		let faceWeights = [];
  		let faceWeightIndices = [];

  		const scope = this;
  		geoInfo.vertexIndices.forEach( function ( vertexIndex, polygonVertexIndex ) {

  			let materialIndex;
  			let endOfFace = false;

  			// Face index and vertex index arrays are combined in a single array
  			// A cube with quad faces looks like this:
  			// PolygonVertexIndex: *24 {
  			//  a: 0, 1, 3, -3, 2, 3, 5, -5, 4, 5, 7, -7, 6, 7, 1, -1, 1, 7, 5, -4, 6, 0, 2, -5
  			//  }
  			// Negative numbers mark the end of a face - first face here is 0, 1, 3, -3
  			// to find index of last vertex bit shift the index: ^ - 1
  			if ( vertexIndex < 0 ) {

  				vertexIndex = vertexIndex ^ -1; // equivalent to ( x * -1 ) - 1
  				endOfFace = true;

  			}

  			let weightIndices = [];
  			let weights = [];

  			facePositionIndexes.push( vertexIndex * 3, vertexIndex * 3 + 1, vertexIndex * 3 + 2 );

  			if ( geoInfo.color ) {

  				const data = getData( polygonVertexIndex, polygonIndex, vertexIndex, geoInfo.color );

  				faceColors.push( data[ 0 ], data[ 1 ], data[ 2 ] );

  			}

  			if ( geoInfo.skeleton ) {

  				if ( geoInfo.weightTable[ vertexIndex ] !== undefined ) {

  					geoInfo.weightTable[ vertexIndex ].forEach( function ( wt ) {

  						weights.push( wt.weight );
  						weightIndices.push( wt.id );

  					} );


  				}

  				if ( weights.length > 4 ) {

  					if ( ! displayedWeightsWarning ) {

  						console.warn( 'THREE.FBXLoader: Vertex has more than 4 skinning weights assigned to vertex. Deleting additional weights.' );
  						displayedWeightsWarning = true;

  					}

  					const wIndex = [ 0, 0, 0, 0 ];
  					const Weight = [ 0, 0, 0, 0 ];

  					weights.forEach( function ( weight, weightIndex ) {

  						let currentWeight = weight;
  						let currentIndex = weightIndices[ weightIndex ];

  						Weight.forEach( function ( comparedWeight, comparedWeightIndex, comparedWeightArray ) {

  							if ( currentWeight > comparedWeight ) {

  								comparedWeightArray[ comparedWeightIndex ] = currentWeight;
  								currentWeight = comparedWeight;

  								const tmp = wIndex[ comparedWeightIndex ];
  								wIndex[ comparedWeightIndex ] = currentIndex;
  								currentIndex = tmp;

  							}

  						} );

  					} );

  					weightIndices = wIndex;
  					weights = Weight;

  				}

  				// if the weight array is shorter than 4 pad with 0s
  				while ( weights.length < 4 ) {

  					weights.push( 0 );
  					weightIndices.push( 0 );

  				}

  				for ( let i = 0; i < 4; ++ i ) {

  					faceWeights.push( weights[ i ] );
  					faceWeightIndices.push( weightIndices[ i ] );

  				}

  			}

  			if ( geoInfo.normal ) {

  				const data = getData( polygonVertexIndex, polygonIndex, vertexIndex, geoInfo.normal );

  				faceNormals.push( data[ 0 ], data[ 1 ], data[ 2 ] );

  			}

  			if ( geoInfo.material && geoInfo.material.mappingType !== 'AllSame' ) {

  				materialIndex = getData( polygonVertexIndex, polygonIndex, vertexIndex, geoInfo.material )[ 0 ];

  				if ( materialIndex < 0 ) {

  					scope.negativeMaterialIndices = true;
  					materialIndex = 0; // fallback

  				}

  			}

  			if ( geoInfo.uv ) {

  				geoInfo.uv.forEach( function ( uv, i ) {

  					const data = getData( polygonVertexIndex, polygonIndex, vertexIndex, uv );

  					if ( faceUVs[ i ] === undefined ) {

  						faceUVs[ i ] = [];

  					}

  					faceUVs[ i ].push( data[ 0 ] );
  					faceUVs[ i ].push( data[ 1 ] );

  				} );

  			}

  			faceLength ++;

  			if ( endOfFace ) {

  				scope.genFace( buffers, geoInfo, facePositionIndexes, materialIndex, faceNormals, faceColors, faceUVs, faceWeights, faceWeightIndices, faceLength );

  				polygonIndex ++;
  				faceLength = 0;

  				// reset arrays for the next face
  				facePositionIndexes = [];
  				faceNormals = [];
  				faceColors = [];
  				faceUVs = [];
  				faceWeights = [];
  				faceWeightIndices = [];

  			}

  		} );

  		return buffers;

  	}

  	// See https://www.khronos.org/opengl/wiki/Calculating_a_Surface_Normal
  	getNormalNewell( vertices ) {

  		const normal = new three$2.Vector3( 0.0, 0.0, 0.0 );

  		for ( let i = 0; i < vertices.length; i ++ ) {

  			const current = vertices[ i ];
  			const next = vertices[ ( i + 1 ) % vertices.length ];

  			normal.x += ( current.y - next.y ) * ( current.z + next.z );
  			normal.y += ( current.z - next.z ) * ( current.x + next.x );
  			normal.z += ( current.x - next.x ) * ( current.y + next.y );

  		}

  		normal.normalize();

  		return normal;

  	}

  	getNormalTangentAndBitangent( vertices ) {

  		const normalVector = this.getNormalNewell( vertices );
  		// Avoid up being equal or almost equal to normalVector
  		const up = Math.abs( normalVector.z ) > 0.5 ? new three$2.Vector3( 0.0, 1.0, 0.0 ) : new three$2.Vector3( 0.0, 0.0, 1.0 );
  		const tangent = up.cross( normalVector ).normalize();
  		const bitangent = normalVector.clone().cross( tangent ).normalize();

  		return {
  			normal: normalVector,
  			tangent: tangent,
  			bitangent: bitangent
  		};

  	}

  	flattenVertex( vertex, normalTangent, normalBitangent ) {

  		return new three$2.Vector2(
  			vertex.dot( normalTangent ),
  			vertex.dot( normalBitangent )
  		);

  	}

  	// Generate data for a single face in a geometry. If the face is a quad then split it into 2 tris
  	genFace( buffers, geoInfo, facePositionIndexes, materialIndex, faceNormals, faceColors, faceUVs, faceWeights, faceWeightIndices, faceLength ) {

  		let triangles;

  		if ( faceLength > 3 ) {

  			// Triangulate n-gon using earcut

  			const vertices = [];

  			for ( let i = 0; i < facePositionIndexes.length; i += 3 ) {

  				vertices.push( new three$2.Vector3(
  					geoInfo.vertexPositions[ facePositionIndexes[ i ] ],
  					geoInfo.vertexPositions[ facePositionIndexes[ i + 1 ] ],
  					geoInfo.vertexPositions[ facePositionIndexes[ i + 2 ] ]
  				) );

  			}

  			const { tangent, bitangent } = this.getNormalTangentAndBitangent( vertices );
  			const triangulationInput = [];

  			for ( const vertex of vertices ) {

  				triangulationInput.push( this.flattenVertex( vertex, tangent, bitangent ) );

  			}

  			triangles = three$2.ShapeUtils.triangulateShape( triangulationInput, [] );

  		} else {

  			// Regular triangle, skip earcut triangulation step
  			triangles = [[ 0, 1, 2 ]];

  		}

  		for ( const [ i0, i1, i2 ] of triangles ) {

  			buffers.vertex.push( geoInfo.vertexPositions[ facePositionIndexes[ i0 * 3 ] ] );
  			buffers.vertex.push( geoInfo.vertexPositions[ facePositionIndexes[ i0 * 3 + 1 ] ] );
  			buffers.vertex.push( geoInfo.vertexPositions[ facePositionIndexes[ i0 * 3 + 2 ] ] );

  			buffers.vertex.push( geoInfo.vertexPositions[ facePositionIndexes[ i1 * 3 ] ] );
  			buffers.vertex.push( geoInfo.vertexPositions[ facePositionIndexes[ i1 * 3 + 1 ] ] );
  			buffers.vertex.push( geoInfo.vertexPositions[ facePositionIndexes[ i1 * 3 + 2 ] ] );

  			buffers.vertex.push( geoInfo.vertexPositions[ facePositionIndexes[ i2 * 3 ] ] );
  			buffers.vertex.push( geoInfo.vertexPositions[ facePositionIndexes[ i2 * 3 + 1 ] ] );
  			buffers.vertex.push( geoInfo.vertexPositions[ facePositionIndexes[ i2 * 3 + 2 ] ] );

  			if ( geoInfo.skeleton ) {

  				buffers.vertexWeights.push( faceWeights[ i0 * 4 ] );
  				buffers.vertexWeights.push( faceWeights[ i0 * 4 + 1 ] );
  				buffers.vertexWeights.push( faceWeights[ i0 * 4 + 2 ] );
  				buffers.vertexWeights.push( faceWeights[ i0 * 4 + 3 ] );

  				buffers.vertexWeights.push( faceWeights[ i1 * 4 ] );
  				buffers.vertexWeights.push( faceWeights[ i1 * 4 + 1 ] );
  				buffers.vertexWeights.push( faceWeights[ i1 * 4 + 2 ] );
  				buffers.vertexWeights.push( faceWeights[ i1 * 4 + 3 ] );

  				buffers.vertexWeights.push( faceWeights[ i2 * 4 ] );
  				buffers.vertexWeights.push( faceWeights[ i2 * 4 + 1 ] );
  				buffers.vertexWeights.push( faceWeights[ i2 * 4 + 2 ] );
  				buffers.vertexWeights.push( faceWeights[ i2 * 4 + 3 ] );

  				buffers.weightsIndices.push( faceWeightIndices[ i0 * 4 ] );
  				buffers.weightsIndices.push( faceWeightIndices[ i0 * 4 + 1 ] );
  				buffers.weightsIndices.push( faceWeightIndices[ i0 * 4 + 2 ] );
  				buffers.weightsIndices.push( faceWeightIndices[ i0 * 4 + 3 ] );

  				buffers.weightsIndices.push( faceWeightIndices[ i1 * 4 ] );
  				buffers.weightsIndices.push( faceWeightIndices[ i1 * 4 + 1 ] );
  				buffers.weightsIndices.push( faceWeightIndices[ i1 * 4 + 2 ] );
  				buffers.weightsIndices.push( faceWeightIndices[ i1 * 4 + 3 ] );

  				buffers.weightsIndices.push( faceWeightIndices[ i2 * 4 ] );
  				buffers.weightsIndices.push( faceWeightIndices[ i2 * 4 + 1 ] );
  				buffers.weightsIndices.push( faceWeightIndices[ i2 * 4 + 2 ] );
  				buffers.weightsIndices.push( faceWeightIndices[ i2 * 4 + 3 ] );

  			}

  			if ( geoInfo.color ) {

  				buffers.colors.push( faceColors[ i0 * 3 ] );
  				buffers.colors.push( faceColors[ i0 * 3 + 1 ] );
  				buffers.colors.push( faceColors[ i0 * 3 + 2 ] );

  				buffers.colors.push( faceColors[ i1 * 3 ] );
  				buffers.colors.push( faceColors[ i1 * 3 + 1 ] );
  				buffers.colors.push( faceColors[ i1 * 3 + 2 ] );

  				buffers.colors.push( faceColors[ i2 * 3 ] );
  				buffers.colors.push( faceColors[ i2 * 3 + 1 ] );
  				buffers.colors.push( faceColors[ i2 * 3 + 2 ] );

  			}

  			if ( geoInfo.material && geoInfo.material.mappingType !== 'AllSame' ) {

  				buffers.materialIndex.push( materialIndex );
  				buffers.materialIndex.push( materialIndex );
  				buffers.materialIndex.push( materialIndex );

  			}

  			if ( geoInfo.normal ) {

  				buffers.normal.push( faceNormals[ i0 * 3 ] );
  				buffers.normal.push( faceNormals[ i0 * 3 + 1 ] );
  				buffers.normal.push( faceNormals[ i0 * 3 + 2 ] );

  				buffers.normal.push( faceNormals[ i1 * 3 ] );
  				buffers.normal.push( faceNormals[ i1 * 3 + 1 ] );
  				buffers.normal.push( faceNormals[ i1 * 3 + 2 ] );

  				buffers.normal.push( faceNormals[ i2 * 3 ] );
  				buffers.normal.push( faceNormals[ i2 * 3 + 1 ] );
  				buffers.normal.push( faceNormals[ i2 * 3 + 2 ] );

  			}

  			if ( geoInfo.uv ) {

  				geoInfo.uv.forEach( function ( uv, j ) {

  					if ( buffers.uvs[ j ] === undefined ) buffers.uvs[ j ] = [];

  					buffers.uvs[ j ].push( faceUVs[ j ][ i0 * 2 ] );
  					buffers.uvs[ j ].push( faceUVs[ j ][ i0 * 2 + 1 ] );

  					buffers.uvs[ j ].push( faceUVs[ j ][ i1 * 2 ] );
  					buffers.uvs[ j ].push( faceUVs[ j ][ i1 * 2 + 1 ] );

  					buffers.uvs[ j ].push( faceUVs[ j ][ i2 * 2 ] );
  					buffers.uvs[ j ].push( faceUVs[ j ][ i2 * 2 + 1 ] );

  				} );

  			}

  		}

  	}

  	addMorphTargets( parentGeo, parentGeoNode, morphTargets, preTransform ) {

  		if ( morphTargets.length === 0 ) return;

  		parentGeo.morphTargetsRelative = true;

  		parentGeo.morphAttributes.position = [];
  		// parentGeo.morphAttributes.normal = []; // not implemented

  		const scope = this;
  		morphTargets.forEach( function ( morphTarget ) {

  			morphTarget.rawTargets.forEach( function ( rawTarget ) {

  				const morphGeoNode = fbxTree.Objects.Geometry[ rawTarget.geoID ];

  				if ( morphGeoNode !== undefined ) {

  					scope.genMorphGeometry( parentGeo, parentGeoNode, morphGeoNode, preTransform, rawTarget.name );

  				}

  			} );

  		} );

  	}

  	// a morph geometry node is similar to a standard  node, and the node is also contained
  	// in FBXTree.Objects.Geometry, however it can only have attributes for position, normal
  	// and a special attribute Index defining which vertices of the original geometry are affected
  	// Normal and position attributes only have data for the vertices that are affected by the morph
  	genMorphGeometry( parentGeo, parentGeoNode, morphGeoNode, preTransform, name ) {

  		const vertexIndices = ( parentGeoNode.PolygonVertexIndex !== undefined ) ? parentGeoNode.PolygonVertexIndex.a : [];

  		const morphPositionsSparse = ( morphGeoNode.Vertices !== undefined ) ? morphGeoNode.Vertices.a : [];
  		const indices = ( morphGeoNode.Indexes !== undefined ) ? morphGeoNode.Indexes.a : [];

  		const length = parentGeo.attributes.position.count * 3;
  		const morphPositions = new Float32Array( length );

  		for ( let i = 0; i < indices.length; i ++ ) {

  			const morphIndex = indices[ i ] * 3;

  			morphPositions[ morphIndex ] = morphPositionsSparse[ i * 3 ];
  			morphPositions[ morphIndex + 1 ] = morphPositionsSparse[ i * 3 + 1 ];
  			morphPositions[ morphIndex + 2 ] = morphPositionsSparse[ i * 3 + 2 ];

  		}

  		// TODO: add morph normal support
  		const morphGeoInfo = {
  			vertexIndices: vertexIndices,
  			vertexPositions: morphPositions,

  		};

  		const morphBuffers = this.genBuffers( morphGeoInfo );

  		const positionAttribute = new three$2.Float32BufferAttribute( morphBuffers.vertex, 3 );
  		positionAttribute.name = name || morphGeoNode.attrName;

  		positionAttribute.applyMatrix4( preTransform );

  		parentGeo.morphAttributes.position.push( positionAttribute );

  	}

  	// Parse normal from FBXTree.Objects.Geometry.LayerElementNormal if it exists
  	parseNormals( NormalNode ) {

  		const mappingType = NormalNode.MappingInformationType;
  		const referenceType = NormalNode.ReferenceInformationType;
  		const buffer = NormalNode.Normals.a;
  		let indexBuffer = [];
  		if ( referenceType === 'IndexToDirect' ) {

  			if ( 'NormalIndex' in NormalNode ) {

  				indexBuffer = NormalNode.NormalIndex.a;

  			} else if ( 'NormalsIndex' in NormalNode ) {

  				indexBuffer = NormalNode.NormalsIndex.a;

  			}

  		}

  		return {
  			dataSize: 3,
  			buffer: buffer,
  			indices: indexBuffer,
  			mappingType: mappingType,
  			referenceType: referenceType
  		};

  	}

  	// Parse UVs from FBXTree.Objects.Geometry.LayerElementUV if it exists
  	parseUVs( UVNode ) {

  		const mappingType = UVNode.MappingInformationType;
  		const referenceType = UVNode.ReferenceInformationType;
  		const buffer = UVNode.UV.a;
  		let indexBuffer = [];
  		if ( referenceType === 'IndexToDirect' ) {

  			indexBuffer = UVNode.UVIndex.a;

  		}

  		return {
  			dataSize: 2,
  			buffer: buffer,
  			indices: indexBuffer,
  			mappingType: mappingType,
  			referenceType: referenceType
  		};

  	}

  	// Parse Vertex Colors from FBXTree.Objects.Geometry.LayerElementColor if it exists
  	parseVertexColors( ColorNode ) {

  		const mappingType = ColorNode.MappingInformationType;
  		const referenceType = ColorNode.ReferenceInformationType;
  		const buffer = ColorNode.Colors.a;
  		let indexBuffer = [];
  		if ( referenceType === 'IndexToDirect' ) {

  			indexBuffer = ColorNode.ColorIndex.a;

  		}

  		for ( let i = 0, c = new three$2.Color(); i < buffer.length; i += 4 ) {

  			c.fromArray( buffer, i ).convertSRGBToLinear().toArray( buffer, i );

  		}

  		return {
  			dataSize: 4,
  			buffer: buffer,
  			indices: indexBuffer,
  			mappingType: mappingType,
  			referenceType: referenceType
  		};

  	}

  	// Parse mapping and material data in FBXTree.Objects.Geometry.LayerElementMaterial if it exists
  	parseMaterialIndices( MaterialNode ) {

  		const mappingType = MaterialNode.MappingInformationType;
  		const referenceType = MaterialNode.ReferenceInformationType;

  		if ( mappingType === 'NoMappingInformation' ) {

  			return {
  				dataSize: 1,
  				buffer: [ 0 ],
  				indices: [ 0 ],
  				mappingType: 'AllSame',
  				referenceType: referenceType
  			};

  		}

  		const materialIndexBuffer = MaterialNode.Materials.a;

  		// Since materials are stored as indices, there's a bit of a mismatch between FBX and what
  		// we expect.So we create an intermediate buffer that points to the index in the buffer,
  		// for conforming with the other functions we've written for other data.
  		const materialIndices = [];

  		for ( let i = 0; i < materialIndexBuffer.length; ++ i ) {

  			materialIndices.push( i );

  		}

  		return {
  			dataSize: 1,
  			buffer: materialIndexBuffer,
  			indices: materialIndices,
  			mappingType: mappingType,
  			referenceType: referenceType
  		};

  	}

  	// Generate a NurbGeometry from a node in FBXTree.Objects.Geometry
  	parseNurbsGeometry( geoNode ) {

  		const order = parseInt( geoNode.Order );

  		if ( isNaN( order ) ) {

  			console.error( 'THREE.FBXLoader: Invalid Order %s given for geometry ID: %s', geoNode.Order, geoNode.id );
  			return new three$2.BufferGeometry();

  		}

  		const degree = order - 1;

  		const knots = geoNode.KnotVector.a;
  		const controlPoints = [];
  		const pointsValues = geoNode.Points.a;

  		for ( let i = 0, l = pointsValues.length; i < l; i += 4 ) {

  			controlPoints.push( new three$2.Vector4().fromArray( pointsValues, i ) );

  		}

  		let startKnot, endKnot;

  		if ( geoNode.Form === 'Closed' ) {

  			controlPoints.push( controlPoints[ 0 ] );

  		} else if ( geoNode.Form === 'Periodic' ) {

  			startKnot = degree;
  			endKnot = knots.length - 1 - startKnot;

  			for ( let i = 0; i < degree; ++ i ) {

  				controlPoints.push( controlPoints[ i ] );

  			}

  		}

  		const curve = new NURBSCurve( degree, knots, controlPoints, startKnot, endKnot );
  		const points = curve.getPoints( controlPoints.length * 12 );

  		return new three$2.BufferGeometry().setFromPoints( points );

  	}

  }

  // parse animation data from FBXTree
  class AnimationParser {

  	// take raw animation clips and turn them into three.js animation clips
  	parse() {

  		const animationClips = [];

  		const rawClips = this.parseClips();

  		if ( rawClips !== undefined ) {

  			for ( const key in rawClips ) {

  				const rawClip = rawClips[ key ];

  				const clip = this.addClip( rawClip );

  				animationClips.push( clip );

  			}

  		}

  		return animationClips;

  	}

  	parseClips() {

  		// since the actual transformation data is stored in FBXTree.Objects.AnimationCurve,
  		// if this is undefined we can safely assume there are no animations
  		if ( fbxTree.Objects.AnimationCurve === undefined ) return undefined;

  		const curveNodesMap = this.parseAnimationCurveNodes();

  		this.parseAnimationCurves( curveNodesMap );

  		const layersMap = this.parseAnimationLayers( curveNodesMap );
  		const rawClips = this.parseAnimStacks( layersMap );

  		return rawClips;

  	}

  	// parse nodes in FBXTree.Objects.AnimationCurveNode
  	// each AnimationCurveNode holds data for an animation transform for a model (e.g. left arm rotation )
  	// and is referenced by an AnimationLayer
  	parseAnimationCurveNodes() {

  		const rawCurveNodes = fbxTree.Objects.AnimationCurveNode;

  		const curveNodesMap = new Map();

  		for ( const nodeID in rawCurveNodes ) {

  			const rawCurveNode = rawCurveNodes[ nodeID ];

  			if ( rawCurveNode.attrName.match( /S|R|T|DeformPercent/ ) !== null ) {

  				const curveNode = {

  					id: rawCurveNode.id,
  					attr: rawCurveNode.attrName,
  					curves: {},

  				};

  				curveNodesMap.set( curveNode.id, curveNode );

  			}

  		}

  		return curveNodesMap;

  	}

  	// parse nodes in FBXTree.Objects.AnimationCurve and connect them up to
  	// previously parsed AnimationCurveNodes. Each AnimationCurve holds data for a single animated
  	// axis ( e.g. times and values of x rotation)
  	parseAnimationCurves( curveNodesMap ) {

  		const rawCurves = fbxTree.Objects.AnimationCurve;

  		// TODO: Many values are identical up to roundoff error, but won't be optimised
  		// e.g. position times: [0, 0.4, 0. 8]
  		// position values: [7.23538335023477e-7, 93.67518615722656, -0.9982695579528809, 7.23538335023477e-7, 93.67518615722656, -0.9982695579528809, 7.235384487103147e-7, 93.67520904541016, -0.9982695579528809]
  		// clearly, this should be optimised to
  		// times: [0], positions [7.23538335023477e-7, 93.67518615722656, -0.9982695579528809]
  		// this shows up in nearly every FBX file, and generally time array is length > 100

  		for ( const nodeID in rawCurves ) {

  			const animationCurve = {

  				id: rawCurves[ nodeID ].id,
  				times: rawCurves[ nodeID ].KeyTime.a.map( convertFBXTimeToSeconds ),
  				values: rawCurves[ nodeID ].KeyValueFloat.a,

  			};

  			const relationships = connections.get( animationCurve.id );

  			if ( relationships !== undefined ) {

  				const animationCurveID = relationships.parents[ 0 ].ID;
  				const animationCurveRelationship = relationships.parents[ 0 ].relationship;

  				if ( animationCurveRelationship.match( /X/ ) ) {

  					curveNodesMap.get( animationCurveID ).curves[ 'x' ] = animationCurve;

  				} else if ( animationCurveRelationship.match( /Y/ ) ) {

  					curveNodesMap.get( animationCurveID ).curves[ 'y' ] = animationCurve;

  				} else if ( animationCurveRelationship.match( /Z/ ) ) {

  					curveNodesMap.get( animationCurveID ).curves[ 'z' ] = animationCurve;

  				} else if ( animationCurveRelationship.match( /DeformPercent/ ) && curveNodesMap.has( animationCurveID ) ) {

  					curveNodesMap.get( animationCurveID ).curves[ 'morph' ] = animationCurve;

  				}

  			}

  		}

  	}

  	// parse nodes in FBXTree.Objects.AnimationLayer. Each layers holds references
  	// to various AnimationCurveNodes and is referenced by an AnimationStack node
  	// note: theoretically a stack can have multiple layers, however in practice there always seems to be one per stack
  	parseAnimationLayers( curveNodesMap ) {

  		const rawLayers = fbxTree.Objects.AnimationLayer;

  		const layersMap = new Map();

  		for ( const nodeID in rawLayers ) {

  			const layerCurveNodes = [];

  			const connection = connections.get( parseInt( nodeID ) );

  			if ( connection !== undefined ) {

  				// all the animationCurveNodes used in the layer
  				const children = connection.children;

  				children.forEach( function ( child, i ) {

  					if ( curveNodesMap.has( child.ID ) ) {

  						const curveNode = curveNodesMap.get( child.ID );

  						// check that the curves are defined for at least one axis, otherwise ignore the curveNode
  						if ( curveNode.curves.x !== undefined || curveNode.curves.y !== undefined || curveNode.curves.z !== undefined ) {

  							if ( layerCurveNodes[ i ] === undefined ) {

  								const modelID = connections.get( child.ID ).parents.filter( function ( parent ) {

  									return parent.relationship !== undefined;

  								} )[ 0 ].ID;

  								if ( modelID !== undefined ) {

  									const rawModel = fbxTree.Objects.Model[ modelID.toString() ];

  									if ( rawModel === undefined ) {

  										console.warn( 'THREE.FBXLoader: Encountered a unused curve.', child );
  										return;

  									}

  									const node = {

  										modelName: rawModel.attrName ? three$2.PropertyBinding.sanitizeNodeName( rawModel.attrName ) : '',
  										ID: rawModel.id,
  										initialPosition: [ 0, 0, 0 ],
  										initialRotation: [ 0, 0, 0 ],
  										initialScale: [ 1, 1, 1 ],

  									};

  									sceneGraph.traverse( function ( child ) {

  										if ( child.ID === rawModel.id ) {

  											node.transform = child.matrix;

  											if ( child.userData.transformData ) node.eulerOrder = child.userData.transformData.eulerOrder;

  										}

  									} );

  									if ( ! node.transform ) node.transform = new three$2.Matrix4();

  									// if the animated model is pre rotated, we'll have to apply the pre rotations to every
  									// animation value as well
  									if ( 'PreRotation' in rawModel ) node.preRotation = rawModel.PreRotation.value;
  									if ( 'PostRotation' in rawModel ) node.postRotation = rawModel.PostRotation.value;

  									layerCurveNodes[ i ] = node;

  								}

  							}

  							if ( layerCurveNodes[ i ] ) layerCurveNodes[ i ][ curveNode.attr ] = curveNode;

  						} else if ( curveNode.curves.morph !== undefined ) {

  							if ( layerCurveNodes[ i ] === undefined ) {

  								const deformerID = connections.get( child.ID ).parents.filter( function ( parent ) {

  									return parent.relationship !== undefined;

  								} )[ 0 ].ID;

  								const morpherID = connections.get( deformerID ).parents[ 0 ].ID;
  								const geoID = connections.get( morpherID ).parents[ 0 ].ID;

  								// assuming geometry is not used in more than one model
  								const modelID = connections.get( geoID ).parents[ 0 ].ID;

  								const rawModel = fbxTree.Objects.Model[ modelID ];

  								const node = {

  									modelName: rawModel.attrName ? three$2.PropertyBinding.sanitizeNodeName( rawModel.attrName ) : '',
  									morphName: fbxTree.Objects.Deformer[ deformerID ].attrName,

  								};

  								layerCurveNodes[ i ] = node;

  							}

  							layerCurveNodes[ i ][ curveNode.attr ] = curveNode;

  						}

  					}

  				} );

  				layersMap.set( parseInt( nodeID ), layerCurveNodes );

  			}

  		}

  		return layersMap;

  	}

  	// parse nodes in FBXTree.Objects.AnimationStack. These are the top level node in the animation
  	// hierarchy. Each Stack node will be used to create a AnimationClip
  	parseAnimStacks( layersMap ) {

  		const rawStacks = fbxTree.Objects.AnimationStack;

  		// connect the stacks (clips) up to the layers
  		const rawClips = {};

  		for ( const nodeID in rawStacks ) {

  			const children = connections.get( parseInt( nodeID ) ).children;

  			if ( children.length > 1 ) {

  				// it seems like stacks will always be associated with a single layer. But just in case there are files
  				// where there are multiple layers per stack, we'll display a warning
  				console.warn( 'THREE.FBXLoader: Encountered an animation stack with multiple layers, this is currently not supported. Ignoring subsequent layers.' );

  			}

  			const layer = layersMap.get( children[ 0 ].ID );

  			rawClips[ nodeID ] = {

  				name: rawStacks[ nodeID ].attrName,
  				layer: layer,

  			};

  		}

  		return rawClips;

  	}

  	addClip( rawClip ) {

  		let tracks = [];

  		const scope = this;
  		rawClip.layer.forEach( function ( rawTracks ) {

  			tracks = tracks.concat( scope.generateTracks( rawTracks ) );

  		} );

  		return new three$2.AnimationClip( rawClip.name, -1, tracks );

  	}

  	generateTracks( rawTracks ) {

  		const tracks = [];

  		let initialPosition = new three$2.Vector3();
  		let initialScale = new three$2.Vector3();

  		if ( rawTracks.transform ) rawTracks.transform.decompose( initialPosition, new three$2.Quaternion(), initialScale );

  		initialPosition = initialPosition.toArray();
  		initialScale = initialScale.toArray();

  		if ( rawTracks.T !== undefined && Object.keys( rawTracks.T.curves ).length > 0 ) {

  			const positionTrack = this.generateVectorTrack( rawTracks.modelName, rawTracks.T.curves, initialPosition, 'position' );
  			if ( positionTrack !== undefined ) tracks.push( positionTrack );

  		}

  		if ( rawTracks.R !== undefined && Object.keys( rawTracks.R.curves ).length > 0 ) {

  			const rotationTrack = this.generateRotationTrack( rawTracks.modelName, rawTracks.R.curves, rawTracks.preRotation, rawTracks.postRotation, rawTracks.eulerOrder );
  			if ( rotationTrack !== undefined ) tracks.push( rotationTrack );

  		}

  		if ( rawTracks.S !== undefined && Object.keys( rawTracks.S.curves ).length > 0 ) {

  			const scaleTrack = this.generateVectorTrack( rawTracks.modelName, rawTracks.S.curves, initialScale, 'scale' );
  			if ( scaleTrack !== undefined ) tracks.push( scaleTrack );

  		}

  		if ( rawTracks.DeformPercent !== undefined ) {

  			const morphTrack = this.generateMorphTrack( rawTracks );
  			if ( morphTrack !== undefined ) tracks.push( morphTrack );

  		}

  		return tracks;

  	}

  	generateVectorTrack( modelName, curves, initialValue, type ) {

  		const times = this.getTimesForAllAxes( curves );
  		const values = this.getKeyframeTrackValues( times, curves, initialValue );

  		return new three$2.VectorKeyframeTrack( modelName + '.' + type, times, values );

  	}

  	generateRotationTrack( modelName, curves, preRotation, postRotation, eulerOrder ) {

  		let times;
  		let values;

  		if ( curves.x !== undefined && curves.y !== undefined && curves.z !== undefined ) {

  			const result = this.interpolateRotations( curves.x, curves.y, curves.z, eulerOrder );

  			times = result[ 0 ];
  			values = result[ 1 ];

  		}

  		if ( preRotation !== undefined ) {

  			preRotation = preRotation.map( three$2.MathUtils.degToRad );
  			preRotation.push( eulerOrder );

  			preRotation = new three$2.Euler().fromArray( preRotation );
  			preRotation = new three$2.Quaternion().setFromEuler( preRotation );

  		}

  		if ( postRotation !== undefined ) {

  			postRotation = postRotation.map( three$2.MathUtils.degToRad );
  			postRotation.push( eulerOrder );

  			postRotation = new three$2.Euler().fromArray( postRotation );
  			postRotation = new three$2.Quaternion().setFromEuler( postRotation ).invert();

  		}

  		const quaternion = new three$2.Quaternion();
  		const euler = new three$2.Euler();

  		const quaternionValues = [];

  		if ( ! values || ! times ) return new three$2.QuaternionKeyframeTrack( modelName + '.quaternion', [ 0 ], [ 0 ] );

  		for ( let i = 0; i < values.length; i += 3 ) {

  			euler.set( values[ i ], values[ i + 1 ], values[ i + 2 ], eulerOrder );
  			quaternion.setFromEuler( euler );

  			if ( preRotation !== undefined ) quaternion.premultiply( preRotation );
  			if ( postRotation !== undefined ) quaternion.multiply( postRotation );

  			// Check unroll
  			if ( i > 2 ) {

  				const prevQuat = new three$2.Quaternion().fromArray(
  					quaternionValues,
  					( ( i - 3 ) / 3 ) * 4
  				);

  				if ( prevQuat.dot( quaternion ) < 0 ) {

  					quaternion.set( - quaternion.x, - quaternion.y, - quaternion.z, - quaternion.w );

  				}

  			}

  			quaternion.toArray( quaternionValues, ( i / 3 ) * 4 );

  		}

  		return new three$2.QuaternionKeyframeTrack( modelName + '.quaternion', times, quaternionValues );

  	}

  	generateMorphTrack( rawTracks ) {

  		const curves = rawTracks.DeformPercent.curves.morph;
  		const values = curves.values.map( function ( val ) {

  			return val / 100;

  		} );

  		const morphNum = sceneGraph.getObjectByName( rawTracks.modelName ).morphTargetDictionary[ rawTracks.morphName ];

  		return new three$2.NumberKeyframeTrack( rawTracks.modelName + '.morphTargetInfluences[' + morphNum + ']', curves.times, values );

  	}

  	// For all animated objects, times are defined separately for each axis
  	// Here we'll combine the times into one sorted array without duplicates
  	getTimesForAllAxes( curves ) {

  		let times = [];

  		// first join together the times for each axis, if defined
  		if ( curves.x !== undefined ) times = times.concat( curves.x.times );
  		if ( curves.y !== undefined ) times = times.concat( curves.y.times );
  		if ( curves.z !== undefined ) times = times.concat( curves.z.times );

  		// then sort them
  		times = times.sort( function ( a, b ) {

  			return a - b;

  		} );

  		// and remove duplicates
  		if ( times.length > 1 ) {

  			let targetIndex = 1;
  			let lastValue = times[ 0 ];
  			for ( let i = 1; i < times.length; i ++ ) {

  				const currentValue = times[ i ];
  				if ( currentValue !== lastValue ) {

  					times[ targetIndex ] = currentValue;
  					lastValue = currentValue;
  					targetIndex ++;

  				}

  			}

  			times = times.slice( 0, targetIndex );

  		}

  		return times;

  	}

  	getKeyframeTrackValues( times, curves, initialValue ) {

  		const prevValue = initialValue;

  		const values = [];

  		let xIndex = -1;
  		let yIndex = -1;
  		let zIndex = -1;

  		times.forEach( function ( time ) {

  			if ( curves.x ) xIndex = curves.x.times.indexOf( time );
  			if ( curves.y ) yIndex = curves.y.times.indexOf( time );
  			if ( curves.z ) zIndex = curves.z.times.indexOf( time );

  			// if there is an x value defined for this frame, use that
  			if ( xIndex !== -1 ) {

  				const xValue = curves.x.values[ xIndex ];
  				values.push( xValue );
  				prevValue[ 0 ] = xValue;

  			} else {

  				// otherwise use the x value from the previous frame
  				values.push( prevValue[ 0 ] );

  			}

  			if ( yIndex !== -1 ) {

  				const yValue = curves.y.values[ yIndex ];
  				values.push( yValue );
  				prevValue[ 1 ] = yValue;

  			} else {

  				values.push( prevValue[ 1 ] );

  			}

  			if ( zIndex !== -1 ) {

  				const zValue = curves.z.values[ zIndex ];
  				values.push( zValue );
  				prevValue[ 2 ] = zValue;

  			} else {

  				values.push( prevValue[ 2 ] );

  			}

  		} );

  		return values;

  	}

  	// Rotations are defined as Euler angles which can have values  of any size
  	// These will be converted to quaternions which don't support values greater than
  	// PI, so we'll interpolate large rotations
  	interpolateRotations( curvex, curvey, curvez, eulerOrder ) {

  		const times = [];
  		const values = [];

  		// Add first frame
  		times.push( curvex.times[ 0 ] );
  		values.push( three$2.MathUtils.degToRad( curvex.values[ 0 ] ) );
  		values.push( three$2.MathUtils.degToRad( curvey.values[ 0 ] ) );
  		values.push( three$2.MathUtils.degToRad( curvez.values[ 0 ] ) );

  		for ( let i = 1; i < curvex.values.length; i ++ ) {

  			const initialValue = [
  				curvex.values[ i - 1 ],
  				curvey.values[ i - 1 ],
  				curvez.values[ i - 1 ],
  			];

  			if ( isNaN( initialValue[ 0 ] ) || isNaN( initialValue[ 1 ] ) || isNaN( initialValue[ 2 ] ) ) {

  				continue;

  			}

  			const initialValueRad = initialValue.map( three$2.MathUtils.degToRad );

  			const currentValue = [
  				curvex.values[ i ],
  				curvey.values[ i ],
  				curvez.values[ i ],
  			];

  			if ( isNaN( currentValue[ 0 ] ) || isNaN( currentValue[ 1 ] ) || isNaN( currentValue[ 2 ] ) ) {

  				continue;

  			}

  			const currentValueRad = currentValue.map( three$2.MathUtils.degToRad );

  			const valuesSpan = [
  				currentValue[ 0 ] - initialValue[ 0 ],
  				currentValue[ 1 ] - initialValue[ 1 ],
  				currentValue[ 2 ] - initialValue[ 2 ],
  			];

  			const absoluteSpan = [
  				Math.abs( valuesSpan[ 0 ] ),
  				Math.abs( valuesSpan[ 1 ] ),
  				Math.abs( valuesSpan[ 2 ] ),
  			];

  			if ( absoluteSpan[ 0 ] >= 180 || absoluteSpan[ 1 ] >= 180 || absoluteSpan[ 2 ] >= 180 ) {

  				const maxAbsSpan = Math.max( ...absoluteSpan );

  				const numSubIntervals = maxAbsSpan / 180;

  				const E1 = new three$2.Euler( ...initialValueRad, eulerOrder );
  				const E2 = new three$2.Euler( ...currentValueRad, eulerOrder );

  				const Q1 = new three$2.Quaternion().setFromEuler( E1 );
  				const Q2 = new three$2.Quaternion().setFromEuler( E2 );

  				// Check unroll
  				if ( Q1.dot( Q2 ) ) {

  					Q2.set( - Q2.x, - Q2.y, - Q2.z, - Q2.w );

  				}

  				// Interpolate
  				const initialTime = curvex.times[ i - 1 ];
  				const timeSpan = curvex.times[ i ] - initialTime;

  				const Q = new three$2.Quaternion();
  				const E = new three$2.Euler();
  				for ( let t = 0; t < 1; t += 1 / numSubIntervals ) {

  					Q.copy( Q1.clone().slerp( Q2.clone(), t ) );

  					times.push( initialTime + t * timeSpan );
  					E.setFromQuaternion( Q, eulerOrder );

  					values.push( E.x );
  					values.push( E.y );
  					values.push( E.z );

  				}

  			} else {

  				times.push( curvex.times[ i ] );
  				values.push( three$2.MathUtils.degToRad( curvex.values[ i ] ) );
  				values.push( three$2.MathUtils.degToRad( curvey.values[ i ] ) );
  				values.push( three$2.MathUtils.degToRad( curvez.values[ i ] ) );

  			}

  		}

  		return [ times, values ];

  	}

  }

  // parse an FBX file in ASCII format
  class TextParser {

  	getPrevNode() {

  		return this.nodeStack[ this.currentIndent - 2 ];

  	}

  	getCurrentNode() {

  		return this.nodeStack[ this.currentIndent - 1 ];

  	}

  	getCurrentProp() {

  		return this.currentProp;

  	}

  	pushStack( node ) {

  		this.nodeStack.push( node );
  		this.currentIndent += 1;

  	}

  	popStack() {

  		this.nodeStack.pop();
  		this.currentIndent -= 1;

  	}

  	setCurrentProp( val, name ) {

  		this.currentProp = val;
  		this.currentPropName = name;

  	}

  	parse( text ) {

  		this.currentIndent = 0;

  		this.allNodes = new FBXTree();
  		this.nodeStack = [];
  		this.currentProp = [];
  		this.currentPropName = '';

  		const scope = this;

  		const split = text.split( /[\r\n]+/ );

  		split.forEach( function ( line, i ) {

  			const matchComment = line.match( /^[\s\t]*;/ );
  			const matchEmpty = line.match( /^[\s\t]*$/ );

  			if ( matchComment || matchEmpty ) return;

  			const matchBeginning = line.match( '^\\t{' + scope.currentIndent + '}(\\w+):(.*){', '' );
  			const matchProperty = line.match( '^\\t{' + ( scope.currentIndent ) + '}(\\w+):[\\s\\t\\r\\n](.*)' );
  			const matchEnd = line.match( '^\\t{' + ( scope.currentIndent - 1 ) + '}}' );

  			if ( matchBeginning ) {

  				scope.parseNodeBegin( line, matchBeginning );

  			} else if ( matchProperty ) {

  				scope.parseNodeProperty( line, matchProperty, split[ ++ i ] );

  			} else if ( matchEnd ) {

  				scope.popStack();

  			} else if ( line.match( /^[^\s\t}]/ ) ) {

  				// large arrays are split over multiple lines terminated with a ',' character
  				// if this is encountered the line needs to be joined to the previous line
  				scope.parseNodePropertyContinued( line );

  			}

  		} );

  		return this.allNodes;

  	}

  	parseNodeBegin( line, property ) {

  		const nodeName = property[ 1 ].trim().replace( /^"/, '' ).replace( /"$/, '' );

  		const nodeAttrs = property[ 2 ].split( ',' ).map( function ( attr ) {

  			return attr.trim().replace( /^"/, '' ).replace( /"$/, '' );

  		} );

  		const node = { name: nodeName };
  		const attrs = this.parseNodeAttr( nodeAttrs );

  		const currentNode = this.getCurrentNode();

  		// a top node
  		if ( this.currentIndent === 0 ) {

  			this.allNodes.add( nodeName, node );

  		} else { // a subnode

  			// if the subnode already exists, append it
  			if ( nodeName in currentNode ) {

  				// special case Pose needs PoseNodes as an array
  				if ( nodeName === 'PoseNode' ) {

  					currentNode.PoseNode.push( node );

  				} else if ( currentNode[ nodeName ].id !== undefined ) {

  					currentNode[ nodeName ] = {};
  					currentNode[ nodeName ][ currentNode[ nodeName ].id ] = currentNode[ nodeName ];

  				}

  				if ( attrs.id !== '' ) currentNode[ nodeName ][ attrs.id ] = node;

  			} else if ( typeof attrs.id === 'number' ) {

  				currentNode[ nodeName ] = {};
  				currentNode[ nodeName ][ attrs.id ] = node;

  			} else if ( nodeName !== 'Properties70' ) {

  				if ( nodeName === 'PoseNode' )	currentNode[ nodeName ] = [ node ];
  				else currentNode[ nodeName ] = node;

  			}

  		}

  		if ( typeof attrs.id === 'number' ) node.id = attrs.id;
  		if ( attrs.name !== '' ) node.attrName = attrs.name;
  		if ( attrs.type !== '' ) node.attrType = attrs.type;

  		this.pushStack( node );

  	}

  	parseNodeAttr( attrs ) {

  		let id = attrs[ 0 ];

  		if ( attrs[ 0 ] !== '' ) {

  			id = parseInt( attrs[ 0 ] );

  			if ( isNaN( id ) ) {

  				id = attrs[ 0 ];

  			}

  		}

  		let name = '', type = '';

  		if ( attrs.length > 1 ) {

  			name = attrs[ 1 ].replace( /^(\w+)::/, '' );
  			type = attrs[ 2 ];

  		}

  		return { id: id, name: name, type: type };

  	}

  	parseNodeProperty( line, property, contentLine ) {

  		let propName = property[ 1 ].replace( /^"/, '' ).replace( /"$/, '' ).trim();
  		let propValue = property[ 2 ].replace( /^"/, '' ).replace( /"$/, '' ).trim();

  		// for special case: base64 image data follows "Content: ," line
  		//	Content: ,
  		//	 "/9j/4RDaRXhpZgAATU0A..."
  		if ( propName === 'Content' && propValue === ',' ) {

  			propValue = contentLine.replace( /"/g, '' ).replace( /,$/, '' ).trim();

  		}

  		const currentNode = this.getCurrentNode();
  		const parentName = currentNode.name;

  		if ( parentName === 'Properties70' ) {

  			this.parseNodeSpecialProperty( line, propName, propValue );
  			return;

  		}

  		// Connections
  		if ( propName === 'C' ) {

  			const connProps = propValue.split( ',' ).slice( 1 );
  			const from = parseInt( connProps[ 0 ] );
  			const to = parseInt( connProps[ 1 ] );

  			let rest = propValue.split( ',' ).slice( 3 );

  			rest = rest.map( function ( elem ) {

  				return elem.trim().replace( /^"/, '' );

  			} );

  			propName = 'connections';
  			propValue = [ from, to ];
  			append( propValue, rest );

  			if ( currentNode[ propName ] === undefined ) {

  				currentNode[ propName ] = [];

  			}

  		}

  		// Node
  		if ( propName === 'Node' ) currentNode.id = propValue;

  		// connections
  		if ( propName in currentNode && Array.isArray( currentNode[ propName ] ) ) {

  			currentNode[ propName ].push( propValue );

  		} else {

  			if ( propName !== 'a' ) currentNode[ propName ] = propValue;
  			else currentNode.a = propValue;

  		}

  		this.setCurrentProp( currentNode, propName );

  		// convert string to array, unless it ends in ',' in which case more will be added to it
  		if ( propName === 'a' && propValue.slice( -1 ) !== ',' ) {

  			currentNode.a = parseNumberArray( propValue );

  		}

  	}

  	parseNodePropertyContinued( line ) {

  		const currentNode = this.getCurrentNode();

  		currentNode.a += line;

  		// if the line doesn't end in ',' we have reached the end of the property value
  		// so convert the string to an array
  		if ( line.slice( -1 ) !== ',' ) {

  			currentNode.a = parseNumberArray( currentNode.a );

  		}

  	}

  	// parse "Property70"
  	parseNodeSpecialProperty( line, propName, propValue ) {

  		// split this
  		// P: "Lcl Scaling", "Lcl Scaling", "", "A",1,1,1
  		// into array like below
  		// ["Lcl Scaling", "Lcl Scaling", "", "A", "1,1,1" ]
  		const props = propValue.split( '",' ).map( function ( prop ) {

  			return prop.trim().replace( /^\"/, '' ).replace( /\s/, '_' );

  		} );

  		const innerPropName = props[ 0 ];
  		const innerPropType1 = props[ 1 ];
  		const innerPropType2 = props[ 2 ];
  		const innerPropFlag = props[ 3 ];
  		let innerPropValue = props[ 4 ];

  		// cast values where needed, otherwise leave as strings
  		switch ( innerPropType1 ) {

  			case 'int':
  			case 'enum':
  			case 'bool':
  			case 'ULongLong':
  			case 'double':
  			case 'Number':
  			case 'FieldOfView':
  				innerPropValue = parseFloat( innerPropValue );
  				break;

  			case 'Color':
  			case 'ColorRGB':
  			case 'Vector3D':
  			case 'Lcl_Translation':
  			case 'Lcl_Rotation':
  			case 'Lcl_Scaling':
  				innerPropValue = parseNumberArray( innerPropValue );
  				break;

  		}

  		// CAUTION: these props must append to parent's parent
  		this.getPrevNode()[ innerPropName ] = {

  			'type': innerPropType1,
  			'type2': innerPropType2,
  			'flag': innerPropFlag,
  			'value': innerPropValue

  		};

  		this.setCurrentProp( this.getPrevNode(), innerPropName );

  	}

  }

  // Parse an FBX file in Binary format
  class BinaryParser {

  	parse( buffer ) {

  		const reader = new BinaryReader( buffer );
  		reader.skip( 23 ); // skip magic 23 bytes

  		const version = reader.getUint32();

  		if ( version < 6400 ) {

  			throw new Error( 'THREE.FBXLoader: FBX version not supported, FileVersion: ' + version );

  		}

  		const allNodes = new FBXTree();

  		while ( ! this.endOfContent( reader ) ) {

  			const node = this.parseNode( reader, version );
  			if ( node !== null ) allNodes.add( node.name, node );

  		}

  		return allNodes;

  	}

  	// Check if reader has reached the end of content.
  	endOfContent( reader ) {

  		// footer size: 160bytes + 16-byte alignment padding
  		// - 16bytes: magic
  		// - padding til 16-byte alignment (at least 1byte?)
  		//	(seems like some exporters embed fixed 15 or 16bytes?)
  		// - 4bytes: magic
  		// - 4bytes: version
  		// - 120bytes: zero
  		// - 16bytes: magic
  		if ( reader.size() % 16 === 0 ) {

  			return ( ( reader.getOffset() + 160 + 16 ) & -16 ) >= reader.size();

  		} else {

  			return reader.getOffset() + 160 + 16 >= reader.size();

  		}

  	}

  	// recursively parse nodes until the end of the file is reached
  	parseNode( reader, version ) {

  		const node = {};

  		// The first three data sizes depends on version.
  		const endOffset = ( version >= 7500 ) ? reader.getUint64() : reader.getUint32();
  		const numProperties = ( version >= 7500 ) ? reader.getUint64() : reader.getUint32();

  		( version >= 7500 ) ? reader.getUint64() : reader.getUint32(); // the returned propertyListLen is not used

  		const nameLen = reader.getUint8();
  		const name = reader.getString( nameLen );

  		// Regards this node as NULL-record if endOffset is zero
  		if ( endOffset === 0 ) return null;

  		const propertyList = [];

  		for ( let i = 0; i < numProperties; i ++ ) {

  			propertyList.push( this.parseProperty( reader ) );

  		}

  		// Regards the first three elements in propertyList as id, attrName, and attrType
  		const id = propertyList.length > 0 ? propertyList[ 0 ] : '';
  		const attrName = propertyList.length > 1 ? propertyList[ 1 ] : '';
  		const attrType = propertyList.length > 2 ? propertyList[ 2 ] : '';

  		// check if this node represents just a single property
  		// like (name, 0) set or (name2, [0, 1, 2]) set of {name: 0, name2: [0, 1, 2]}
  		node.singleProperty = ( numProperties === 1 && reader.getOffset() === endOffset ) ? true : false;

  		while ( endOffset > reader.getOffset() ) {

  			const subNode = this.parseNode( reader, version );

  			if ( subNode !== null ) this.parseSubNode( name, node, subNode );

  		}

  		node.propertyList = propertyList; // raw property list used by parent

  		if ( typeof id === 'number' ) node.id = id;
  		if ( attrName !== '' ) node.attrName = attrName;
  		if ( attrType !== '' ) node.attrType = attrType;
  		if ( name !== '' ) node.name = name;

  		return node;

  	}

  	parseSubNode( name, node, subNode ) {

  		// special case: child node is single property
  		if ( subNode.singleProperty === true ) {

  			const value = subNode.propertyList[ 0 ];

  			if ( Array.isArray( value ) ) {

  				node[ subNode.name ] = subNode;

  				subNode.a = value;

  			} else {

  				node[ subNode.name ] = value;

  			}

  		} else if ( name === 'Connections' && subNode.name === 'C' ) {

  			const array = [];

  			subNode.propertyList.forEach( function ( property, i ) {

  				// first Connection is FBX type (OO, OP, etc.). We'll discard these
  				if ( i !== 0 ) array.push( property );

  			} );

  			if ( node.connections === undefined ) {

  				node.connections = [];

  			}

  			node.connections.push( array );

  		} else if ( subNode.name === 'Properties70' ) {

  			const keys = Object.keys( subNode );

  			keys.forEach( function ( key ) {

  				node[ key ] = subNode[ key ];

  			} );

  		} else if ( name === 'Properties70' && subNode.name === 'P' ) {

  			let innerPropName = subNode.propertyList[ 0 ];
  			let innerPropType1 = subNode.propertyList[ 1 ];
  			const innerPropType2 = subNode.propertyList[ 2 ];
  			const innerPropFlag = subNode.propertyList[ 3 ];
  			let innerPropValue;

  			if ( innerPropName.indexOf( 'Lcl ' ) === 0 ) innerPropName = innerPropName.replace( 'Lcl ', 'Lcl_' );
  			if ( innerPropType1.indexOf( 'Lcl ' ) === 0 ) innerPropType1 = innerPropType1.replace( 'Lcl ', 'Lcl_' );

  			if ( innerPropType1 === 'Color' || innerPropType1 === 'ColorRGB' || innerPropType1 === 'Vector' || innerPropType1 === 'Vector3D' || innerPropType1.indexOf( 'Lcl_' ) === 0 ) {

  				innerPropValue = [
  					subNode.propertyList[ 4 ],
  					subNode.propertyList[ 5 ],
  					subNode.propertyList[ 6 ]
  				];

  			} else {

  				innerPropValue = subNode.propertyList[ 4 ];

  			}

  			// this will be copied to parent, see above
  			node[ innerPropName ] = {

  				'type': innerPropType1,
  				'type2': innerPropType2,
  				'flag': innerPropFlag,
  				'value': innerPropValue

  			};

  		} else if ( node[ subNode.name ] === undefined ) {

  			if ( typeof subNode.id === 'number' ) {

  				node[ subNode.name ] = {};
  				node[ subNode.name ][ subNode.id ] = subNode;

  			} else {

  				node[ subNode.name ] = subNode;

  			}

  		} else {

  			if ( subNode.name === 'PoseNode' ) {

  				if ( ! Array.isArray( node[ subNode.name ] ) ) {

  					node[ subNode.name ] = [ node[ subNode.name ] ];

  				}

  				node[ subNode.name ].push( subNode );

  			} else if ( node[ subNode.name ][ subNode.id ] === undefined ) {

  				node[ subNode.name ][ subNode.id ] = subNode;

  			}

  		}

  	}

  	parseProperty( reader ) {

  		const type = reader.getString( 1 );
  		let length;

  		switch ( type ) {

  			case 'C':
  				return reader.getBoolean();

  			case 'D':
  				return reader.getFloat64();

  			case 'F':
  				return reader.getFloat32();

  			case 'I':
  				return reader.getInt32();

  			case 'L':
  				return reader.getInt64();

  			case 'R':
  				length = reader.getUint32();
  				return reader.getArrayBuffer( length );

  			case 'S':
  				length = reader.getUint32();
  				return reader.getString( length );

  			case 'Y':
  				return reader.getInt16();

  			case 'b':
  			case 'c':
  			case 'd':
  			case 'f':
  			case 'i':
  			case 'l':

  				const arrayLength = reader.getUint32();
  				const encoding = reader.getUint32(); // 0: non-compressed, 1: compressed
  				const compressedLength = reader.getUint32();

  				if ( encoding === 0 ) {

  					switch ( type ) {

  						case 'b':
  						case 'c':
  							return reader.getBooleanArray( arrayLength );

  						case 'd':
  							return reader.getFloat64Array( arrayLength );

  						case 'f':
  							return reader.getFloat32Array( arrayLength );

  						case 'i':
  							return reader.getInt32Array( arrayLength );

  						case 'l':
  							return reader.getInt64Array( arrayLength );

  					}

  				}

  				const data = unzlibSync( new Uint8Array( reader.getArrayBuffer( compressedLength ) ) );
  				const reader2 = new BinaryReader( data.buffer );

  				switch ( type ) {

  					case 'b':
  					case 'c':
  						return reader2.getBooleanArray( arrayLength );

  					case 'd':
  						return reader2.getFloat64Array( arrayLength );

  					case 'f':
  						return reader2.getFloat32Array( arrayLength );

  					case 'i':
  						return reader2.getInt32Array( arrayLength );

  					case 'l':
  						return reader2.getInt64Array( arrayLength );

  				}

  				break; // cannot happen but is required by the DeepScan

  			default:
  				throw new Error( 'THREE.FBXLoader: Unknown property type ' + type );

  		}

  	}

  }

  class BinaryReader {

  	constructor( buffer, littleEndian ) {

  		this.dv = new DataView( buffer );
  		this.offset = 0;
  		this.littleEndian = ( littleEndian !== undefined ) ? littleEndian : true;
  		this._textDecoder = new TextDecoder();

  	}

  	getOffset() {

  		return this.offset;

  	}

  	size() {

  		return this.dv.buffer.byteLength;

  	}

  	skip( length ) {

  		this.offset += length;

  	}

  	// seems like true/false representation depends on exporter.
  	// true: 1 or 'Y'(=0x59), false: 0 or 'T'(=0x54)
  	// then sees LSB.
  	getBoolean() {

  		return ( this.getUint8() & 1 ) === 1;

  	}

  	getBooleanArray( size ) {

  		const a = [];

  		for ( let i = 0; i < size; i ++ ) {

  			a.push( this.getBoolean() );

  		}

  		return a;

  	}

  	getUint8() {

  		const value = this.dv.getUint8( this.offset );
  		this.offset += 1;
  		return value;

  	}

  	getInt16() {

  		const value = this.dv.getInt16( this.offset, this.littleEndian );
  		this.offset += 2;
  		return value;

  	}

  	getInt32() {

  		const value = this.dv.getInt32( this.offset, this.littleEndian );
  		this.offset += 4;
  		return value;

  	}

  	getInt32Array( size ) {

  		const a = [];

  		for ( let i = 0; i < size; i ++ ) {

  			a.push( this.getInt32() );

  		}

  		return a;

  	}

  	getUint32() {

  		const value = this.dv.getUint32( this.offset, this.littleEndian );
  		this.offset += 4;
  		return value;

  	}

  	// JavaScript doesn't support 64-bit integer so calculate this here
  	// 1 << 32 will return 1 so using multiply operation instead here.
  	// There's a possibility that this method returns wrong value if the value
  	// is out of the range between Number.MAX_SAFE_INTEGER and Number.MIN_SAFE_INTEGER.
  	// TODO: safely handle 64-bit integer
  	getInt64() {

  		let low, high;

  		if ( this.littleEndian ) {

  			low = this.getUint32();
  			high = this.getUint32();

  		} else {

  			high = this.getUint32();
  			low = this.getUint32();

  		}

  		// calculate negative value
  		if ( high & 0x80000000 ) {

  			high = ~ high & 0xFFFFFFFF;
  			low = ~ low & 0xFFFFFFFF;

  			if ( low === 0xFFFFFFFF ) high = ( high + 1 ) & 0xFFFFFFFF;

  			low = ( low + 1 ) & 0xFFFFFFFF;

  			return - ( high * 0x100000000 + low );

  		}

  		return high * 0x100000000 + low;

  	}

  	getInt64Array( size ) {

  		const a = [];

  		for ( let i = 0; i < size; i ++ ) {

  			a.push( this.getInt64() );

  		}

  		return a;

  	}

  	// Note: see getInt64() comment
  	getUint64() {

  		let low, high;

  		if ( this.littleEndian ) {

  			low = this.getUint32();
  			high = this.getUint32();

  		} else {

  			high = this.getUint32();
  			low = this.getUint32();

  		}

  		return high * 0x100000000 + low;

  	}

  	getFloat32() {

  		const value = this.dv.getFloat32( this.offset, this.littleEndian );
  		this.offset += 4;
  		return value;

  	}

  	getFloat32Array( size ) {

  		const a = [];

  		for ( let i = 0; i < size; i ++ ) {

  			a.push( this.getFloat32() );

  		}

  		return a;

  	}

  	getFloat64() {

  		const value = this.dv.getFloat64( this.offset, this.littleEndian );
  		this.offset += 8;
  		return value;

  	}

  	getFloat64Array( size ) {

  		const a = [];

  		for ( let i = 0; i < size; i ++ ) {

  			a.push( this.getFloat64() );

  		}

  		return a;

  	}

  	getArrayBuffer( size ) {

  		const value = this.dv.buffer.slice( this.offset, this.offset + size );
  		this.offset += size;
  		return value;

  	}

  	getString( size ) {

  		const start = this.offset;
  		let a = new Uint8Array( this.dv.buffer, start, size );

  		this.skip( size );

  		const nullByte = a.indexOf( 0 );
  		if ( nullByte >= 0 ) a = new Uint8Array( this.dv.buffer, start, nullByte );

  		return this._textDecoder.decode( a );

  	}

  }

  // FBXTree holds a representation of the FBX data, returned by the TextParser ( FBX ASCII format)
  // and BinaryParser( FBX Binary format)
  class FBXTree {

  	add( key, val ) {

  		this[ key ] = val;

  	}

  }

  // ************** UTILITY FUNCTIONS **************

  function isFbxFormatBinary( buffer ) {

  	const CORRECT = 'Kaydara\u0020FBX\u0020Binary\u0020\u0020\0';

  	return buffer.byteLength >= CORRECT.length && CORRECT === convertArrayBufferToString( buffer, 0, CORRECT.length );

  }

  function isFbxFormatASCII( text ) {

  	const CORRECT = [ 'K', 'a', 'y', 'd', 'a', 'r', 'a', '\\', 'F', 'B', 'X', '\\', 'B', 'i', 'n', 'a', 'r', 'y', '\\', '\\' ];

  	let cursor = 0;

  	function read( offset ) {

  		const result = text[ offset - 1 ];
  		text = text.slice( cursor + offset );
  		cursor ++;
  		return result;

  	}

  	for ( let i = 0; i < CORRECT.length; ++ i ) {

  		const num = read( 1 );
  		if ( num === CORRECT[ i ] ) {

  			return false;

  		}

  	}

  	return true;

  }

  function getFbxVersion( text ) {

  	const versionRegExp = /FBXVersion: (\d+)/;
  	const match = text.match( versionRegExp );

  	if ( match ) {

  		const version = parseInt( match[ 1 ] );
  		return version;

  	}

  	throw new Error( 'THREE.FBXLoader: Cannot find the version number for the file given.' );

  }

  // Converts FBX ticks into real time seconds.
  function convertFBXTimeToSeconds( time ) {

  	return time / 46186158000;

  }

  const dataArray = [];

  // extracts the data from the correct position in the FBX array based on indexing type
  function getData( polygonVertexIndex, polygonIndex, vertexIndex, infoObject ) {

  	let index;

  	switch ( infoObject.mappingType ) {

  		case 'ByPolygonVertex' :
  			index = polygonVertexIndex;
  			break;
  		case 'ByPolygon' :
  			index = polygonIndex;
  			break;
  		case 'ByVertice' :
  			index = vertexIndex;
  			break;
  		case 'AllSame' :
  			index = infoObject.indices[ 0 ];
  			break;
  		default :
  			console.warn( 'THREE.FBXLoader: unknown attribute mapping type ' + infoObject.mappingType );

  	}

  	if ( infoObject.referenceType === 'IndexToDirect' ) index = infoObject.indices[ index ];

  	const from = index * infoObject.dataSize;
  	const to = from + infoObject.dataSize;

  	return slice( dataArray, infoObject.buffer, from, to );

  }

  const tempEuler = new three$2.Euler();
  const tempVec = new three$2.Vector3();

  // generate transformation from FBX transform data
  // ref: https://help.autodesk.com/view/FBX/2017/ENU/?guid=__files_GUID_10CDD63C_79C1_4F2D_BB28_AD2BE65A02ED_htm
  // ref: http://docs.autodesk.com/FBX/2014/ENU/FBX-SDK-Documentation/index.html?url=cpp_ref/_transformations_2main_8cxx-example.html,topicNumber=cpp_ref__transformations_2main_8cxx_example_htmlfc10a1e1-b18d-4e72-9dc0-70d0f1959f5e
  function generateTransform( transformData ) {

  	const lTranslationM = new three$2.Matrix4();
  	const lPreRotationM = new three$2.Matrix4();
  	const lRotationM = new three$2.Matrix4();
  	const lPostRotationM = new three$2.Matrix4();

  	const lScalingM = new three$2.Matrix4();
  	const lScalingPivotM = new three$2.Matrix4();
  	const lScalingOffsetM = new three$2.Matrix4();
  	const lRotationOffsetM = new three$2.Matrix4();
  	const lRotationPivotM = new three$2.Matrix4();

  	const lParentGX = new three$2.Matrix4();
  	const lParentLX = new three$2.Matrix4();
  	const lGlobalT = new three$2.Matrix4();

  	const inheritType = ( transformData.inheritType ) ? transformData.inheritType : 0;

  	if ( transformData.translation ) lTranslationM.setPosition( tempVec.fromArray( transformData.translation ) );

  	if ( transformData.preRotation ) {

  		const array = transformData.preRotation.map( three$2.MathUtils.degToRad );
  		array.push( transformData.eulerOrder || three$2.Euler.DEFAULT_ORDER );
  		lPreRotationM.makeRotationFromEuler( tempEuler.fromArray( array ) );

  	}

  	if ( transformData.rotation ) {

  		const array = transformData.rotation.map( three$2.MathUtils.degToRad );
  		array.push( transformData.eulerOrder || three$2.Euler.DEFAULT_ORDER );
  		lRotationM.makeRotationFromEuler( tempEuler.fromArray( array ) );

  	}

  	if ( transformData.postRotation ) {

  		const array = transformData.postRotation.map( three$2.MathUtils.degToRad );
  		array.push( transformData.eulerOrder || three$2.Euler.DEFAULT_ORDER );
  		lPostRotationM.makeRotationFromEuler( tempEuler.fromArray( array ) );
  		lPostRotationM.invert();

  	}

  	if ( transformData.scale ) lScalingM.scale( tempVec.fromArray( transformData.scale ) );

  	// Pivots and offsets
  	if ( transformData.scalingOffset ) lScalingOffsetM.setPosition( tempVec.fromArray( transformData.scalingOffset ) );
  	if ( transformData.scalingPivot ) lScalingPivotM.setPosition( tempVec.fromArray( transformData.scalingPivot ) );
  	if ( transformData.rotationOffset ) lRotationOffsetM.setPosition( tempVec.fromArray( transformData.rotationOffset ) );
  	if ( transformData.rotationPivot ) lRotationPivotM.setPosition( tempVec.fromArray( transformData.rotationPivot ) );

  	// parent transform
  	if ( transformData.parentMatrixWorld ) {

  		lParentLX.copy( transformData.parentMatrix );
  		lParentGX.copy( transformData.parentMatrixWorld );

  	}

  	const lLRM = lPreRotationM.clone().multiply( lRotationM ).multiply( lPostRotationM );
  	// Global Rotation
  	const lParentGRM = new three$2.Matrix4();
  	lParentGRM.extractRotation( lParentGX );

  	// Global Shear*Scaling
  	const lParentTM = new three$2.Matrix4();
  	lParentTM.copyPosition( lParentGX );

  	const lParentGRSM = lParentTM.clone().invert().multiply( lParentGX );
  	const lParentGSM = lParentGRM.clone().invert().multiply( lParentGRSM );
  	const lLSM = lScalingM;

  	const lGlobalRS = new three$2.Matrix4();

  	if ( inheritType === 0 ) {

  		lGlobalRS.copy( lParentGRM ).multiply( lLRM ).multiply( lParentGSM ).multiply( lLSM );

  	} else if ( inheritType === 1 ) {

  		lGlobalRS.copy( lParentGRM ).multiply( lParentGSM ).multiply( lLRM ).multiply( lLSM );

  	} else {

  		const lParentLSM = new three$2.Matrix4().scale( new three$2.Vector3().setFromMatrixScale( lParentLX ) );
  		const lParentLSM_inv = lParentLSM.clone().invert();
  		const lParentGSM_noLocal = lParentGSM.clone().multiply( lParentLSM_inv );

  		lGlobalRS.copy( lParentGRM ).multiply( lLRM ).multiply( lParentGSM_noLocal ).multiply( lLSM );

  	}

  	const lRotationPivotM_inv = lRotationPivotM.clone().invert();
  	const lScalingPivotM_inv = lScalingPivotM.clone().invert();
  	// Calculate the local transform matrix
  	let lTransform = lTranslationM.clone().multiply( lRotationOffsetM ).multiply( lRotationPivotM ).multiply( lPreRotationM ).multiply( lRotationM ).multiply( lPostRotationM ).multiply( lRotationPivotM_inv ).multiply( lScalingOffsetM ).multiply( lScalingPivotM ).multiply( lScalingM ).multiply( lScalingPivotM_inv );

  	const lLocalTWithAllPivotAndOffsetInfo = new three$2.Matrix4().copyPosition( lTransform );

  	const lGlobalTranslation = lParentGX.clone().multiply( lLocalTWithAllPivotAndOffsetInfo );
  	lGlobalT.copyPosition( lGlobalTranslation );

  	lTransform = lGlobalT.clone().multiply( lGlobalRS );

  	// from global to local
  	lTransform.premultiply( lParentGX.invert() );

  	return lTransform;

  }

  // Returns the three.js intrinsic Euler order corresponding to FBX extrinsic Euler order
  // ref: http://help.autodesk.com/view/FBX/2017/ENU/?guid=__cpp_ref_class_fbx_euler_html
  function getEulerOrder( order ) {

  	order = order || 0;

  	const enums = [
  		'ZYX', // -> XYZ extrinsic
  		'YZX', // -> XZY extrinsic
  		'XZY', // -> YZX extrinsic
  		'ZXY', // -> YXZ extrinsic
  		'YXZ', // -> ZXY extrinsic
  		'XYZ', // -> ZYX extrinsic
  		//'SphericXYZ', // not possible to support
  	];

  	if ( order === 6 ) {

  		console.warn( 'THREE.FBXLoader: unsupported Euler Order: Spherical XYZ. Animations and rotations may be incorrect.' );
  		return enums[ 0 ];

  	}

  	return enums[ order ];

  }

  // Parses comma separated list of numbers and returns them an array.
  // Used internally by the TextParser
  function parseNumberArray( value ) {

  	const array = value.split( ',' ).map( function ( val ) {

  		return parseFloat( val );

  	} );

  	return array;

  }

  function convertArrayBufferToString( buffer, from, to ) {

  	if ( from === undefined ) from = 0;
  	if ( to === undefined ) to = buffer.byteLength;

  	return new TextDecoder().decode( new Uint8Array( buffer, from, to ) );

  }

  function append( a, b ) {

  	for ( let i = 0, j = a.length, l = b.length; i < l; i ++, j ++ ) {

  		a[ j ] = b[ i ];

  	}

  }

  function slice( a, b, from, to ) {

  	for ( let i = from, j = 0; i < to; i ++, j ++ ) {

  		a[ j ] = b[ i ];

  	}

  	return a;

  }

  THREE.FBXLoader = FBXLoader;

  /**
   * fbx-model
   *
   * Loader for FBX format.
   */
  AFRAME.registerComponent('fbx-model', {
    schema: {
      src:         { type: 'asset' },
      crossorigin: { default: '' }
    },

    init: function () {
      this.model = null;
    },

    update: function () {
      const data = this.data;
      if (!data.src) return;

      this.remove();
      const loader = new THREE.FBXLoader();
      if (data.crossorigin) loader.setCrossOrigin(data.crossorigin);
      loader.load(data.src, this.load.bind(this));
    },

    load: function (model) {
      this.model = model;
      this.el.setObject3D('mesh', model);
      this.el.emit('model-loaded', {format: 'fbx', model: model});
    },

    remove: function () {
      if (this.model) this.el.removeObject3D('mesh');
    }
  });

  /**
   * Source: https://github.com/Adobe-Marketing-Cloud/fetch-script
   */

  var fetchScript_1;
  var hasRequiredFetchScript;

  function requireFetchScript () {
  	if (hasRequiredFetchScript) return fetchScript_1;
  	hasRequiredFetchScript = 1;
  	function getScriptId() {
  	  return 'script_' + Date.now() + '_' + Math.ceil(Math.random() * 100000);
  	}

  	function createScript(url, id) {
  	  var script = document.createElement('script');
  	  script.type = 'text/javascript';
  	  script.async = true;
  	  script.id = id;
  	  script.src = url;

  	  return script;
  	}

  	function removeScript(id) {
  	  const script = document.getElementById(id);
  	  const parent = script.parentNode;

  	  try {
  	    parent && parent.removeChild(script);
  	  } catch (e) {
  	    // ignore
  	  }
  	}

  	function appendScript(script) {
  	  const firstScript = document.getElementsByTagName('script')[0];
  	  firstScript.parentNode.insertBefore(script, firstScript);
  	}

  	function fetchScriptInternal(url, options, Promise) {
  	  return new Promise(function(resolve, reject) {
  	    const timeout = options.timeout || 5000;
  	    const scriptId = getScriptId();
  	    const script = createScript(url, scriptId);

  	    const timeoutId = setTimeout(function() {
  	      reject(new Error('Script request to ' + url + ' timed out'));

  	      removeScript(scriptId);
  	    }, timeout);

  	    const disableTimeout = function(timeoutId) { clearTimeout(timeoutId); };

  	    script.addEventListener('load', function(e) {
  	      resolve({ok: true});

  	      disableTimeout(timeoutId);
  	      removeScript(scriptId);
  	    });

  	    script.addEventListener('error', function(e) {
  	      reject(new Error('Script request to ' + url + ' failed ' + e));

  	      disableTimeout(timeoutId);
  	      removeScript(scriptId);
  	    });

  	    appendScript(script);
  	  });
  	}

  	function fetchScript(settings) {
  	  settings = settings || {};
  	  return function (url, options) {
  	    options = options || {};
  	    return fetchScriptInternal(url, options, settings.Promise || Promise);
  	  };
  	}

  	fetchScript_1 = fetchScript;
  	return fetchScript_1;
  }

  var gltfModelLegacy;
  var hasRequiredGltfModelLegacy;

  function requireGltfModelLegacy () {
  	if (hasRequiredGltfModelLegacy) return gltfModelLegacy;
  	hasRequiredGltfModelLegacy = 1;
  	const fetchScript = requireFetchScript()();

  	const LOADER_SRC = 'https://cdn.jsdelivr.net/gh/mrdoob/three.js@r86/examples/js/loaders/GLTFLoader.js';

  	const loadLoader = (function () {
  	  let promise;
  	  return function () {
  	    promise = promise || fetchScript(LOADER_SRC);
  	    return promise;
  	  };
  	}());

  	/**
  	 * Legacy loader for glTF 1.0 models.
  	 * Asynchronously loads THREE.GLTFLoader from jsdelivr.
  	 */
  	gltfModelLegacy = AFRAME.registerComponent('gltf-model-legacy', {
  	  schema: {type: 'model'},

  	  init: function () {
  	    this.model = null;
  	    this.loader = null;
  	    this.loaderPromise = loadLoader().then(() => {
  	      this.loader = new THREE.GLTFLoader();
  	      this.loader.setCrossOrigin('Anonymous');
  	    });
  	  },

  	  update: function () {
  	    const self = this;
  	    const el = this.el;
  	    const src = this.data;

  	    if (!src) { return; }

  	    this.remove();

  	    this.loaderPromise.then(() => {
  	      this.loader.load(src, function gltfLoaded (gltfModel) {
  	        self.model = gltfModel.scene;
  	        self.model.animations = gltfModel.animations;
  	        el.setObject3D('mesh', self.model);
  	        el.emit('model-loaded', {format: 'gltf', model: self.model});
  	      });
  	    });
  	  },

  	  remove: function () {
  	    if (!this.model) { return; }
  	    this.el.removeObject3D('mesh');
  	  }
  	});
  	return gltfModelLegacy;
  }

  /**
   * object-model
   *
   * Loader for THREE.js JSON format. Somewhat confusingly, there are two different THREE.js formats,
   * both having the .json extension. This loader supports only THREE.ObjectLoader, which typically
   * includes multiple meshes or an entire scene.
   *
   * Check the console for errors, if in doubt. You may need to use `json-model` or
   * `blend-character-model` for some .js and .json files.
   *
   * See: https://clara.io/learn/user-guide/data_exchange/threejs_export
   */

  var objectModel;
  var hasRequiredObjectModel;

  function requireObjectModel () {
  	if (hasRequiredObjectModel) return objectModel;
  	hasRequiredObjectModel = 1;
  	objectModel = AFRAME.registerComponent('object-model', {
  	  schema: {
  	    src:         { type: 'asset' },
  	    crossorigin: { default: '' }
  	  },

  	  init: function () {
  	    this.model = null;
  	  },

  	  update: function () {
  	    let loader;
  	    const data = this.data;
  	    if (!data.src) return;

  	    this.remove();
  	    loader = new THREE.ObjectLoader();
  	    if (data.crossorigin) loader.setCrossOrigin(data.crossorigin);
  	    loader.load(data.src, (object) => {

  	      // Enable skinning, if applicable.
  	      object.traverse((o) => {
  	        if (o instanceof THREE.SkinnedMesh && o.material) {
  	          o.material.skinning = !!((o.geometry && o.geometry.bones) || []).length;
  	        }
  	      });

  	      this.load(object);
  	    });
  	  },

  	  load: function (model) {
  	    this.model = model;
  	    this.el.setObject3D('mesh', model);
  	    this.el.emit('model-loaded', {format: 'json', model: model});
  	  },

  	  remove: function () {
  	    if (this.model) this.el.removeObject3D('mesh');
  	  }
  	});
  	return objectModel;
  }

  var hasRequiredLoaders;

  function requireLoaders () {
  	if (hasRequiredLoaders) return loaders;
  	hasRequiredLoaders = 1;
  	requireAnimationMixer();


  	requireGltfModelLegacy();
  	requireObjectModel();
  	return loaders;
  }

  var misc = {};

  var checkpoint;
  var hasRequiredCheckpoint;

  function requireCheckpoint () {
  	if (hasRequiredCheckpoint) return checkpoint;
  	hasRequiredCheckpoint = 1;
  	checkpoint = AFRAME.registerComponent('checkpoint', {
  	  schema: {
  	    offset: {default: {x: 0, y: 0, z: 0}, type: 'vec3'}
  	  },

  	  init: function () {
  	    this.active = false;
  	    this.targetEl = null;
  	    this.fire = this.fire.bind(this);
  	    this.offset = new THREE.Vector3();
  	  },

  	  update: function () {
  	    this.offset.copy(this.data.offset);
  	  },

  	  play: function () { this.el.addEventListener('click', this.fire); },
  	  pause: function () { this.el.removeEventListener('click', this.fire); },
  	  remove: function () { this.pause(); },

  	  fire: function () {
  	    const targetEl = this.el.sceneEl.querySelector('[checkpoint-controls]');
  	    if (!targetEl) {
  	      throw new Error('No `checkpoint-controls` component found.');
  	    }
  	    targetEl.components['checkpoint-controls'].setCheckpoint(this.el);
  	  },

  	  getOffset: function () {
  	    return this.offset.copy(this.data.offset);
  	  }
  	});
  	return checkpoint;
  }

  /**
   * @param  {Array<THREE.Material>|THREE.Material} material
   * @return {Array<THREE.Material>}
   */

  var cubeEnvMap;
  var hasRequiredCubeEnvMap;

  function requireCubeEnvMap () {
  	if (hasRequiredCubeEnvMap) return cubeEnvMap;
  	hasRequiredCubeEnvMap = 1;
  	function ensureMaterialArray (material) {
  	  if (!material) {
  	    return [];
  	  } else if (Array.isArray(material)) {
  	    return material;
  	  } else if (material.materials) {
  	    return material.materials;
  	  } else {
  	    return [material];
  	  }
  	}

  	/**
  	 * @param  {THREE.Object3D} mesh
  	 * @param  {Array<string>} materialNames
  	 * @param  {THREE.Texture} envMap
  	 * @param  {number} reflectivity  [description]
  	 */
  	function applyEnvMap (mesh, materialNames, envMap, reflectivity) {
  	  if (!mesh) return;

  	  materialNames = materialNames || [];

  	  mesh.traverse((node) => {

  	    if (!node.isMesh) return;

  	    const meshMaterials = ensureMaterialArray(node.material);

  	    meshMaterials.forEach((material) => {

  	      if (material && !('envMap' in material)) return;
  	      if (materialNames.length && materialNames.indexOf(material.name) === -1) return;

  	      material.envMap = envMap;
  	      material.reflectivity = reflectivity;
  	      material.needsUpdate = true;

  	    });

  	  });
  	}

  	/**
  	 * Specifies an envMap on an entity, without replacing any existing material
  	 * properties.
  	 */
  	cubeEnvMap = AFRAME.registerComponent('cube-env-map', {
  	  multiple: true,

  	  schema: {
  	    path: {default: ''},
  	    extension: {default: 'jpg', oneOf: ['jpg', 'png']},
  	    enableBackground: {default: false},
  	    reflectivity: {default: 1, min: 0, max: 1},
  	    materials: {default: []}
  	  },

  	  init: function () {
  	    const data = this.data;

  	    this.texture = new THREE.CubeTextureLoader().load([
  	      data.path + 'posx.' + data.extension, data.path + 'negx.' + data.extension,
  	      data.path + 'posy.' + data.extension, data.path + 'negy.' + data.extension,
  	      data.path + 'posz.' + data.extension, data.path + 'negz.' + data.extension
  	    ]);
  	    this.texture.format = THREE.RGBAFormat;

  	    this.object3dsetHandler = () => {
  	      const mesh = this.el.getObject3D('mesh');
  	      const data = this.data;
  	      applyEnvMap(mesh, data.materials, this.texture, data.reflectivity);
  	    };

  	    this.object3dsetHandler();
  	    this.el.addEventListener('object3dset', this.object3dsetHandler);
  	    
  	  },

  	  update: function (oldData) {
  	    const data = this.data;
  	    const mesh = this.el.getObject3D('mesh');

  	    let addedMaterialNames = [];
  	    let removedMaterialNames = [];

  	    if (data.materials.length) {
  	      if (oldData.materials) {
  	        addedMaterialNames = data.materials.filter((name) => !oldData.materials.includes(name));
  	        removedMaterialNames = oldData.materials.filter((name) => !data.materials.includes(name));
  	      } else {
  	        addedMaterialNames = data.materials;
  	      }
  	    }
  	    if (addedMaterialNames.length) {
  	      applyEnvMap(mesh, addedMaterialNames, this.texture, data.reflectivity);
  	    }
  	    if (removedMaterialNames.length) {
  	      applyEnvMap(mesh, removedMaterialNames, null, 1);
  	    }

  	    if (oldData.materials && data.reflectivity !== oldData.reflectivity) {
  	      const maintainedMaterialNames = data.materials
  	        .filter((name) => oldData.materials.includes(name));
  	      if (maintainedMaterialNames.length) {
  	        applyEnvMap(mesh, maintainedMaterialNames, this.texture, data.reflectivity);
  	      }
  	    }

  	    if (this.data.enableBackground && !oldData.enableBackground) {
  	      this.setBackground(this.texture);
  	    } else if (!this.data.enableBackground && oldData.enableBackground) {
  	      this.setBackground(null);
  	    }
  	  },

  	  remove: function () {
  	    this.el.removeEventListener('object3dset', this.object3dsetHandler);
  	    const mesh = this.el.getObject3D('mesh');
  	    const data = this.data;

  	    applyEnvMap(mesh, data.materials, null, 1);
  	    if (data.enableBackground) this.setBackground(null);
  	  },

  	  setBackground: function (texture) {
  	    this.el.sceneEl.object3D.background = texture;
  	  }
  	});
  	return cubeEnvMap;
  }

  /* global CANNON */

  var grab;
  var hasRequiredGrab;

  function requireGrab () {
  	if (hasRequiredGrab) return grab;
  	hasRequiredGrab = 1;
  	/**
  	 * Based on aframe/examples/showcase/tracked-controls.
  	 *
  	 * Handles events coming from the hand-controls.
  	 * Determines if the entity is grabbed or released.
  	 * Updates its position to move along the controller.
  	 */
  	grab = AFRAME.registerComponent('grab', {
  	  init: function () {
  	    this.system = this.el.sceneEl.systems.physics;

  	    this.GRABBED_STATE = 'grabbed';

  	    this.grabbing = false;
  	    this.hitEl =      /** @type {AFRAME.Element}    */ null;
  	    this.physics =    /** @type {AFRAME.System}     */ this.el.sceneEl.systems.physics;
  	    this.constraint = /** @type {CANNON.Constraint} */ null;

  	    // Bind event handlers
  	    this.onHit = this.onHit.bind(this);
  	    this.onGripOpen = this.onGripOpen.bind(this);
  	    this.onGripClose = this.onGripClose.bind(this);
  	  },

  	  play: function () {
  	    const el = this.el;
  	    el.addEventListener('hit', this.onHit);
  	    el.addEventListener('gripdown', this.onGripClose);
  	    el.addEventListener('gripup', this.onGripOpen);
  	    el.addEventListener('trackpaddown', this.onGripClose);
  	    el.addEventListener('trackpadup', this.onGripOpen);
  	    el.addEventListener('triggerdown', this.onGripClose);
  	    el.addEventListener('triggerup', this.onGripOpen);
  	  },

  	  pause: function () {
  	    const el = this.el;
  	    el.removeEventListener('hit', this.onHit);
  	    el.removeEventListener('gripdown', this.onGripClose);
  	    el.removeEventListener('gripup', this.onGripOpen);
  	    el.removeEventListener('trackpaddown', this.onGripClose);
  	    el.removeEventListener('trackpadup', this.onGripOpen);
  	    el.removeEventListener('triggerdown', this.onGripClose);
  	    el.removeEventListener('triggerup', this.onGripOpen);
  	  },

  	  onGripClose: function () {
  	    this.grabbing = true;
  	  },

  	  onGripOpen: function () {
  	    const hitEl = this.hitEl;
  	    this.grabbing = false;
  	    if (!hitEl) { return; }
  	    hitEl.removeState(this.GRABBED_STATE);
  	    this.hitEl = undefined;
  	    this.system.removeConstraint(this.constraint);
  	    this.constraint = null;
  	  },

  	  onHit: function (evt) {
  	    const hitEl = evt.detail.el;
  	    // If the element is already grabbed (it could be grabbed by another controller).
  	    // If the hand is not grabbing the element does not stick.
  	    // If we're already grabbing something you can't grab again.
  	    if (hitEl.is(this.GRABBED_STATE) || !this.grabbing || this.hitEl) { return; }
  	    hitEl.addState(this.GRABBED_STATE);
  	    this.hitEl = hitEl;
  	    this.constraint = new CANNON.LockConstraint(this.el.body, hitEl.body);
  	    this.system.addConstraint(this.constraint);
  	  }
  	});
  	return grab;
  }

  /**
   * Recursively applies a MeshNormalMaterial to the entity, such that
   * face colors are determined by their orientation. Helpful for
   * debugging geometry
   */

  var normalMaterial;
  var hasRequiredNormalMaterial;

  function requireNormalMaterial () {
  	if (hasRequiredNormalMaterial) return normalMaterial;
  	hasRequiredNormalMaterial = 1;
  	normalMaterial = AFRAME.registerComponent('normal-material', {
  	  init: function () {
  	    this.material = new THREE.MeshNormalMaterial({flatShading: true});
  	    this.applyMaterial = this.applyMaterial.bind(this);
  	    this.el.addEventListener('object3dset', this.applyMaterial);
  	    this.applyMaterial();
  	  },

  	  remove: function () {
  	    this.el.removeEventListener('object3dset', this.applyMaterial);
  	  },

  	  applyMaterial: function () {
  	    this.el.object3D.traverse((node) => {
  	      if (node.isMesh) node.material = this.material;
  	    });
  	  }
  	});
  	return normalMaterial;
  }

  /**
   * Based on aframe/examples/showcase/tracked-controls.
   *
   * Implement bounding sphere collision detection for entities with a mesh.
   * Sets the specified state on the intersected entities.
   *
   * @property {string} objects - Selector of the entities to test for collision.
   * @property {string} state - State to set on collided entities.
   *
   */

  var sphereCollider;
  var hasRequiredSphereCollider;

  function requireSphereCollider () {
  	if (hasRequiredSphereCollider) return sphereCollider;
  	hasRequiredSphereCollider = 1;
  	sphereCollider = AFRAME.registerComponent('sphere-collider', {
  	  schema: {
  	    enabled: {default: true},
  	    interval: {default: 80},
  	    objects: {default: ''},
  	    state: {default: 'collided'},
  	    radius: {default: 0.05},
  	    watch: {default: true}
  	  },

  	  init: function () {
  	    /** @type {MutationObserver} */
  	    this.observer = null;
  	    /** @type {Array<Element>} Elements to watch for collisions. */
  	    this.els = [];
  	    /** @type {Array<Element>} Elements currently in collision state. */
  	    this.collisions = [];
  	    this.prevCheckTime = undefined;

  	    this.eventDetail = {};
  	    this.handleHit = this.handleHit.bind(this);
  	    this.handleHitEnd = this.handleHitEnd.bind(this);
  	  },

  	  play: function () {
  	    const sceneEl = this.el.sceneEl;

  	    if (this.data.watch) {
  	      this.observer = new MutationObserver(this.update.bind(this, null));
  	      this.observer.observe(sceneEl, {childList: true, subtree: true});
  	    }
  	  },

  	  pause: function () {
  	    if (this.observer) {
  	      this.observer.disconnect();
  	      this.observer = null;
  	    }
  	  },

  	  /**
  	   * Update list of entities to test for collision.
  	   */
  	  update: function () {
  	    const data = this.data;
  	    let objectEls;

  	    // Push entities into list of els to intersect.
  	    if (data.objects) {
  	      objectEls = this.el.sceneEl.querySelectorAll(data.objects);
  	    } else {
  	      // If objects not defined, intersect with everything.
  	      objectEls = this.el.sceneEl.children;
  	    }
  	    // Convert from NodeList to Array
  	    this.els = Array.prototype.slice.call(objectEls);
  	  },

  	  tick: (function () {
  	    const position = new THREE.Vector3(),
  	        meshPosition = new THREE.Vector3(),
  	        colliderScale = new THREE.Vector3(),
  	        size = new THREE.Vector3(),
  	        box = new THREE.Box3(),
  	        collisions = [],
  	        distanceMap = new Map();
  	    return function (time) {
  	      if (!this.data.enabled) { return; }

  	      // Only check for intersection if interval time has passed.
  	      const prevCheckTime = this.prevCheckTime;
  	      if (prevCheckTime && (time - prevCheckTime < this.data.interval)) { return; }
  	      // Update check time.
  	      this.prevCheckTime = time;

  	      const el = this.el,
  	          data = this.data,
  	          mesh = el.getObject3D('mesh');
  	      let colliderRadius;

  	      if (!mesh) { return; }

  	      collisions.length = 0;
  	      distanceMap.clear();
  	      el.object3D.getWorldPosition(position);
  	      el.object3D.getWorldScale(colliderScale);
  	      colliderRadius = data.radius * scaleFactor(colliderScale);
  	      // Update collision list.
  	      this.els.forEach(intersect);

  	      // Emit events and add collision states, in order of distance.
  	      collisions
  	        .sort((a, b) => distanceMap.get(a) > distanceMap.get(b) ? 1 : -1)
  	        .forEach(this.handleHit);

  	      // Remove collision state from other elements.
  	      this.collisions
  	        .filter((el) => !distanceMap.has(el))
  	        .forEach(this.handleHitEnd);

  	      // Store new collisions
  	      copyArray(this.collisions, collisions);

  	      // Bounding sphere collision detection
  	      function intersect (el) {
  	        let radius, mesh, distance, extent;

  	        if (!el.isEntity) { return; }

  	        mesh = el.getObject3D('mesh');

  	        if (!mesh) { return; }

  	        box.setFromObject(mesh).getSize(size);
  	        extent = Math.max(size.x, size.y, size.z) / 2;
  	        radius = Math.sqrt(2 * extent * extent);
  	        box.getCenter(meshPosition);

  	        if (!radius) { return; }

  	        distance = position.distanceTo(meshPosition);
  	        if (distance < radius + colliderRadius) {
  	          collisions.push(el);
  	          distanceMap.set(el, distance);
  	        }
  	      }
  	      // use max of scale factors to maintain bounding sphere collision
  	      function scaleFactor (scaleVec) {
  	        return Math.max(scaleVec.x, scaleVec.y, scaleVec.z);
  	      }
  	    };
  	  })(),

  	  handleHit: function (targetEl) {
  	    targetEl.emit('hit');
  	    targetEl.addState(this.data.state);
  	    this.eventDetail.el = targetEl;
  	    this.el.emit('hit', this.eventDetail);
  	  },
  	  handleHitEnd: function (targetEl) {
  	    targetEl.emit('hitend');
  	    targetEl.removeState(this.data.state);
  	    this.eventDetail.el = targetEl;
  	    this.el.emit('hitend', this.eventDetail);
  	  }
  	});

  	function copyArray (dest, source) {
  	  dest.length = 0;
  	  for (let i = 0; i < source.length; i++) { dest[i] = source[i]; }
  	}
  	return sphereCollider;
  }

  var hasRequiredMisc;

  function requireMisc () {
  	if (hasRequiredMisc) return misc;
  	hasRequiredMisc = 1;
  	requireCheckpoint();
  	requireCubeEnvMap();
  	requireGrab();
  	requireNormalMaterial();
  	requireSphereCollider();
  	return misc;
  }

  var pathfinding = {};

  /**
   * nav-mesh
   *
   * Waits for a mesh to be loaded on the current entity, then sets it as the
   * nav mesh in the pathfinding system.
   */

  var navMesh;
  var hasRequiredNavMesh;

  function requireNavMesh () {
  	if (hasRequiredNavMesh) return navMesh;
  	hasRequiredNavMesh = 1;
  	navMesh = AFRAME.registerComponent('nav-mesh', {
  	  schema: {
  	    nodeName: {type: 'string'}
  	  },

  	  init: function () {
  	    this.system = this.el.sceneEl.systems.nav;
  	    this.hasLoadedNavMesh = false;
  	    this.nodeName = this.data.nodeName;
  	    this.el.addEventListener('object3dset', this.loadNavMesh.bind(this));
  	  },

  	  play: function () {
  	    if (!this.hasLoadedNavMesh) this.loadNavMesh();
  	  },

  	  loadNavMesh: function () {
  	    var self = this;
  	    const object = this.el.getObject3D('mesh');
  	    this.el.sceneEl.object3D;

  	    if (!object) return;

  	    let navMesh;
  	    object.traverse((node) => {
  	      if (node.isMesh &&
  	          (!self.nodeName || node.name === self.nodeName)) navMesh = node;
  	    });

  	    if (!navMesh) return;

  	    const navMeshGeometry = navMesh.geometry.clone();
  	    navMesh.updateWorldMatrix(true, false);
  	    navMeshGeometry.applyMatrix4(navMesh.matrixWorld);
  	    this.system.setNavMeshGeometry(navMeshGeometry);
  	    this.hasLoadedNavMesh = true;
  	  }
  	});
  	return navMesh;
  }

  var navAgent;
  var hasRequiredNavAgent;

  function requireNavAgent () {
  	if (hasRequiredNavAgent) return navAgent;
  	hasRequiredNavAgent = 1;
  	navAgent = AFRAME.registerComponent('nav-agent', {
  	  schema: {
  	    destination: {type: 'vec3'},
  	    active: {default: false},
  	    speed: {default: 2}
  	  },
  	  init: function () {
  	    this.system = this.el.sceneEl.systems.nav;
  	    this.system.addAgent(this);
  	    this.group = null;
  	    this.path = [];
  	    this.raycaster = new THREE.Raycaster();
  	  },
  	  remove: function () {
  	    this.system.removeAgent(this);
  	  },
  	  update: function () {
  	    this.path.length = 0;
  	  },
  	  updateNavLocation: function () {
  	    this.group = null;
  	    this.path = [];
  	  },
  	  tick: (function () {
  	    const vDest = new THREE.Vector3();
  	    const vDelta = new THREE.Vector3();
  	    const vNext = new THREE.Vector3();

  	    return function (t, dt) {
  	      const el = this.el;
  	      const data = this.data;
  	      const raycaster = this.raycaster;
  	      const speed = data.speed * dt / 1000;

  	      if (!data.active) return;

  	      // Use PatrolJS pathfinding system to get shortest path to target.
  	      if (!this.path.length) {
  	        const position = this.el.object3D.position;
  	        this.group = this.group || this.system.getGroup(position);
  	        this.path = this.system.getPath(position, vDest.copy(data.destination), this.group) || [];
  	        el.emit('navigation-start');
  	      }

  	      // If no path is found, exit.
  	      if (!this.path.length) {
  	        console.warn('[nav] Unable to find path to %o.', data.destination);
  	        this.el.setAttribute('nav-agent', {active: false});
  	        el.emit('navigation-end');
  	        return;
  	      }

  	      // Current segment is a vector from current position to next waypoint.
  	      const vCurrent = el.object3D.position;
  	      const vWaypoint = this.path[0];
  	      vDelta.subVectors(vWaypoint, vCurrent);

  	      const distance = vDelta.length();
  	      let gazeTarget;

  	      if (distance < speed) {
  	        // If <1 step from current waypoint, discard it and move toward next.
  	        this.path.shift();

  	        // After discarding the last waypoint, exit pathfinding.
  	        if (!this.path.length) {
  	          this.el.setAttribute('nav-agent', {active: false});
  	          el.emit('navigation-end');
  	          return;
  	        }

  	        vNext.copy(vCurrent);
  	        gazeTarget = this.path[0];
  	      } else {
  	        // If still far away from next waypoint, find next position for
  	        // the current frame.
  	        vNext.copy(vDelta.setLength(speed)).add(vCurrent);
  	        gazeTarget = vWaypoint;
  	      }

  	      // Look at the next waypoint.
  	      gazeTarget.y = vCurrent.y;
  	      el.object3D.lookAt(gazeTarget);

  	      // Raycast against the nav mesh, to keep the agent moving along the
  	      // ground, not traveling in a straight line from higher to lower waypoints.
  	      raycaster.ray.origin.copy(vNext);
  	      raycaster.ray.origin.y += 1.5;
  	      raycaster.ray.direction = {x:0, y:-1, z:0};
  	      const intersections = raycaster.intersectObject(this.system.getNavMesh());

  	      if (!intersections.length) {
  	        // Raycasting failed. Step toward the waypoint and hope for the best.
  	        vCurrent.copy(vNext);
  	      } else {
  	        // Re-project next position onto nav mesh.
  	        vDelta.subVectors(intersections[0].point, vCurrent);
  	        vCurrent.add(vDelta.setLength(speed));
  	      }

  	    };
  	  }())
  	});
  	return navAgent;
  }

  class d{static roundNumber(t,e){const s=Math.pow(10,e);return Math.round(t*s)/s}static sample(t){return t[Math.floor(Math.random()*t.length)]}static distanceToSquared(t,e){var s=t.x-e.x,r=t.y-e.y,n=t.z-e.z;return s*s+r*r+n*n}static isPointInPoly(t,e){for(var s=false,r=-1,n=t.length,o=n-1;++r<n;o=r)(t[r].z<=e.z&&e.z<t[o].z||t[o].z<=e.z&&e.z<t[r].z)&&e.x<(t[o].x-t[r].x)*(e.z-t[r].z)/(t[o].z-t[r].z)+t[r].x&&(s=!s);return s}static isVectorInPolygon(t,e,s){var r=1e5,n=-1e5,o=[];return e.vertexIds.forEach(t=>{r=Math.min(s[t].y,r),n=Math.max(s[t].y,n),o.push(s[t]);}),!!(t.y<n+.5&&t.y>r-.5&&this.isPointInPoly(o,t))}static triarea2(t,e,s){return (s.x-t.x)*(e.z-t.z)-(e.x-t.x)*(s.z-t.z)}static vequal(t,e){return this.distanceToSquared(t,e)<1e-5}static mergeVertices(s,r=1e-4){r=Math.max(r,Number.EPSILON);for(var n={},o=s.getIndex(),i=s.getAttribute("position"),h=o?o.count:i.count,c=0,a=[],u=[],l=Math.log10(1/r),d=Math.pow(10,l),p=0;p<h;p++){var g=o?o.getX(p):p,f="";f+=~~(i.getX(g)*d)+",",f+=~~(i.getY(g)*d)+",",(f+=~~(i.getZ(g)*d)+",")in n?a.push(n[f]):(u.push(i.getX(g)),u.push(i.getY(g)),u.push(i.getZ(g)),n[f]=c,a.push(c),c++);}const v=new three$2.BufferAttribute(new Float32Array(u),i.itemSize,i.normalized),b=new three$2.BufferGeometry;return b.setAttribute("position",v),b.setIndex(a),b}}class p{constructor(t){this.content=[],this.scoreFunction=t;}push(t){this.content.push(t),this.sinkDown(this.content.length-1);}pop(){const t=this.content[0],e=this.content.pop();return this.content.length>0&&(this.content[0]=e,this.bubbleUp(0)),t}remove(t){const e=this.content.indexOf(t),s=this.content.pop();e!==this.content.length-1&&(this.content[e]=s,this.scoreFunction(s)<this.scoreFunction(t)?this.sinkDown(e):this.bubbleUp(e));}size(){return this.content.length}rescoreElement(t){this.sinkDown(this.content.indexOf(t));}sinkDown(t){const e=this.content[t];for(;t>0;){const s=(t+1>>1)-1,r=this.content[s];if(!(this.scoreFunction(e)<this.scoreFunction(r)))break;this.content[s]=e,this.content[t]=r,t=s;}}bubbleUp(t){const e=this.content.length,s=this.content[t],r=this.scoreFunction(s);for(;;){const n=t+1<<1,o=n-1;let i,h=null;if(o<e&&(i=this.scoreFunction(this.content[o]),i<r&&(h=o)),n<e&&this.scoreFunction(this.content[n])<(null===h?r:i)&&(h=n),null===h)break;this.content[t]=this.content[h],this.content[h]=s,t=h;}}}class g{constructor(){this.portals=[];}push(t,e){ void 0===e&&(e=t),this.portals.push({left:t,right:e});}stringPull(){const t=this.portals,e=[];let s,r,n,o=0,i=0,h=0;s=t[0].left,r=t[0].left,n=t[0].right,e.push(s);for(let c=1;c<t.length;c++){const a=t[c].left,u=t[c].right;if(d.triarea2(s,n,u)<=0){if(!(d.vequal(s,n)||d.triarea2(s,r,u)>0)){e.push(r),s=r,o=i,r=s,n=s,i=o,h=o,c=o;continue}n=u,h=c;}if(d.triarea2(s,r,a)>=0){if(!(d.vequal(s,r)||d.triarea2(s,n,a)<0)){e.push(n),s=n,o=h,r=s,n=s,i=o,h=o,c=o;continue}r=a,i=c;}}return 0!==e.length&&d.vequal(e[e.length-1],t[t.length-1].left)||e.push(t[t.length-1].left),this.path=e,e}}class f{constructor(){this.zones={};}static createZone(t,e=1e-4){return class{static buildZone(t,e){const r=this._buildNavigationMesh(t,e),n={};r.vertices.forEach(t=>{t.x=d.roundNumber(t.x,2),t.y=d.roundNumber(t.y,2),t.z=d.roundNumber(t.z,2);}),n.vertices=r.vertices;const o=this._buildPolygonGroups(r);return n.groups=new Array(o.length),o.forEach((t,e)=>{const r=new Map;t.forEach((t,e)=>{r.set(t,e);});const o=new Array(t.length);t.forEach((t,e)=>{const i=[];t.neighbours.forEach(t=>i.push(r.get(t)));const h=[];t.neighbours.forEach(e=>h.push(this._getSharedVerticesInOrder(t,e)));const c=new three$2.Vector3(0,0,0);c.add(n.vertices[t.vertexIds[0]]),c.add(n.vertices[t.vertexIds[1]]),c.add(n.vertices[t.vertexIds[2]]),c.divideScalar(3),c.x=d.roundNumber(c.x,2),c.y=d.roundNumber(c.y,2),c.z=d.roundNumber(c.z,2),o[e]={id:e,neighbours:i,vertexIds:t.vertexIds,centroid:c,portals:h};}),n.groups[e]=o;}),n}static _buildNavigationMesh(t,e){return t=d.mergeVertices(t,e),this._buildPolygonsFromGeometry(t)}static _spreadGroupId(t){let e=new Set([t]);for(;e.size>0;){const s=e;e=new Set,s.forEach(s=>{s.group=t.group,s.neighbours.forEach(t=>{ void 0===t.group&&e.add(t);});});}}static _buildPolygonGroups(t){const e=[];return t.polygons.forEach(t=>{ void 0!==t.group?e[t.group].push(t):(t.group=e.length,this._spreadGroupId(t),e.push([t]));}),e}static _buildPolygonNeighbours(t,e){const s=new Set,r=e[t.vertexIds[1]],n=e[t.vertexIds[2]];return e[t.vertexIds[0]].forEach(e=>{e!==t&&(r.includes(e)||n.includes(e))&&s.add(e);}),r.forEach(e=>{e!==t&&n.includes(e)&&s.add(e);}),s}static _buildPolygonsFromGeometry(t){const e=[],r=[],n=t.attributes.position,o=t.index,i=[];for(let t=0;t<n.count;t++)r.push((new three$2.Vector3).fromBufferAttribute(n,t)),i[t]=[];for(let s=0;s<t.index.count;s+=3){const t=o.getX(s),r=o.getX(s+1),n=o.getX(s+2),h={vertexIds:[t,r,n],neighbours:null};e.push(h),i[t].push(h),i[r].push(h),i[n].push(h);}return e.forEach(t=>{t.neighbours=this._buildPolygonNeighbours(t,i);}),{polygons:e,vertices:r}}static _getSharedVerticesInOrder(t,e){const s=t.vertexIds,r=s[0],n=s[1],o=s[2],i=e.vertexIds,h=i.includes(r),c=i.includes(n),a=i.includes(o);return h&&c&&a?Array.from(s):h&&c?[r,n]:c&&a?[n,o]:h&&a?[o,r]:(console.warn("Error processing navigation mesh neighbors; neighbors with <2 shared vertices found."),[])}}.buildZone(t,e)}setZoneData(t,e){this.zones[t]=e;}getRandomNode(t,e,r,n){if(!this.zones[t])return new three$2.Vector3;r=r||null,n=n||0;const o=[];return this.zones[t].groups[e].forEach(t=>{r&&n?d.distanceToSquared(r,t.centroid)<n*n&&o.push(t.centroid):o.push(t.centroid);}),d.sample(o)||new three$2.Vector3}getClosestNode(t,e,s,r=false){const n=this.zones[e].vertices;let o=null,i=Infinity;return this.zones[e].groups[s].forEach(e=>{const s=d.distanceToSquared(e.centroid,t);s<i&&(!r||d.isVectorInPolygon(t,e,n))&&(o=e,i=s);}),o}findPath(t,e,r,n){const o=this.zones[r].groups[n],i=this.zones[r].vertices,h=this.getClosestNode(t,r,n,true),c=this.getClosestNode(e,r,n,true);if(!h||!c)return null;const a=class{static init(t){for(let e=0;e<t.length;e++){const s=t[e];s.f=0,s.g=0,s.h=0,s.cost=1,s.visited=false,s.closed=false,s.parent=null;}}static cleanUp(t){for(let e=0;e<t.length;e++){const s=t[e];delete s.f,delete s.g,delete s.h,delete s.cost,delete s.visited,delete s.closed,delete s.parent;}}static heap(){return new p(function(t){return t.f})}static search(t,e,s){this.init(t);const r=this.heap();for(r.push(e);r.size()>0;){const e=r.pop();if(e===s){let t=e;const s=[];for(;t.parent;)s.push(t),t=t.parent;return this.cleanUp(s),s.reverse()}e.closed=true;const n=this.neighbours(t,e);for(let t=0,o=n.length;t<o;t++){const o=n[t];if(o.closed)continue;const i=e.g+o.cost,h=o.visited;if(!h||i<o.g){if(o.visited=true,o.parent=e,!o.centroid||!s.centroid)throw new Error("Unexpected state");o.h=o.h||this.heuristic(o.centroid,s.centroid),o.g=i,o.f=o.g+o.h,h?r.rescoreElement(o):r.push(o);}}}return []}static heuristic(t,e){return d.distanceToSquared(t,e)}static neighbours(t,e){const s=[];for(let r=0;r<e.neighbours.length;r++)s.push(t[e.neighbours[r]]);return s}}.search(o,h,c),u=function(t,e){for(var s=0;s<t.neighbours.length;s++)if(t.neighbours[s]===e.id)return t.portals[s]},l=new g;l.push(t);for(let t=0;t<a.length;t++){const e=a[t],s=a[t+1];if(s){const t=u(e,s);l.push(i[t[0]],i[t[1]]);}}l.push(e),l.stringPull();const f=l.path.map(t=>new three$2.Vector3(t.x,t.y,t.z));return f.shift(),f}}f.prototype.getGroup=function(){const t=new three$2.Plane;return function(e,s,r=false){if(!this.zones[e])return null;let n=null,o=Math.pow(50,2);const i=this.zones[e];for(let e=0;e<i.groups.length;e++){const h=i.groups[e];for(const c of h){if(r&&(t.setFromCoplanarPoints(i.vertices[c.vertexIds[0]],i.vertices[c.vertexIds[1]],i.vertices[c.vertexIds[2]]),Math.abs(t.distanceToPoint(s))<.01)&&d.isPointInPoly([i.vertices[c.vertexIds[0]],i.vertices[c.vertexIds[1]],i.vertices[c.vertexIds[2]]],s))return e;const h=d.distanceToSquared(c.centroid,s);h<o&&(n=e,o=h);}}return n}}(),f.prototype.clampStep=function(){const t=new three$2.Vector3,e=new three$2.Plane,o=new three$2.Triangle,i=new three$2.Vector3;let h,c,a=new three$2.Vector3;return function(s,r,n,u,l,d){const p=this.zones[u].vertices,g=this.zones[u].groups[l],f=[n],v={};v[n.id]=0,h=void 0,a.set(0,0,0),c=Infinity,e.setFromCoplanarPoints(p[n.vertexIds[0]],p[n.vertexIds[1]],p[n.vertexIds[2]]),e.projectPoint(r,t),i.copy(t);for(let e=f.pop();e;e=f.pop()){o.set(p[e.vertexIds[0]],p[e.vertexIds[1]],p[e.vertexIds[2]]),o.closestPointToPoint(i,t),t.distanceToSquared(i)<c&&(h=e,a.copy(t),c=t.distanceToSquared(i));const s=v[e.id];if(!(s>2))for(let t=0;t<e.neighbours.length;t++){const r=g[e.neighbours[t]];r.id in v||(f.push(r),v[r.id]=s+1);}}return d.copy(a),h}}();class v extends three$2.Object3D{constructor(){super(),this._playerMarker=new three$2.Mesh(new three$2.SphereGeometry(.25,32,32),new three$2.MeshBasicMaterial({color:15631215})),this._targetMarker=new three$2.Mesh(new three$2.BoxGeometry(.3,.3,.3),new three$2.MeshBasicMaterial({color:14469912})),this._nodeMarker=new three$2.Mesh(new three$2.BoxGeometry(.1,.8,.1),new three$2.MeshBasicMaterial({color:4417387})),this._stepMarker=new three$2.Mesh(new three$2.BoxGeometry(.1,1,.1),new three$2.MeshBasicMaterial({color:14472114})),this._pathMarker=new three$2.Object3D,this._pathLineMaterial=new three$2.LineBasicMaterial({color:41903,linewidth:2}),this._pathPointMaterial=new three$2.MeshBasicMaterial({color:41903}),this._pathPointGeometry=new three$2.SphereGeometry(.08),this._markers=[this._playerMarker,this._targetMarker,this._nodeMarker,this._stepMarker,this._pathMarker],this._markers.forEach(t=>{t.visible=false,this.add(t);});}setPath(s){for(;this._pathMarker.children.length;)this._pathMarker.children[0].visible=false,this._pathMarker.remove(this._pathMarker.children[0]);s=[this._playerMarker.position].concat(s);const r=new three$2.BufferGeometry;r.setAttribute("position",new three$2.BufferAttribute(new Float32Array(3*s.length),3));for(let t=0;t<s.length;t++)r.attributes.position.setXYZ(t,s[t].x,s[t].y+.2,s[t].z);this._pathMarker.add(new three$2.Line(r,this._pathLineMaterial));for(let t=0;t<s.length-1;t++){const e=new three$2.Mesh(this._pathPointGeometry,this._pathPointMaterial);e.position.copy(s[t]),e.position.y+=.2,this._pathMarker.add(e);}return this._pathMarker.visible=true,this}setPlayerPosition(t){return this._playerMarker.position.copy(t),this._playerMarker.visible=true,this}setTargetPosition(t){return this._targetMarker.position.copy(t),this._targetMarker.visible=true,this}setNodePosition(t){return this._nodeMarker.position.copy(t),this._nodeMarker.visible=true,this}setStepPosition(t){return this._stepMarker.position.copy(t),this._stepMarker.visible=true,this}reset(){for(;this._pathMarker.children.length;)this._pathMarker.children[0].visible=false,this._pathMarker.remove(this._pathMarker.children[0]);return this._markers.forEach(t=>{t.visible=false;}),this}}

  var threePathfinding_module = /*#__PURE__*/Object.freeze({
    __proto__: null,
    Pathfinding: f,
    PathfindingHelper: v
  });

  var require$$0 = /*@__PURE__*/getAugmentedNamespace(threePathfinding_module);

  var system;
  var hasRequiredSystem;

  function requireSystem () {
  	if (hasRequiredSystem) return system;
  	hasRequiredSystem = 1;
  	const { Pathfinding } = require$$0;

  	const pathfinder = new Pathfinding();
  	const ZONE = 'level';

  	/**
  	 * nav
  	 *
  	 * Pathfinding system, using PatrolJS.
  	 */
  	system = AFRAME.registerSystem('nav', {
  	  init: function () {
  	    this.navMesh = null;
  	    this.agents = new Set();
  	  },

  	  /**
  	   * @param {THREE.Geometry} geometry
  	   */
  	  setNavMeshGeometry: function (geometry) {
  	    this.navMesh = new THREE.Mesh(geometry);
  	    pathfinder.setZoneData(ZONE, Pathfinding.createZone(geometry));
  	    Array.from(this.agents).forEach((agent) => agent.updateNavLocation());
  	  },

  	  /**
  	   * @return {THREE.Mesh}
  	   */
  	  getNavMesh: function () {
  	    return this.navMesh;
  	  },

  	  /**
  	   * @param {NavAgent} ctrl
  	   */
  	  addAgent: function (ctrl) {
  	    this.agents.add(ctrl);
  	  },

  	  /**
  	   * @param {NavAgent} ctrl
  	   */
  	  removeAgent: function (ctrl) {
  	    this.agents.delete(ctrl);
  	  },

  	  /**
  	   * @param  {THREE.Vector3} start
  	   * @param  {THREE.Vector3} end
  	   * @param  {number} groupID
  	   * @return {Array<THREE.Vector3>}
  	   */
  	  getPath: function (start, end, groupID) {
  	    return this.navMesh
  	      ? pathfinder.findPath(start, end, ZONE, groupID)
  	      : null;
  	  },

  	  /**
  	   * @param {THREE.Vector3} position
  	   * @return {number}
  	   */
  	  getGroup: function (position) {
  	    return this.navMesh
  	      ? pathfinder.getGroup(ZONE, position)
  	      : null;
  	  },

  	  /**
  	   * @param  {THREE.Vector3} position
  	   * @param  {number} groupID
  	   * @return {Node}
  	   */
  	  getNode: function (position, groupID) {
  	    return this.navMesh
  	      ? pathfinder.getClosestNode(position, ZONE, groupID, true)
  	      : null;
  	  },

  	  /**
  	   * @param  {THREE.Vector3} start Starting position.
  	   * @param  {THREE.Vector3} end Desired ending position.
  	   * @param  {number} groupID
  	   * @param  {Node} node
  	   * @param  {THREE.Vector3} endTarget (Output) Adjusted step end position.
  	   * @return {Node} Current node, after step is taken.
  	   */
  	  clampStep: function (start, end, groupID, node, endTarget) {
  	    if (!this.navMesh) {
  	      endTarget.copy(end);
  	      return null;
  	    } else if (!node) {
  	      endTarget.copy(end);
  	      return this.getNode(end, groupID);
  	    }
  	    return pathfinder.clampStep(start, end, node, ZONE, groupID, endTarget);
  	  }
  	});
  	return system;
  }

  var hasRequiredPathfinding;

  function requirePathfinding () {
  	if (hasRequiredPathfinding) return pathfinding;
  	hasRequiredPathfinding = 1;
  	requireNavMesh();
  	requireNavAgent();
  	requireSystem();
  	return pathfinding;
  }

  var primitives = {};

  /**
   * Flat grid.
   *
   * Defaults to 75x75.
   */

  var aGrid;
  var hasRequiredAGrid;

  function requireAGrid () {
  	if (hasRequiredAGrid) return aGrid;
  	hasRequiredAGrid = 1;
  	aGrid = AFRAME.registerPrimitive('a-grid', {
  	  defaultComponents: {
  	    geometry: {
  	      primitive: 'plane',
  	      width: 75,
  	      height: 75
  	    },
  	    rotation: {x: -90, y: 0, z: 0},
  	    material: {
  	      src: 'url(https://cdn.jsdelivr.net/gh/donmccurdy/aframe-extras@v1.16.3/assets/grid.png)',
  	      repeat: '75 75'
  	    }
  	  },
  	  mappings: {
  	    width: 'geometry.width',
  	    height: 'geometry.height',
  	    src: 'material.src'
  	  }
  	});
  	return aGrid;
  }

  var aOcean = {};

  /**
   * Flat-shaded ocean primitive.
   *
   * Based on a Codrops tutorial:
   * http://tympanus.net/codrops/2016/04/26/the-aviator-animating-basic-3d-scene-threejs/
   */

  var hasRequiredAOcean;

  function requireAOcean () {
  	if (hasRequiredAOcean) return aOcean;
  	hasRequiredAOcean = 1;
  	aOcean.Primitive = AFRAME.registerPrimitive('a-ocean', {
  	  defaultComponents: {
  	    ocean: {},
  	    rotation: {x: -90, y: 0, z: 0}
  	  },
  	  mappings: {
  	    width: 'ocean.width',
  	    depth: 'ocean.depth',
  	    density: 'ocean.density',
  	    amplitude: 'ocean.amplitude',
  	    amplitudeVariance: 'ocean.amplitudeVariance',
  	    speed: 'ocean.speed',
  	    speedVariance: 'ocean.speedVariance',
  	    color: 'ocean.color',
  	    opacity: 'ocean.opacity'
  	  }
  	});

  	aOcean.Component = AFRAME.registerComponent('ocean', {
  	  schema: {
  	    // Dimensions of the ocean area.
  	    width: {default: 10, min: 0},
  	    depth: {default: 10, min: 0},

  	    // Density of waves.
  	    density: {default: 10},

  	    // Wave amplitude and variance.
  	    amplitude: {default: 0.1},
  	    amplitudeVariance: {default: 0.3},

  	    // Wave speed and variance.
  	    speed: {default: 1},
  	    speedVariance: {default: 2},

  	    // Material.
  	    color: {default: '#7AD2F7', type: 'color'},
  	    opacity: {default: 0.8}
  	  },

  	  /**
  	   * Use play() instead of init(), because component mappings – unavailable as dependencies – are
  	   * not guaranteed to have parsed when this component is initialized.
  	   */
  	  play: function () {
  	    const el = this.el;
  	    const data = this.data;
  	    let material = el.components.material;

  	    const geometry = new THREE.PlaneGeometry(data.width, data.depth, data.density, data.density);
  	    this.waves = [];
  	    const posAttribute = geometry.getAttribute('position');
  	    for (let i = 0; i < posAttribute.count; i++) {
  	      this.waves.push({
  	        z: posAttribute.getZ(i),
  	        ang: Math.random() * Math.PI * 2,
  	        amp: data.amplitude + Math.random() * data.amplitudeVariance,
  	        speed: (data.speed + Math.random() * data.speedVariance) / 1000 // radians / frame
  	      });
  	    }

  	    if (!material) {
  	      material = {};
  	      material.material = new THREE.MeshPhongMaterial({
  	        color: data.color,
  	        transparent: data.opacity < 1,
  	        opacity: data.opacity,
  	        flatShading: true,
  	      });
  	    }

  	    this.mesh = new THREE.Mesh(geometry, material.material);
  	    el.setObject3D('mesh', this.mesh);
  	  },

  	  remove: function () {
  	    this.el.removeObject3D('mesh');
  	  },

  	  tick: function (t, dt) {
  	    if (!dt) return;

  	    const posAttribute = this.mesh.geometry.getAttribute('position');
  	    for (let i = 0; i < posAttribute.count; i++){
  	      const vprops = this.waves[i];
  	      const value = vprops.z + Math.sin(vprops.ang) * vprops.amp;
  	      posAttribute.setZ(i, value);
  	      vprops.ang += vprops.speed * dt;
  	    }
  	    posAttribute.needsUpdate = true;
  	  }
  	});
  	return aOcean;
  }

  var aTube = {};

  /**
   * Tube following a custom path.
   *
   * Usage:
   *
   * ```html
   * <a-tube path="5 0 5, 5 0 -5, -5 0 -5" radius="0.5"></a-tube>
   * ```
   */

  var hasRequiredATube;

  function requireATube () {
  	if (hasRequiredATube) return aTube;
  	hasRequiredATube = 1;
  	aTube.Primitive = AFRAME.registerPrimitive('a-tube', {
  	  defaultComponents: {
  	    tube:           {},
  	  },
  	  mappings: {
  	    path:           'tube.path',
  	    segments:       'tube.segments',
  	    radius:         'tube.radius',
  	    'radial-segments': 'tube.radialSegments',
  	    closed:         'tube.closed'
  	  }
  	});

  	aTube.Component = AFRAME.registerComponent('tube', {
  	  schema: {
  	    path:           {default: []},
  	    segments:       {default: 64},
  	    radius:         {default: 1},
  	    radialSegments: {default: 8},
  	    closed:         {default: false}
  	  },

  	  init: function () {
  	    const el = this.el,
  	        data = this.data;
  	    let material = el.components.material;

  	    if (!data.path.length) {
  	      console.error('[a-tube] `path` property expected but not found.');
  	      return;
  	    }

  	    const curve = new THREE.CatmullRomCurve3(data.path.map(function (point) {
  	      point = point.split(' ');
  	      return new THREE.Vector3(Number(point[0]), Number(point[1]), Number(point[2]));
  	    }));
  	    const geometry = new THREE.TubeGeometry(
  	      curve, data.segments, data.radius, data.radialSegments, data.closed
  	    );

  	    if (!material) {
  	      material = {};
  	      material.material = new THREE.MeshPhongMaterial();
  	    }

  	    this.mesh = new THREE.Mesh(geometry, material.material);
  	    this.el.setObject3D('mesh', this.mesh);
  	  },

  	  update: function (prevData) {
  	    if (!Object.keys(prevData).length) return;

  	    this.remove();
  	    this.init();
  	  },

  	  remove: function () {
  	    if (this.mesh) this.el.removeObject3D('mesh');
  	  }
  	});
  	return aTube;
  }

  var hasRequiredPrimitives;

  function requirePrimitives () {
  	if (hasRequiredPrimitives) return primitives;
  	hasRequiredPrimitives = 1;
  	requireAGrid();
  	requireAOcean();
  	requireATube();
  	return primitives;
  }

  var hasRequiredAframeExtras;

  function requireAframeExtras () {
  	if (hasRequiredAframeExtras) return aframeExtras;
  	hasRequiredAframeExtras = 1;
  	requireControls();
  	requireLoaders();
  	requireMisc();
  	requirePathfinding();
  	requirePrimitives();
  	return aframeExtras;
  }

  requireAframeExtras();

  function forceCenter(x, y, z) {
    var nodes, strength = 1;

    if (x == null) x = 0;
    if (y == null) y = 0;
    if (z == null) z = 0;

    function force() {
      var i,
          n = nodes.length,
          node,
          sx = 0,
          sy = 0,
          sz = 0;

      for (i = 0; i < n; ++i) {
        node = nodes[i], sx += node.x || 0, sy += node.y || 0, sz += node.z || 0;
      }

      for (sx = (sx / n - x) * strength, sy = (sy / n - y) * strength, sz = (sz / n - z) * strength, i = 0; i < n; ++i) {
        node = nodes[i];
        if (sx) { node.x -= sx; }
        if (sy) { node.y -= sy; }
        if (sz) { node.z -= sz; }
      }
    }

    force.initialize = function(_) {
      nodes = _;
    };

    force.x = function(_) {
      return arguments.length ? (x = +_, force) : x;
    };

    force.y = function(_) {
      return arguments.length ? (y = +_, force) : y;
    };

    force.z = function(_) {
      return arguments.length ? (z = +_, force) : z;
    };

    force.strength = function(_) {
      return arguments.length ? (strength = +_, force) : strength;
    };

    return force;
  }

  function tree_add$2(d) {
    const x = +this._x.call(null, d);
    return add$2(this.cover(x), x, d);
  }

  function add$2(tree, x, d) {
    if (isNaN(x)) return tree; // ignore invalid points

    var parent,
        node = tree._root,
        leaf = {data: d},
        x0 = tree._x0,
        x1 = tree._x1,
        xm,
        xp,
        right,
        i,
        j;

    // If the tree is empty, initialize the root as a leaf.
    if (!node) return tree._root = leaf, tree;

    // Find the existing leaf for the new point, or add it.
    while (node.length) {
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm; else x1 = xm;
      if (parent = node, !(node = node[i = +right])) return parent[i] = leaf, tree;
    }

    // Is the new point is exactly coincident with the existing point?
    xp = +tree._x.call(null, node.data);
    if (x === xp) return leaf.next = node, parent ? parent[i] = leaf : tree._root = leaf, tree;

    // Otherwise, split the leaf node until the old and new point are separated.
    do {
      parent = parent ? parent[i] = new Array(2) : tree._root = new Array(2);
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm; else x1 = xm;
    } while ((i = +right) === (j = +(xp >= xm)));
    return parent[j] = node, parent[i] = leaf, tree;
  }

  function addAll$2(data) {
    if (!Array.isArray(data)) data = Array.from(data);
    const n = data.length;
    const xz = new Float64Array(n);
    let x0 = Infinity,
        x1 = -Infinity;

    // Compute the points and their extent.
    for (let i = 0, x; i < n; ++i) {
      if (isNaN(x = +this._x.call(null, data[i]))) continue;
      xz[i] = x;
      if (x < x0) x0 = x;
      if (x > x1) x1 = x;
    }

    // If there were no (valid) points, abort.
    if (x0 > x1) return this;

    // Expand the tree to cover the new points.
    this.cover(x0).cover(x1);

    // Add the new points.
    for (let i = 0; i < n; ++i) {
      add$2(this, xz[i], data[i]);
    }

    return this;
  }

  function tree_cover$2(x) {
    if (isNaN(x = +x)) return this; // ignore invalid points

    var x0 = this._x0,
        x1 = this._x1;

    // If the binarytree has no extent, initialize them.
    // Integer extent are necessary so that if we later double the extent,
    // the existing half boundaries don’t change due to floating point error!
    if (isNaN(x0)) {
      x1 = (x0 = Math.floor(x)) + 1;
    }

    // Otherwise, double repeatedly to cover.
    else {
      var z = x1 - x0 || 1,
          node = this._root,
          parent,
          i;

      while (x0 > x || x >= x1) {
        i = +(x < x0);
        parent = new Array(2), parent[i] = node, node = parent, z *= 2;
        switch (i) {
          case 0: x1 = x0 + z; break;
          case 1: x0 = x1 - z; break;
        }
      }

      if (this._root && this._root.length) this._root = node;
    }

    this._x0 = x0;
    this._x1 = x1;
    return this;
  }

  function tree_data$2() {
    var data = [];
    this.visit(function(node) {
      if (!node.length) do data.push(node.data); while (node = node.next)
    });
    return data;
  }

  function tree_extent$2(_) {
    return arguments.length
        ? this.cover(+_[0][0]).cover(+_[1][0])
        : isNaN(this._x0) ? undefined : [[this._x0], [this._x1]];
  }

  function Half(node, x0, x1) {
    this.node = node;
    this.x0 = x0;
    this.x1 = x1;
  }

  function tree_find$2(x, radius) {
    var data,
        x0 = this._x0,
        x1,
        x2,
        x3 = this._x1,
        halves = [],
        node = this._root,
        q,
        i;

    if (node) halves.push(new Half(node, x0, x3));
    if (radius == null) radius = Infinity;
    else {
      x0 = x - radius;
      x3 = x + radius;
    }

    while (q = halves.pop()) {

      // Stop searching if this half can’t contain a closer node.
      if (!(node = q.node)
          || (x1 = q.x0) > x3
          || (x2 = q.x1) < x0) continue;

      // Bisect the current half.
      if (node.length) {
        var xm = (x1 + x2) / 2;

        halves.push(
          new Half(node[1], xm, x2),
          new Half(node[0], x1, xm)
        );

        // Visit the closest half first.
        if (i = +(x >= xm)) {
          q = halves[halves.length - 1];
          halves[halves.length - 1] = halves[halves.length - 1 - i];
          halves[halves.length - 1 - i] = q;
        }
      }

      // Visit this point. (Visiting coincident points isn’t necessary!)
      else {
        var d = Math.abs(x - +this._x.call(null, node.data));
        if (d < radius) {
          radius = d;
          x0 = x - d;
          x3 = x + d;
          data = node.data;
        }
      }
    }

    return data;
  }

  function tree_remove$2(d) {
    if (isNaN(x = +this._x.call(null, d))) return this; // ignore invalid points

    var parent,
        node = this._root,
        retainer,
        previous,
        next,
        x0 = this._x0,
        x1 = this._x1,
        x,
        xm,
        right,
        i,
        j;

    // If the tree is empty, initialize the root as a leaf.
    if (!node) return this;

    // Find the leaf node for the point.
    // While descending, also retain the deepest parent with a non-removed sibling.
    if (node.length) while (true) {
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm; else x1 = xm;
      if (!(parent = node, node = node[i = +right])) return this;
      if (!node.length) break;
      if (parent[(i + 1) & 1]) retainer = parent, j = i;
    }

    // Find the point to remove.
    while (node.data !== d) if (!(previous = node, node = node.next)) return this;
    if (next = node.next) delete node.next;

    // If there are multiple coincident points, remove just the point.
    if (previous) return (next ? previous.next = next : delete previous.next), this;

    // If this is the root point, remove it.
    if (!parent) return this._root = next, this;

    // Remove this leaf.
    next ? parent[i] = next : delete parent[i];

    // If the parent now contains exactly one leaf, collapse superfluous parents.
    if ((node = parent[0] || parent[1])
        && node === (parent[1] || parent[0])
        && !node.length) {
      if (retainer) retainer[j] = node;
      else this._root = node;
    }

    return this;
  }

  function removeAll$2(data) {
    for (var i = 0, n = data.length; i < n; ++i) this.remove(data[i]);
    return this;
  }

  function tree_root$2() {
    return this._root;
  }

  function tree_size$2() {
    var size = 0;
    this.visit(function(node) {
      if (!node.length) do ++size; while (node = node.next)
    });
    return size;
  }

  function tree_visit$2(callback) {
    var halves = [], q, node = this._root, child, x0, x1;
    if (node) halves.push(new Half(node, this._x0, this._x1));
    while (q = halves.pop()) {
      if (!callback(node = q.node, x0 = q.x0, x1 = q.x1) && node.length) {
        var xm = (x0 + x1) / 2;
        if (child = node[1]) halves.push(new Half(child, xm, x1));
        if (child = node[0]) halves.push(new Half(child, x0, xm));
      }
    }
    return this;
  }

  function tree_visitAfter$2(callback) {
    var halves = [], next = [], q;
    if (this._root) halves.push(new Half(this._root, this._x0, this._x1));
    while (q = halves.pop()) {
      var node = q.node;
      if (node.length) {
        var child, x0 = q.x0, x1 = q.x1, xm = (x0 + x1) / 2;
        if (child = node[0]) halves.push(new Half(child, x0, xm));
        if (child = node[1]) halves.push(new Half(child, xm, x1));
      }
      next.push(q);
    }
    while (q = next.pop()) {
      callback(q.node, q.x0, q.x1);
    }
    return this;
  }

  function defaultX$2(d) {
    return d[0];
  }

  function tree_x$2(_) {
    return arguments.length ? (this._x = _, this) : this._x;
  }

  function binarytree(nodes, x) {
    var tree = new Binarytree(x == null ? defaultX$2 : x, NaN, NaN);
    return nodes == null ? tree : tree.addAll(nodes);
  }

  function Binarytree(x, x0, x1) {
    this._x = x;
    this._x0 = x0;
    this._x1 = x1;
    this._root = undefined;
  }

  function leaf_copy$2(leaf) {
    var copy = {data: leaf.data}, next = copy;
    while (leaf = leaf.next) next = next.next = {data: leaf.data};
    return copy;
  }

  var treeProto$2 = binarytree.prototype = Binarytree.prototype;

  treeProto$2.copy = function() {
    var copy = new Binarytree(this._x, this._x0, this._x1),
        node = this._root,
        nodes,
        child;

    if (!node) return copy;

    if (!node.length) return copy._root = leaf_copy$2(node), copy;

    nodes = [{source: node, target: copy._root = new Array(2)}];
    while (node = nodes.pop()) {
      for (var i = 0; i < 2; ++i) {
        if (child = node.source[i]) {
          if (child.length) nodes.push({source: child, target: node.target[i] = new Array(2)});
          else node.target[i] = leaf_copy$2(child);
        }
      }
    }

    return copy;
  };

  treeProto$2.add = tree_add$2;
  treeProto$2.addAll = addAll$2;
  treeProto$2.cover = tree_cover$2;
  treeProto$2.data = tree_data$2;
  treeProto$2.extent = tree_extent$2;
  treeProto$2.find = tree_find$2;
  treeProto$2.remove = tree_remove$2;
  treeProto$2.removeAll = removeAll$2;
  treeProto$2.root = tree_root$2;
  treeProto$2.size = tree_size$2;
  treeProto$2.visit = tree_visit$2;
  treeProto$2.visitAfter = tree_visitAfter$2;
  treeProto$2.x = tree_x$2;

  function tree_add$1(d) {
    const x = +this._x.call(null, d),
        y = +this._y.call(null, d);
    return add$1(this.cover(x, y), x, y, d);
  }

  function add$1(tree, x, y, d) {
    if (isNaN(x) || isNaN(y)) return tree; // ignore invalid points

    var parent,
        node = tree._root,
        leaf = {data: d},
        x0 = tree._x0,
        y0 = tree._y0,
        x1 = tree._x1,
        y1 = tree._y1,
        xm,
        ym,
        xp,
        yp,
        right,
        bottom,
        i,
        j;

    // If the tree is empty, initialize the root as a leaf.
    if (!node) return tree._root = leaf, tree;

    // Find the existing leaf for the new point, or add it.
    while (node.length) {
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm; else x1 = xm;
      if (bottom = y >= (ym = (y0 + y1) / 2)) y0 = ym; else y1 = ym;
      if (parent = node, !(node = node[i = bottom << 1 | right])) return parent[i] = leaf, tree;
    }

    // Is the new point is exactly coincident with the existing point?
    xp = +tree._x.call(null, node.data);
    yp = +tree._y.call(null, node.data);
    if (x === xp && y === yp) return leaf.next = node, parent ? parent[i] = leaf : tree._root = leaf, tree;

    // Otherwise, split the leaf node until the old and new point are separated.
    do {
      parent = parent ? parent[i] = new Array(4) : tree._root = new Array(4);
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm; else x1 = xm;
      if (bottom = y >= (ym = (y0 + y1) / 2)) y0 = ym; else y1 = ym;
    } while ((i = bottom << 1 | right) === (j = (yp >= ym) << 1 | (xp >= xm)));
    return parent[j] = node, parent[i] = leaf, tree;
  }

  function addAll$1(data) {
    var d, i, n = data.length,
        x,
        y,
        xz = new Array(n),
        yz = new Array(n),
        x0 = Infinity,
        y0 = Infinity,
        x1 = -Infinity,
        y1 = -Infinity;

    // Compute the points and their extent.
    for (i = 0; i < n; ++i) {
      if (isNaN(x = +this._x.call(null, d = data[i])) || isNaN(y = +this._y.call(null, d))) continue;
      xz[i] = x;
      yz[i] = y;
      if (x < x0) x0 = x;
      if (x > x1) x1 = x;
      if (y < y0) y0 = y;
      if (y > y1) y1 = y;
    }

    // If there were no (valid) points, abort.
    if (x0 > x1 || y0 > y1) return this;

    // Expand the tree to cover the new points.
    this.cover(x0, y0).cover(x1, y1);

    // Add the new points.
    for (i = 0; i < n; ++i) {
      add$1(this, xz[i], yz[i], data[i]);
    }

    return this;
  }

  function tree_cover$1(x, y) {
    if (isNaN(x = +x) || isNaN(y = +y)) return this; // ignore invalid points

    var x0 = this._x0,
        y0 = this._y0,
        x1 = this._x1,
        y1 = this._y1;

    // If the quadtree has no extent, initialize them.
    // Integer extent are necessary so that if we later double the extent,
    // the existing quadrant boundaries don’t change due to floating point error!
    if (isNaN(x0)) {
      x1 = (x0 = Math.floor(x)) + 1;
      y1 = (y0 = Math.floor(y)) + 1;
    }

    // Otherwise, double repeatedly to cover.
    else {
      var z = x1 - x0 || 1,
          node = this._root,
          parent,
          i;

      while (x0 > x || x >= x1 || y0 > y || y >= y1) {
        i = (y < y0) << 1 | (x < x0);
        parent = new Array(4), parent[i] = node, node = parent, z *= 2;
        switch (i) {
          case 0: x1 = x0 + z, y1 = y0 + z; break;
          case 1: x0 = x1 - z, y1 = y0 + z; break;
          case 2: x1 = x0 + z, y0 = y1 - z; break;
          case 3: x0 = x1 - z, y0 = y1 - z; break;
        }
      }

      if (this._root && this._root.length) this._root = node;
    }

    this._x0 = x0;
    this._y0 = y0;
    this._x1 = x1;
    this._y1 = y1;
    return this;
  }

  function tree_data$1() {
    var data = [];
    this.visit(function(node) {
      if (!node.length) do data.push(node.data); while (node = node.next)
    });
    return data;
  }

  function tree_extent$1(_) {
    return arguments.length
        ? this.cover(+_[0][0], +_[0][1]).cover(+_[1][0], +_[1][1])
        : isNaN(this._x0) ? undefined : [[this._x0, this._y0], [this._x1, this._y1]];
  }

  function Quad(node, x0, y0, x1, y1) {
    this.node = node;
    this.x0 = x0;
    this.y0 = y0;
    this.x1 = x1;
    this.y1 = y1;
  }

  function tree_find$1(x, y, radius) {
    var data,
        x0 = this._x0,
        y0 = this._y0,
        x1,
        y1,
        x2,
        y2,
        x3 = this._x1,
        y3 = this._y1,
        quads = [],
        node = this._root,
        q,
        i;

    if (node) quads.push(new Quad(node, x0, y0, x3, y3));
    if (radius == null) radius = Infinity;
    else {
      x0 = x - radius, y0 = y - radius;
      x3 = x + radius, y3 = y + radius;
      radius *= radius;
    }

    while (q = quads.pop()) {

      // Stop searching if this quadrant can’t contain a closer node.
      if (!(node = q.node)
          || (x1 = q.x0) > x3
          || (y1 = q.y0) > y3
          || (x2 = q.x1) < x0
          || (y2 = q.y1) < y0) continue;

      // Bisect the current quadrant.
      if (node.length) {
        var xm = (x1 + x2) / 2,
            ym = (y1 + y2) / 2;

        quads.push(
          new Quad(node[3], xm, ym, x2, y2),
          new Quad(node[2], x1, ym, xm, y2),
          new Quad(node[1], xm, y1, x2, ym),
          new Quad(node[0], x1, y1, xm, ym)
        );

        // Visit the closest quadrant first.
        if (i = (y >= ym) << 1 | (x >= xm)) {
          q = quads[quads.length - 1];
          quads[quads.length - 1] = quads[quads.length - 1 - i];
          quads[quads.length - 1 - i] = q;
        }
      }

      // Visit this point. (Visiting coincident points isn’t necessary!)
      else {
        var dx = x - +this._x.call(null, node.data),
            dy = y - +this._y.call(null, node.data),
            d2 = dx * dx + dy * dy;
        if (d2 < radius) {
          var d = Math.sqrt(radius = d2);
          x0 = x - d, y0 = y - d;
          x3 = x + d, y3 = y + d;
          data = node.data;
        }
      }
    }

    return data;
  }

  function tree_remove$1(d) {
    if (isNaN(x = +this._x.call(null, d)) || isNaN(y = +this._y.call(null, d))) return this; // ignore invalid points

    var parent,
        node = this._root,
        retainer,
        previous,
        next,
        x0 = this._x0,
        y0 = this._y0,
        x1 = this._x1,
        y1 = this._y1,
        x,
        y,
        xm,
        ym,
        right,
        bottom,
        i,
        j;

    // If the tree is empty, initialize the root as a leaf.
    if (!node) return this;

    // Find the leaf node for the point.
    // While descending, also retain the deepest parent with a non-removed sibling.
    if (node.length) while (true) {
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm; else x1 = xm;
      if (bottom = y >= (ym = (y0 + y1) / 2)) y0 = ym; else y1 = ym;
      if (!(parent = node, node = node[i = bottom << 1 | right])) return this;
      if (!node.length) break;
      if (parent[(i + 1) & 3] || parent[(i + 2) & 3] || parent[(i + 3) & 3]) retainer = parent, j = i;
    }

    // Find the point to remove.
    while (node.data !== d) if (!(previous = node, node = node.next)) return this;
    if (next = node.next) delete node.next;

    // If there are multiple coincident points, remove just the point.
    if (previous) return (next ? previous.next = next : delete previous.next), this;

    // If this is the root point, remove it.
    if (!parent) return this._root = next, this;

    // Remove this leaf.
    next ? parent[i] = next : delete parent[i];

    // If the parent now contains exactly one leaf, collapse superfluous parents.
    if ((node = parent[0] || parent[1] || parent[2] || parent[3])
        && node === (parent[3] || parent[2] || parent[1] || parent[0])
        && !node.length) {
      if (retainer) retainer[j] = node;
      else this._root = node;
    }

    return this;
  }

  function removeAll$1(data) {
    for (var i = 0, n = data.length; i < n; ++i) this.remove(data[i]);
    return this;
  }

  function tree_root$1() {
    return this._root;
  }

  function tree_size$1() {
    var size = 0;
    this.visit(function(node) {
      if (!node.length) do ++size; while (node = node.next)
    });
    return size;
  }

  function tree_visit$1(callback) {
    var quads = [], q, node = this._root, child, x0, y0, x1, y1;
    if (node) quads.push(new Quad(node, this._x0, this._y0, this._x1, this._y1));
    while (q = quads.pop()) {
      if (!callback(node = q.node, x0 = q.x0, y0 = q.y0, x1 = q.x1, y1 = q.y1) && node.length) {
        var xm = (x0 + x1) / 2, ym = (y0 + y1) / 2;
        if (child = node[3]) quads.push(new Quad(child, xm, ym, x1, y1));
        if (child = node[2]) quads.push(new Quad(child, x0, ym, xm, y1));
        if (child = node[1]) quads.push(new Quad(child, xm, y0, x1, ym));
        if (child = node[0]) quads.push(new Quad(child, x0, y0, xm, ym));
      }
    }
    return this;
  }

  function tree_visitAfter$1(callback) {
    var quads = [], next = [], q;
    if (this._root) quads.push(new Quad(this._root, this._x0, this._y0, this._x1, this._y1));
    while (q = quads.pop()) {
      var node = q.node;
      if (node.length) {
        var child, x0 = q.x0, y0 = q.y0, x1 = q.x1, y1 = q.y1, xm = (x0 + x1) / 2, ym = (y0 + y1) / 2;
        if (child = node[0]) quads.push(new Quad(child, x0, y0, xm, ym));
        if (child = node[1]) quads.push(new Quad(child, xm, y0, x1, ym));
        if (child = node[2]) quads.push(new Quad(child, x0, ym, xm, y1));
        if (child = node[3]) quads.push(new Quad(child, xm, ym, x1, y1));
      }
      next.push(q);
    }
    while (q = next.pop()) {
      callback(q.node, q.x0, q.y0, q.x1, q.y1);
    }
    return this;
  }

  function defaultX$1(d) {
    return d[0];
  }

  function tree_x$1(_) {
    return arguments.length ? (this._x = _, this) : this._x;
  }

  function defaultY$1(d) {
    return d[1];
  }

  function tree_y$1(_) {
    return arguments.length ? (this._y = _, this) : this._y;
  }

  function quadtree(nodes, x, y) {
    var tree = new Quadtree(x == null ? defaultX$1 : x, y == null ? defaultY$1 : y, NaN, NaN, NaN, NaN);
    return nodes == null ? tree : tree.addAll(nodes);
  }

  function Quadtree(x, y, x0, y0, x1, y1) {
    this._x = x;
    this._y = y;
    this._x0 = x0;
    this._y0 = y0;
    this._x1 = x1;
    this._y1 = y1;
    this._root = undefined;
  }

  function leaf_copy$1(leaf) {
    var copy = {data: leaf.data}, next = copy;
    while (leaf = leaf.next) next = next.next = {data: leaf.data};
    return copy;
  }

  var treeProto$1 = quadtree.prototype = Quadtree.prototype;

  treeProto$1.copy = function() {
    var copy = new Quadtree(this._x, this._y, this._x0, this._y0, this._x1, this._y1),
        node = this._root,
        nodes,
        child;

    if (!node) return copy;

    if (!node.length) return copy._root = leaf_copy$1(node), copy;

    nodes = [{source: node, target: copy._root = new Array(4)}];
    while (node = nodes.pop()) {
      for (var i = 0; i < 4; ++i) {
        if (child = node.source[i]) {
          if (child.length) nodes.push({source: child, target: node.target[i] = new Array(4)});
          else node.target[i] = leaf_copy$1(child);
        }
      }
    }

    return copy;
  };

  treeProto$1.add = tree_add$1;
  treeProto$1.addAll = addAll$1;
  treeProto$1.cover = tree_cover$1;
  treeProto$1.data = tree_data$1;
  treeProto$1.extent = tree_extent$1;
  treeProto$1.find = tree_find$1;
  treeProto$1.remove = tree_remove$1;
  treeProto$1.removeAll = removeAll$1;
  treeProto$1.root = tree_root$1;
  treeProto$1.size = tree_size$1;
  treeProto$1.visit = tree_visit$1;
  treeProto$1.visitAfter = tree_visitAfter$1;
  treeProto$1.x = tree_x$1;
  treeProto$1.y = tree_y$1;

  function tree_add(d) {
    const x = +this._x.call(null, d),
        y = +this._y.call(null, d),
        z = +this._z.call(null, d);
    return add(this.cover(x, y, z), x, y, z, d);
  }

  function add(tree, x, y, z, d) {
    if (isNaN(x) || isNaN(y) || isNaN(z)) return tree; // ignore invalid points

    var parent,
        node = tree._root,
        leaf = {data: d},
        x0 = tree._x0,
        y0 = tree._y0,
        z0 = tree._z0,
        x1 = tree._x1,
        y1 = tree._y1,
        z1 = tree._z1,
        xm,
        ym,
        zm,
        xp,
        yp,
        zp,
        right,
        bottom,
        deep,
        i,
        j;

    // If the tree is empty, initialize the root as a leaf.
    if (!node) return tree._root = leaf, tree;

    // Find the existing leaf for the new point, or add it.
    while (node.length) {
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm; else x1 = xm;
      if (bottom = y >= (ym = (y0 + y1) / 2)) y0 = ym; else y1 = ym;
      if (deep = z >= (zm = (z0 + z1) / 2)) z0 = zm; else z1 = zm;
      if (parent = node, !(node = node[i = deep << 2 | bottom << 1 | right])) return parent[i] = leaf, tree;
    }

    // Is the new point is exactly coincident with the existing point?
    xp = +tree._x.call(null, node.data);
    yp = +tree._y.call(null, node.data);
    zp = +tree._z.call(null, node.data);
    if (x === xp && y === yp && z === zp) return leaf.next = node, parent ? parent[i] = leaf : tree._root = leaf, tree;

    // Otherwise, split the leaf node until the old and new point are separated.
    do {
      parent = parent ? parent[i] = new Array(8) : tree._root = new Array(8);
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm; else x1 = xm;
      if (bottom = y >= (ym = (y0 + y1) / 2)) y0 = ym; else y1 = ym;
      if (deep = z >= (zm = (z0 + z1) / 2)) z0 = zm; else z1 = zm;
    } while ((i = deep << 2 | bottom << 1 | right) === (j = (zp >= zm) << 2 | (yp >= ym) << 1 | (xp >= xm)));
    return parent[j] = node, parent[i] = leaf, tree;
  }

  function addAll(data) {
    if (!Array.isArray(data)) data = Array.from(data);
    const n = data.length;
    const xz = new Float64Array(n);
    const yz = new Float64Array(n);
    const zz = new Float64Array(n);
    let x0 = Infinity,
        y0 = Infinity,
        z0 = Infinity,
        x1 = -Infinity,
        y1 = -Infinity,
        z1 = -Infinity;

    // Compute the points and their extent.
    for (let i = 0, d, x, y, z; i < n; ++i) {
      if (isNaN(x = +this._x.call(null, d = data[i])) || isNaN(y = +this._y.call(null, d)) || isNaN(z = +this._z.call(null, d))) continue;
      xz[i] = x;
      yz[i] = y;
      zz[i] = z;
      if (x < x0) x0 = x;
      if (x > x1) x1 = x;
      if (y < y0) y0 = y;
      if (y > y1) y1 = y;
      if (z < z0) z0 = z;
      if (z > z1) z1 = z;
    }

    // If there were no (valid) points, abort.
    if (x0 > x1 || y0 > y1 || z0 > z1) return this;

    // Expand the tree to cover the new points.
    this.cover(x0, y0, z0).cover(x1, y1, z1);

    // Add the new points.
    for (let i = 0; i < n; ++i) {
      add(this, xz[i], yz[i], zz[i], data[i]);
    }

    return this;
  }

  function tree_cover(x, y, z) {
    if (isNaN(x = +x) || isNaN(y = +y) || isNaN(z = +z)) return this; // ignore invalid points

    var x0 = this._x0,
        y0 = this._y0,
        z0 = this._z0,
        x1 = this._x1,
        y1 = this._y1,
        z1 = this._z1;

    // If the octree has no extent, initialize them.
    // Integer extent are necessary so that if we later double the extent,
    // the existing octant boundaries don’t change due to floating point error!
    if (isNaN(x0)) {
      x1 = (x0 = Math.floor(x)) + 1;
      y1 = (y0 = Math.floor(y)) + 1;
      z1 = (z0 = Math.floor(z)) + 1;
    }

    // Otherwise, double repeatedly to cover.
    else {
      var t = x1 - x0 || 1,
          node = this._root,
          parent,
          i;

      while (x0 > x || x >= x1 || y0 > y || y >= y1 || z0 > z || z >= z1) {
        i = (z < z0) << 2 | (y < y0) << 1 | (x < x0);
        parent = new Array(8), parent[i] = node, node = parent, t *= 2;
        switch (i) {
          case 0: x1 = x0 + t, y1 = y0 + t, z1 = z0 + t; break;
          case 1: x0 = x1 - t, y1 = y0 + t, z1 = z0 + t; break;
          case 2: x1 = x0 + t, y0 = y1 - t, z1 = z0 + t; break;
          case 3: x0 = x1 - t, y0 = y1 - t, z1 = z0 + t; break;
          case 4: x1 = x0 + t, y1 = y0 + t, z0 = z1 - t; break;
          case 5: x0 = x1 - t, y1 = y0 + t, z0 = z1 - t; break;
          case 6: x1 = x0 + t, y0 = y1 - t, z0 = z1 - t; break;
          case 7: x0 = x1 - t, y0 = y1 - t, z0 = z1 - t; break;
        }
      }

      if (this._root && this._root.length) this._root = node;
    }

    this._x0 = x0;
    this._y0 = y0;
    this._z0 = z0;
    this._x1 = x1;
    this._y1 = y1;
    this._z1 = z1;
    return this;
  }

  function tree_data() {
    var data = [];
    this.visit(function(node) {
      if (!node.length) do data.push(node.data); while (node = node.next)
    });
    return data;
  }

  function tree_extent(_) {
    return arguments.length
        ? this.cover(+_[0][0], +_[0][1], +_[0][2]).cover(+_[1][0], +_[1][1], +_[1][2])
        : isNaN(this._x0) ? undefined : [[this._x0, this._y0, this._z0], [this._x1, this._y1, this._z1]];
  }

  function Octant(node, x0, y0, z0, x1, y1, z1) {
    this.node = node;
    this.x0 = x0;
    this.y0 = y0;
    this.z0 = z0;
    this.x1 = x1;
    this.y1 = y1;
    this.z1 = z1;
  }

  function tree_find(x, y, z, radius) {
    var data,
        x0 = this._x0,
        y0 = this._y0,
        z0 = this._z0,
        x1,
        y1,
        z1,
        x2,
        y2,
        z2,
        x3 = this._x1,
        y3 = this._y1,
        z3 = this._z1,
        octs = [],
        node = this._root,
        q,
        i;

    if (node) octs.push(new Octant(node, x0, y0, z0, x3, y3, z3));
    if (radius == null) radius = Infinity;
    else {
      x0 = x - radius, y0 = y - radius, z0 = z - radius;
      x3 = x + radius, y3 = y + radius, z3 = z + radius;
      radius *= radius;
    }

    while (q = octs.pop()) {

      // Stop searching if this octant can’t contain a closer node.
      if (!(node = q.node)
          || (x1 = q.x0) > x3
          || (y1 = q.y0) > y3
          || (z1 = q.z0) > z3
          || (x2 = q.x1) < x0
          || (y2 = q.y1) < y0
          || (z2 = q.z1) < z0) continue;

      // Bisect the current octant.
      if (node.length) {
        var xm = (x1 + x2) / 2,
            ym = (y1 + y2) / 2,
            zm = (z1 + z2) / 2;

        octs.push(
          new Octant(node[7], xm, ym, zm, x2, y2, z2),
          new Octant(node[6], x1, ym, zm, xm, y2, z2),
          new Octant(node[5], xm, y1, zm, x2, ym, z2),
          new Octant(node[4], x1, y1, zm, xm, ym, z2),
          new Octant(node[3], xm, ym, z1, x2, y2, zm),
          new Octant(node[2], x1, ym, z1, xm, y2, zm),
          new Octant(node[1], xm, y1, z1, x2, ym, zm),
          new Octant(node[0], x1, y1, z1, xm, ym, zm)
        );

        // Visit the closest octant first.
        if (i = (z >= zm) << 2 | (y >= ym) << 1 | (x >= xm)) {
          q = octs[octs.length - 1];
          octs[octs.length - 1] = octs[octs.length - 1 - i];
          octs[octs.length - 1 - i] = q;
        }
      }

      // Visit this point. (Visiting coincident points isn’t necessary!)
      else {
        var dx = x - +this._x.call(null, node.data),
            dy = y - +this._y.call(null, node.data),
            dz = z - +this._z.call(null, node.data),
            d2 = dx * dx + dy * dy + dz * dz;
        if (d2 < radius) {
          var d = Math.sqrt(radius = d2);
          x0 = x - d, y0 = y - d, z0 = z - d;
          x3 = x + d, y3 = y + d, z3 = z + d;
          data = node.data;
        }
      }
    }

    return data;
  }

  const distance = (x1, y1, z1, x2, y2, z2) => Math.sqrt((x1-x2)**2 + (y1-y2)**2 + (z1-z2)**2);

  function findAllWithinRadius(x, y, z, radius) {
    const result = [];

    const xMin = x - radius;
    const yMin = y - radius;
    const zMin = z - radius;
    const xMax = x + radius;
    const yMax = y + radius;
    const zMax = z + radius;

    this.visit((node, x1, y1, z1, x2, y2, z2) => {
      if (!node.length) {
        do {
          const d = node.data;
          if (distance(x, y, z, this._x(d), this._y(d), this._z(d)) <= radius) {
            result.push(d);
          }
        } while (node = node.next);
      }
      return x1 > xMax || y1 > yMax || z1 > zMax || x2 < xMin || y2 < yMin || z2 < zMin;
    });

    return result;
  }

  function tree_remove(d) {
    if (isNaN(x = +this._x.call(null, d)) || isNaN(y = +this._y.call(null, d)) || isNaN(z = +this._z.call(null, d))) return this; // ignore invalid points

    var parent,
        node = this._root,
        retainer,
        previous,
        next,
        x0 = this._x0,
        y0 = this._y0,
        z0 = this._z0,
        x1 = this._x1,
        y1 = this._y1,
        z1 = this._z1,
        x,
        y,
        z,
        xm,
        ym,
        zm,
        right,
        bottom,
        deep,
        i,
        j;

    // If the tree is empty, initialize the root as a leaf.
    if (!node) return this;

    // Find the leaf node for the point.
    // While descending, also retain the deepest parent with a non-removed sibling.
    if (node.length) while (true) {
      if (right = x >= (xm = (x0 + x1) / 2)) x0 = xm; else x1 = xm;
      if (bottom = y >= (ym = (y0 + y1) / 2)) y0 = ym; else y1 = ym;
      if (deep = z >= (zm = (z0 + z1) / 2)) z0 = zm; else z1 = zm;
      if (!(parent = node, node = node[i = deep << 2 | bottom << 1 | right])) return this;
      if (!node.length) break;
      if (parent[(i + 1) & 7] || parent[(i + 2) & 7] || parent[(i + 3) & 7] || parent[(i + 4) & 7] || parent[(i + 5) & 7] || parent[(i + 6) & 7] || parent[(i + 7) & 7]) retainer = parent, j = i;
    }

    // Find the point to remove.
    while (node.data !== d) if (!(previous = node, node = node.next)) return this;
    if (next = node.next) delete node.next;

    // If there are multiple coincident points, remove just the point.
    if (previous) return (next ? previous.next = next : delete previous.next), this;

    // If this is the root point, remove it.
    if (!parent) return this._root = next, this;

    // Remove this leaf.
    next ? parent[i] = next : delete parent[i];

    // If the parent now contains exactly one leaf, collapse superfluous parents.
    if ((node = parent[0] || parent[1] || parent[2] || parent[3] || parent[4] || parent[5] || parent[6] || parent[7])
        && node === (parent[7] || parent[6] || parent[5] || parent[4] || parent[3] || parent[2] || parent[1] || parent[0])
        && !node.length) {
      if (retainer) retainer[j] = node;
      else this._root = node;
    }

    return this;
  }

  function removeAll(data) {
    for (var i = 0, n = data.length; i < n; ++i) this.remove(data[i]);
    return this;
  }

  function tree_root() {
    return this._root;
  }

  function tree_size() {
    var size = 0;
    this.visit(function(node) {
      if (!node.length) do ++size; while (node = node.next)
    });
    return size;
  }

  function tree_visit(callback) {
    var octs = [], q, node = this._root, child, x0, y0, z0, x1, y1, z1;
    if (node) octs.push(new Octant(node, this._x0, this._y0, this._z0, this._x1, this._y1, this._z1));
    while (q = octs.pop()) {
      if (!callback(node = q.node, x0 = q.x0, y0 = q.y0, z0 = q.z0, x1 = q.x1, y1 = q.y1, z1 = q.z1) && node.length) {
        var xm = (x0 + x1) / 2, ym = (y0 + y1) / 2, zm = (z0 + z1) / 2;
        if (child = node[7]) octs.push(new Octant(child, xm, ym, zm, x1, y1, z1));
        if (child = node[6]) octs.push(new Octant(child, x0, ym, zm, xm, y1, z1));
        if (child = node[5]) octs.push(new Octant(child, xm, y0, zm, x1, ym, z1));
        if (child = node[4]) octs.push(new Octant(child, x0, y0, zm, xm, ym, z1));
        if (child = node[3]) octs.push(new Octant(child, xm, ym, z0, x1, y1, zm));
        if (child = node[2]) octs.push(new Octant(child, x0, ym, z0, xm, y1, zm));
        if (child = node[1]) octs.push(new Octant(child, xm, y0, z0, x1, ym, zm));
        if (child = node[0]) octs.push(new Octant(child, x0, y0, z0, xm, ym, zm));
      }
    }
    return this;
  }

  function tree_visitAfter(callback) {
    var octs = [], next = [], q;
    if (this._root) octs.push(new Octant(this._root, this._x0, this._y0, this._z0, this._x1, this._y1, this._z1));
    while (q = octs.pop()) {
      var node = q.node;
      if (node.length) {
        var child, x0 = q.x0, y0 = q.y0, z0 = q.z0, x1 = q.x1, y1 = q.y1, z1 = q.z1, xm = (x0 + x1) / 2, ym = (y0 + y1) / 2, zm = (z0 + z1) / 2;
        if (child = node[0]) octs.push(new Octant(child, x0, y0, z0, xm, ym, zm));
        if (child = node[1]) octs.push(new Octant(child, xm, y0, z0, x1, ym, zm));
        if (child = node[2]) octs.push(new Octant(child, x0, ym, z0, xm, y1, zm));
        if (child = node[3]) octs.push(new Octant(child, xm, ym, z0, x1, y1, zm));
        if (child = node[4]) octs.push(new Octant(child, x0, y0, zm, xm, ym, z1));
        if (child = node[5]) octs.push(new Octant(child, xm, y0, zm, x1, ym, z1));
        if (child = node[6]) octs.push(new Octant(child, x0, ym, zm, xm, y1, z1));
        if (child = node[7]) octs.push(new Octant(child, xm, ym, zm, x1, y1, z1));
      }
      next.push(q);
    }
    while (q = next.pop()) {
      callback(q.node, q.x0, q.y0, q.z0, q.x1, q.y1, q.z1);
    }
    return this;
  }

  function defaultX(d) {
    return d[0];
  }

  function tree_x(_) {
    return arguments.length ? (this._x = _, this) : this._x;
  }

  function defaultY(d) {
    return d[1];
  }

  function tree_y(_) {
    return arguments.length ? (this._y = _, this) : this._y;
  }

  function defaultZ(d) {
    return d[2];
  }

  function tree_z(_) {
    return arguments.length ? (this._z = _, this) : this._z;
  }

  function octree(nodes, x, y, z) {
    var tree = new Octree(x == null ? defaultX : x, y == null ? defaultY : y, z == null ? defaultZ : z, NaN, NaN, NaN, NaN, NaN, NaN);
    return nodes == null ? tree : tree.addAll(nodes);
  }

  function Octree(x, y, z, x0, y0, z0, x1, y1, z1) {
    this._x = x;
    this._y = y;
    this._z = z;
    this._x0 = x0;
    this._y0 = y0;
    this._z0 = z0;
    this._x1 = x1;
    this._y1 = y1;
    this._z1 = z1;
    this._root = undefined;
  }

  function leaf_copy(leaf) {
    var copy = {data: leaf.data}, next = copy;
    while (leaf = leaf.next) next = next.next = {data: leaf.data};
    return copy;
  }

  var treeProto = octree.prototype = Octree.prototype;

  treeProto.copy = function() {
    var copy = new Octree(this._x, this._y, this._z, this._x0, this._y0, this._z0, this._x1, this._y1, this._z1),
        node = this._root,
        nodes,
        child;

    if (!node) return copy;

    if (!node.length) return copy._root = leaf_copy(node), copy;

    nodes = [{source: node, target: copy._root = new Array(8)}];
    while (node = nodes.pop()) {
      for (var i = 0; i < 8; ++i) {
        if (child = node.source[i]) {
          if (child.length) nodes.push({source: child, target: node.target[i] = new Array(8)});
          else node.target[i] = leaf_copy(child);
        }
      }
    }

    return copy;
  };

  treeProto.add = tree_add;
  treeProto.addAll = addAll;
  treeProto.cover = tree_cover;
  treeProto.data = tree_data;
  treeProto.extent = tree_extent;
  treeProto.find = tree_find;
  treeProto.findAllWithinRadius = findAllWithinRadius;
  treeProto.remove = tree_remove;
  treeProto.removeAll = removeAll;
  treeProto.root = tree_root;
  treeProto.size = tree_size;
  treeProto.visit = tree_visit;
  treeProto.visitAfter = tree_visitAfter;
  treeProto.x = tree_x;
  treeProto.y = tree_y;
  treeProto.z = tree_z;

  function constant(x) {
    return function() {
      return x;
    };
  }

  function jiggle(random) {
    return (random() - 0.5) * 1e-6;
  }

  function index$2(d) {
    return d.index;
  }

  function find(nodeById, nodeId) {
    var node = nodeById.get(nodeId);
    if (!node) throw new Error("node not found: " + nodeId);
    return node;
  }

  function forceLink(links) {
    var id = index$2,
        strength = defaultStrength,
        strengths,
        distance = constant(30),
        distances,
        nodes,
        nDim,
        count,
        bias,
        random,
        iterations = 1;

    if (links == null) links = [];

    function defaultStrength(link) {
      return 1 / Math.min(count[link.source.index], count[link.target.index]);
    }

    function force(alpha) {
      for (var k = 0, n = links.length; k < iterations; ++k) {
        for (var i = 0, link, source, target, x = 0, y = 0, z = 0, l, b; i < n; ++i) {
          link = links[i], source = link.source, target = link.target;
          x = target.x + target.vx - source.x - source.vx || jiggle(random);
          if (nDim > 1) { y = target.y + target.vy - source.y - source.vy || jiggle(random); }
          if (nDim > 2) { z = target.z + target.vz - source.z - source.vz || jiggle(random); }
          l = Math.sqrt(x * x + y * y + z * z);
          l = (l - distances[i]) / l * alpha * strengths[i];
          x *= l, y *= l, z *= l;

          target.vx -= x * (b = bias[i]);
          if (nDim > 1) { target.vy -= y * b; }
          if (nDim > 2) { target.vz -= z * b; }

          source.vx += x * (b = 1 - b);
          if (nDim > 1) { source.vy += y * b; }
          if (nDim > 2) { source.vz += z * b; }
        }
      }
    }

    function initialize() {
      if (!nodes) return;

      var i,
          n = nodes.length,
          m = links.length,
          nodeById = new Map(nodes.map((d, i) => [id(d, i, nodes), d])),
          link;

      for (i = 0, count = new Array(n); i < m; ++i) {
        link = links[i], link.index = i;
        if (typeof link.source !== "object") link.source = find(nodeById, link.source);
        if (typeof link.target !== "object") link.target = find(nodeById, link.target);
        count[link.source.index] = (count[link.source.index] || 0) + 1;
        count[link.target.index] = (count[link.target.index] || 0) + 1;
      }

      for (i = 0, bias = new Array(m); i < m; ++i) {
        link = links[i], bias[i] = count[link.source.index] / (count[link.source.index] + count[link.target.index]);
      }

      strengths = new Array(m), initializeStrength();
      distances = new Array(m), initializeDistance();
    }

    function initializeStrength() {
      if (!nodes) return;

      for (var i = 0, n = links.length; i < n; ++i) {
        strengths[i] = +strength(links[i], i, links);
      }
    }

    function initializeDistance() {
      if (!nodes) return;

      for (var i = 0, n = links.length; i < n; ++i) {
        distances[i] = +distance(links[i], i, links);
      }
    }

    force.initialize = function(_nodes, ...args) {
      nodes = _nodes;
      random = args.find(arg => typeof arg === 'function') || Math.random;
      nDim = args.find(arg => [1, 2, 3].includes(arg)) || 2;
      initialize();
    };

    force.links = function(_) {
      return arguments.length ? (links = _, initialize(), force) : links;
    };

    force.id = function(_) {
      return arguments.length ? (id = _, force) : id;
    };

    force.iterations = function(_) {
      return arguments.length ? (iterations = +_, force) : iterations;
    };

    force.strength = function(_) {
      return arguments.length ? (strength = typeof _ === "function" ? _ : constant(+_), initializeStrength(), force) : strength;
    };

    force.distance = function(_) {
      return arguments.length ? (distance = typeof _ === "function" ? _ : constant(+_), initializeDistance(), force) : distance;
    };

    return force;
  }

  var noop = {value: () => {}};

  function dispatch() {
    for (var i = 0, n = arguments.length, _ = {}, t; i < n; ++i) {
      if (!(t = arguments[i] + "") || (t in _) || /[\s.]/.test(t)) throw new Error("illegal type: " + t);
      _[t] = [];
    }
    return new Dispatch(_);
  }

  function Dispatch(_) {
    this._ = _;
  }

  function parseTypenames(typenames, types) {
    return typenames.trim().split(/^|\s+/).map(function(t) {
      var name = "", i = t.indexOf(".");
      if (i >= 0) name = t.slice(i + 1), t = t.slice(0, i);
      if (t && !types.hasOwnProperty(t)) throw new Error("unknown type: " + t);
      return {type: t, name: name};
    });
  }

  Dispatch.prototype = dispatch.prototype = {
    constructor: Dispatch,
    on: function(typename, callback) {
      var _ = this._,
          T = parseTypenames(typename + "", _),
          t,
          i = -1,
          n = T.length;

      // If no callback was specified, return the callback of the given type and name.
      if (arguments.length < 2) {
        while (++i < n) if ((t = (typename = T[i]).type) && (t = get(_[t], typename.name))) return t;
        return;
      }

      // If a type was specified, set the callback for the given type and name.
      // Otherwise, if a null callback was specified, remove callbacks of the given name.
      if (callback != null && typeof callback !== "function") throw new Error("invalid callback: " + callback);
      while (++i < n) {
        if (t = (typename = T[i]).type) _[t] = set(_[t], typename.name, callback);
        else if (callback == null) for (t in _) _[t] = set(_[t], typename.name, null);
      }

      return this;
    },
    copy: function() {
      var copy = {}, _ = this._;
      for (var t in _) copy[t] = _[t].slice();
      return new Dispatch(copy);
    },
    call: function(type, that) {
      if ((n = arguments.length - 2) > 0) for (var args = new Array(n), i = 0, n, t; i < n; ++i) args[i] = arguments[i + 2];
      if (!this._.hasOwnProperty(type)) throw new Error("unknown type: " + type);
      for (t = this._[type], i = 0, n = t.length; i < n; ++i) t[i].value.apply(that, args);
    },
    apply: function(type, that, args) {
      if (!this._.hasOwnProperty(type)) throw new Error("unknown type: " + type);
      for (var t = this._[type], i = 0, n = t.length; i < n; ++i) t[i].value.apply(that, args);
    }
  };

  function get(type, name) {
    for (var i = 0, n = type.length, c; i < n; ++i) {
      if ((c = type[i]).name === name) {
        return c.value;
      }
    }
  }

  function set(type, name, callback) {
    for (var i = 0, n = type.length; i < n; ++i) {
      if (type[i].name === name) {
        type[i] = noop, type = type.slice(0, i).concat(type.slice(i + 1));
        break;
      }
    }
    if (callback != null) type.push({name: name, value: callback});
    return type;
  }

  var frame = 0, // is an animation frame pending?
      timeout = 0, // is a timeout pending?
      interval = 0, // are any timers active?
      pokeDelay = 1000, // how frequently we check for clock skew
      taskHead,
      taskTail,
      clockLast = 0,
      clockNow = 0,
      clockSkew = 0,
      clock = typeof performance === "object" && performance.now ? performance : Date,
      setFrame = typeof window === "object" && window.requestAnimationFrame ? window.requestAnimationFrame.bind(window) : function(f) { setTimeout(f, 17); };

  function now$1() {
    return clockNow || (setFrame(clearNow), clockNow = clock.now() + clockSkew);
  }

  function clearNow() {
    clockNow = 0;
  }

  function Timer() {
    this._call =
    this._time =
    this._next = null;
  }

  Timer.prototype = timer.prototype = {
    constructor: Timer,
    restart: function(callback, delay, time) {
      if (typeof callback !== "function") throw new TypeError("callback is not a function");
      time = (time == null ? now$1() : +time) + (delay == null ? 0 : +delay);
      if (!this._next && taskTail !== this) {
        if (taskTail) taskTail._next = this;
        else taskHead = this;
        taskTail = this;
      }
      this._call = callback;
      this._time = time;
      sleep();
    },
    stop: function() {
      if (this._call) {
        this._call = null;
        this._time = Infinity;
        sleep();
      }
    }
  };

  function timer(callback, delay, time) {
    var t = new Timer;
    t.restart(callback, delay, time);
    return t;
  }

  function timerFlush() {
    now$1(); // Get the current time, if not already set.
    ++frame; // Pretend we’ve set an alarm, if we haven’t already.
    var t = taskHead, e;
    while (t) {
      if ((e = clockNow - t._time) >= 0) t._call.call(undefined, e);
      t = t._next;
    }
    --frame;
  }

  function wake() {
    clockNow = (clockLast = clock.now()) + clockSkew;
    frame = timeout = 0;
    try {
      timerFlush();
    } finally {
      frame = 0;
      nap();
      clockNow = 0;
    }
  }

  function poke() {
    var now = clock.now(), delay = now - clockLast;
    if (delay > pokeDelay) clockSkew -= delay, clockLast = now;
  }

  function nap() {
    var t0, t1 = taskHead, t2, time = Infinity;
    while (t1) {
      if (t1._call) {
        if (time > t1._time) time = t1._time;
        t0 = t1, t1 = t1._next;
      } else {
        t2 = t1._next, t1._next = null;
        t1 = t0 ? t0._next = t2 : taskHead = t2;
      }
    }
    taskTail = t0;
    sleep(time);
  }

  function sleep(time) {
    if (frame) return; // Soonest alarm already set, or will be.
    if (timeout) timeout = clearTimeout(timeout);
    var delay = time - clockNow; // Strictly less than if we recomputed clockNow.
    if (delay > 24) {
      if (time < Infinity) timeout = setTimeout(wake, time - clock.now() - clockSkew);
      if (interval) interval = clearInterval(interval);
    } else {
      if (!interval) clockLast = clock.now(), interval = setInterval(poke, pokeDelay);
      frame = 1, setFrame(wake);
    }
  }

  // https://en.wikipedia.org/wiki/Linear_congruential_generator#Parameters_in_common_use
  const a = 1664525;
  const c = 1013904223;
  const m = 4294967296; // 2^32

  function lcg() {
    let s = 1;
    return () => (s = (a * s + c) % m) / m;
  }

  var MAX_DIMENSIONS = 3;

  function x(d) {
    return d.x;
  }

  function y(d) {
    return d.y;
  }

  function z(d) {
    return d.z;
  }

  var initialRadius = 10,
      initialAngleRoll = Math.PI * (3 - Math.sqrt(5)), // Golden ratio angle
      initialAngleYaw = Math.PI * 20 / (9 + Math.sqrt(221)); // Markov irrational number

  function forceSimulation(nodes, numDimensions) {
    numDimensions = numDimensions || 2;

    var nDim = Math.min(MAX_DIMENSIONS, Math.max(1, Math.round(numDimensions))),
        simulation,
        alpha = 1,
        alphaMin = 0.001,
        alphaDecay = 1 - Math.pow(alphaMin, 1 / 300),
        alphaTarget = 0,
        velocityDecay = 0.6,
        forces = new Map(),
        stepper = timer(step),
        event = dispatch("tick", "end"),
        random = lcg();

    if (nodes == null) nodes = [];

    function step() {
      tick();
      event.call("tick", simulation);
      if (alpha < alphaMin) {
        stepper.stop();
        event.call("end", simulation);
      }
    }

    function tick(iterations) {
      var i, n = nodes.length, node;

      if (iterations === undefined) iterations = 1;

      for (var k = 0; k < iterations; ++k) {
        alpha += (alphaTarget - alpha) * alphaDecay;

        forces.forEach(function (force) {
          force(alpha);
        });

        for (i = 0; i < n; ++i) {
          node = nodes[i];
          if (node.fx == null) node.x += node.vx *= velocityDecay;
          else node.x = node.fx, node.vx = 0;
          if (nDim > 1) {
            if (node.fy == null) node.y += node.vy *= velocityDecay;
            else node.y = node.fy, node.vy = 0;
          }
          if (nDim > 2) {
            if (node.fz == null) node.z += node.vz *= velocityDecay;
            else node.z = node.fz, node.vz = 0;
          }
        }
      }

      return simulation;
    }

    function initializeNodes() {
      for (var i = 0, n = nodes.length, node; i < n; ++i) {
        node = nodes[i], node.index = i;
        if (node.fx != null) node.x = node.fx;
        if (node.fy != null) node.y = node.fy;
        if (node.fz != null) node.z = node.fz;
        if (isNaN(node.x) || (nDim > 1 && isNaN(node.y)) || (nDim > 2 && isNaN(node.z))) {
          var radius = initialRadius * (nDim > 2 ? Math.cbrt(0.5 + i) : (nDim > 1 ? Math.sqrt(0.5 + i) : i)),
            rollAngle = i * initialAngleRoll,
            yawAngle = i * initialAngleYaw;

          if (nDim === 1) {
            node.x = radius;
          } else if (nDim === 2) {
            node.x = radius * Math.cos(rollAngle);
            node.y = radius * Math.sin(rollAngle);
          } else { // 3 dimensions: use spherical distribution along 2 irrational number angles
            node.x = radius * Math.sin(rollAngle) * Math.cos(yawAngle);
            node.y = radius * Math.cos(rollAngle);
            node.z = radius * Math.sin(rollAngle) * Math.sin(yawAngle);
          }
        }
        if (isNaN(node.vx) || (nDim > 1 && isNaN(node.vy)) || (nDim > 2 && isNaN(node.vz))) {
          node.vx = 0;
          if (nDim > 1) { node.vy = 0; }
          if (nDim > 2) { node.vz = 0; }
        }
      }
    }

    function initializeForce(force) {
      if (force.initialize) force.initialize(nodes, random, nDim);
      return force;
    }

    initializeNodes();

    return simulation = {
      tick: tick,

      restart: function() {
        return stepper.restart(step), simulation;
      },

      stop: function() {
        return stepper.stop(), simulation;
      },

      numDimensions: function(_) {
        return arguments.length
            ? (nDim = Math.min(MAX_DIMENSIONS, Math.max(1, Math.round(_))), forces.forEach(initializeForce), simulation)
            : nDim;
      },

      nodes: function(_) {
        return arguments.length ? (nodes = _, initializeNodes(), forces.forEach(initializeForce), simulation) : nodes;
      },

      alpha: function(_) {
        return arguments.length ? (alpha = +_, simulation) : alpha;
      },

      alphaMin: function(_) {
        return arguments.length ? (alphaMin = +_, simulation) : alphaMin;
      },

      alphaDecay: function(_) {
        return arguments.length ? (alphaDecay = +_, simulation) : +alphaDecay;
      },

      alphaTarget: function(_) {
        return arguments.length ? (alphaTarget = +_, simulation) : alphaTarget;
      },

      velocityDecay: function(_) {
        return arguments.length ? (velocityDecay = 1 - _, simulation) : 1 - velocityDecay;
      },

      randomSource: function(_) {
        return arguments.length ? (random = _, forces.forEach(initializeForce), simulation) : random;
      },

      force: function(name, _) {
        return arguments.length > 1 ? ((_ == null ? forces.delete(name) : forces.set(name, initializeForce(_))), simulation) : forces.get(name);
      },

      find: function() {
        var args = Array.prototype.slice.call(arguments);
        var x = args.shift() || 0,
            y = (nDim > 1 ? args.shift() : null) || 0,
            z = (nDim > 2 ? args.shift() : null) || 0,
            radius = args.shift() || Infinity;

        var i = 0,
            n = nodes.length,
            dx,
            dy,
            dz,
            d2,
            node,
            closest;

        radius *= radius;

        for (i = 0; i < n; ++i) {
          node = nodes[i];
          dx = x - node.x;
          dy = y - (node.y || 0);
          dz = z - (node.z ||0);
          d2 = dx * dx + dy * dy + dz * dz;
          if (d2 < radius) closest = node, radius = d2;
        }

        return closest;
      },

      on: function(name, _) {
        return arguments.length > 1 ? (event.on(name, _), simulation) : event.on(name);
      }
    };
  }

  function forceManyBody() {
    var nodes,
        nDim,
        node,
        random,
        alpha,
        strength = constant(-30),
        strengths,
        distanceMin2 = 1,
        distanceMax2 = Infinity,
        theta2 = 0.81;

    function force(_) {
      var i,
          n = nodes.length,
          tree =
              (nDim === 1 ? binarytree(nodes, x)
              :(nDim === 2 ? quadtree(nodes, x, y)
              :(nDim === 3 ? octree(nodes, x, y, z)
              :null
          ))).visitAfter(accumulate);

      for (alpha = _, i = 0; i < n; ++i) node = nodes[i], tree.visit(apply);
    }

    function initialize() {
      if (!nodes) return;
      var i, n = nodes.length, node;
      strengths = new Array(n);
      for (i = 0; i < n; ++i) node = nodes[i], strengths[node.index] = +strength(node, i, nodes);
    }

    function accumulate(treeNode) {
      var strength = 0, q, c, weight = 0, x, y, z, i;
      var numChildren = treeNode.length;

      // For internal nodes, accumulate forces from children.
      if (numChildren) {
        for (x = y = z = i = 0; i < numChildren; ++i) {
          if ((q = treeNode[i]) && (c = Math.abs(q.value))) {
            strength += q.value, weight += c, x += c * (q.x || 0), y += c * (q.y || 0), z += c * (q.z || 0);
          }
        }
        strength *= Math.sqrt(4 / numChildren); // scale accumulated strength according to number of dimensions

        treeNode.x = x / weight;
        if (nDim > 1) { treeNode.y = y / weight; }
        if (nDim > 2) { treeNode.z = z / weight; }
      }

      // For leaf nodes, accumulate forces from coincident nodes.
      else {
        q = treeNode;
        q.x = q.data.x;
        if (nDim > 1) { q.y = q.data.y; }
        if (nDim > 2) { q.z = q.data.z; }
        do strength += strengths[q.data.index];
        while (q = q.next);
      }

      treeNode.value = strength;
    }

    function apply(treeNode, x1, arg1, arg2, arg3) {
      if (!treeNode.value) return true;
      var x2 = [arg1, arg2, arg3][nDim-1];

      var x = treeNode.x - node.x,
          y = (nDim > 1 ? treeNode.y - node.y : 0),
          z = (nDim > 2 ? treeNode.z - node.z : 0),
          w = x2 - x1,
          l = x * x + y * y + z * z;

      // Apply the Barnes-Hut approximation if possible.
      // Limit forces for very close nodes; randomize direction if coincident.
      if (w * w / theta2 < l) {
        if (l < distanceMax2) {
          if (x === 0) x = jiggle(random), l += x * x;
          if (nDim > 1 && y === 0) y = jiggle(random), l += y * y;
          if (nDim > 2 && z === 0) z = jiggle(random), l += z * z;
          if (l < distanceMin2) l = Math.sqrt(distanceMin2 * l);
          node.vx += x * treeNode.value * alpha / l;
          if (nDim > 1) { node.vy += y * treeNode.value * alpha / l; }
          if (nDim > 2) { node.vz += z * treeNode.value * alpha / l; }
        }
        return true;
      }

      // Otherwise, process points directly.
      else if (treeNode.length || l >= distanceMax2) return;

      // Limit forces for very close nodes; randomize direction if coincident.
      if (treeNode.data !== node || treeNode.next) {
        if (x === 0) x = jiggle(random), l += x * x;
        if (nDim > 1 && y === 0) y = jiggle(random), l += y * y;
        if (nDim > 2 && z === 0) z = jiggle(random), l += z * z;
        if (l < distanceMin2) l = Math.sqrt(distanceMin2 * l);
      }

      do if (treeNode.data !== node) {
        w = strengths[treeNode.data.index] * alpha / l;
        node.vx += x * w;
        if (nDim > 1) { node.vy += y * w; }
        if (nDim > 2) { node.vz += z * w; }
      } while (treeNode = treeNode.next);
    }

    force.initialize = function(_nodes, ...args) {
      nodes = _nodes;
      random = args.find(arg => typeof arg === 'function') || Math.random;
      nDim = args.find(arg => [1, 2, 3].includes(arg)) || 2;
      initialize();
    };

    force.strength = function(_) {
      return arguments.length ? (strength = typeof _ === "function" ? _ : constant(+_), initialize(), force) : strength;
    };

    force.distanceMin = function(_) {
      return arguments.length ? (distanceMin2 = _ * _, force) : Math.sqrt(distanceMin2);
    };

    force.distanceMax = function(_) {
      return arguments.length ? (distanceMax2 = _ * _, force) : Math.sqrt(distanceMax2);
    };

    force.theta = function(_) {
      return arguments.length ? (theta2 = _ * _, force) : Math.sqrt(theta2);
    };

    return force;
  }

  function forceRadial(radius, x, y, z) {
    var nodes,
        nDim,
        strength = constant(0.1),
        strengths,
        radiuses;

    if (typeof radius !== "function") radius = constant(+radius);
    if (x == null) x = 0;
    if (y == null) y = 0;
    if (z == null) z = 0;

    function force(alpha) {
      for (var i = 0, n = nodes.length; i < n; ++i) {
        var node = nodes[i],
            dx = node.x - x || 1e-6,
            dy = (node.y || 0) - y || 1e-6,
            dz = (node.z || 0) - z || 1e-6,
            r = Math.sqrt(dx * dx + dy * dy + dz * dz),
            k = (radiuses[i] - r) * strengths[i] * alpha / r;
        node.vx += dx * k;
        if (nDim>1) { node.vy += dy * k; }
        if (nDim>2) { node.vz += dz * k; }
      }
    }

    function initialize() {
      if (!nodes) return;
      var i, n = nodes.length;
      strengths = new Array(n);
      radiuses = new Array(n);
      for (i = 0; i < n; ++i) {
        radiuses[i] = +radius(nodes[i], i, nodes);
        strengths[i] = isNaN(radiuses[i]) ? 0 : +strength(nodes[i], i, nodes);
      }
    }

    force.initialize = function(initNodes, ...args) {
      nodes = initNodes;
      nDim = args.find(arg => [1, 2, 3].includes(arg)) || 2;
      initialize();
    };

    force.strength = function(_) {
      return arguments.length ? (strength = typeof _ === "function" ? _ : constant(+_), initialize(), force) : strength;
    };

    force.radius = function(_) {
      return arguments.length ? (radius = typeof _ === "function" ? _ : constant(+_), initialize(), force) : radius;
    };

    force.x = function(_) {
      return arguments.length ? (x = +_, force) : x;
    };

    force.y = function(_) {
      return arguments.length ? (y = +_, force) : y;
    };

    force.z = function(_) {
      return arguments.length ? (z = +_, force) : z;
    };

    return force;
  }

  var ngraph_events;
  var hasRequiredNgraph_events;

  function requireNgraph_events () {
  	if (hasRequiredNgraph_events) return ngraph_events;
  	hasRequiredNgraph_events = 1;
  	ngraph_events = function eventify(subject) {
  	  validateSubject(subject);

  	  var eventsStorage = createEventsStorage(subject);
  	  subject.on = eventsStorage.on;
  	  subject.off = eventsStorage.off;
  	  subject.fire = eventsStorage.fire;
  	  return subject;
  	};

  	function createEventsStorage(subject) {
  	  // Store all event listeners to this hash. Key is event name, value is array
  	  // of callback records.
  	  //
  	  // A callback record consists of callback function and its optional context:
  	  // { 'eventName' => [{callback: function, ctx: object}] }
  	  var registeredEvents = Object.create(null);

  	  return {
  	    on: function (eventName, callback, ctx) {
  	      if (typeof callback !== 'function') {
  	        throw new Error('callback is expected to be a function');
  	      }
  	      var handlers = registeredEvents[eventName];
  	      if (!handlers) {
  	        handlers = registeredEvents[eventName] = [];
  	      }
  	      handlers.push({callback: callback, ctx: ctx});

  	      return subject;
  	    },

  	    off: function (eventName, callback) {
  	      var wantToRemoveAll = (typeof eventName === 'undefined');
  	      if (wantToRemoveAll) {
  	        // Killing old events storage should be enough in this case:
  	        registeredEvents = Object.create(null);
  	        return subject;
  	      }

  	      if (registeredEvents[eventName]) {
  	        var deleteAllCallbacksForEvent = (typeof callback !== 'function');
  	        if (deleteAllCallbacksForEvent) {
  	          delete registeredEvents[eventName];
  	        } else {
  	          var callbacks = registeredEvents[eventName];
  	          for (var i = 0; i < callbacks.length; ++i) {
  	            if (callbacks[i].callback === callback) {
  	              callbacks.splice(i, 1);
  	            }
  	          }
  	        }
  	      }

  	      return subject;
  	    },

  	    fire: function (eventName) {
  	      var callbacks = registeredEvents[eventName];
  	      if (!callbacks) {
  	        return subject;
  	      }

  	      var fireArguments;
  	      if (arguments.length > 1) {
  	        fireArguments = Array.prototype.splice.call(arguments, 1);
  	      }
  	      for(var i = 0; i < callbacks.length; ++i) {
  	        var callbackInfo = callbacks[i];
  	        callbackInfo.callback.apply(callbackInfo.ctx, fireArguments);
  	      }

  	      return subject;
  	    }
  	  };
  	}

  	function validateSubject(subject) {
  	  if (!subject) {
  	    throw new Error('Eventify cannot use falsy object as events subject');
  	  }
  	  var reservedWords = ['on', 'fire', 'off'];
  	  for (var i = 0; i < reservedWords.length; ++i) {
  	    if (subject.hasOwnProperty(reservedWords[i])) {
  	      throw new Error("Subject cannot be eventified, since it already has property '" + reservedWords[i] + "'");
  	    }
  	  }
  	}
  	return ngraph_events;
  }

  /**
   * @fileOverview Contains definition of the core graph object.
   */

  var ngraph_graph;
  var hasRequiredNgraph_graph;

  function requireNgraph_graph () {
  	if (hasRequiredNgraph_graph) return ngraph_graph;
  	hasRequiredNgraph_graph = 1;
  	// TODO: need to change storage layer:
  	// 1. Be able to get all nodes O(1)
  	// 2. Be able to get number of links O(1)

  	/**
  	 * @example
  	 *  var graph = require('ngraph.graph')();
  	 *  graph.addNode(1);     // graph has one node.
  	 *  graph.addLink(2, 3);  // now graph contains three nodes and one link.
  	 *
  	 */
  	ngraph_graph = createGraph;

  	var eventify = requireNgraph_events();

  	/**
  	 * Creates a new graph
  	 */
  	function createGraph(options) {
  	  // Graph structure is maintained as dictionary of nodes
  	  // and array of links. Each node has 'links' property which
  	  // hold all links related to that node. And general links
  	  // array is used to speed up all links enumeration. This is inefficient
  	  // in terms of memory, but simplifies coding.
  	  options = options || {};
  	  if ('uniqueLinkId' in options) {
  	    console.warn(
  	      'ngraph.graph: Starting from version 0.14 `uniqueLinkId` is deprecated.\n' +
  	      'Use `multigraph` option instead\n',
  	      '\n',
  	      'Note: there is also change in default behavior: From now on each graph\n'+
  	      'is considered to be not a multigraph by default (each edge is unique).'
  	    );

  	    options.multigraph = options.uniqueLinkId;
  	  }

  	  // Dear reader, the non-multigraphs do not guarantee that there is only
  	  // one link for a given pair of node. When this option is set to false
  	  // we can save some memory and CPU (18% faster for non-multigraph);
  	  if (options.multigraph === undefined) options.multigraph = false;

  	  if (typeof Map !== 'function') {
  	    // TODO: Should we polyfill it ourselves? We don't use much operations there..
  	    throw new Error('ngraph.graph requires `Map` to be defined. Please polyfill it before using ngraph');
  	  } 

  	  var nodes = new Map(); // nodeId => Node
  	  var links = new Map(); // linkId => Link
  	    // Hash of multi-edges. Used to track ids of edges between same nodes
  	  var multiEdges = {};
  	  var suspendEvents = 0;

  	  var createLink = options.multigraph ? createUniqueLink : createSingleLink,

  	    // Our graph API provides means to listen to graph changes. Users can subscribe
  	    // to be notified about changes in the graph by using `on` method. However
  	    // in some cases they don't use it. To avoid unnecessary memory consumption
  	    // we will not record graph changes until we have at least one subscriber.
  	    // Code below supports this optimization.
  	    //
  	    // Accumulates all changes made during graph updates.
  	    // Each change element contains:
  	    //  changeType - one of the strings: 'add', 'remove' or 'update';
  	    //  node - if change is related to node this property is set to changed graph's node;
  	    //  link - if change is related to link this property is set to changed graph's link;
  	    changes = [],
  	    recordLinkChange = noop,
  	    recordNodeChange = noop,
  	    enterModification = noop,
  	    exitModification = noop;

  	  // this is our public API:
  	  var graphPart = {
  	    /**
  	     * Sometimes duck typing could be slow. Giving clients a hint about data structure
  	     * via explicit version number here:
  	     */
  	    version: 20.0,

  	    /**
  	     * Adds node to the graph. If node with given id already exists in the graph
  	     * its data is extended with whatever comes in 'data' argument.
  	     *
  	     * @param nodeId the node's identifier. A string or number is preferred.
  	     * @param [data] additional data for the node being added. If node already
  	     *   exists its data object is augmented with the new one.
  	     *
  	     * @return {node} The newly added node or node with given id if it already exists.
  	     */
  	    addNode: addNode,

  	    /**
  	     * Adds a link to the graph. The function always create a new
  	     * link between two nodes. If one of the nodes does not exists
  	     * a new node is created.
  	     *
  	     * @param fromId link start node id;
  	     * @param toId link end node id;
  	     * @param [data] additional data to be set on the new link;
  	     *
  	     * @return {link} The newly created link
  	     */
  	    addLink: addLink,

  	    /**
  	     * Removes link from the graph. If link does not exist does nothing.
  	     *
  	     * @param link - object returned by addLink() or getLinks() methods.
  	     *
  	     * @returns true if link was removed; false otherwise.
  	     */
  	    removeLink: removeLink,

  	    /**
  	     * Removes node with given id from the graph. If node does not exist in the graph
  	     * does nothing.
  	     *
  	     * @param nodeId node's identifier passed to addNode() function.
  	     *
  	     * @returns true if node was removed; false otherwise.
  	     */
  	    removeNode: removeNode,

  	    /**
  	     * Gets node with given identifier. If node does not exist undefined value is returned.
  	     *
  	     * @param nodeId requested node identifier;
  	     *
  	     * @return {node} in with requested identifier or undefined if no such node exists.
  	     */
  	    getNode: getNode,

  	    /**
  	     * Gets number of nodes in this graph.
  	     *
  	     * @return number of nodes in the graph.
  	     */
  	    getNodeCount: getNodeCount,

  	    /**
  	     * Gets total number of links in the graph.
  	     */
  	    getLinkCount: getLinkCount,

  	    /**
  	     * Gets total number of links in the graph.
  	     */
  	    getEdgeCount: getLinkCount,

  	    /**
  	     * Synonym for `getLinkCount()`
  	     */
  	    getLinksCount: getLinkCount,
  	    
  	    /**
  	     * Synonym for `getNodeCount()`
  	     */
  	    getNodesCount: getNodeCount,

  	    /**
  	     * Gets all links (inbound and outbound) from the node with given id.
  	     * If node with given id is not found null is returned.
  	     *
  	     * @param nodeId requested node identifier.
  	     *
  	     * @return Set of links from and to requested node if such node exists;
  	     *   otherwise null is returned.
  	     */
  	    getLinks: getLinks,

  	    /**
  	     * Invokes callback on each node of the graph.
  	     *
  	     * @param {Function(node)} callback Function to be invoked. The function
  	     *   is passed one argument: visited node.
  	     */
  	    forEachNode: forEachNode,

  	    /**
  	     * Invokes callback on every linked (adjacent) node to the given one.
  	     *
  	     * @param nodeId Identifier of the requested node.
  	     * @param {Function(node, link)} callback Function to be called on all linked nodes.
  	     *   The function is passed two parameters: adjacent node and link object itself.
  	     * @param oriented if true graph treated as oriented.
  	     */
  	    forEachLinkedNode: forEachLinkedNode,

  	    /**
  	     * Enumerates all links in the graph
  	     *
  	     * @param {Function(link)} callback Function to be called on all links in the graph.
  	     *   The function is passed one parameter: graph's link object.
  	     *
  	     * Link object contains at least the following fields:
  	     *  fromId - node id where link starts;
  	     *  toId - node id where link ends,
  	     *  data - additional data passed to graph.addLink() method.
  	     */
  	    forEachLink: forEachLink,

  	    /**
  	     * Suspend all notifications about graph changes until
  	     * endUpdate is called.
  	     */
  	    beginUpdate: enterModification,

  	    /**
  	     * Resumes all notifications about graph changes and fires
  	     * graph 'changed' event in case there are any pending changes.
  	     */
  	    endUpdate: exitModification,

  	    /**
  	     * Removes all nodes and links from the graph.
  	     */
  	    clear: clear,

  	    /**
  	     * Detects whether there is a link between two nodes.
  	     * Operation complexity is O(n) where n - number of links of a node.
  	     * NOTE: this function is synonym for getLink()
  	     *
  	     * @returns link if there is one. null otherwise.
  	     */
  	    hasLink: getLink,

  	    /**
  	     * Detects whether there is a node with given id
  	     * 
  	     * Operation complexity is O(1)
  	     * NOTE: this function is synonym for getNode()
  	     *
  	     * @returns node if there is one; Falsy value otherwise.
  	     */
  	    hasNode: getNode,

  	    /**
  	     * Gets an edge between two nodes.
  	     * Operation complexity is O(n) where n - number of links of a node.
  	     *
  	     * @param {string} fromId link start identifier
  	     * @param {string} toId link end identifier
  	     *
  	     * @returns link if there is one; undefined otherwise.
  	     */
  	    getLink: getLink
  	  };

  	  // this will add `on()` and `fire()` methods.
  	  eventify(graphPart);

  	  monitorSubscribers();

  	  return graphPart;

  	  function monitorSubscribers() {
  	    var realOn = graphPart.on;

  	    // replace real `on` with our temporary on, which will trigger change
  	    // modification monitoring:
  	    graphPart.on = on;

  	    function on() {
  	      // now it's time to start tracking stuff:
  	      graphPart.beginUpdate = enterModification = enterModificationReal;
  	      graphPart.endUpdate = exitModification = exitModificationReal;
  	      recordLinkChange = recordLinkChangeReal;
  	      recordNodeChange = recordNodeChangeReal;

  	      // this will replace current `on` method with real pub/sub from `eventify`.
  	      graphPart.on = realOn;
  	      // delegate to real `on` handler:
  	      return realOn.apply(graphPart, arguments);
  	    }
  	  }

  	  function recordLinkChangeReal(link, changeType) {
  	    changes.push({
  	      link: link,
  	      changeType: changeType
  	    });
  	  }

  	  function recordNodeChangeReal(node, changeType) {
  	    changes.push({
  	      node: node,
  	      changeType: changeType
  	    });
  	  }

  	  function addNode(nodeId, data) {
  	    if (nodeId === undefined) {
  	      throw new Error('Invalid node identifier');
  	    }

  	    enterModification();

  	    var node = getNode(nodeId);
  	    if (!node) {
  	      node = new Node(nodeId, data);
  	      recordNodeChange(node, 'add');
  	    } else {
  	      node.data = data;
  	      recordNodeChange(node, 'update');
  	    }

  	    nodes.set(nodeId, node);

  	    exitModification();
  	    return node;
  	  }

  	  function getNode(nodeId) {
  	    return nodes.get(nodeId);
  	  }

  	  function removeNode(nodeId) {
  	    var node = getNode(nodeId);
  	    if (!node) {
  	      return false;
  	    }

  	    enterModification();

  	    var prevLinks = node.links;
  	    if (prevLinks) {
  	      prevLinks.forEach(removeLinkInstance);
  	      node.links = null;
  	    }

  	    nodes.delete(nodeId);

  	    recordNodeChange(node, 'remove');

  	    exitModification();

  	    return true;
  	  }


  	  function addLink(fromId, toId, data) {
  	    enterModification();

  	    var fromNode = getNode(fromId) || addNode(fromId);
  	    var toNode = getNode(toId) || addNode(toId);

  	    var link = createLink(fromId, toId, data);
  	    var isUpdate = links.has(link.id);

  	    links.set(link.id, link);

  	    // TODO: this is not cool. On large graphs potentially would consume more memory.
  	    addLinkToNode(fromNode, link);
  	    if (fromId !== toId) {
  	      // make sure we are not duplicating links for self-loops
  	      addLinkToNode(toNode, link);
  	    }

  	    recordLinkChange(link, isUpdate ? 'update' : 'add');

  	    exitModification();

  	    return link;
  	  }

  	  function createSingleLink(fromId, toId, data) {
  	    var linkId = makeLinkId(fromId, toId);
  	    var prevLink = links.get(linkId);
  	    if (prevLink) {
  	      prevLink.data = data;
  	      return prevLink;
  	    }

  	    return new Link(fromId, toId, data, linkId);
  	  }

  	  function createUniqueLink(fromId, toId, data) {
  	    // TODO: Find a better/faster way to store multigraphs
  	    var linkId = makeLinkId(fromId, toId);
  	    var isMultiEdge = multiEdges.hasOwnProperty(linkId);
  	    if (isMultiEdge || getLink(fromId, toId)) {
  	      if (!isMultiEdge) {
  	        multiEdges[linkId] = 0;
  	      }
  	      var suffix = '@' + (++multiEdges[linkId]);
  	      linkId = makeLinkId(fromId + suffix, toId + suffix);
  	    }

  	    return new Link(fromId, toId, data, linkId);
  	  }

  	  function getNodeCount() {
  	    return nodes.size;
  	  }

  	  function getLinkCount() {
  	    return links.size;
  	  }

  	  function getLinks(nodeId) {
  	    var node = getNode(nodeId);
  	    return node ? node.links : null;
  	  }

  	  function removeLink(link, otherId) {
  	    if (otherId !== undefined) {
  	      link = getLink(link, otherId);
  	    }
  	    return removeLinkInstance(link);
  	  }

  	  function removeLinkInstance(link) {
  	    if (!link) {
  	      return false;
  	    }
  	    if (!links.get(link.id)) return false;

  	    enterModification();

  	    links.delete(link.id);

  	    var fromNode = getNode(link.fromId);
  	    var toNode = getNode(link.toId);

  	    if (fromNode) {
  	      fromNode.links.delete(link);
  	    }

  	    if (toNode) {
  	      toNode.links.delete(link);
  	    }

  	    recordLinkChange(link, 'remove');

  	    exitModification();

  	    return true;
  	  }

  	  function getLink(fromNodeId, toNodeId) {
  	    if (fromNodeId === undefined || toNodeId === undefined) return undefined;
  	    return links.get(makeLinkId(fromNodeId, toNodeId));
  	  }

  	  function clear() {
  	    enterModification();
  	    forEachNode(function(node) {
  	      removeNode(node.id);
  	    });
  	    exitModification();
  	  }

  	  function forEachLink(callback) {
  	    if (typeof callback === 'function') {
  	      var valuesIterator = links.values();
  	      var nextValue = valuesIterator.next();
  	      while (!nextValue.done) {
  	        if (callback(nextValue.value)) {
  	          return true; // client doesn't want to proceed. Return.
  	        }
  	        nextValue = valuesIterator.next();
  	      }
  	    }
  	  }

  	  function forEachLinkedNode(nodeId, callback, oriented) {
  	    var node = getNode(nodeId);

  	    if (node && node.links && typeof callback === 'function') {
  	      if (oriented) {
  	        return forEachOrientedLink(node.links, nodeId, callback);
  	      } else {
  	        return forEachNonOrientedLink(node.links, nodeId, callback);
  	      }
  	    }
  	  }

  	  // eslint-disable-next-line no-shadow
  	  function forEachNonOrientedLink(links, nodeId, callback) {
  	    var quitFast;

  	    var valuesIterator = links.values();
  	    var nextValue = valuesIterator.next();
  	    while (!nextValue.done) {
  	      var link = nextValue.value;
  	      var linkedNodeId = link.fromId === nodeId ? link.toId : link.fromId;
  	      quitFast = callback(nodes.get(linkedNodeId), link);
  	      if (quitFast) {
  	        return true; // Client does not need more iterations. Break now.
  	      }
  	      nextValue = valuesIterator.next();
  	    }
  	  }

  	  // eslint-disable-next-line no-shadow
  	  function forEachOrientedLink(links, nodeId, callback) {
  	    var quitFast;
  	    var valuesIterator = links.values();
  	    var nextValue = valuesIterator.next();
  	    while (!nextValue.done) {
  	      var link = nextValue.value;
  	      if (link.fromId === nodeId) {
  	        quitFast = callback(nodes.get(link.toId), link);
  	        if (quitFast) {
  	          return true; // Client does not need more iterations. Break now.
  	        }
  	      }
  	      nextValue = valuesIterator.next();
  	    }
  	  }

  	  // we will not fire anything until users of this library explicitly call `on()`
  	  // method.
  	  function noop() {}

  	  // Enter, Exit modification allows bulk graph updates without firing events.
  	  function enterModificationReal() {
  	    suspendEvents += 1;
  	  }

  	  function exitModificationReal() {
  	    suspendEvents -= 1;
  	    if (suspendEvents === 0 && changes.length > 0) {
  	      graphPart.fire('changed', changes);
  	      changes.length = 0;
  	    }
  	  }

  	  function forEachNode(callback) {
  	    if (typeof callback !== 'function') {
  	      throw new Error('Function is expected to iterate over graph nodes. You passed ' + callback);
  	    }

  	    var valuesIterator = nodes.values();
  	    var nextValue = valuesIterator.next();
  	    while (!nextValue.done) {
  	      if (callback(nextValue.value)) {
  	        return true; // client doesn't want to proceed. Return.
  	      }
  	      nextValue = valuesIterator.next();
  	    }
  	  }
  	}

  	/**
  	 * Internal structure to represent node;
  	 */
  	function Node(id, data) {
  	  this.id = id;
  	  this.links = null;
  	  this.data = data;
  	}

  	function addLinkToNode(node, link) {
  	  if (node.links) {
  	    node.links.add(link);
  	  } else {
  	    node.links = new Set([link]);
  	  }
  	}

  	/**
  	 * Internal structure to represent links;
  	 */
  	function Link(fromId, toId, data, id) {
  	  this.fromId = fromId;
  	  this.toId = toId;
  	  this.data = data;
  	  this.id = id;
  	}

  	function makeLinkId(fromId, toId) {
  	  return fromId.toString() + '👉 ' + toId.toString();
  	}
  	return ngraph_graph;
  }

  var ngraph_graphExports = requireNgraph_graph();
  var graph = /*@__PURE__*/getDefaultExportFromCjs(ngraph_graphExports);

  var ngraph_forcelayout = {exports: {}};

  var generateCreateBody = {exports: {}};

  var getVariableName;
  var hasRequiredGetVariableName;

  function requireGetVariableName () {
  	if (hasRequiredGetVariableName) return getVariableName;
  	hasRequiredGetVariableName = 1;
  	getVariableName = function getVariableName(index) {
  	  if (index === 0) return 'x';
  	  if (index === 1) return 'y';
  	  if (index === 2) return 'z';
  	  return 'c' + (index + 1);
  	};
  	return getVariableName;
  }

  var createPatternBuilder;
  var hasRequiredCreatePatternBuilder;

  function requireCreatePatternBuilder () {
  	if (hasRequiredCreatePatternBuilder) return createPatternBuilder;
  	hasRequiredCreatePatternBuilder = 1;
  	const getVariableName = requireGetVariableName();

  	createPatternBuilder = function createPatternBuilder(dimension) {

  	  return pattern;
  	  
  	  function pattern(template, config) {
  	    let indent = (config && config.indent) || 0;
  	    let join = (config && config.join !== undefined) ? config.join : '\n';
  	    let indentString = Array(indent + 1).join(' ');
  	    let buffer = [];
  	    for (let i = 0; i < dimension; ++i) {
  	      let variableName = getVariableName(i);
  	      let prefix = (i === 0) ? '' : indentString;
  	      buffer.push(prefix + template.replace(/{var}/g, variableName));
  	    }
  	    return buffer.join(join);
  	  }
  	};
  	return createPatternBuilder;
  }

  var hasRequiredGenerateCreateBody;

  function requireGenerateCreateBody () {
  	if (hasRequiredGenerateCreateBody) return generateCreateBody.exports;
  	hasRequiredGenerateCreateBody = 1;
  	const createPatternBuilder = requireCreatePatternBuilder();

  	generateCreateBody.exports = generateCreateBodyFunction;
  	generateCreateBody.exports.generateCreateBodyFunctionBody = generateCreateBodyFunctionBody;

  	// InlineTransform: getVectorCode
  	generateCreateBody.exports.getVectorCode = getVectorCode;
  	// InlineTransform: getBodyCode
  	generateCreateBody.exports.getBodyCode = getBodyCode;
  	// InlineTransformExport: module.exports = function() { return Body; }

  	function generateCreateBodyFunction(dimension, debugSetters) {
  	  let code = generateCreateBodyFunctionBody(dimension, debugSetters);
  	  let {Body} = (new Function(code))();
  	  return Body;
  	}

  	function generateCreateBodyFunctionBody(dimension, debugSetters) {
  	  let code = `
${getVectorCode(dimension, debugSetters)}
${getBodyCode(dimension)}
return {Body: Body, Vector: Vector};
`;
  	  return code;
  	}

  	function getBodyCode(dimension) {
  	  let pattern = createPatternBuilder(dimension);
  	  let variableList = pattern('{var}', {join: ', '});
  	  return `
function Body(${variableList}) {
  this.isPinned = false;
  this.pos = new Vector(${variableList});
  this.force = new Vector();
  this.velocity = new Vector();
  this.mass = 1;

  this.springCount = 0;
  this.springLength = 0;
}

Body.prototype.reset = function() {
  this.force.reset();
  this.springCount = 0;
  this.springLength = 0;
}

Body.prototype.setPosition = function (${variableList}) {
  ${pattern('this.pos.{var} = {var} || 0;', {indent: 2})}
};`;
  	}

  	function getVectorCode(dimension, debugSetters) {
  	  let pattern = createPatternBuilder(dimension);
  	  let setters = '';
  	  if (debugSetters) {
  	    setters = `${pattern("\n\
	   var v{var};\n\
	Object.defineProperty(this, '{var}', {\n\
	  set: function(v) { \n\
	    if (!Number.isFinite(v)) throw new Error('Cannot set non-numbers to {var}');\n\
	    v{var} = v; \n\
	  },\n\
	  get: function() { return v{var}; }\n\
	});")}`;
  	  }

  	  let variableList = pattern('{var}', {join: ', '});
  	  return `function Vector(${variableList}) {
  ${setters}
    if (typeof arguments[0] === 'object') {
      // could be another vector
      let v = arguments[0];
      ${pattern('if (!Number.isFinite(v.{var})) throw new Error("Expected value is not a finite number at Vector constructor ({var})");', {indent: 4})}
      ${pattern('this.{var} = v.{var};', {indent: 4})}
    } else {
      ${pattern('this.{var} = typeof {var} === "number" ? {var} : 0;', {indent: 4})}
    }
  }
  
  Vector.prototype.reset = function () {
    ${pattern('this.{var} = ', {join: ''})}0;
  };`;
  	}
  	return generateCreateBody.exports;
  }

  var generateQuadTree = {exports: {}};

  var hasRequiredGenerateQuadTree;

  function requireGenerateQuadTree () {
  	if (hasRequiredGenerateQuadTree) return generateQuadTree.exports;
  	hasRequiredGenerateQuadTree = 1;
  	const createPatternBuilder = requireCreatePatternBuilder();
  	const getVariableName = requireGetVariableName();

  	generateQuadTree.exports = generateQuadTreeFunction;
  	generateQuadTree.exports.generateQuadTreeFunctionBody = generateQuadTreeFunctionBody;

  	// These exports are for InlineTransform tool.
  	// InlineTransform: getInsertStackCode
  	generateQuadTree.exports.getInsertStackCode = getInsertStackCode;
  	// InlineTransform: getQuadNodeCode
  	generateQuadTree.exports.getQuadNodeCode = getQuadNodeCode;
  	// InlineTransform: isSamePosition
  	generateQuadTree.exports.isSamePosition = isSamePosition;
  	// InlineTransform: getChildBodyCode
  	generateQuadTree.exports.getChildBodyCode = getChildBodyCode;
  	// InlineTransform: setChildBodyCode
  	generateQuadTree.exports.setChildBodyCode = setChildBodyCode;

  	function generateQuadTreeFunction(dimension) {
  	  let code = generateQuadTreeFunctionBody(dimension);
  	  return (new Function(code))();
  	}

  	function generateQuadTreeFunctionBody(dimension) {
  	  let pattern = createPatternBuilder(dimension);
  	  let quadCount = Math.pow(2, dimension);

  	  let code = `
${getInsertStackCode()}
${getQuadNodeCode(dimension)}
${isSamePosition(dimension)}
${getChildBodyCode(dimension)}
${setChildBodyCode(dimension)}

function createQuadTree(options, random) {
  options = options || {};
  options.gravity = typeof options.gravity === 'number' ? options.gravity : -1;
  options.theta = typeof options.theta === 'number' ? options.theta : 0.8;

  var gravity = options.gravity;
  var updateQueue = [];
  var insertStack = new InsertStack();
  var theta = options.theta;

  var nodesCache = [];
  var currentInCache = 0;
  var root = newNode();

  return {
    insertBodies: insertBodies,

    /**
     * Gets root node if it is present
     */
    getRoot: function() {
      return root;
    },

    updateBodyForce: update,

    options: function(newOptions) {
      if (newOptions) {
        if (typeof newOptions.gravity === 'number') {
          gravity = newOptions.gravity;
        }
        if (typeof newOptions.theta === 'number') {
          theta = newOptions.theta;
        }

        return this;
      }

      return {
        gravity: gravity,
        theta: theta
      };
    }
  };

  function newNode() {
    // To avoid pressure on GC we reuse nodes.
    var node = nodesCache[currentInCache];
    if (node) {
${assignQuads('      node.')}
      node.body = null;
      node.mass = ${pattern('node.mass_{var} = ', {join: ''})}0;
      ${pattern('node.min_{var} = node.max_{var} = ', {join: ''})}0;
    } else {
      node = new QuadNode();
      nodesCache[currentInCache] = node;
    }

    ++currentInCache;
    return node;
  }

  function update(sourceBody) {
    var queue = updateQueue;
    var v;
    ${pattern('var d{var};', {indent: 4})}
    var r; 
    ${pattern('var f{var} = 0;', {indent: 4})}
    var queueLength = 1;
    var shiftIdx = 0;
    var pushIdx = 1;

    queue[0] = root;

    while (queueLength) {
      var node = queue[shiftIdx];
      var body = node.body;

      queueLength -= 1;
      shiftIdx += 1;
      var differentBody = (body !== sourceBody);
      if (body && differentBody) {
        // If the current node is a leaf node (and it is not source body),
        // calculate the force exerted by the current node on body, and add this
        // amount to body's net force.
        ${pattern('d{var} = body.pos.{var} - sourceBody.pos.{var};', {indent: 8})}
        r = Math.sqrt(${pattern('d{var} * d{var}', {join: ' + '})});

        if (r === 0) {
          // Poor man's protection against zero distance.
          ${pattern('d{var} = (random.nextDouble() - 0.5) / 50;', {indent: 10})}
          r = Math.sqrt(${pattern('d{var} * d{var}', {join: ' + '})});
        }

        // This is standard gravitation force calculation but we divide
        // by r^3 to save two operations when normalizing force vector.
        v = gravity * body.mass * sourceBody.mass / (r * r * r);
        ${pattern('f{var} += v * d{var};', {indent: 8})}
      } else if (differentBody) {
        // Otherwise, calculate the ratio s / r,  where s is the width of the region
        // represented by the internal node, and r is the distance between the body
        // and the node's center-of-mass
        ${pattern('d{var} = node.mass_{var} / node.mass - sourceBody.pos.{var};', {indent: 8})}
        r = Math.sqrt(${pattern('d{var} * d{var}', {join: ' + '})});

        if (r === 0) {
          // Sorry about code duplication. I don't want to create many functions
          // right away. Just want to see performance first.
          ${pattern('d{var} = (random.nextDouble() - 0.5) / 50;', {indent: 10})}
          r = Math.sqrt(${pattern('d{var} * d{var}', {join: ' + '})});
        }
        // If s / r < θ, treat this internal node as a single body, and calculate the
        // force it exerts on sourceBody, and add this amount to sourceBody's net force.
        if ((node.max_${getVariableName(0)} - node.min_${getVariableName(0)}) / r < theta) {
          // in the if statement above we consider node's width only
          // because the region was made into square during tree creation.
          // Thus there is no difference between using width or height.
          v = gravity * node.mass * sourceBody.mass / (r * r * r);
          ${pattern('f{var} += v * d{var};', {indent: 10})}
        } else {
          // Otherwise, run the procedure recursively on each of the current node's children.

          // I intentionally unfolded this loop, to save several CPU cycles.
${runRecursiveOnChildren()}
        }
      }
    }

    ${pattern('sourceBody.force.{var} += f{var};', {indent: 4})}
  }

  function insertBodies(bodies) {
    ${pattern('var {var}min = Number.MAX_VALUE;', {indent: 4})}
    ${pattern('var {var}max = Number.MIN_VALUE;', {indent: 4})}
    var i = bodies.length;

    // To reduce quad tree depth we are looking for exact bounding box of all particles.
    while (i--) {
      var pos = bodies[i].pos;
      ${pattern('if (pos.{var} < {var}min) {var}min = pos.{var};', {indent: 6})}
      ${pattern('if (pos.{var} > {var}max) {var}max = pos.{var};', {indent: 6})}
    }

    // Makes the bounds square.
    var maxSideLength = -Infinity;
    ${pattern('if ({var}max - {var}min > maxSideLength) maxSideLength = {var}max - {var}min ;', {indent: 4})}

    currentInCache = 0;
    root = newNode();
    ${pattern('root.min_{var} = {var}min;', {indent: 4})}
    ${pattern('root.max_{var} = {var}min + maxSideLength;', {indent: 4})}

    i = bodies.length - 1;
    if (i >= 0) {
      root.body = bodies[i];
    }
    while (i--) {
      insert(bodies[i], root);
    }
  }

  function insert(newBody) {
    insertStack.reset();
    insertStack.push(root, newBody);

    while (!insertStack.isEmpty()) {
      var stackItem = insertStack.pop();
      var node = stackItem.node;
      var body = stackItem.body;

      if (!node.body) {
        // This is internal node. Update the total mass of the node and center-of-mass.
        ${pattern('var {var} = body.pos.{var};', {indent: 8})}
        node.mass += body.mass;
        ${pattern('node.mass_{var} += body.mass * {var};', {indent: 8})}

        // Recursively insert the body in the appropriate quadrant.
        // But first find the appropriate quadrant.
        var quadIdx = 0; // Assume we are in the 0's quad.
        ${pattern('var min_{var} = node.min_{var};', {indent: 8})}
        ${pattern('var max_{var} = (min_{var} + node.max_{var}) / 2;', {indent: 8})}

${assignInsertionQuadIndex(8)}

        var child = getChild(node, quadIdx);

        if (!child) {
          // The node is internal but this quadrant is not taken. Add
          // subnode to it.
          child = newNode();
          ${pattern('child.min_{var} = min_{var};', {indent: 10})}
          ${pattern('child.max_{var} = max_{var};', {indent: 10})}
          child.body = body;

          setChild(node, quadIdx, child);
        } else {
          // continue searching in this quadrant.
          insertStack.push(child, body);
        }
      } else {
        // We are trying to add to the leaf node.
        // We have to convert current leaf into internal node
        // and continue adding two nodes.
        var oldBody = node.body;
        node.body = null; // internal nodes do not cary bodies

        if (isSamePosition(oldBody.pos, body.pos)) {
          // Prevent infinite subdivision by bumping one node
          // anywhere in this quadrant
          var retriesCount = 3;
          do {
            var offset = random.nextDouble();
            ${pattern('var d{var} = (node.max_{var} - node.min_{var}) * offset;', {indent: 12})}

            ${pattern('oldBody.pos.{var} = node.min_{var} + d{var};', {indent: 12})}
            retriesCount -= 1;
            // Make sure we don't bump it out of the box. If we do, next iteration should fix it
          } while (retriesCount > 0 && isSamePosition(oldBody.pos, body.pos));

          if (retriesCount === 0 && isSamePosition(oldBody.pos, body.pos)) {
            // This is very bad, we ran out of precision.
            // if we do not return from the method we'll get into
            // infinite loop here. So we sacrifice correctness of layout, and keep the app running
            // Next layout iteration should get larger bounding box in the first step and fix this
            return;
          }
        }
        // Next iteration should subdivide node further.
        insertStack.push(node, oldBody);
        insertStack.push(node, body);
      }
    }
  }
}
return createQuadTree;

`;
  	  return code;


  	  function assignInsertionQuadIndex(indentCount) {
  	    let insertionCode = [];
  	    let indent = Array(indentCount + 1).join(' ');
  	    for (let i = 0; i < dimension; ++i) {
  	      insertionCode.push(indent + `if (${getVariableName(i)} > max_${getVariableName(i)}) {`);
  	      insertionCode.push(indent + `  quadIdx = quadIdx + ${Math.pow(2, i)};`);
  	      insertionCode.push(indent + `  min_${getVariableName(i)} = max_${getVariableName(i)};`);
  	      insertionCode.push(indent + `  max_${getVariableName(i)} = node.max_${getVariableName(i)};`);
  	      insertionCode.push(indent + `}`);
  	    }
  	    return insertionCode.join('\n');
  	    // if (x > max_x) { // somewhere in the eastern part.
  	    //   quadIdx = quadIdx + 1;
  	    //   left = right;
  	    //   right = node.right;
  	    // }
  	  }

  	  function runRecursiveOnChildren() {
  	    let indent = Array(11).join(' ');
  	    let recursiveCode = [];
  	    for (let i = 0; i < quadCount; ++i) {
  	      recursiveCode.push(indent + `if (node.quad${i}) {`);
  	      recursiveCode.push(indent + `  queue[pushIdx] = node.quad${i};`);
  	      recursiveCode.push(indent + `  queueLength += 1;`);
  	      recursiveCode.push(indent + `  pushIdx += 1;`);
  	      recursiveCode.push(indent + `}`);
  	    }
  	    return recursiveCode.join('\n');
  	    // if (node.quad0) {
  	    //   queue[pushIdx] = node.quad0;
  	    //   queueLength += 1;
  	    //   pushIdx += 1;
  	    // }
  	  }

  	  function assignQuads(indent) {
  	    // this.quad0 = null;
  	    // this.quad1 = null;
  	    // this.quad2 = null;
  	    // this.quad3 = null;
  	    let quads = [];
  	    for (let i = 0; i < quadCount; ++i) {
  	      quads.push(`${indent}quad${i} = null;`);
  	    }
  	    return quads.join('\n');
  	  }
  	}

  	function isSamePosition(dimension) {
  	  let pattern = createPatternBuilder(dimension);
  	  return `
  function isSamePosition(point1, point2) {
    ${pattern('var d{var} = Math.abs(point1.{var} - point2.{var});', {indent: 2})}
  
    return ${pattern('d{var} < 1e-8', {join: ' && '})};
  }  
`;
  	}

  	function setChildBodyCode(dimension) {
  	  var quadCount = Math.pow(2, dimension);
  	  return `
function setChild(node, idx, child) {
  ${setChildBody()}
}`;
  	  function setChildBody() {
  	    let childBody = [];
  	    for (let i = 0; i < quadCount; ++i) {
  	      let prefix = (i === 0) ? '  ' : '  else ';
  	      childBody.push(`${prefix}if (idx === ${i}) node.quad${i} = child;`);
  	    }

  	    return childBody.join('\n');
  	    // if (idx === 0) node.quad0 = child;
  	    // else if (idx === 1) node.quad1 = child;
  	    // else if (idx === 2) node.quad2 = child;
  	    // else if (idx === 3) node.quad3 = child;
  	  }
  	}

  	function getChildBodyCode(dimension) {
  	  return `function getChild(node, idx) {
${getChildBody()}
  return null;
}`;

  	  function getChildBody() {
  	    let childBody = [];
  	    let quadCount = Math.pow(2, dimension);
  	    for (let i = 0; i < quadCount; ++i) {
  	      childBody.push(`  if (idx === ${i}) return node.quad${i};`);
  	    }

  	    return childBody.join('\n');
  	    // if (idx === 0) return node.quad0;
  	    // if (idx === 1) return node.quad1;
  	    // if (idx === 2) return node.quad2;
  	    // if (idx === 3) return node.quad3;
  	  }
  	}

  	function getQuadNodeCode(dimension) {
  	  let pattern = createPatternBuilder(dimension);
  	  let quadCount = Math.pow(2, dimension);
  	  var quadNodeCode = `
function QuadNode() {
  // body stored inside this node. In quad tree only leaf nodes (by construction)
  // contain bodies:
  this.body = null;

  // Child nodes are stored in quads. Each quad is presented by number:
  // 0 | 1
  // -----
  // 2 | 3
${assignQuads('  this.')}

  // Total mass of current node
  this.mass = 0;

  // Center of mass coordinates
  ${pattern('this.mass_{var} = 0;', {indent: 2})}

  // bounding box coordinates
  ${pattern('this.min_{var} = 0;', {indent: 2})}
  ${pattern('this.max_{var} = 0;', {indent: 2})}
}
`;
  	  return quadNodeCode;

  	  function assignQuads(indent) {
  	    // this.quad0 = null;
  	    // this.quad1 = null;
  	    // this.quad2 = null;
  	    // this.quad3 = null;
  	    let quads = [];
  	    for (let i = 0; i < quadCount; ++i) {
  	      quads.push(`${indent}quad${i} = null;`);
  	    }
  	    return quads.join('\n');
  	  }
  	}

  	function getInsertStackCode() {
  	  return `
/**
 * Our implementation of QuadTree is non-recursive to avoid GC hit
 * This data structure represent stack of elements
 * which we are trying to insert into quad tree.
 */
function InsertStack () {
    this.stack = [];
    this.popIdx = 0;
}

InsertStack.prototype = {
    isEmpty: function() {
        return this.popIdx === 0;
    },
    push: function (node, body) {
        var item = this.stack[this.popIdx];
        if (!item) {
            // we are trying to avoid memory pressure: create new element
            // only when absolutely necessary
            this.stack[this.popIdx] = new InsertStackElement(node, body);
        } else {
            item.node = node;
            item.body = body;
        }
        ++this.popIdx;
    },
    pop: function () {
        if (this.popIdx > 0) {
            return this.stack[--this.popIdx];
        }
    },
    reset: function () {
        this.popIdx = 0;
    }
};

function InsertStackElement(node, body) {
    this.node = node; // QuadTree node
    this.body = body; // physical body which needs to be inserted to node
}
`;
  	}
  	return generateQuadTree.exports;
  }

  var generateBounds = {exports: {}};

  var hasRequiredGenerateBounds;

  function requireGenerateBounds () {
  	if (hasRequiredGenerateBounds) return generateBounds.exports;
  	hasRequiredGenerateBounds = 1;
  	generateBounds.exports = generateBoundsFunction;
  	generateBounds.exports.generateFunctionBody = generateBoundsFunctionBody;

  	const createPatternBuilder = requireCreatePatternBuilder();

  	function generateBoundsFunction(dimension) {
  	  let code = generateBoundsFunctionBody(dimension);
  	  return new Function('bodies', 'settings', 'random', code);
  	}

  	function generateBoundsFunctionBody(dimension) {
  	  let pattern = createPatternBuilder(dimension);

  	  let code = `
  var boundingBox = {
    ${pattern('min_{var}: 0, max_{var}: 0,', {indent: 4})}
  };

  return {
    box: boundingBox,

    update: updateBoundingBox,

    reset: resetBoundingBox,

    getBestNewPosition: function (neighbors) {
      var ${pattern('base_{var} = 0', {join: ', '})};

      if (neighbors.length) {
        for (var i = 0; i < neighbors.length; ++i) {
          let neighborPos = neighbors[i].pos;
          ${pattern('base_{var} += neighborPos.{var};', {indent: 10})}
        }

        ${pattern('base_{var} /= neighbors.length;', {indent: 8})}
      } else {
        ${pattern('base_{var} = (boundingBox.min_{var} + boundingBox.max_{var}) / 2;', {indent: 8})}
      }

      var springLength = settings.springLength;
      return {
        ${pattern('{var}: base_{var} + (random.nextDouble() - 0.5) * springLength,', {indent: 8})}
      };
    }
  };

  function updateBoundingBox() {
    var i = bodies.length;
    if (i === 0) return; // No bodies - no borders.

    ${pattern('var max_{var} = -Infinity;', {indent: 4})}
    ${pattern('var min_{var} = Infinity;', {indent: 4})}

    while(i--) {
      // this is O(n), it could be done faster with quadtree, if we check the root node bounds
      var bodyPos = bodies[i].pos;
      ${pattern('if (bodyPos.{var} < min_{var}) min_{var} = bodyPos.{var};', {indent: 6})}
      ${pattern('if (bodyPos.{var} > max_{var}) max_{var} = bodyPos.{var};', {indent: 6})}
    }

    ${pattern('boundingBox.min_{var} = min_{var};', {indent: 4})}
    ${pattern('boundingBox.max_{var} = max_{var};', {indent: 4})}
  }

  function resetBoundingBox() {
    ${pattern('boundingBox.min_{var} = boundingBox.max_{var} = 0;', {indent: 4})}
  }
`;
  	  return code;
  	}
  	return generateBounds.exports;
  }

  var generateCreateDragForce = {exports: {}};

  var hasRequiredGenerateCreateDragForce;

  function requireGenerateCreateDragForce () {
  	if (hasRequiredGenerateCreateDragForce) return generateCreateDragForce.exports;
  	hasRequiredGenerateCreateDragForce = 1;
  	const createPatternBuilder = requireCreatePatternBuilder();

  	generateCreateDragForce.exports = generateCreateDragForceFunction;
  	generateCreateDragForce.exports.generateCreateDragForceFunctionBody = generateCreateDragForceFunctionBody;

  	function generateCreateDragForceFunction(dimension) {
  	  let code = generateCreateDragForceFunctionBody(dimension);
  	  return new Function('options', code);
  	}

  	function generateCreateDragForceFunctionBody(dimension) {
  	  let pattern = createPatternBuilder(dimension);
  	  let code = `
  if (!Number.isFinite(options.dragCoefficient)) throw new Error('dragCoefficient is not a finite number');

  return {
    update: function(body) {
      ${pattern('body.force.{var} -= options.dragCoefficient * body.velocity.{var};', {indent: 6})}
    }
  };
`;
  	  return code;
  	}
  	return generateCreateDragForce.exports;
  }

  var generateCreateSpringForce = {exports: {}};

  var hasRequiredGenerateCreateSpringForce;

  function requireGenerateCreateSpringForce () {
  	if (hasRequiredGenerateCreateSpringForce) return generateCreateSpringForce.exports;
  	hasRequiredGenerateCreateSpringForce = 1;
  	const createPatternBuilder = requireCreatePatternBuilder();

  	generateCreateSpringForce.exports = generateCreateSpringForceFunction;
  	generateCreateSpringForce.exports.generateCreateSpringForceFunctionBody = generateCreateSpringForceFunctionBody;

  	function generateCreateSpringForceFunction(dimension) {
  	  let code = generateCreateSpringForceFunctionBody(dimension);
  	  return new Function('options', 'random', code);
  	}

  	function generateCreateSpringForceFunctionBody(dimension) {
  	  let pattern = createPatternBuilder(dimension);
  	  let code = `
  if (!Number.isFinite(options.springCoefficient)) throw new Error('Spring coefficient is not a number');
  if (!Number.isFinite(options.springLength)) throw new Error('Spring length is not a number');

  return {
    /**
     * Updates forces acting on a spring
     */
    update: function (spring) {
      var body1 = spring.from;
      var body2 = spring.to;
      var length = spring.length < 0 ? options.springLength : spring.length;
      ${pattern('var d{var} = body2.pos.{var} - body1.pos.{var};', {indent: 6})}
      var r = Math.sqrt(${pattern('d{var} * d{var}', {join: ' + '})});

      if (r === 0) {
        ${pattern('d{var} = (random.nextDouble() - 0.5) / 50;', {indent: 8})}
        r = Math.sqrt(${pattern('d{var} * d{var}', {join: ' + '})});
      }

      var d = r - length;
      var coefficient = ((spring.coefficient > 0) ? spring.coefficient : options.springCoefficient) * d / r;

      ${pattern('body1.force.{var} += coefficient * d{var}', {indent: 6})};
      body1.springCount += 1;
      body1.springLength += r;

      ${pattern('body2.force.{var} -= coefficient * d{var}', {indent: 6})};
      body2.springCount += 1;
      body2.springLength += r;
    }
  };
`;
  	  return code;
  	}
  	return generateCreateSpringForce.exports;
  }

  var generateIntegrator = {exports: {}};

  var hasRequiredGenerateIntegrator;

  function requireGenerateIntegrator () {
  	if (hasRequiredGenerateIntegrator) return generateIntegrator.exports;
  	hasRequiredGenerateIntegrator = 1;
  	const createPatternBuilder = requireCreatePatternBuilder();

  	generateIntegrator.exports = generateIntegratorFunction;
  	generateIntegrator.exports.generateIntegratorFunctionBody = generateIntegratorFunctionBody;

  	function generateIntegratorFunction(dimension) {
  	  let code = generateIntegratorFunctionBody(dimension);
  	  return new Function('bodies', 'timeStep', 'adaptiveTimeStepWeight', code);
  	}

  	function generateIntegratorFunctionBody(dimension) {
  	  let pattern = createPatternBuilder(dimension);
  	  let code = `
  var length = bodies.length;
  if (length === 0) return 0;

  ${pattern('var d{var} = 0, t{var} = 0;', {indent: 2})}

  for (var i = 0; i < length; ++i) {
    var body = bodies[i];
    if (body.isPinned) continue;

    if (adaptiveTimeStepWeight && body.springCount) {
      timeStep = (adaptiveTimeStepWeight * body.springLength/body.springCount);
    }

    var coeff = timeStep / body.mass;

    ${pattern('body.velocity.{var} += coeff * body.force.{var};', {indent: 4})}
    ${pattern('var v{var} = body.velocity.{var};', {indent: 4})}
    var v = Math.sqrt(${pattern('v{var} * v{var}', {join: ' + '})});

    if (v > 1) {
      // We normalize it so that we move within timeStep range. 
      // for the case when v <= 1 - we let velocity to fade out.
      ${pattern('body.velocity.{var} = v{var} / v;', {indent: 6})}
    }

    ${pattern('d{var} = timeStep * body.velocity.{var};', {indent: 4})}

    ${pattern('body.pos.{var} += d{var};', {indent: 4})}

    ${pattern('t{var} += Math.abs(d{var});', {indent: 4})}
  }

  return (${pattern('t{var} * t{var}', {join: ' + '})})/length;
`;
  	  return code;
  	}
  	return generateIntegrator.exports;
  }

  var spring;
  var hasRequiredSpring;

  function requireSpring () {
  	if (hasRequiredSpring) return spring;
  	hasRequiredSpring = 1;
  	spring = Spring;

  	/**
  	 * Represents a physical spring. Spring connects two bodies, has rest length
  	 * stiffness coefficient and optional weight
  	 */
  	function Spring(fromBody, toBody, length, springCoefficient) {
  	    this.from = fromBody;
  	    this.to = toBody;
  	    this.length = length;
  	    this.coefficient = springCoefficient;
  	}
  	return spring;
  }

  var ngraph_merge;
  var hasRequiredNgraph_merge;

  function requireNgraph_merge () {
  	if (hasRequiredNgraph_merge) return ngraph_merge;
  	hasRequiredNgraph_merge = 1;
  	ngraph_merge = merge;

  	/**
  	 * Augments `target` with properties in `options`. Does not override
  	 * target's properties if they are defined and matches expected type in 
  	 * options
  	 *
  	 * @returns {Object} merged object
  	 */
  	function merge(target, options) {
  	  var key;
  	  if (!target) { target = {}; }
  	  if (options) {
  	    for (key in options) {
  	      if (options.hasOwnProperty(key)) {
  	        var targetHasIt = target.hasOwnProperty(key),
  	            optionsValueType = typeof options[key],
  	            shouldReplace = !targetHasIt || (typeof target[key] !== optionsValueType);

  	        if (shouldReplace) {
  	          target[key] = options[key];
  	        } else if (optionsValueType === 'object') {
  	          // go deep, don't care about loops here, we are simple API!:
  	          target[key] = merge(target[key], options[key]);
  	        }
  	      }
  	    }
  	  }

  	  return target;
  	}
  	return ngraph_merge;
  }

  var ngraph_random = {exports: {}};

  var hasRequiredNgraph_random;

  function requireNgraph_random () {
  	if (hasRequiredNgraph_random) return ngraph_random.exports;
  	hasRequiredNgraph_random = 1;
  	ngraph_random.exports = random;

  	// TODO: Deprecate?
  	ngraph_random.exports.random = random,
  	ngraph_random.exports.randomIterator = randomIterator;

  	/**
  	 * Creates seeded PRNG with two methods:
  	 *   next() and nextDouble()
  	 */
  	function random(inputSeed) {
  	  var seed = typeof inputSeed === 'number' ? inputSeed : (+new Date());
  	  return new Generator(seed)
  	}

  	function Generator(seed) {
  	  this.seed = seed;
  	}

  	/**
  	  * Generates random integer number in the range from 0 (inclusive) to maxValue (exclusive)
  	  *
  	  * @param maxValue Number REQUIRED. Omitting this number will result in NaN values from PRNG.
  	  */
  	Generator.prototype.next = next;

  	/**
  	  * Generates random double number in the range from 0 (inclusive) to 1 (exclusive)
  	  * This function is the same as Math.random() (except that it could be seeded)
  	  */
  	Generator.prototype.nextDouble = nextDouble;

  	/**
  	 * Returns a random real number from uniform distribution in [0, 1)
  	 */
  	Generator.prototype.uniform = nextDouble;

  	/**
  	 * Returns a random real number from a Gaussian distribution
  	 * with 0 as a mean, and 1 as standard deviation u ~ N(0,1)
  	 */
  	Generator.prototype.gaussian = gaussian;

  	function gaussian() {
  	  // use the polar form of the Box-Muller transform
  	  // based on https://introcs.cs.princeton.edu/java/23recursion/StdRandom.java
  	  var r, x, y;
  	  do {
  	    x = this.nextDouble() * 2 - 1;
  	    y = this.nextDouble() * 2 - 1;
  	    r = x * x + y * y;
  	  } while (r >= 1 || r === 0);

  	  return x * Math.sqrt(-2 * Math.log(r)/r);
  	}

  	/**
  	 * See https://twitter.com/anvaka/status/1296182534150135808
  	 */
  	Generator.prototype.levy = levy;

  	function levy() {
  	  var beta = 3 / 2;
  	  var sigma = Math.pow(
  	      gamma( 1 + beta ) * Math.sin(Math.PI * beta / 2) / 
  	        (gamma((1 + beta) / 2) * beta * Math.pow(2, (beta - 1) / 2)),
  	      1/beta
  	  );
  	  return this.gaussian() * sigma / Math.pow(Math.abs(this.gaussian()), 1/beta);
  	}

  	// gamma function approximation
  	function gamma(z) {
  	  return Math.sqrt(2 * Math.PI / z) * Math.pow((1 / Math.E) * (z + 1 / (12 * z - 1 / (10 * z))), z);
  	}

  	function nextDouble() {
  	  var seed = this.seed;
  	  // Robert Jenkins' 32 bit integer hash function.
  	  seed = ((seed + 0x7ed55d16) + (seed << 12)) & 0xffffffff;
  	  seed = ((seed ^ 0xc761c23c) ^ (seed >>> 19)) & 0xffffffff;
  	  seed = ((seed + 0x165667b1) + (seed << 5)) & 0xffffffff;
  	  seed = ((seed + 0xd3a2646c) ^ (seed << 9)) & 0xffffffff;
  	  seed = ((seed + 0xfd7046c5) + (seed << 3)) & 0xffffffff;
  	  seed = ((seed ^ 0xb55a4f09) ^ (seed >>> 16)) & 0xffffffff;
  	  this.seed = seed;
  	  return (seed & 0xfffffff) / 0x10000000;
  	}

  	function next(maxValue) {
  	  return Math.floor(this.nextDouble() * maxValue);
  	}

  	/*
  	 * Creates iterator over array, which returns items of array in random order
  	 * Time complexity is guaranteed to be O(n);
  	 */
  	function randomIterator(array, customRandom) {
  	  var localRandom = customRandom || random();
  	  if (typeof localRandom.next !== 'function') {
  	    throw new Error('customRandom does not match expected API: next() function is missing');
  	  }

  	  return {
  	    forEach: forEach,

  	    /**
  	     * Shuffles array randomly, in place.
  	     */
  	    shuffle: shuffle
  	  };

  	  function shuffle() {
  	    var i, j, t;
  	    for (i = array.length - 1; i > 0; --i) {
  	      j = localRandom.next(i + 1); // i inclusive
  	      t = array[j];
  	      array[j] = array[i];
  	      array[i] = t;
  	    }

  	    return array;
  	  }

  	  function forEach(callback) {
  	    var i, j, t;
  	    for (i = array.length - 1; i > 0; --i) {
  	      j = localRandom.next(i + 1); // i inclusive
  	      t = array[j];
  	      array[j] = array[i];
  	      array[i] = t;

  	      callback(t);
  	    }

  	    if (array.length) {
  	      callback(array[0]);
  	    }
  	  }
  	}
  	return ngraph_random.exports;
  }

  /**
   * Manages a simulation of physical forces acting on bodies and springs.
   */

  var createPhysicsSimulator_1;
  var hasRequiredCreatePhysicsSimulator;

  function requireCreatePhysicsSimulator () {
  	if (hasRequiredCreatePhysicsSimulator) return createPhysicsSimulator_1;
  	hasRequiredCreatePhysicsSimulator = 1;
  	createPhysicsSimulator_1 = createPhysicsSimulator;

  	var generateCreateBodyFunction = requireGenerateCreateBody();
  	var generateQuadTreeFunction = requireGenerateQuadTree();
  	var generateBoundsFunction = requireGenerateBounds();
  	var generateCreateDragForceFunction = requireGenerateCreateDragForce();
  	var generateCreateSpringForceFunction = requireGenerateCreateSpringForce();
  	var generateIntegratorFunction = requireGenerateIntegrator();

  	var dimensionalCache = {};

  	function createPhysicsSimulator(settings) {
  	  var Spring = requireSpring();
  	  var merge = requireNgraph_merge();
  	  var eventify = requireNgraph_events();
  	  if (settings) {
  	    // Check for names from older versions of the layout
  	    if (settings.springCoeff !== undefined) throw new Error('springCoeff was renamed to springCoefficient');
  	    if (settings.dragCoeff !== undefined) throw new Error('dragCoeff was renamed to dragCoefficient');
  	  }

  	  settings = merge(settings, {
  	      /**
  	       * Ideal length for links (springs in physical model).
  	       */
  	      springLength: 10,

  	      /**
  	       * Hook's law coefficient. 1 - solid spring.
  	       */
  	      springCoefficient: 0.8, 

  	      /**
  	       * Coulomb's law coefficient. It's used to repel nodes thus should be negative
  	       * if you make it positive nodes start attract each other :).
  	       */
  	      gravity: -12,

  	      /**
  	       * Theta coefficient from Barnes Hut simulation. Ranged between (0, 1).
  	       * The closer it's to 1 the more nodes algorithm will have to go through.
  	       * Setting it to one makes Barnes Hut simulation no different from
  	       * brute-force forces calculation (each node is considered).
  	       */
  	      theta: 0.8,

  	      /**
  	       * Drag force coefficient. Used to slow down system, thus should be less than 1.
  	       * The closer it is to 0 the less tight system will be.
  	       */
  	      dragCoefficient: 0.9, // TODO: Need to rename this to something better. E.g. `dragCoefficient`

  	      /**
  	       * Default time step (dt) for forces integration
  	       */
  	      timeStep : 0.5,

  	      /**
  	       * Adaptive time step uses average spring length to compute actual time step:
  	       * See: https://twitter.com/anvaka/status/1293067160755957760
  	       */
  	      adaptiveTimeStepWeight: 0,

  	      /**
  	       * This parameter defines number of dimensions of the space where simulation
  	       * is performed. 
  	       */
  	      dimensions: 2,

  	      /**
  	       * In debug mode more checks are performed, this will help you catch errors
  	       * quickly, however for production build it is recommended to turn off this flag
  	       * to speed up computation.
  	       */
  	      debug: false
  	  });

  	  var factory = dimensionalCache[settings.dimensions];
  	  if (!factory) {
  	    var dimensions = settings.dimensions;
  	    factory = {
  	      Body: generateCreateBodyFunction(dimensions, settings.debug),
  	      createQuadTree: generateQuadTreeFunction(dimensions),
  	      createBounds: generateBoundsFunction(dimensions),
  	      createDragForce: generateCreateDragForceFunction(dimensions),
  	      createSpringForce: generateCreateSpringForceFunction(dimensions),
  	      integrate: generateIntegratorFunction(dimensions),
  	    };
  	    dimensionalCache[dimensions] = factory;
  	  }

  	  var Body = factory.Body;
  	  var createQuadTree = factory.createQuadTree;
  	  var createBounds = factory.createBounds;
  	  var createDragForce = factory.createDragForce;
  	  var createSpringForce = factory.createSpringForce;
  	  var integrate = factory.integrate;
  	  var createBody = pos => new Body(pos);

  	  var random = requireNgraph_random().random(42);
  	  var bodies = []; // Bodies in this simulation.
  	  var springs = []; // Springs in this simulation.

  	  var quadTree = createQuadTree(settings, random);
  	  var bounds = createBounds(bodies, settings, random);
  	  var springForce = createSpringForce(settings, random);
  	  var dragForce = createDragForce(settings);

  	  var totalMovement = 0; // how much movement we made on last step
  	  var forces = [];
  	  var forceMap = new Map();
  	  var iterationNumber = 0;
  	 
  	  addForce('nbody', nbodyForce);
  	  addForce('spring', updateSpringForce);

  	  var publicApi = {
  	    /**
  	     * Array of bodies, registered with current simulator
  	     *
  	     * Note: To add new body, use addBody() method. This property is only
  	     * exposed for testing/performance purposes.
  	     */
  	    bodies: bodies,
  	  
  	    quadTree: quadTree,

  	    /**
  	     * Array of springs, registered with current simulator
  	     *
  	     * Note: To add new spring, use addSpring() method. This property is only
  	     * exposed for testing/performance purposes.
  	     */
  	    springs: springs,

  	    /**
  	     * Returns settings with which current simulator was initialized
  	     */
  	    settings: settings,

  	    /**
  	     * Adds a new force to simulation
  	     */
  	    addForce: addForce,
  	    
  	    /**
  	     * Removes a force from the simulation.
  	     */
  	    removeForce: removeForce,

  	    /**
  	     * Returns a map of all registered forces.
  	     */
  	    getForces: getForces,

  	    /**
  	     * Performs one step of force simulation.
  	     *
  	     * @returns {boolean} true if system is considered stable; False otherwise.
  	     */
  	    step: function () {
  	      for (var i = 0; i < forces.length; ++i) {
  	        forces[i](iterationNumber);
  	      }
  	      var movement = integrate(bodies, settings.timeStep, settings.adaptiveTimeStepWeight);
  	      iterationNumber += 1;
  	      return movement;
  	    },

  	    /**
  	     * Adds body to the system
  	     *
  	     * @param {ngraph.physics.primitives.Body} body physical body
  	     *
  	     * @returns {ngraph.physics.primitives.Body} added body
  	     */
  	    addBody: function (body) {
  	      if (!body) {
  	        throw new Error('Body is required');
  	      }
  	      bodies.push(body);

  	      return body;
  	    },

  	    /**
  	     * Adds body to the system at given position
  	     *
  	     * @param {Object} pos position of a body
  	     *
  	     * @returns {ngraph.physics.primitives.Body} added body
  	     */
  	    addBodyAt: function (pos) {
  	      if (!pos) {
  	        throw new Error('Body position is required');
  	      }
  	      var body = createBody(pos);
  	      bodies.push(body);

  	      return body;
  	    },

  	    /**
  	     * Removes body from the system
  	     *
  	     * @param {ngraph.physics.primitives.Body} body to remove
  	     *
  	     * @returns {Boolean} true if body found and removed. falsy otherwise;
  	     */
  	    removeBody: function (body) {
  	      if (!body) { return; }

  	      var idx = bodies.indexOf(body);
  	      if (idx < 0) { return; }

  	      bodies.splice(idx, 1);
  	      if (bodies.length === 0) {
  	        bounds.reset();
  	      }
  	      return true;
  	    },

  	    /**
  	     * Adds a spring to this simulation.
  	     *
  	     * @returns {Object} - a handle for a spring. If you want to later remove
  	     * spring pass it to removeSpring() method.
  	     */
  	    addSpring: function (body1, body2, springLength, springCoefficient) {
  	      if (!body1 || !body2) {
  	        throw new Error('Cannot add null spring to force simulator');
  	      }

  	      if (typeof springLength !== 'number') {
  	        springLength = -1; // assume global configuration
  	      }

  	      var spring = new Spring(body1, body2, springLength, springCoefficient >= 0 ? springCoefficient : -1);
  	      springs.push(spring);

  	      // TODO: could mark simulator as dirty.
  	      return spring;
  	    },

  	    /**
  	     * Returns amount of movement performed on last step() call
  	     */
  	    getTotalMovement: function () {
  	      return totalMovement;
  	    },

  	    /**
  	     * Removes spring from the system
  	     *
  	     * @param {Object} spring to remove. Spring is an object returned by addSpring
  	     *
  	     * @returns {Boolean} true if spring found and removed. falsy otherwise;
  	     */
  	    removeSpring: function (spring) {
  	      if (!spring) { return; }
  	      var idx = springs.indexOf(spring);
  	      if (idx > -1) {
  	        springs.splice(idx, 1);
  	        return true;
  	      }
  	    },

  	    getBestNewBodyPosition: function (neighbors) {
  	      return bounds.getBestNewPosition(neighbors);
  	    },

  	    /**
  	     * Returns bounding box which covers all bodies
  	     */
  	    getBBox: getBoundingBox, 
  	    getBoundingBox: getBoundingBox, 

  	    invalidateBBox: function () {
  	      console.warn('invalidateBBox() is deprecated, bounds always recomputed on `getBBox()` call');
  	    },

  	    // TODO: Move the force specific stuff to force
  	    gravity: function (value) {
  	      if (value !== undefined) {
  	        settings.gravity = value;
  	        quadTree.options({gravity: value});
  	        return this;
  	      } else {
  	        return settings.gravity;
  	      }
  	    },

  	    theta: function (value) {
  	      if (value !== undefined) {
  	        settings.theta = value;
  	        quadTree.options({theta: value});
  	        return this;
  	      } else {
  	        return settings.theta;
  	      }
  	    },

  	    /**
  	     * Returns pseudo-random number generator instance.
  	     */
  	    random: random
  	  };

  	  // allow settings modification via public API:
  	  expose(settings, publicApi);

  	  eventify(publicApi);

  	  return publicApi;

  	  function getBoundingBox() {
  	    bounds.update();
  	    return bounds.box;
  	  }

  	  function addForce(forceName, forceFunction) {
  	    if (forceMap.has(forceName)) throw new Error('Force ' + forceName + ' is already added');

  	    forceMap.set(forceName, forceFunction);
  	    forces.push(forceFunction);
  	  }

  	  function removeForce(forceName) {
  	    var forceIndex = forces.indexOf(forceMap.get(forceName));
  	    if (forceIndex < 0) return;
  	    forces.splice(forceIndex, 1);
  	    forceMap.delete(forceName);
  	  }

  	  function getForces() {
  	    // TODO: Should I trust them or clone the forces?
  	    return forceMap;
  	  }

  	  function nbodyForce(/* iterationUmber */) {
  	    if (bodies.length === 0) return;

  	    quadTree.insertBodies(bodies);
  	    var i = bodies.length;
  	    while (i--) {
  	      var body = bodies[i];
  	      if (!body.isPinned) {
  	        body.reset();
  	        quadTree.updateBodyForce(body);
  	        dragForce.update(body);
  	      }
  	    }
  	  }

  	  function updateSpringForce() {
  	    var i = springs.length;
  	    while (i--) {
  	      springForce.update(springs[i]);
  	    }
  	  }

  	}

  	function expose(settings, target) {
  	  for (var key in settings) {
  	    augment(settings, target, key);
  	  }
  	}

  	function augment(source, target, key) {
  	  if (!source.hasOwnProperty(key)) return;
  	  if (typeof target[key] === 'function') {
  	    // this accessor is already defined. Ignore it
  	    return;
  	  }
  	  var sourceIsNumber = Number.isFinite(source[key]);

  	  if (sourceIsNumber) {
  	    target[key] = function (value) {
  	      if (value !== undefined) {
  	        if (!Number.isFinite(value)) throw new Error('Value of ' + key + ' should be a valid number.');
  	        source[key] = value;
  	        return target;
  	      }
  	      return source[key];
  	    };
  	  } else {
  	    target[key] = function (value) {
  	      if (value !== undefined) {
  	        source[key] = value;
  	        return target;
  	      }
  	      return source[key];
  	    };
  	  }
  	}
  	return createPhysicsSimulator_1;
  }

  var hasRequiredNgraph_forcelayout;

  function requireNgraph_forcelayout () {
  	if (hasRequiredNgraph_forcelayout) return ngraph_forcelayout.exports;
  	hasRequiredNgraph_forcelayout = 1;
  	ngraph_forcelayout.exports = createLayout;
  	ngraph_forcelayout.exports.simulator = requireCreatePhysicsSimulator();

  	var eventify = requireNgraph_events();

  	/**
  	 * Creates force based layout for a given graph.
  	 *
  	 * @param {ngraph.graph} graph which needs to be laid out
  	 * @param {object} physicsSettings if you need custom settings
  	 * for physics simulator you can pass your own settings here. If it's not passed
  	 * a default one will be created.
  	 */
  	function createLayout(graph, physicsSettings) {
  	  if (!graph) {
  	    throw new Error('Graph structure cannot be undefined');
  	  }

  	  var createSimulator = (physicsSettings && physicsSettings.createSimulator) || requireCreatePhysicsSimulator();
  	  var physicsSimulator = createSimulator(physicsSettings);
  	  if (Array.isArray(physicsSettings)) throw new Error('Physics settings is expected to be an object');

  	  var nodeMass = graph.version > 19 ? defaultSetNodeMass : defaultArrayNodeMass;
  	  if (physicsSettings && typeof physicsSettings.nodeMass === 'function') {
  	    nodeMass = physicsSettings.nodeMass;
  	  }

  	  var nodeBodies = new Map();
  	  var springs = {};
  	  var bodiesCount = 0;

  	  var springTransform = physicsSimulator.settings.springTransform || noop;

  	  // Initialize physics with what we have in the graph:
  	  initPhysics();
  	  listenToEvents();

  	  var wasStable = false;

  	  var api = {
  	    /**
  	     * Performs one step of iterative layout algorithm
  	     *
  	     * @returns {boolean} true if the system should be considered stable; False otherwise.
  	     * The system is stable if no further call to `step()` can improve the layout.
  	     */
  	    step: function() {
  	      if (bodiesCount === 0) {
  	        updateStableStatus(true);
  	        return true;
  	      }

  	      var lastMove = physicsSimulator.step();

  	      // Save the movement in case if someone wants to query it in the step
  	      // callback.
  	      api.lastMove = lastMove;

  	      // Allow listeners to perform low-level actions after nodes are updated.
  	      api.fire('step');

  	      var ratio = lastMove/bodiesCount;
  	      var isStableNow = ratio <= 0.01; // TODO: The number is somewhat arbitrary...
  	      updateStableStatus(isStableNow);


  	      return isStableNow;
  	    },

  	    /**
  	     * For a given `nodeId` returns position
  	     */
  	    getNodePosition: function (nodeId) {
  	      return getInitializedBody(nodeId).pos;
  	    },

  	    /**
  	     * Sets position of a node to a given coordinates
  	     * @param {string} nodeId node identifier
  	     * @param {number} x position of a node
  	     * @param {number} y position of a node
  	     * @param {number=} z position of node (only if applicable to body)
  	     */
  	    setNodePosition: function (nodeId) {
  	      var body = getInitializedBody(nodeId);
  	      body.setPosition.apply(body, Array.prototype.slice.call(arguments, 1));
  	    },

  	    /**
  	     * @returns {Object} Link position by link id
  	     * @returns {Object.from} {x, y} coordinates of link start
  	     * @returns {Object.to} {x, y} coordinates of link end
  	     */
  	    getLinkPosition: function (linkId) {
  	      var spring = springs[linkId];
  	      if (spring) {
  	        return {
  	          from: spring.from.pos,
  	          to: spring.to.pos
  	        };
  	      }
  	    },

  	    /**
  	     * @returns {Object} area required to fit in the graph. Object contains
  	     * `x1`, `y1` - top left coordinates
  	     * `x2`, `y2` - bottom right coordinates
  	     */
  	    getGraphRect: function () {
  	      return physicsSimulator.getBBox();
  	    },

  	    /**
  	     * Iterates over each body in the layout simulator and performs a callback(body, nodeId)
  	     */
  	    forEachBody: forEachBody,

  	    /*
  	     * Requests layout algorithm to pin/unpin node to its current position
  	     * Pinned nodes should not be affected by layout algorithm and always
  	     * remain at their position
  	     */
  	    pinNode: function (node, isPinned) {
  	      var body = getInitializedBody(node.id);
  	       body.isPinned = !!isPinned;
  	    },

  	    /**
  	     * Checks whether given graph's node is currently pinned
  	     */
  	    isNodePinned: function (node) {
  	      return getInitializedBody(node.id).isPinned;
  	    },

  	    /**
  	     * Request to release all resources
  	     */
  	    dispose: function() {
  	      graph.off('changed', onGraphChanged);
  	      api.fire('disposed');
  	    },

  	    /**
  	     * Gets physical body for a given node id. If node is not found undefined
  	     * value is returned.
  	     */
  	    getBody: getBody,

  	    /**
  	     * Gets spring for a given edge.
  	     *
  	     * @param {string} linkId link identifer. If two arguments are passed then
  	     * this argument is treated as formNodeId
  	     * @param {string=} toId when defined this parameter denotes head of the link
  	     * and first argument is treated as tail of the link (fromId)
  	     */
  	    getSpring: getSpring,

  	    /**
  	     * Returns length of cumulative force vector. The closer this to zero - the more stable the system is
  	     */
  	    getForceVectorLength: getForceVectorLength,

  	    /**
  	     * [Read only] Gets current physics simulator
  	     */
  	    simulator: physicsSimulator,

  	    /**
  	     * Gets the graph that was used for layout
  	     */
  	    graph: graph,

  	    /**
  	     * Gets amount of movement performed during last step operation
  	     */
  	    lastMove: 0
  	  };

  	  eventify(api);

  	  return api;

  	  function updateStableStatus(isStableNow) {
  	    if (wasStable !== isStableNow) {
  	      wasStable = isStableNow;
  	      onStableChanged(isStableNow);
  	    }
  	  }

  	  function forEachBody(cb) {
  	    nodeBodies.forEach(cb);
  	  }

  	  function getForceVectorLength() {
  	    var fx = 0, fy = 0;
  	    forEachBody(function(body) {
  	      fx += Math.abs(body.force.x);
  	      fy += Math.abs(body.force.y);
  	    });
  	    return Math.sqrt(fx * fx + fy * fy);
  	  }

  	  function getSpring(fromId, toId) {
  	    var linkId;
  	    if (toId === undefined) {
  	      if (typeof fromId !== 'object') {
  	        // assume fromId as a linkId:
  	        linkId = fromId;
  	      } else {
  	        // assume fromId to be a link object:
  	        linkId = fromId.id;
  	      }
  	    } else {
  	      // toId is defined, should grab link:
  	      var link = graph.hasLink(fromId, toId);
  	      if (!link) return;
  	      linkId = link.id;
  	    }

  	    return springs[linkId];
  	  }

  	  function getBody(nodeId) {
  	    return nodeBodies.get(nodeId);
  	  }

  	  function listenToEvents() {
  	    graph.on('changed', onGraphChanged);
  	  }

  	  function onStableChanged(isStable) {
  	    api.fire('stable', isStable);
  	  }

  	  function onGraphChanged(changes) {
  	    for (var i = 0; i < changes.length; ++i) {
  	      var change = changes[i];
  	      if (change.changeType === 'add') {
  	        if (change.node) {
  	          initBody(change.node.id);
  	        }
  	        if (change.link) {
  	          initLink(change.link);
  	        }
  	      } else if (change.changeType === 'remove') {
  	        if (change.node) {
  	          releaseNode(change.node);
  	        }
  	        if (change.link) {
  	          releaseLink(change.link);
  	        }
  	      }
  	    }
  	    bodiesCount = graph.getNodesCount();
  	  }

  	  function initPhysics() {
  	    bodiesCount = 0;

  	    graph.forEachNode(function (node) {
  	      initBody(node.id);
  	      bodiesCount += 1;
  	    });

  	    graph.forEachLink(initLink);
  	  }

  	  function initBody(nodeId) {
  	    var body = nodeBodies.get(nodeId);
  	    if (!body) {
  	      var node = graph.getNode(nodeId);
  	      if (!node) {
  	        throw new Error('initBody() was called with unknown node id');
  	      }

  	      var pos = node.position;
  	      if (!pos) {
  	        var neighbors = getNeighborBodies(node);
  	        pos = physicsSimulator.getBestNewBodyPosition(neighbors);
  	      }

  	      body = physicsSimulator.addBodyAt(pos);
  	      body.id = nodeId;

  	      nodeBodies.set(nodeId, body);
  	      updateBodyMass(nodeId);

  	      if (isNodeOriginallyPinned(node)) {
  	        body.isPinned = true;
  	      }
  	    }
  	  }

  	  function releaseNode(node) {
  	    var nodeId = node.id;
  	    var body = nodeBodies.get(nodeId);
  	    if (body) {
  	      nodeBodies.delete(nodeId);
  	      physicsSimulator.removeBody(body);
  	    }
  	  }

  	  function initLink(link) {
  	    updateBodyMass(link.fromId);
  	    updateBodyMass(link.toId);

  	    var fromBody = nodeBodies.get(link.fromId),
  	        toBody  = nodeBodies.get(link.toId),
  	        spring = physicsSimulator.addSpring(fromBody, toBody, link.length);

  	    springTransform(link, spring);

  	    springs[link.id] = spring;
  	  }

  	  function releaseLink(link) {
  	    var spring = springs[link.id];
  	    if (spring) {
  	      var from = graph.getNode(link.fromId),
  	          to = graph.getNode(link.toId);

  	      if (from) updateBodyMass(from.id);
  	      if (to) updateBodyMass(to.id);

  	      delete springs[link.id];

  	      physicsSimulator.removeSpring(spring);
  	    }
  	  }

  	  function getNeighborBodies(node) {
  	    // TODO: Could probably be done better on memory
  	    var neighbors = [];
  	    if (!node.links) {
  	      return neighbors;
  	    }
  	    var maxNeighbors = Math.min(node.links.length, 2);
  	    for (var i = 0; i < maxNeighbors; ++i) {
  	      var link = node.links[i];
  	      var otherBody = link.fromId !== node.id ? nodeBodies.get(link.fromId) : nodeBodies.get(link.toId);
  	      if (otherBody && otherBody.pos) {
  	        neighbors.push(otherBody);
  	      }
  	    }

  	    return neighbors;
  	  }

  	  function updateBodyMass(nodeId) {
  	    var body = nodeBodies.get(nodeId);
  	    body.mass = nodeMass(nodeId);
  	    if (Number.isNaN(body.mass)) {
  	      throw new Error('Node mass should be a number');
  	    }
  	  }

  	  /**
  	   * Checks whether graph node has in its settings pinned attribute,
  	   * which means layout algorithm cannot move it. Node can be marked
  	   * as pinned, if it has "isPinned" attribute, or when node.data has it.
  	   *
  	   * @param {Object} node a graph node to check
  	   * @return {Boolean} true if node should be treated as pinned; false otherwise.
  	   */
  	  function isNodeOriginallyPinned(node) {
  	    return (node && (node.isPinned || (node.data && node.data.isPinned)));
  	  }

  	  function getInitializedBody(nodeId) {
  	    var body = nodeBodies.get(nodeId);
  	    if (!body) {
  	      initBody(nodeId);
  	      body = nodeBodies.get(nodeId);
  	    }
  	    return body;
  	  }

  	  /**
  	   * Calculates mass of a body, which corresponds to node with given id.
  	   *
  	   * @param {String|Number} nodeId identifier of a node, for which body mass needs to be calculated
  	   * @returns {Number} recommended mass of the body;
  	   */
  	  function defaultArrayNodeMass(nodeId) {
  	    // This function is for older versions of ngraph.graph.
  	    var links = graph.getLinks(nodeId);
  	    if (!links) return 1;
  	    return 1 + links.length / 3.0;
  	  }

  	  function defaultSetNodeMass(nodeId) {
  	    var links = graph.getLinks(nodeId);
  	    if (!links) return 1;
  	    return 1 + links.size / 3.0;
  	  }
  	}

  	function noop() { }
  	return ngraph_forcelayout.exports;
  }

  var ngraph_forcelayoutExports = requireNgraph_forcelayout();
  var forcelayout = /*@__PURE__*/getDefaultExportFromCjs(ngraph_forcelayoutExports);

  /**
   * Checks if `value` is the
   * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
   * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an object, else `false`.
   * @example
   *
   * _.isObject({});
   * // => true
   *
   * _.isObject([1, 2, 3]);
   * // => true
   *
   * _.isObject(_.noop);
   * // => true
   *
   * _.isObject(null);
   * // => false
   */
  function isObject(value) {
    var type = typeof value;
    return value != null && (type == 'object' || type == 'function');
  }

  /** Detect free variable `global` from Node.js. */
  var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

  /** Detect free variable `self`. */
  var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

  /** Used as a reference to the global object. */
  var root = freeGlobal || freeSelf || Function('return this')();

  /**
   * Gets the timestamp of the number of milliseconds that have elapsed since
   * the Unix epoch (1 January 1970 00:00:00 UTC).
   *
   * @static
   * @memberOf _
   * @since 2.4.0
   * @category Date
   * @returns {number} Returns the timestamp.
   * @example
   *
   * _.defer(function(stamp) {
   *   console.log(_.now() - stamp);
   * }, _.now());
   * // => Logs the number of milliseconds it took for the deferred invocation.
   */
  var now = function() {
    return root.Date.now();
  };

  /** Used to match a single whitespace character. */
  var reWhitespace = /\s/;

  /**
   * Used by `_.trim` and `_.trimEnd` to get the index of the last non-whitespace
   * character of `string`.
   *
   * @private
   * @param {string} string The string to inspect.
   * @returns {number} Returns the index of the last non-whitespace character.
   */
  function trimmedEndIndex(string) {
    var index = string.length;

    while (index-- && reWhitespace.test(string.charAt(index))) {}
    return index;
  }

  /** Used to match leading whitespace. */
  var reTrimStart = /^\s+/;

  /**
   * The base implementation of `_.trim`.
   *
   * @private
   * @param {string} string The string to trim.
   * @returns {string} Returns the trimmed string.
   */
  function baseTrim(string) {
    return string
      ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, '')
      : string;
  }

  /** Built-in value references. */
  var Symbol$1 = root.Symbol;

  /** Used for built-in method references. */
  var objectProto$1 = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty = objectProto$1.hasOwnProperty;

  /**
   * Used to resolve the
   * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
   * of values.
   */
  var nativeObjectToString$1 = objectProto$1.toString;

  /** Built-in value references. */
  var symToStringTag$1 = Symbol$1 ? Symbol$1.toStringTag : undefined;

  /**
   * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the raw `toStringTag`.
   */
  function getRawTag(value) {
    var isOwn = hasOwnProperty.call(value, symToStringTag$1),
        tag = value[symToStringTag$1];

    try {
      value[symToStringTag$1] = undefined;
      var unmasked = true;
    } catch (e) {}

    var result = nativeObjectToString$1.call(value);
    if (unmasked) {
      if (isOwn) {
        value[symToStringTag$1] = tag;
      } else {
        delete value[symToStringTag$1];
      }
    }
    return result;
  }

  /** Used for built-in method references. */
  var objectProto = Object.prototype;

  /**
   * Used to resolve the
   * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
   * of values.
   */
  var nativeObjectToString = objectProto.toString;

  /**
   * Converts `value` to a string using `Object.prototype.toString`.
   *
   * @private
   * @param {*} value The value to convert.
   * @returns {string} Returns the converted string.
   */
  function objectToString(value) {
    return nativeObjectToString.call(value);
  }

  /** `Object#toString` result references. */
  var nullTag = '[object Null]',
      undefinedTag = '[object Undefined]';

  /** Built-in value references. */
  var symToStringTag = Symbol$1 ? Symbol$1.toStringTag : undefined;

  /**
   * The base implementation of `getTag` without fallbacks for buggy environments.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the `toStringTag`.
   */
  function baseGetTag(value) {
    if (value == null) {
      return value === undefined ? undefinedTag : nullTag;
    }
    return (symToStringTag && symToStringTag in Object(value))
      ? getRawTag(value)
      : objectToString(value);
  }

  /**
   * Checks if `value` is object-like. A value is object-like if it's not `null`
   * and has a `typeof` result of "object".
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
   * @example
   *
   * _.isObjectLike({});
   * // => true
   *
   * _.isObjectLike([1, 2, 3]);
   * // => true
   *
   * _.isObjectLike(_.noop);
   * // => false
   *
   * _.isObjectLike(null);
   * // => false
   */
  function isObjectLike(value) {
    return value != null && typeof value == 'object';
  }

  /** `Object#toString` result references. */
  var symbolTag = '[object Symbol]';

  /**
   * Checks if `value` is classified as a `Symbol` primitive or object.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
   * @example
   *
   * _.isSymbol(Symbol.iterator);
   * // => true
   *
   * _.isSymbol('abc');
   * // => false
   */
  function isSymbol(value) {
    return typeof value == 'symbol' ||
      (isObjectLike(value) && baseGetTag(value) == symbolTag);
  }

  /** Used as references for various `Number` constants. */
  var NAN = 0 / 0;

  /** Used to detect bad signed hexadecimal string values. */
  var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

  /** Used to detect binary string values. */
  var reIsBinary = /^0b[01]+$/i;

  /** Used to detect octal string values. */
  var reIsOctal = /^0o[0-7]+$/i;

  /** Built-in method references without a dependency on `root`. */
  var freeParseInt = parseInt;

  /**
   * Converts `value` to a number.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to process.
   * @returns {number} Returns the number.
   * @example
   *
   * _.toNumber(3.2);
   * // => 3.2
   *
   * _.toNumber(Number.MIN_VALUE);
   * // => 5e-324
   *
   * _.toNumber(Infinity);
   * // => Infinity
   *
   * _.toNumber('3.2');
   * // => 3.2
   */
  function toNumber(value) {
    if (typeof value == 'number') {
      return value;
    }
    if (isSymbol(value)) {
      return NAN;
    }
    if (isObject(value)) {
      var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
      value = isObject(other) ? (other + '') : other;
    }
    if (typeof value != 'string') {
      return value === 0 ? value : +value;
    }
    value = baseTrim(value);
    var isBinary = reIsBinary.test(value);
    return (isBinary || reIsOctal.test(value))
      ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
      : (reIsBadHex.test(value) ? NAN : +value);
  }

  /** Error message constants. */
  var FUNC_ERROR_TEXT = 'Expected a function';

  /* Built-in method references for those with the same name as other `lodash` methods. */
  var nativeMax = Math.max,
      nativeMin = Math.min;

  /**
   * Creates a debounced function that delays invoking `func` until after `wait`
   * milliseconds have elapsed since the last time the debounced function was
   * invoked. The debounced function comes with a `cancel` method to cancel
   * delayed `func` invocations and a `flush` method to immediately invoke them.
   * Provide `options` to indicate whether `func` should be invoked on the
   * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
   * with the last arguments provided to the debounced function. Subsequent
   * calls to the debounced function return the result of the last `func`
   * invocation.
   *
   * **Note:** If `leading` and `trailing` options are `true`, `func` is
   * invoked on the trailing edge of the timeout only if the debounced function
   * is invoked more than once during the `wait` timeout.
   *
   * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
   * until to the next tick, similar to `setTimeout` with a timeout of `0`.
   *
   * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
   * for details over the differences between `_.debounce` and `_.throttle`.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Function
   * @param {Function} func The function to debounce.
   * @param {number} [wait=0] The number of milliseconds to delay.
   * @param {Object} [options={}] The options object.
   * @param {boolean} [options.leading=false]
   *  Specify invoking on the leading edge of the timeout.
   * @param {number} [options.maxWait]
   *  The maximum time `func` is allowed to be delayed before it's invoked.
   * @param {boolean} [options.trailing=true]
   *  Specify invoking on the trailing edge of the timeout.
   * @returns {Function} Returns the new debounced function.
   * @example
   *
   * // Avoid costly calculations while the window size is in flux.
   * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
   *
   * // Invoke `sendMail` when clicked, debouncing subsequent calls.
   * jQuery(element).on('click', _.debounce(sendMail, 300, {
   *   'leading': true,
   *   'trailing': false
   * }));
   *
   * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
   * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
   * var source = new EventSource('/stream');
   * jQuery(source).on('message', debounced);
   *
   * // Cancel the trailing debounced invocation.
   * jQuery(window).on('popstate', debounced.cancel);
   */
  function debounce(func, wait, options) {
    var lastArgs,
        lastThis,
        maxWait,
        result,
        timerId,
        lastCallTime,
        lastInvokeTime = 0,
        leading = false,
        maxing = false,
        trailing = true;

    if (typeof func != 'function') {
      throw new TypeError(FUNC_ERROR_TEXT);
    }
    wait = toNumber(wait) || 0;
    if (isObject(options)) {
      leading = !!options.leading;
      maxing = 'maxWait' in options;
      maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
      trailing = 'trailing' in options ? !!options.trailing : trailing;
    }

    function invokeFunc(time) {
      var args = lastArgs,
          thisArg = lastThis;

      lastArgs = lastThis = undefined;
      lastInvokeTime = time;
      result = func.apply(thisArg, args);
      return result;
    }

    function leadingEdge(time) {
      // Reset any `maxWait` timer.
      lastInvokeTime = time;
      // Start the timer for the trailing edge.
      timerId = setTimeout(timerExpired, wait);
      // Invoke the leading edge.
      return leading ? invokeFunc(time) : result;
    }

    function remainingWait(time) {
      var timeSinceLastCall = time - lastCallTime,
          timeSinceLastInvoke = time - lastInvokeTime,
          timeWaiting = wait - timeSinceLastCall;

      return maxing
        ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke)
        : timeWaiting;
    }

    function shouldInvoke(time) {
      var timeSinceLastCall = time - lastCallTime,
          timeSinceLastInvoke = time - lastInvokeTime;

      // Either this is the first call, activity has stopped and we're at the
      // trailing edge, the system time has gone backwards and we're treating
      // it as the trailing edge, or we've hit the `maxWait` limit.
      return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
        (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
    }

    function timerExpired() {
      var time = now();
      if (shouldInvoke(time)) {
        return trailingEdge(time);
      }
      // Restart the timer.
      timerId = setTimeout(timerExpired, remainingWait(time));
    }

    function trailingEdge(time) {
      timerId = undefined;

      // Only invoke if we have `lastArgs` which means `func` has been
      // debounced at least once.
      if (trailing && lastArgs) {
        return invokeFunc(time);
      }
      lastArgs = lastThis = undefined;
      return result;
    }

    function cancel() {
      if (timerId !== undefined) {
        clearTimeout(timerId);
      }
      lastInvokeTime = 0;
      lastArgs = lastCallTime = lastThis = timerId = undefined;
    }

    function flush() {
      return timerId === undefined ? result : trailingEdge(now());
    }

    function debounced() {
      var time = now(),
          isInvoking = shouldInvoke(time);

      lastArgs = arguments;
      lastThis = this;
      lastCallTime = time;

      if (isInvoking) {
        if (timerId === undefined) {
          return leadingEdge(lastCallTime);
        }
        if (maxing) {
          // Handle invocations in a tight loop.
          clearTimeout(timerId);
          timerId = setTimeout(timerExpired, wait);
          return invokeFunc(lastCallTime);
        }
      }
      if (timerId === undefined) {
        timerId = setTimeout(timerExpired, wait);
      }
      return result;
    }
    debounced.cancel = cancel;
    debounced.flush = flush;
    return debounced;
  }

  function _arrayLikeToArray$2(r, a) {
    (null == a || a > r.length) && (a = r.length);
    for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
    return n;
  }
  function _arrayWithHoles$2(r) {
    if (Array.isArray(r)) return r;
  }
  function _classCallCheck$2(a, n) {
    if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function");
  }
  function _createClass$2(e, r, t) {
    return Object.defineProperty(e, "prototype", {
      writable: false
    }), e;
  }
  function _iterableToArrayLimit$2(r, l) {
    var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
    if (null != t) {
      var e,
        n,
        i,
        u,
        a = [],
        f = true,
        o = false;
      try {
        if (i = (t = t.call(r)).next, 0 === l) ; else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
      } catch (r) {
        o = true, n = r;
      } finally {
        try {
          if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
        } finally {
          if (o) throw n;
        }
      }
      return a;
    }
  }
  function _nonIterableRest$2() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _slicedToArray$2(r, e) {
    return _arrayWithHoles$2(r) || _iterableToArrayLimit$2(r, e) || _unsupportedIterableToArray$2(r, e) || _nonIterableRest$2();
  }
  function _unsupportedIterableToArray$2(r, a) {
    if (r) {
      if ("string" == typeof r) return _arrayLikeToArray$2(r, a);
      var t = {}.toString.call(r).slice(8, -1);
      return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$2(r, a) : void 0;
    }
  }

  var Prop = /*#__PURE__*/_createClass$2(function Prop(name, _ref) {
    var _ref$default = _ref["default"],
      defaultVal = _ref$default === void 0 ? null : _ref$default,
      _ref$triggerUpdate = _ref.triggerUpdate,
      triggerUpdate = _ref$triggerUpdate === void 0 ? true : _ref$triggerUpdate,
      _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === void 0 ? function (newVal, state) {} : _ref$onChange;
    _classCallCheck$2(this, Prop);
    this.name = name;
    this.defaultVal = defaultVal;
    this.triggerUpdate = triggerUpdate;
    this.onChange = onChange;
  });
  function index$1 (_ref2) {
    var _ref2$stateInit = _ref2.stateInit,
      stateInit = _ref2$stateInit === void 0 ? function () {
        return {};
      } : _ref2$stateInit,
      _ref2$props = _ref2.props,
      rawProps = _ref2$props === void 0 ? {} : _ref2$props,
      _ref2$methods = _ref2.methods,
      methods = _ref2$methods === void 0 ? {} : _ref2$methods,
      _ref2$aliases = _ref2.aliases,
      aliases = _ref2$aliases === void 0 ? {} : _ref2$aliases,
      _ref2$init = _ref2.init,
      initFn = _ref2$init === void 0 ? function () {} : _ref2$init,
      _ref2$update = _ref2.update,
      updateFn = _ref2$update === void 0 ? function () {} : _ref2$update;
    // Parse props into Prop instances
    var props = Object.keys(rawProps).map(function (propName) {
      return new Prop(propName, rawProps[propName]);
    });
    return function KapsuleComp() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      var classMode = !!(this instanceof KapsuleComp ? this.constructor : void 0);
      var nodeElement = classMode ? args.shift() : undefined;
      var _args$ = args[0],
        options = _args$ === void 0 ? {} : _args$;

      // Holds component state
      var state = Object.assign({}, stateInit instanceof Function ? stateInit(options) : stateInit,
      // Support plain objects for backwards compatibility
      {
        initialised: false
      });

      // keeps track of which props triggered an update
      var changedProps = {};

      // Component constructor
      function comp(nodeElement) {
        initStatic(nodeElement, options);
        digest();
        return comp;
      }
      var initStatic = function initStatic(nodeElement, options) {
        initFn.call(comp, nodeElement, state, options);
        state.initialised = true;
      };
      var digest = debounce(function () {
        if (!state.initialised) {
          return;
        }
        updateFn.call(comp, state, changedProps);
        changedProps = {};
      }, 1);

      // Getter/setter methods
      props.forEach(function (prop) {
        comp[prop.name] = getSetProp(prop);
        function getSetProp(_ref3) {
          var prop = _ref3.name,
            _ref3$triggerUpdate = _ref3.triggerUpdate,
            redigest = _ref3$triggerUpdate === void 0 ? false : _ref3$triggerUpdate,
            _ref3$onChange = _ref3.onChange,
            onChange = _ref3$onChange === void 0 ? function (newVal, state) {} : _ref3$onChange,
            _ref3$defaultVal = _ref3.defaultVal,
            defaultVal = _ref3$defaultVal === void 0 ? null : _ref3$defaultVal;
          return function (_) {
            var curVal = state[prop];
            if (!arguments.length) {
              return curVal;
            } // Getter mode

            var val = _ === undefined ? defaultVal : _; // pick default if value passed is undefined
            state[prop] = val;
            onChange.call(comp, val, state, curVal);

            // track changed props
            !changedProps.hasOwnProperty(prop) && (changedProps[prop] = curVal);
            if (redigest) {
              digest();
            }
            return comp;
          };
        }
      });

      // Other methods
      Object.keys(methods).forEach(function (methodName) {
        comp[methodName] = function () {
          var _methods$methodName;
          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }
          return (_methods$methodName = methods[methodName]).call.apply(_methods$methodName, [comp, state].concat(args));
        };
      });

      // Link aliases
      Object.entries(aliases).forEach(function (_ref4) {
        var _ref5 = _slicedToArray$2(_ref4, 2),
          alias = _ref5[0],
          target = _ref5[1];
        return comp[alias] = comp[target];
      });

      // Reset all component props to their default value
      comp.resetProps = function () {
        props.forEach(function (prop) {
          comp[prop.name](prop.defaultVal);
        });
        return comp;
      };

      //

      comp.resetProps(); // Apply all prop defaults
      state._rerender = digest; // Expose digest method

      classMode && nodeElement && comp(nodeElement);
      return comp;
    };
  }

  var index = (function (p) {
    return typeof p === 'function' ? p // fn
    : typeof p === 'string' ? function (obj) {
      return obj[p];
    } // property name
    : function (obj) {
      return p;
    };
  }); // constant

  class InternMap extends Map {
    constructor(entries, key = keyof) {
      super();
      Object.defineProperties(this, {_intern: {value: new Map()}, _key: {value: key}});
      if (entries != null) for (const [key, value] of entries) this.set(key, value);
    }
    get(key) {
      return super.get(intern_get(this, key));
    }
    has(key) {
      return super.has(intern_get(this, key));
    }
    set(key, value) {
      return super.set(intern_set(this, key), value);
    }
    delete(key) {
      return super.delete(intern_delete(this, key));
    }
  }

  function intern_get({_intern, _key}, value) {
    const key = _key(value);
    return _intern.has(key) ? _intern.get(key) : value;
  }

  function intern_set({_intern, _key}, value) {
    const key = _key(value);
    if (_intern.has(key)) return _intern.get(key);
    _intern.set(key, value);
    return value;
  }

  function intern_delete({_intern, _key}, value) {
    const key = _key(value);
    if (_intern.has(key)) {
      value = _intern.get(key);
      _intern.delete(key);
    }
    return value;
  }

  function keyof(value) {
    return value !== null && typeof value === "object" ? value.valueOf() : value;
  }

  function max(values, valueof) {
    let max;
    if (valueof === undefined) {
      for (const value of values) {
        if (value != null
            && (max < value || (max === undefined && value >= value))) {
          max = value;
        }
      }
    } else {
      let index = -1;
      for (let value of values) {
        if ((value = valueof(value, ++index, values)) != null
            && (max < value || (max === undefined && value >= value))) {
          max = value;
        }
      }
    }
    return max;
  }

  function min(values, valueof) {
    let min;
    if (valueof === undefined) {
      for (const value of values) {
        if (value != null
            && (min > value || (min === undefined && value >= value))) {
          min = value;
        }
      }
    } else {
      let index = -1;
      for (let value of values) {
        if ((value = valueof(value, ++index, values)) != null
            && (min > value || (min === undefined && value >= value))) {
          min = value;
        }
      }
    }
    return min;
  }

  function _arrayLikeToArray$1(r, a) {
    (null == a || a > r.length) && (a = r.length);
    for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
    return n;
  }
  function _arrayWithHoles$1(r) {
    if (Array.isArray(r)) return r;
  }
  function _arrayWithoutHoles$1(r) {
    if (Array.isArray(r)) return _arrayLikeToArray$1(r);
  }
  function _assertClassBrand$1(e, t, n) {
    if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n;
    throw new TypeError("Private element is not present on this object");
  }
  function _checkPrivateRedeclaration$1(e, t) {
    if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object");
  }
  function _classCallCheck$1(a, n) {
    if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function");
  }
  function _classPrivateFieldGet2$1(s, a) {
    return s.get(_assertClassBrand$1(s, a));
  }
  function _classPrivateFieldInitSpec$1(e, t, a) {
    _checkPrivateRedeclaration$1(e, t), t.set(e, a);
  }
  function _classPrivateFieldSet2$1(s, a, r) {
    return s.set(_assertClassBrand$1(s, a), r), r;
  }
  function _defineProperties$1(e, r) {
    for (var t = 0; t < r.length; t++) {
      var o = r[t];
      o.enumerable = o.enumerable || false, o.configurable = true, "value" in o && (o.writable = true), Object.defineProperty(e, _toPropertyKey$1(o.key), o);
    }
  }
  function _createClass$1(e, r, t) {
    return r && _defineProperties$1(e.prototype, r), Object.defineProperty(e, "prototype", {
      writable: false
    }), e;
  }
  function _iterableToArray$1(r) {
    if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r);
  }
  function _iterableToArrayLimit$1(r, l) {
    var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
    if (null != t) {
      var e,
        n,
        i,
        u,
        a = [],
        f = true,
        o = false;
      try {
        if (i = (t = t.call(r)).next, 0 === l) ; else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
      } catch (r) {
        o = true, n = r;
      } finally {
        try {
          if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
        } finally {
          if (o) throw n;
        }
      }
      return a;
    }
  }
  function _nonIterableRest$1() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _nonIterableSpread$1() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _slicedToArray$1(r, e) {
    return _arrayWithHoles$1(r) || _iterableToArrayLimit$1(r, e) || _unsupportedIterableToArray$1(r, e) || _nonIterableRest$1();
  }
  function _toConsumableArray$1(r) {
    return _arrayWithoutHoles$1(r) || _iterableToArray$1(r) || _unsupportedIterableToArray$1(r) || _nonIterableSpread$1();
  }
  function _toPrimitive$1(t, r) {
    if ("object" != typeof t || !t) return t;
    var e = t[Symbol.toPrimitive];
    if (void 0 !== e) {
      var i = e.call(t, r);
      if ("object" != typeof i) return i;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (String )(t);
  }
  function _toPropertyKey$1(t) {
    var i = _toPrimitive$1(t, "string");
    return "symbol" == typeof i ? i : i + "";
  }
  function _unsupportedIterableToArray$1(r, a) {
    if (r) {
      if ("string" == typeof r) return _arrayLikeToArray$1(r, a);
      var t = {}.toString.call(r).slice(8, -1);
      return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray$1(r, a) : void 0;
    }
  }

  var _dataMap = /*#__PURE__*/new WeakMap();
  var _objMap = /*#__PURE__*/new WeakMap();
  var _id = /*#__PURE__*/new WeakMap();
  var _createObj = /*#__PURE__*/new WeakMap();
  var _updateObj = /*#__PURE__*/new WeakMap();
  var _removeObj = /*#__PURE__*/new WeakMap();
  var DataBindMapper = /*#__PURE__*/function () {
    function DataBindMapper() {
      _classCallCheck$1(this, DataBindMapper);
      _classPrivateFieldInitSpec$1(this, _dataMap, new Map());
      _classPrivateFieldInitSpec$1(this, _objMap, new Map());
      _classPrivateFieldInitSpec$1(this, _id, function (d) {
        return d;
      });
      _classPrivateFieldInitSpec$1(this, _createObj, function () {
        return {};
      });
      _classPrivateFieldInitSpec$1(this, _updateObj, function () {});
      _classPrivateFieldInitSpec$1(this, _removeObj, function () {});
    }
    return _createClass$1(DataBindMapper, [{
      key: "getObj",
      value: function getObj(d) {
        return _classPrivateFieldGet2$1(_dataMap, this).get(_classPrivateFieldGet2$1(_id, this).call(this, d));
      }
    }, {
      key: "getData",
      value: function getData(o) {
        return _classPrivateFieldGet2$1(_objMap, this).get(o);
      }
    }, {
      key: "entries",
      value: function entries() {
        return _toConsumableArray$1(_classPrivateFieldGet2$1(_objMap, this).entries()).map(function (_ref) {
          var _ref2 = _slicedToArray$1(_ref, 2),
            o = _ref2[0],
            d = _ref2[1];
          return [d, o];
        });
      }
    }, {
      key: "id",
      value: function id(p) {
        _classPrivateFieldSet2$1(_id, this, index(p));
        return this;
      }
    }, {
      key: "onCreateObj",
      value: function onCreateObj(fn) {
        _classPrivateFieldSet2$1(_createObj, this, fn);
        return this;
      }
    }, {
      key: "onUpdateObj",
      value: function onUpdateObj(fn) {
        _classPrivateFieldSet2$1(_updateObj, this, fn);
        return this;
      }
    }, {
      key: "onRemoveObj",
      value: function onRemoveObj(fn) {
        _classPrivateFieldSet2$1(_removeObj, this, fn);
        return this;
      }
    }, {
      key: "digest",
      value: function digest(data) {
        var _this = this;
        data.filter(function (d) {
          return !_classPrivateFieldGet2$1(_dataMap, _this).has(_classPrivateFieldGet2$1(_id, _this).call(_this, d));
        }).forEach(function (d) {
          var obj = _classPrivateFieldGet2$1(_createObj, _this).call(_this, d);
          _classPrivateFieldGet2$1(_dataMap, _this).set(_classPrivateFieldGet2$1(_id, _this).call(_this, d), obj);
          _classPrivateFieldGet2$1(_objMap, _this).set(obj, d);
        });
        var dataIdsMap = new Map(data.map(function (d) {
          return [_classPrivateFieldGet2$1(_id, _this).call(_this, d), d];
        }));
        _classPrivateFieldGet2$1(_dataMap, this).forEach(function (o, dId) {
          if (!dataIdsMap.has(dId)) {
            _classPrivateFieldGet2$1(_removeObj, _this).call(_this, o, dId);
            _classPrivateFieldGet2$1(_dataMap, _this)["delete"](dId);
            _classPrivateFieldGet2$1(_objMap, _this)["delete"](o);
          } else {
            _classPrivateFieldGet2$1(_updateObj, _this).call(_this, o, dataIdsMap.get(dId));
          }
        });
        return this;
      }
    }, {
      key: "clear",
      value: function clear() {
        this.digest([]);
        return this;
      }
    }]);
  }();

  function initRange(domain, range) {
    switch (arguments.length) {
      case 0: break;
      case 1: this.range(domain); break;
      default: this.range(range).domain(domain); break;
    }
    return this;
  }

  const implicit = Symbol("implicit");

  function ordinal() {
    var index = new InternMap(),
        domain = [],
        range = [],
        unknown = implicit;

    function scale(d) {
      let i = index.get(d);
      if (i === undefined) {
        if (unknown !== implicit) return unknown;
        index.set(d, i = domain.push(d) - 1);
      }
      return range[i % range.length];
    }

    scale.domain = function(_) {
      if (!arguments.length) return domain.slice();
      domain = [], index = new InternMap();
      for (const value of _) {
        if (index.has(value)) continue;
        index.set(value, domain.push(value) - 1);
      }
      return scale;
    };

    scale.range = function(_) {
      return arguments.length ? (range = Array.from(_), scale) : range.slice();
    };

    scale.unknown = function(_) {
      return arguments.length ? (unknown = _, scale) : unknown;
    };

    scale.copy = function() {
      return ordinal(domain, range).unknown(unknown);
    };

    initRange.apply(scale, arguments);

    return scale;
  }

  function colors(specifier) {
    var n = specifier.length / 6 | 0, colors = new Array(n), i = 0;
    while (i < n) colors[i] = "#" + specifier.slice(i * 6, ++i * 6);
    return colors;
  }

  var schemePaired = colors("a6cee31f78b4b2df8a33a02cfb9a99e31a1cfdbf6fff7f00cab2d66a3d9affff99b15928");

  // This file is autogenerated. It's used to publish ESM to npm.
  function _typeof$1(obj) {
    "@babel/helpers - typeof";

    return _typeof$1 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
      return typeof obj;
    } : function (obj) {
      return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    }, _typeof$1(obj);
  }

  // https://github.com/bgrins/TinyColor
  // Brian Grinstead, MIT License

  var trimLeft = /^\s+/;
  var trimRight = /\s+$/;
  function tinycolor(color, opts) {
    color = color ? color : "";
    opts = opts || {};

    // If input is already a tinycolor, return itself
    if (color instanceof tinycolor) {
      return color;
    }
    // If we are called as a function, call using new instead
    if (!(this instanceof tinycolor)) {
      return new tinycolor(color, opts);
    }
    var rgb = inputToRGB(color);
    this._originalInput = color, this._r = rgb.r, this._g = rgb.g, this._b = rgb.b, this._a = rgb.a, this._roundA = Math.round(100 * this._a) / 100, this._format = opts.format || rgb.format;
    this._gradientType = opts.gradientType;

    // Don't let the range of [0,255] come back in [0,1].
    // Potentially lose a little bit of precision here, but will fix issues where
    // .5 gets interpreted as half of the total, instead of half of 1
    // If it was supposed to be 128, this was already taken care of by `inputToRgb`
    if (this._r < 1) this._r = Math.round(this._r);
    if (this._g < 1) this._g = Math.round(this._g);
    if (this._b < 1) this._b = Math.round(this._b);
    this._ok = rgb.ok;
  }
  tinycolor.prototype = {
    isDark: function isDark() {
      return this.getBrightness() < 128;
    },
    isLight: function isLight() {
      return !this.isDark();
    },
    isValid: function isValid() {
      return this._ok;
    },
    getOriginalInput: function getOriginalInput() {
      return this._originalInput;
    },
    getFormat: function getFormat() {
      return this._format;
    },
    getAlpha: function getAlpha() {
      return this._a;
    },
    getBrightness: function getBrightness() {
      //http://www.w3.org/TR/AERT#color-contrast
      var rgb = this.toRgb();
      return (rgb.r * 299 + rgb.g * 587 + rgb.b * 114) / 1000;
    },
    getLuminance: function getLuminance() {
      //http://www.w3.org/TR/2008/REC-WCAG20-20081211/#relativeluminancedef
      var rgb = this.toRgb();
      var RsRGB, GsRGB, BsRGB, R, G, B;
      RsRGB = rgb.r / 255;
      GsRGB = rgb.g / 255;
      BsRGB = rgb.b / 255;
      if (RsRGB <= 0.03928) R = RsRGB / 12.92;else R = Math.pow((RsRGB + 0.055) / 1.055, 2.4);
      if (GsRGB <= 0.03928) G = GsRGB / 12.92;else G = Math.pow((GsRGB + 0.055) / 1.055, 2.4);
      if (BsRGB <= 0.03928) B = BsRGB / 12.92;else B = Math.pow((BsRGB + 0.055) / 1.055, 2.4);
      return 0.2126 * R + 0.7152 * G + 0.0722 * B;
    },
    setAlpha: function setAlpha(value) {
      this._a = boundAlpha(value);
      this._roundA = Math.round(100 * this._a) / 100;
      return this;
    },
    toHsv: function toHsv() {
      var hsv = rgbToHsv(this._r, this._g, this._b);
      return {
        h: hsv.h * 360,
        s: hsv.s,
        v: hsv.v,
        a: this._a
      };
    },
    toHsvString: function toHsvString() {
      var hsv = rgbToHsv(this._r, this._g, this._b);
      var h = Math.round(hsv.h * 360),
        s = Math.round(hsv.s * 100),
        v = Math.round(hsv.v * 100);
      return this._a == 1 ? "hsv(" + h + ", " + s + "%, " + v + "%)" : "hsva(" + h + ", " + s + "%, " + v + "%, " + this._roundA + ")";
    },
    toHsl: function toHsl() {
      var hsl = rgbToHsl$1(this._r, this._g, this._b);
      return {
        h: hsl.h * 360,
        s: hsl.s,
        l: hsl.l,
        a: this._a
      };
    },
    toHslString: function toHslString() {
      var hsl = rgbToHsl$1(this._r, this._g, this._b);
      var h = Math.round(hsl.h * 360),
        s = Math.round(hsl.s * 100),
        l = Math.round(hsl.l * 100);
      return this._a == 1 ? "hsl(" + h + ", " + s + "%, " + l + "%)" : "hsla(" + h + ", " + s + "%, " + l + "%, " + this._roundA + ")";
    },
    toHex: function toHex(allow3Char) {
      return rgbToHex(this._r, this._g, this._b, allow3Char);
    },
    toHexString: function toHexString(allow3Char) {
      return "#" + this.toHex(allow3Char);
    },
    toHex8: function toHex8(allow4Char) {
      return rgbaToHex(this._r, this._g, this._b, this._a, allow4Char);
    },
    toHex8String: function toHex8String(allow4Char) {
      return "#" + this.toHex8(allow4Char);
    },
    toRgb: function toRgb() {
      return {
        r: Math.round(this._r),
        g: Math.round(this._g),
        b: Math.round(this._b),
        a: this._a
      };
    },
    toRgbString: function toRgbString() {
      return this._a == 1 ? "rgb(" + Math.round(this._r) + ", " + Math.round(this._g) + ", " + Math.round(this._b) + ")" : "rgba(" + Math.round(this._r) + ", " + Math.round(this._g) + ", " + Math.round(this._b) + ", " + this._roundA + ")";
    },
    toPercentageRgb: function toPercentageRgb() {
      return {
        r: Math.round(bound01(this._r, 255) * 100) + "%",
        g: Math.round(bound01(this._g, 255) * 100) + "%",
        b: Math.round(bound01(this._b, 255) * 100) + "%",
        a: this._a
      };
    },
    toPercentageRgbString: function toPercentageRgbString() {
      return this._a == 1 ? "rgb(" + Math.round(bound01(this._r, 255) * 100) + "%, " + Math.round(bound01(this._g, 255) * 100) + "%, " + Math.round(bound01(this._b, 255) * 100) + "%)" : "rgba(" + Math.round(bound01(this._r, 255) * 100) + "%, " + Math.round(bound01(this._g, 255) * 100) + "%, " + Math.round(bound01(this._b, 255) * 100) + "%, " + this._roundA + ")";
    },
    toName: function toName() {
      if (this._a === 0) {
        return "transparent";
      }
      if (this._a < 1) {
        return false;
      }
      return hexNames[rgbToHex(this._r, this._g, this._b, true)] || false;
    },
    toFilter: function toFilter(secondColor) {
      var hex8String = "#" + rgbaToArgbHex(this._r, this._g, this._b, this._a);
      var secondHex8String = hex8String;
      var gradientType = this._gradientType ? "GradientType = 1, " : "";
      if (secondColor) {
        var s = tinycolor(secondColor);
        secondHex8String = "#" + rgbaToArgbHex(s._r, s._g, s._b, s._a);
      }
      return "progid:DXImageTransform.Microsoft.gradient(" + gradientType + "startColorstr=" + hex8String + ",endColorstr=" + secondHex8String + ")";
    },
    toString: function toString(format) {
      var formatSet = !!format;
      format = format || this._format;
      var formattedString = false;
      var hasAlpha = this._a < 1 && this._a >= 0;
      var needsAlphaFormat = !formatSet && hasAlpha && (format === "hex" || format === "hex6" || format === "hex3" || format === "hex4" || format === "hex8" || format === "name");
      if (needsAlphaFormat) {
        // Special case for "transparent", all other non-alpha formats
        // will return rgba when there is transparency.
        if (format === "name" && this._a === 0) {
          return this.toName();
        }
        return this.toRgbString();
      }
      if (format === "rgb") {
        formattedString = this.toRgbString();
      }
      if (format === "prgb") {
        formattedString = this.toPercentageRgbString();
      }
      if (format === "hex" || format === "hex6") {
        formattedString = this.toHexString();
      }
      if (format === "hex3") {
        formattedString = this.toHexString(true);
      }
      if (format === "hex4") {
        formattedString = this.toHex8String(true);
      }
      if (format === "hex8") {
        formattedString = this.toHex8String();
      }
      if (format === "name") {
        formattedString = this.toName();
      }
      if (format === "hsl") {
        formattedString = this.toHslString();
      }
      if (format === "hsv") {
        formattedString = this.toHsvString();
      }
      return formattedString || this.toHexString();
    },
    clone: function clone() {
      return tinycolor(this.toString());
    },
    _applyModification: function _applyModification(fn, args) {
      var color = fn.apply(null, [this].concat([].slice.call(args)));
      this._r = color._r;
      this._g = color._g;
      this._b = color._b;
      this.setAlpha(color._a);
      return this;
    },
    lighten: function lighten() {
      return this._applyModification(_lighten, arguments);
    },
    brighten: function brighten() {
      return this._applyModification(_brighten, arguments);
    },
    darken: function darken() {
      return this._applyModification(_darken, arguments);
    },
    desaturate: function desaturate() {
      return this._applyModification(_desaturate, arguments);
    },
    saturate: function saturate() {
      return this._applyModification(_saturate, arguments);
    },
    greyscale: function greyscale() {
      return this._applyModification(_greyscale, arguments);
    },
    spin: function spin() {
      return this._applyModification(_spin, arguments);
    },
    _applyCombination: function _applyCombination(fn, args) {
      return fn.apply(null, [this].concat([].slice.call(args)));
    },
    analogous: function analogous() {
      return this._applyCombination(_analogous, arguments);
    },
    complement: function complement() {
      return this._applyCombination(_complement, arguments);
    },
    monochromatic: function monochromatic() {
      return this._applyCombination(_monochromatic, arguments);
    },
    splitcomplement: function splitcomplement() {
      return this._applyCombination(_splitcomplement, arguments);
    },
    // Disabled until https://github.com/bgrins/TinyColor/issues/254
    // polyad: function (number) {
    //   return this._applyCombination(polyad, [number]);
    // },
    triad: function triad() {
      return this._applyCombination(polyad, [3]);
    },
    tetrad: function tetrad() {
      return this._applyCombination(polyad, [4]);
    }
  };

  // If input is an object, force 1 into "1.0" to handle ratios properly
  // String input requires "1.0" as input, so 1 will be treated as 1
  tinycolor.fromRatio = function (color, opts) {
    if (_typeof$1(color) == "object") {
      var newColor = {};
      for (var i in color) {
        if (color.hasOwnProperty(i)) {
          if (i === "a") {
            newColor[i] = color[i];
          } else {
            newColor[i] = convertToPercentage(color[i]);
          }
        }
      }
      color = newColor;
    }
    return tinycolor(color, opts);
  };

  // Given a string or object, convert that input to RGB
  // Possible string inputs:
  //
  //     "red"
  //     "#f00" or "f00"
  //     "#ff0000" or "ff0000"
  //     "#ff000000" or "ff000000"
  //     "rgb 255 0 0" or "rgb (255, 0, 0)"
  //     "rgb 1.0 0 0" or "rgb (1, 0, 0)"
  //     "rgba (255, 0, 0, 1)" or "rgba 255, 0, 0, 1"
  //     "rgba (1.0, 0, 0, 1)" or "rgba 1.0, 0, 0, 1"
  //     "hsl(0, 100%, 50%)" or "hsl 0 100% 50%"
  //     "hsla(0, 100%, 50%, 1)" or "hsla 0 100% 50%, 1"
  //     "hsv(0, 100%, 100%)" or "hsv 0 100% 100%"
  //
  function inputToRGB(color) {
    var rgb = {
      r: 0,
      g: 0,
      b: 0
    };
    var a = 1;
    var s = null;
    var v = null;
    var l = null;
    var ok = false;
    var format = false;
    if (typeof color == "string") {
      color = stringInputToObject(color);
    }
    if (_typeof$1(color) == "object") {
      if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
        rgb = rgbToRgb(color.r, color.g, color.b);
        ok = true;
        format = String(color.r).substr(-1) === "%" ? "prgb" : "rgb";
      } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
        s = convertToPercentage(color.s);
        v = convertToPercentage(color.v);
        rgb = hsvToRgb(color.h, s, v);
        ok = true;
        format = "hsv";
      } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
        s = convertToPercentage(color.s);
        l = convertToPercentage(color.l);
        rgb = hslToRgb$1(color.h, s, l);
        ok = true;
        format = "hsl";
      }
      if (color.hasOwnProperty("a")) {
        a = color.a;
      }
    }
    a = boundAlpha(a);
    return {
      ok: ok,
      format: color.format || format,
      r: Math.min(255, Math.max(rgb.r, 0)),
      g: Math.min(255, Math.max(rgb.g, 0)),
      b: Math.min(255, Math.max(rgb.b, 0)),
      a: a
    };
  }

  // Conversion Functions
  // --------------------

  // `rgbToHsl`, `rgbToHsv`, `hslToRgb`, `hsvToRgb` modified from:
  // <http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript>

  // `rgbToRgb`
  // Handle bounds / percentage checking to conform to CSS color spec
  // <http://www.w3.org/TR/css3-color/>
  // *Assumes:* r, g, b in [0, 255] or [0, 1]
  // *Returns:* { r, g, b } in [0, 255]
  function rgbToRgb(r, g, b) {
    return {
      r: bound01(r, 255) * 255,
      g: bound01(g, 255) * 255,
      b: bound01(b, 255) * 255
    };
  }

  // `rgbToHsl`
  // Converts an RGB color value to HSL.
  // *Assumes:* r, g, and b are contained in [0, 255] or [0, 1]
  // *Returns:* { h, s, l } in [0,1]
  function rgbToHsl$1(r, g, b) {
    r = bound01(r, 255);
    g = bound01(g, 255);
    b = bound01(b, 255);
    var max = Math.max(r, g, b),
      min = Math.min(r, g, b);
    var h,
      s,
      l = (max + min) / 2;
    if (max == min) {
      h = s = 0; // achromatic
    } else {
      var d = max - min;
      s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
      switch (max) {
        case r:
          h = (g - b) / d + (g < b ? 6 : 0);
          break;
        case g:
          h = (b - r) / d + 2;
          break;
        case b:
          h = (r - g) / d + 4;
          break;
      }
      h /= 6;
    }
    return {
      h: h,
      s: s,
      l: l
    };
  }

  // `hslToRgb`
  // Converts an HSL color value to RGB.
  // *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
  // *Returns:* { r, g, b } in the set [0, 255]
  function hslToRgb$1(h, s, l) {
    var r, g, b;
    h = bound01(h, 360);
    s = bound01(s, 100);
    l = bound01(l, 100);
    function hue2rgb(p, q, t) {
      if (t < 0) t += 1;
      if (t > 1) t -= 1;
      if (t < 1 / 6) return p + (q - p) * 6 * t;
      if (t < 1 / 2) return q;
      if (t < 2 / 3) return p + (q - p) * (2 / 3 - t) * 6;
      return p;
    }
    if (s === 0) {
      r = g = b = l; // achromatic
    } else {
      var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
      var p = 2 * l - q;
      r = hue2rgb(p, q, h + 1 / 3);
      g = hue2rgb(p, q, h);
      b = hue2rgb(p, q, h - 1 / 3);
    }
    return {
      r: r * 255,
      g: g * 255,
      b: b * 255
    };
  }

  // `rgbToHsv`
  // Converts an RGB color value to HSV
  // *Assumes:* r, g, and b are contained in the set [0, 255] or [0, 1]
  // *Returns:* { h, s, v } in [0,1]
  function rgbToHsv(r, g, b) {
    r = bound01(r, 255);
    g = bound01(g, 255);
    b = bound01(b, 255);
    var max = Math.max(r, g, b),
      min = Math.min(r, g, b);
    var h,
      s,
      v = max;
    var d = max - min;
    s = max === 0 ? 0 : d / max;
    if (max == min) {
      h = 0; // achromatic
    } else {
      switch (max) {
        case r:
          h = (g - b) / d + (g < b ? 6 : 0);
          break;
        case g:
          h = (b - r) / d + 2;
          break;
        case b:
          h = (r - g) / d + 4;
          break;
      }
      h /= 6;
    }
    return {
      h: h,
      s: s,
      v: v
    };
  }

  // `hsvToRgb`
  // Converts an HSV color value to RGB.
  // *Assumes:* h is contained in [0, 1] or [0, 360] and s and v are contained in [0, 1] or [0, 100]
  // *Returns:* { r, g, b } in the set [0, 255]
  function hsvToRgb(h, s, v) {
    h = bound01(h, 360) * 6;
    s = bound01(s, 100);
    v = bound01(v, 100);
    var i = Math.floor(h),
      f = h - i,
      p = v * (1 - s),
      q = v * (1 - f * s),
      t = v * (1 - (1 - f) * s),
      mod = i % 6,
      r = [v, q, p, p, t, v][mod],
      g = [t, v, v, q, p, p][mod],
      b = [p, p, t, v, v, q][mod];
    return {
      r: r * 255,
      g: g * 255,
      b: b * 255
    };
  }

  // `rgbToHex`
  // Converts an RGB color to hex
  // Assumes r, g, and b are contained in the set [0, 255]
  // Returns a 3 or 6 character hex
  function rgbToHex(r, g, b, allow3Char) {
    var hex = [pad2(Math.round(r).toString(16)), pad2(Math.round(g).toString(16)), pad2(Math.round(b).toString(16))];

    // Return a 3 character hex if possible
    if (allow3Char && hex[0].charAt(0) == hex[0].charAt(1) && hex[1].charAt(0) == hex[1].charAt(1) && hex[2].charAt(0) == hex[2].charAt(1)) {
      return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0);
    }
    return hex.join("");
  }

  // `rgbaToHex`
  // Converts an RGBA color plus alpha transparency to hex
  // Assumes r, g, b are contained in the set [0, 255] and
  // a in [0, 1]. Returns a 4 or 8 character rgba hex
  function rgbaToHex(r, g, b, a, allow4Char) {
    var hex = [pad2(Math.round(r).toString(16)), pad2(Math.round(g).toString(16)), pad2(Math.round(b).toString(16)), pad2(convertDecimalToHex(a))];

    // Return a 4 character hex if possible
    if (allow4Char && hex[0].charAt(0) == hex[0].charAt(1) && hex[1].charAt(0) == hex[1].charAt(1) && hex[2].charAt(0) == hex[2].charAt(1) && hex[3].charAt(0) == hex[3].charAt(1)) {
      return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0) + hex[3].charAt(0);
    }
    return hex.join("");
  }

  // `rgbaToArgbHex`
  // Converts an RGBA color to an ARGB Hex8 string
  // Rarely used, but required for "toFilter()"
  function rgbaToArgbHex(r, g, b, a) {
    var hex = [pad2(convertDecimalToHex(a)), pad2(Math.round(r).toString(16)), pad2(Math.round(g).toString(16)), pad2(Math.round(b).toString(16))];
    return hex.join("");
  }

  // `equals`
  // Can be called with any tinycolor input
  tinycolor.equals = function (color1, color2) {
    if (!color1 || !color2) return false;
    return tinycolor(color1).toRgbString() == tinycolor(color2).toRgbString();
  };
  tinycolor.random = function () {
    return tinycolor.fromRatio({
      r: Math.random(),
      g: Math.random(),
      b: Math.random()
    });
  };

  // Modification Functions
  // ----------------------
  // Thanks to less.js for some of the basics here
  // <https://github.com/cloudhead/less.js/blob/master/lib/less/functions.js>

  function _desaturate(color, amount) {
    amount = amount === 0 ? 0 : amount || 10;
    var hsl = tinycolor(color).toHsl();
    hsl.s -= amount / 100;
    hsl.s = clamp01(hsl.s);
    return tinycolor(hsl);
  }
  function _saturate(color, amount) {
    amount = amount === 0 ? 0 : amount || 10;
    var hsl = tinycolor(color).toHsl();
    hsl.s += amount / 100;
    hsl.s = clamp01(hsl.s);
    return tinycolor(hsl);
  }
  function _greyscale(color) {
    return tinycolor(color).desaturate(100);
  }
  function _lighten(color, amount) {
    amount = amount === 0 ? 0 : amount || 10;
    var hsl = tinycolor(color).toHsl();
    hsl.l += amount / 100;
    hsl.l = clamp01(hsl.l);
    return tinycolor(hsl);
  }
  function _brighten(color, amount) {
    amount = amount === 0 ? 0 : amount || 10;
    var rgb = tinycolor(color).toRgb();
    rgb.r = Math.max(0, Math.min(255, rgb.r - Math.round(255 * -(amount / 100))));
    rgb.g = Math.max(0, Math.min(255, rgb.g - Math.round(255 * -(amount / 100))));
    rgb.b = Math.max(0, Math.min(255, rgb.b - Math.round(255 * -(amount / 100))));
    return tinycolor(rgb);
  }
  function _darken(color, amount) {
    amount = amount === 0 ? 0 : amount || 10;
    var hsl = tinycolor(color).toHsl();
    hsl.l -= amount / 100;
    hsl.l = clamp01(hsl.l);
    return tinycolor(hsl);
  }

  // Spin takes a positive or negative amount within [-360, 360] indicating the change of hue.
  // Values outside of this range will be wrapped into this range.
  function _spin(color, amount) {
    var hsl = tinycolor(color).toHsl();
    var hue = (hsl.h + amount) % 360;
    hsl.h = hue < 0 ? 360 + hue : hue;
    return tinycolor(hsl);
  }

  // Combination Functions
  // ---------------------
  // Thanks to jQuery xColor for some of the ideas behind these
  // <https://github.com/infusion/jQuery-xcolor/blob/master/jquery.xcolor.js>

  function _complement(color) {
    var hsl = tinycolor(color).toHsl();
    hsl.h = (hsl.h + 180) % 360;
    return tinycolor(hsl);
  }
  function polyad(color, number) {
    if (isNaN(number) || number <= 0) {
      throw new Error("Argument to polyad must be a positive number");
    }
    var hsl = tinycolor(color).toHsl();
    var result = [tinycolor(color)];
    var step = 360 / number;
    for (var i = 1; i < number; i++) {
      result.push(tinycolor({
        h: (hsl.h + i * step) % 360,
        s: hsl.s,
        l: hsl.l
      }));
    }
    return result;
  }
  function _splitcomplement(color) {
    var hsl = tinycolor(color).toHsl();
    var h = hsl.h;
    return [tinycolor(color), tinycolor({
      h: (h + 72) % 360,
      s: hsl.s,
      l: hsl.l
    }), tinycolor({
      h: (h + 216) % 360,
      s: hsl.s,
      l: hsl.l
    })];
  }
  function _analogous(color, results, slices) {
    results = results || 6;
    slices = slices || 30;
    var hsl = tinycolor(color).toHsl();
    var part = 360 / slices;
    var ret = [tinycolor(color)];
    for (hsl.h = (hsl.h - (part * results >> 1) + 720) % 360; --results;) {
      hsl.h = (hsl.h + part) % 360;
      ret.push(tinycolor(hsl));
    }
    return ret;
  }
  function _monochromatic(color, results) {
    results = results || 6;
    var hsv = tinycolor(color).toHsv();
    var h = hsv.h,
      s = hsv.s,
      v = hsv.v;
    var ret = [];
    var modification = 1 / results;
    while (results--) {
      ret.push(tinycolor({
        h: h,
        s: s,
        v: v
      }));
      v = (v + modification) % 1;
    }
    return ret;
  }

  // Utility Functions
  // ---------------------

  tinycolor.mix = function (color1, color2, amount) {
    amount = amount === 0 ? 0 : amount || 50;
    var rgb1 = tinycolor(color1).toRgb();
    var rgb2 = tinycolor(color2).toRgb();
    var p = amount / 100;
    var rgba = {
      r: (rgb2.r - rgb1.r) * p + rgb1.r,
      g: (rgb2.g - rgb1.g) * p + rgb1.g,
      b: (rgb2.b - rgb1.b) * p + rgb1.b,
      a: (rgb2.a - rgb1.a) * p + rgb1.a
    };
    return tinycolor(rgba);
  };

  // Readability Functions
  // ---------------------
  // <http://www.w3.org/TR/2008/REC-WCAG20-20081211/#contrast-ratiodef (WCAG Version 2)

  // `contrast`
  // Analyze the 2 colors and returns the color contrast defined by (WCAG Version 2)
  tinycolor.readability = function (color1, color2) {
    var c1 = tinycolor(color1);
    var c2 = tinycolor(color2);
    return (Math.max(c1.getLuminance(), c2.getLuminance()) + 0.05) / (Math.min(c1.getLuminance(), c2.getLuminance()) + 0.05);
  };

  // `isReadable`
  // Ensure that foreground and background color combinations meet WCAG2 guidelines.
  // The third argument is an optional Object.
  //      the 'level' property states 'AA' or 'AAA' - if missing or invalid, it defaults to 'AA';
  //      the 'size' property states 'large' or 'small' - if missing or invalid, it defaults to 'small'.
  // If the entire object is absent, isReadable defaults to {level:"AA",size:"small"}.

  // *Example*
  //    tinycolor.isReadable("#000", "#111") => false
  //    tinycolor.isReadable("#000", "#111",{level:"AA",size:"large"}) => false
  tinycolor.isReadable = function (color1, color2, wcag2) {
    var readability = tinycolor.readability(color1, color2);
    var wcag2Parms, out;
    out = false;
    wcag2Parms = validateWCAG2Parms(wcag2);
    switch (wcag2Parms.level + wcag2Parms.size) {
      case "AAsmall":
      case "AAAlarge":
        out = readability >= 4.5;
        break;
      case "AAlarge":
        out = readability >= 3;
        break;
      case "AAAsmall":
        out = readability >= 7;
        break;
    }
    return out;
  };

  // `mostReadable`
  // Given a base color and a list of possible foreground or background
  // colors for that base, returns the most readable color.
  // Optionally returns Black or White if the most readable color is unreadable.
  // *Example*
  //    tinycolor.mostReadable(tinycolor.mostReadable("#123", ["#124", "#125"],{includeFallbackColors:false}).toHexString(); // "#112255"
  //    tinycolor.mostReadable(tinycolor.mostReadable("#123", ["#124", "#125"],{includeFallbackColors:true}).toHexString();  // "#ffffff"
  //    tinycolor.mostReadable("#a8015a", ["#faf3f3"],{includeFallbackColors:true,level:"AAA",size:"large"}).toHexString(); // "#faf3f3"
  //    tinycolor.mostReadable("#a8015a", ["#faf3f3"],{includeFallbackColors:true,level:"AAA",size:"small"}).toHexString(); // "#ffffff"
  tinycolor.mostReadable = function (baseColor, colorList, args) {
    var bestColor = null;
    var bestScore = 0;
    var readability;
    var includeFallbackColors, level, size;
    args = args || {};
    includeFallbackColors = args.includeFallbackColors;
    level = args.level;
    size = args.size;
    for (var i = 0; i < colorList.length; i++) {
      readability = tinycolor.readability(baseColor, colorList[i]);
      if (readability > bestScore) {
        bestScore = readability;
        bestColor = tinycolor(colorList[i]);
      }
    }
    if (tinycolor.isReadable(baseColor, bestColor, {
      level: level,
      size: size
    }) || !includeFallbackColors) {
      return bestColor;
    } else {
      args.includeFallbackColors = false;
      return tinycolor.mostReadable(baseColor, ["#fff", "#000"], args);
    }
  };

  // Big List of Colors
  // ------------------
  // <https://www.w3.org/TR/css-color-4/#named-colors>
  var names = tinycolor.names = {
    aliceblue: "f0f8ff",
    antiquewhite: "faebd7",
    aqua: "0ff",
    aquamarine: "7fffd4",
    azure: "f0ffff",
    beige: "f5f5dc",
    bisque: "ffe4c4",
    black: "000",
    blanchedalmond: "ffebcd",
    blue: "00f",
    blueviolet: "8a2be2",
    brown: "a52a2a",
    burlywood: "deb887",
    burntsienna: "ea7e5d",
    cadetblue: "5f9ea0",
    chartreuse: "7fff00",
    chocolate: "d2691e",
    coral: "ff7f50",
    cornflowerblue: "6495ed",
    cornsilk: "fff8dc",
    crimson: "dc143c",
    cyan: "0ff",
    darkblue: "00008b",
    darkcyan: "008b8b",
    darkgoldenrod: "b8860b",
    darkgray: "a9a9a9",
    darkgreen: "006400",
    darkgrey: "a9a9a9",
    darkkhaki: "bdb76b",
    darkmagenta: "8b008b",
    darkolivegreen: "556b2f",
    darkorange: "ff8c00",
    darkorchid: "9932cc",
    darkred: "8b0000",
    darksalmon: "e9967a",
    darkseagreen: "8fbc8f",
    darkslateblue: "483d8b",
    darkslategray: "2f4f4f",
    darkslategrey: "2f4f4f",
    darkturquoise: "00ced1",
    darkviolet: "9400d3",
    deeppink: "ff1493",
    deepskyblue: "00bfff",
    dimgray: "696969",
    dimgrey: "696969",
    dodgerblue: "1e90ff",
    firebrick: "b22222",
    floralwhite: "fffaf0",
    forestgreen: "228b22",
    fuchsia: "f0f",
    gainsboro: "dcdcdc",
    ghostwhite: "f8f8ff",
    gold: "ffd700",
    goldenrod: "daa520",
    gray: "808080",
    green: "008000",
    greenyellow: "adff2f",
    grey: "808080",
    honeydew: "f0fff0",
    hotpink: "ff69b4",
    indianred: "cd5c5c",
    indigo: "4b0082",
    ivory: "fffff0",
    khaki: "f0e68c",
    lavender: "e6e6fa",
    lavenderblush: "fff0f5",
    lawngreen: "7cfc00",
    lemonchiffon: "fffacd",
    lightblue: "add8e6",
    lightcoral: "f08080",
    lightcyan: "e0ffff",
    lightgoldenrodyellow: "fafad2",
    lightgray: "d3d3d3",
    lightgreen: "90ee90",
    lightgrey: "d3d3d3",
    lightpink: "ffb6c1",
    lightsalmon: "ffa07a",
    lightseagreen: "20b2aa",
    lightskyblue: "87cefa",
    lightslategray: "789",
    lightslategrey: "789",
    lightsteelblue: "b0c4de",
    lightyellow: "ffffe0",
    lime: "0f0",
    limegreen: "32cd32",
    linen: "faf0e6",
    magenta: "f0f",
    maroon: "800000",
    mediumaquamarine: "66cdaa",
    mediumblue: "0000cd",
    mediumorchid: "ba55d3",
    mediumpurple: "9370db",
    mediumseagreen: "3cb371",
    mediumslateblue: "7b68ee",
    mediumspringgreen: "00fa9a",
    mediumturquoise: "48d1cc",
    mediumvioletred: "c71585",
    midnightblue: "191970",
    mintcream: "f5fffa",
    mistyrose: "ffe4e1",
    moccasin: "ffe4b5",
    navajowhite: "ffdead",
    navy: "000080",
    oldlace: "fdf5e6",
    olive: "808000",
    olivedrab: "6b8e23",
    orange: "ffa500",
    orangered: "ff4500",
    orchid: "da70d6",
    palegoldenrod: "eee8aa",
    palegreen: "98fb98",
    paleturquoise: "afeeee",
    palevioletred: "db7093",
    papayawhip: "ffefd5",
    peachpuff: "ffdab9",
    peru: "cd853f",
    pink: "ffc0cb",
    plum: "dda0dd",
    powderblue: "b0e0e6",
    purple: "800080",
    rebeccapurple: "663399",
    red: "f00",
    rosybrown: "bc8f8f",
    royalblue: "4169e1",
    saddlebrown: "8b4513",
    salmon: "fa8072",
    sandybrown: "f4a460",
    seagreen: "2e8b57",
    seashell: "fff5ee",
    sienna: "a0522d",
    silver: "c0c0c0",
    skyblue: "87ceeb",
    slateblue: "6a5acd",
    slategray: "708090",
    slategrey: "708090",
    snow: "fffafa",
    springgreen: "00ff7f",
    steelblue: "4682b4",
    tan: "d2b48c",
    teal: "008080",
    thistle: "d8bfd8",
    tomato: "ff6347",
    turquoise: "40e0d0",
    violet: "ee82ee",
    wheat: "f5deb3",
    white: "fff",
    whitesmoke: "f5f5f5",
    yellow: "ff0",
    yellowgreen: "9acd32"
  };

  // Make it easy to access colors via `hexNames[hex]`
  var hexNames = tinycolor.hexNames = flip(names);

  // Utilities
  // ---------

  // `{ 'name1': 'val1' }` becomes `{ 'val1': 'name1' }`
  function flip(o) {
    var flipped = {};
    for (var i in o) {
      if (o.hasOwnProperty(i)) {
        flipped[o[i]] = i;
      }
    }
    return flipped;
  }

  // Return a valid alpha value [0,1] with all invalid values being set to 1
  function boundAlpha(a) {
    a = parseFloat(a);
    if (isNaN(a) || a < 0 || a > 1) {
      a = 1;
    }
    return a;
  }

  // Take input from [0, n] and return it as [0, 1]
  function bound01(n, max) {
    if (isOnePointZero(n)) n = "100%";
    var processPercent = isPercentage(n);
    n = Math.min(max, Math.max(0, parseFloat(n)));

    // Automatically convert percentage into number
    if (processPercent) {
      n = parseInt(n * max, 10) / 100;
    }

    // Handle floating point rounding errors
    if (Math.abs(n - max) < 0.000001) {
      return 1;
    }

    // Convert into [0, 1] range if it isn't already
    return n % max / parseFloat(max);
  }

  // Force a number between 0 and 1
  function clamp01(val) {
    return Math.min(1, Math.max(0, val));
  }

  // Parse a base-16 hex value into a base-10 integer
  function parseIntFromHex(val) {
    return parseInt(val, 16);
  }

  // Need to handle 1.0 as 100%, since once it is a number, there is no difference between it and 1
  // <http://stackoverflow.com/questions/7422072/javascript-how-to-detect-number-as-a-decimal-including-1-0>
  function isOnePointZero(n) {
    return typeof n == "string" && n.indexOf(".") != -1 && parseFloat(n) === 1;
  }

  // Check to see if string passed in is a percentage
  function isPercentage(n) {
    return typeof n === "string" && n.indexOf("%") != -1;
  }

  // Force a hex value to have 2 characters
  function pad2(c) {
    return c.length == 1 ? "0" + c : "" + c;
  }

  // Replace a decimal with it's percentage value
  function convertToPercentage(n) {
    if (n <= 1) {
      n = n * 100 + "%";
    }
    return n;
  }

  // Converts a decimal to a hex value
  function convertDecimalToHex(d) {
    return Math.round(parseFloat(d) * 255).toString(16);
  }
  // Converts a hex value to a decimal
  function convertHexToDecimal(h) {
    return parseIntFromHex(h) / 255;
  }
  var matchers = function () {
    // <http://www.w3.org/TR/css3-values/#integers>
    var CSS_INTEGER = "[-\\+]?\\d+%?";

    // <http://www.w3.org/TR/css3-values/#number-value>
    var CSS_NUMBER = "[-\\+]?\\d*\\.\\d+%?";

    // Allow positive/negative integer/number.  Don't capture the either/or, just the entire outcome.
    var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";

    // Actual matching.
    // Parentheses and commas are optional, but not required.
    // Whitespace can take the place of commas or opening paren
    var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
    var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
    return {
      CSS_UNIT: new RegExp(CSS_UNIT),
      rgb: new RegExp("rgb" + PERMISSIVE_MATCH3),
      rgba: new RegExp("rgba" + PERMISSIVE_MATCH4),
      hsl: new RegExp("hsl" + PERMISSIVE_MATCH3),
      hsla: new RegExp("hsla" + PERMISSIVE_MATCH4),
      hsv: new RegExp("hsv" + PERMISSIVE_MATCH3),
      hsva: new RegExp("hsva" + PERMISSIVE_MATCH4),
      hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
      hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
      hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
      hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/
    };
  }();

  // `isValidCSSUnit`
  // Take in a single string / number and check to see if it looks like a CSS unit
  // (see `matchers` above for definition).
  function isValidCSSUnit(color) {
    return !!matchers.CSS_UNIT.exec(color);
  }

  // `stringInputToObject`
  // Permissive string parsing.  Take in a number of formats, and output an object
  // based on detected format.  Returns `{ r, g, b }` or `{ h, s, l }` or `{ h, s, v}`
  function stringInputToObject(color) {
    color = color.replace(trimLeft, "").replace(trimRight, "").toLowerCase();
    var named = false;
    if (names[color]) {
      color = names[color];
      named = true;
    } else if (color == "transparent") {
      return {
        r: 0,
        g: 0,
        b: 0,
        a: 0,
        format: "name"
      };
    }

    // Try to match string input using regular expressions.
    // Keep most of the number bounding out of this function - don't worry about [0,1] or [0,100] or [0,360]
    // Just return an object and let the conversion functions handle that.
    // This way the result will be the same whether the tinycolor is initialized with string or object.
    var match;
    if (match = matchers.rgb.exec(color)) {
      return {
        r: match[1],
        g: match[2],
        b: match[3]
      };
    }
    if (match = matchers.rgba.exec(color)) {
      return {
        r: match[1],
        g: match[2],
        b: match[3],
        a: match[4]
      };
    }
    if (match = matchers.hsl.exec(color)) {
      return {
        h: match[1],
        s: match[2],
        l: match[3]
      };
    }
    if (match = matchers.hsla.exec(color)) {
      return {
        h: match[1],
        s: match[2],
        l: match[3],
        a: match[4]
      };
    }
    if (match = matchers.hsv.exec(color)) {
      return {
        h: match[1],
        s: match[2],
        v: match[3]
      };
    }
    if (match = matchers.hsva.exec(color)) {
      return {
        h: match[1],
        s: match[2],
        v: match[3],
        a: match[4]
      };
    }
    if (match = matchers.hex8.exec(color)) {
      return {
        r: parseIntFromHex(match[1]),
        g: parseIntFromHex(match[2]),
        b: parseIntFromHex(match[3]),
        a: convertHexToDecimal(match[4]),
        format: named ? "name" : "hex8"
      };
    }
    if (match = matchers.hex6.exec(color)) {
      return {
        r: parseIntFromHex(match[1]),
        g: parseIntFromHex(match[2]),
        b: parseIntFromHex(match[3]),
        format: named ? "name" : "hex"
      };
    }
    if (match = matchers.hex4.exec(color)) {
      return {
        r: parseIntFromHex(match[1] + "" + match[1]),
        g: parseIntFromHex(match[2] + "" + match[2]),
        b: parseIntFromHex(match[3] + "" + match[3]),
        a: convertHexToDecimal(match[4] + "" + match[4]),
        format: named ? "name" : "hex8"
      };
    }
    if (match = matchers.hex3.exec(color)) {
      return {
        r: parseIntFromHex(match[1] + "" + match[1]),
        g: parseIntFromHex(match[2] + "" + match[2]),
        b: parseIntFromHex(match[3] + "" + match[3]),
        format: named ? "name" : "hex"
      };
    }
    return false;
  }
  function validateWCAG2Parms(parms) {
    // return valid WCAG2 parms for isReadable.
    // If input parms are invalid, return {"level":"AA", "size":"small"}
    var level, size;
    parms = parms || {
      level: "AA",
      size: "small"
    };
    level = (parms.level || "AA").toUpperCase();
    size = (parms.size || "small").toLowerCase();
    if (level !== "AA" && level !== "AAA") {
      level = "AA";
    }
    if (size !== "small" && size !== "large") {
      size = "small";
    }
    return {
      level: level,
      size: size
    };
  }

  function _arrayLikeToArray(r, a) {
    (null == a || a > r.length) && (a = r.length);
    for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
    return n;
  }
  function _arrayWithHoles(r) {
    if (Array.isArray(r)) return r;
  }
  function _arrayWithoutHoles(r) {
    if (Array.isArray(r)) return _arrayLikeToArray(r);
  }
  function _assertClassBrand(e, t, n) {
    if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n;
    throw new TypeError("Private element is not present on this object");
  }
  function _assertThisInitialized$1(e) {
    if (undefined === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    return e;
  }
  function _callSuper(t, o, e) {
    return o = _getPrototypeOf$1(o), _possibleConstructorReturn(t, _isNativeReflectConstruct$1() ? Reflect.construct(o, e || [], _getPrototypeOf$1(t).constructor) : o.apply(t, e));
  }
  function _checkPrivateRedeclaration(e, t) {
    if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object");
  }
  function _classCallCheck(a, n) {
    if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function");
  }
  function _classPrivateFieldGet2(s, a) {
    return s.get(_assertClassBrand(s, a));
  }
  function _classPrivateFieldInitSpec(e, t, a) {
    _checkPrivateRedeclaration(e, t), t.set(e, a);
  }
  function _classPrivateFieldSet2(s, a, r) {
    return s.set(_assertClassBrand(s, a), r), r;
  }
  function _construct$1(t, e, r) {
    if (_isNativeReflectConstruct$1()) return Reflect.construct.apply(null, arguments);
    var o = [null];
    o.push.apply(o, e);
    var p = new (t.bind.apply(t, o))();
    return p;
  }
  function _defineProperties(e, r) {
    for (var t = 0; t < r.length; t++) {
      var o = r[t];
      o.enumerable = o.enumerable || false, o.configurable = true, "value" in o && (o.writable = true), Object.defineProperty(e, _toPropertyKey(o.key), o);
    }
  }
  function _createClass(e, r, t) {
    return r && _defineProperties(e.prototype, r), Object.defineProperty(e, "prototype", {
      writable: false
    }), e;
  }
  function _defineProperty(e, r, t) {
    return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, {
      value: t,
      enumerable: true,
      configurable: true,
      writable: true
    }) : e[r] = t, e;
  }
  function _get() {
    return _get = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) {
      var p = _superPropBase(e, t);
      if (p) {
        var n = Object.getOwnPropertyDescriptor(p, t);
        return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value;
      }
    }, _get.apply(null, arguments);
  }
  function _getPrototypeOf$1(t) {
    return _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) {
      return t.__proto__ || Object.getPrototypeOf(t);
    }, _getPrototypeOf$1(t);
  }
  function _inherits(t, e) {
    if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function");
    t.prototype = Object.create(e && e.prototype, {
      constructor: {
        value: t,
        writable: true,
        configurable: true
      }
    }), Object.defineProperty(t, "prototype", {
      writable: false
    }), e && _setPrototypeOf$1(t, e);
  }
  function _isNativeReflectConstruct$1() {
    try {
      var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    } catch (t) {}
    return (_isNativeReflectConstruct$1 = function () {
      return !!t;
    })();
  }
  function _iterableToArray(r) {
    if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r);
  }
  function _iterableToArrayLimit(r, l) {
    var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
    if (null != t) {
      var e,
        n,
        i,
        u,
        a = [],
        f = true,
        o = false;
      try {
        if (i = (t = t.call(r)).next, 0 === l) ; else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
      } catch (r) {
        o = true, n = r;
      } finally {
        try {
          if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
        } finally {
          if (o) throw n;
        }
      }
      return a;
    }
  }
  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function ownKeys(e, r) {
    var t = Object.keys(e);
    if (Object.getOwnPropertySymbols) {
      var o = Object.getOwnPropertySymbols(e);
      r && (o = o.filter(function (r) {
        return Object.getOwnPropertyDescriptor(e, r).enumerable;
      })), t.push.apply(t, o);
    }
    return t;
  }
  function _objectSpread2(e) {
    for (var r = 1; r < arguments.length; r++) {
      var t = null != arguments[r] ? arguments[r] : {};
      r % 2 ? ownKeys(Object(t), true).forEach(function (r) {
        _defineProperty(e, r, t[r]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) {
        Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r));
      });
    }
    return e;
  }
  function _possibleConstructorReturn(t, e) {
    if (e && ("object" == typeof e || "function" == typeof e)) return e;
    if (undefined !== e) throw new TypeError("Derived constructors may only return object or undefined");
    return _assertThisInitialized$1(t);
  }
  function _setPrototypeOf$1(t, e) {
    return _setPrototypeOf$1 = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) {
      return t.__proto__ = e, t;
    }, _setPrototypeOf$1(t, e);
  }
  function _slicedToArray(r, e) {
    return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest();
  }
  function _superPropBase(t, o) {
    for (; !{}.hasOwnProperty.call(t, o) && null !== (t = _getPrototypeOf$1(t)););
    return t;
  }
  function _superPropGet(t, o, e, r) {
    var p = _get(_getPrototypeOf$1(t.prototype ), o, e);
    return "function" == typeof p ? function (t) {
      return p.apply(e, t);
    } : p;
  }
  function _toConsumableArray(r) {
    return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread();
  }
  function _toPrimitive(t, r) {
    if ("object" != typeof t || !t) return t;
    var e = t[Symbol.toPrimitive];
    if (undefined !== e) {
      var i = e.call(t, r);
      if ("object" != typeof i) return i;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return ("string" === r ? String : Number)(t);
  }
  function _toPropertyKey(t) {
    var i = _toPrimitive(t, "string");
    return "symbol" == typeof i ? i : i + "";
  }
  function _typeof(o) {
    "@babel/helpers - typeof";

    return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
      return typeof o;
    } : function (o) {
      return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
    }, _typeof(o);
  }
  function _unsupportedIterableToArray(r, a) {
    if (r) {
      if ("string" == typeof r) return _arrayLikeToArray(r, a);
      var t = {}.toString.call(r).slice(8, -1);
      return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : undefined;
    }
  }

  var _materialDispose = function materialDispose(material) {
    if (material instanceof Array) {
      material.forEach(_materialDispose);
    } else {
      if (material.map) {
        material.map.dispose();
      }
      material.dispose();
    }
  };
  var _deallocate = function deallocate(obj) {
    if (obj.geometry) {
      obj.geometry.dispose();
    }
    if (obj.material) {
      _materialDispose(obj.material);
    }
    if (obj.texture) {
      obj.texture.dispose();
    }
    if (obj.children) {
      obj.children.forEach(_deallocate);
    }
  };
  var emptyObject = function emptyObject(obj) {
    while (obj.children.length) {
      var childObj = obj.children[0];
      obj.remove(childObj);
      _deallocate(childObj);
    }
  };

  var _dataBindAttr = /*#__PURE__*/new WeakMap();
  var _objBindAttr = /*#__PURE__*/new WeakMap();
  var ThreeDigest = /*#__PURE__*/function (_DataBindMapper) {
    function ThreeDigest(scene) {
      var _this;
      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        _ref$dataBindAttr = _ref.dataBindAttr,
        dataBindAttr = _ref$dataBindAttr === undefined ? '__data' : _ref$dataBindAttr,
        _ref$objBindAttr = _ref.objBindAttr,
        objBindAttr = _ref$objBindAttr === undefined ? '__threeObj' : _ref$objBindAttr;
      _classCallCheck(this, ThreeDigest);
      _this = _callSuper(this, ThreeDigest);
      _defineProperty(_this, "scene", undefined);
      _classPrivateFieldInitSpec(_this, _dataBindAttr, undefined);
      _classPrivateFieldInitSpec(_this, _objBindAttr, undefined);
      _this.scene = scene;
      _classPrivateFieldSet2(_dataBindAttr, _this, dataBindAttr);
      _classPrivateFieldSet2(_objBindAttr, _this, objBindAttr);
      _this.onRemoveObj(function () {});
      return _this;
    }
    _inherits(ThreeDigest, _DataBindMapper);
    return _createClass(ThreeDigest, [{
      key: "onCreateObj",
      value: function onCreateObj(fn) {
        var _this2 = this;
        _superPropGet(ThreeDigest, "onCreateObj", this)([function (d) {
          var obj = fn(d);
          d[_classPrivateFieldGet2(_objBindAttr, _this2)] = obj;
          obj[_classPrivateFieldGet2(_dataBindAttr, _this2)] = d;
          _this2.scene.add(obj);
          return obj;
        }]);
        return this;
      }
    }, {
      key: "onRemoveObj",
      value: function onRemoveObj(fn) {
        var _this3 = this;
        _superPropGet(ThreeDigest, "onRemoveObj", this)([function (obj, dId) {
          var d = _superPropGet(ThreeDigest, "getData", _this3)([obj]);
          fn(obj, dId);
          _this3.scene.remove(obj);
          emptyObject(obj);
          delete d[_classPrivateFieldGet2(_objBindAttr, _this3)];
        }]);
        return this;
      }
    }]);
  }(DataBindMapper);

  var colorStr2Hex = function colorStr2Hex(str) {
    return isNaN(str) ? parseInt(tinycolor(str).toHex(), 16) : str;
  };
  var colorAlpha = function colorAlpha(str) {
    return isNaN(str) ? tinycolor(str).getAlpha() : 1;
  };
  var autoColorScale = ordinal(schemePaired);

  // Autoset attribute colorField by colorByAccessor property
  // If an object has already a color, don't set it
  // Objects can be nodes or links
  function autoColorObjects(objects, colorByAccessor, colorField) {
    if (!colorByAccessor || typeof colorField !== 'string') return;
    objects.filter(function (obj) {
      return !obj[colorField];
    }).forEach(function (obj) {
      obj[colorField] = autoColorScale(colorByAccessor(obj));
    });
  }

  function getDagDepths (_ref, idAccessor) {
    var nodes = _ref.nodes,
      links = _ref.links;
    var _ref2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
      _ref2$nodeFilter = _ref2.nodeFilter,
      nodeFilter = _ref2$nodeFilter === undefined ? function () {
        return true;
      } : _ref2$nodeFilter,
      _ref2$onLoopError = _ref2.onLoopError,
      onLoopError = _ref2$onLoopError === undefined ? function (loopIds) {
        throw "Invalid DAG structure! Found cycle in node path: ".concat(loopIds.join(' -> '), ".");
      } : _ref2$onLoopError;
    // linked graph
    var graph = {};
    nodes.forEach(function (node) {
      return graph[idAccessor(node)] = {
        data: node,
        out: [],
        depth: -1,
        skip: !nodeFilter(node)
      };
    });
    links.forEach(function (_ref3) {
      var source = _ref3.source,
        target = _ref3.target;
      var sourceId = getNodeId(source);
      var targetId = getNodeId(target);
      if (!graph.hasOwnProperty(sourceId)) throw "Missing source node with id: ".concat(sourceId);
      if (!graph.hasOwnProperty(targetId)) throw "Missing target node with id: ".concat(targetId);
      var sourceNode = graph[sourceId];
      var targetNode = graph[targetId];
      sourceNode.out.push(targetNode);
      function getNodeId(node) {
        return _typeof(node) === 'object' ? idAccessor(node) : node;
      }
    });
    var foundLoops = [];
    traverse(Object.values(graph));
    var nodeDepths = Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.entries(graph).filter(function (_ref4) {
      var _ref5 = _slicedToArray(_ref4, 2),
        node = _ref5[1];
      return !node.skip;
    }).map(function (_ref6) {
      var _ref7 = _slicedToArray(_ref6, 2),
        id = _ref7[0],
        node = _ref7[1];
      return _defineProperty({}, id, node.depth);
    }))));
    return nodeDepths;
    function traverse(nodes) {
      var nodeStack = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var currentDepth = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      var _loop = function _loop() {
        var node = nodes[i];
        if (nodeStack.indexOf(node) !== -1) {
          var loop = [].concat(_toConsumableArray(nodeStack.slice(nodeStack.indexOf(node))), [node]).map(function (d) {
            return idAccessor(d.data);
          });
          if (!foundLoops.some(function (foundLoop) {
            return foundLoop.length === loop.length && foundLoop.every(function (id, idx) {
              return id === loop[idx];
            });
          })) {
            foundLoops.push(loop);
            onLoopError(loop);
          }
          return 1; // continue
        }
        if (currentDepth > node.depth) {
          // Don't unnecessarily revisit chunks of the graph
          node.depth = currentDepth;
          traverse(node.out, [].concat(_toConsumableArray(nodeStack), [node]), currentDepth + (node.skip ? 0 : 1));
        }
      };
      for (var i = 0, l = nodes.length; i < l; i++) {
        if (_loop()) continue;
      }
    }
  }

  var three$1 = window.THREE ? window.THREE // Prefer consumption from global THREE, if exists
  : {
    Group: three$2.Group,
    Mesh: three$2.Mesh,
    MeshLambertMaterial: three$2.MeshLambertMaterial,
    Color: three$2.Color,
    BufferGeometry: three$2.BufferGeometry,
    BufferAttribute: three$2.BufferAttribute,
    Matrix4: three$2.Matrix4,
    Vector3: three$2.Vector3,
    SphereGeometry: three$2.SphereGeometry,
    CylinderGeometry: three$2.CylinderGeometry,
    TubeGeometry: three$2.TubeGeometry,
    ConeGeometry: three$2.ConeGeometry,
    Line: three$2.Line,
    LineBasicMaterial: three$2.LineBasicMaterial,
    QuadraticBezierCurve3: three$2.QuadraticBezierCurve3,
    CubicBezierCurve3: three$2.CubicBezierCurve3,
    Box3: three$2.Box3
  };
  var ngraph = {
    graph: graph,
    forcelayout: forcelayout
  };

  //

  var DAG_LEVEL_NODE_RATIO = 2;

  // support multiple method names for backwards threejs compatibility
  var setAttributeFn = new three$1.BufferGeometry().setAttribute ? 'setAttribute' : 'addAttribute';
  var applyMatrix4Fn = new three$1.BufferGeometry().applyMatrix4 ? 'applyMatrix4' : 'applyMatrix';
  var ForceGraph = index$1({
    props: {
      jsonUrl: {
        onChange: function onChange(jsonUrl, state) {
          var _this = this;
          if (jsonUrl && !state.fetchingJson) {
            // Load data asynchronously
            state.fetchingJson = true;
            state.onLoading();
            fetch(jsonUrl).then(function (r) {
              return r.json();
            }).then(function (json) {
              state.fetchingJson = false;
              state.onFinishLoading(json);
              _this.graphData(json);
            });
          }
        },
        triggerUpdate: false
      },
      graphData: {
        "default": {
          nodes: [],
          links: []
        },
        onChange: function onChange(graphData, state) {
          state.engineRunning = false; // Pause simulation immediately
        }
      },
      numDimensions: {
        "default": 3,
        onChange: function onChange(numDim, state) {
          var chargeForce = state.d3ForceLayout.force('charge');
          // Increase repulsion on 3D mode for improved spatial separation
          if (chargeForce) {
            chargeForce.strength(numDim > 2 ? -60 : -30);
          }
          if (numDim < 3) {
            eraseDimension(state.graphData.nodes, 'z');
          }
          if (numDim < 2) {
            eraseDimension(state.graphData.nodes, 'y');
          }
          function eraseDimension(nodes, dim) {
            nodes.forEach(function (d) {
              delete d[dim]; // position
              delete d["v".concat(dim)]; // velocity
            });
          }
        }
      },
      dagMode: {
        onChange: function onChange(dagMode, state) {
          // td, bu, lr, rl, zin, zout, radialin, radialout
          !dagMode && state.forceEngine === 'd3' && (state.graphData.nodes || []).forEach(function (n) {
            return n.fx = n.fy = n.fz = undefined;
          }); // unfix nodes when disabling dag mode
        }
      },
      dagLevelDistance: {},
      dagNodeFilter: {
        "default": function _default(node) {
          return true;
        }
      },
      onDagError: {
        triggerUpdate: false
      },
      nodeRelSize: {
        "default": 4
      },
      // volume per val unit
      nodeId: {
        "default": 'id'
      },
      nodeVal: {
        "default": 'val'
      },
      nodeResolution: {
        "default": 8
      },
      // how many slice segments in the sphere's circumference
      nodeColor: {
        "default": 'color'
      },
      nodeAutoColorBy: {},
      nodeOpacity: {
        "default": 0.75
      },
      nodeVisibility: {
        "default": true
      },
      nodeThreeObject: {},
      nodeThreeObjectExtend: {
        "default": false
      },
      nodePositionUpdate: {
        triggerUpdate: false
      },
      // custom function to call for updating the node's position. Signature: (threeObj, { x, y, z}, node). If the function returns a truthy value, the regular node position update will not run.
      linkSource: {
        "default": 'source'
      },
      linkTarget: {
        "default": 'target'
      },
      linkVisibility: {
        "default": true
      },
      linkColor: {
        "default": 'color'
      },
      linkAutoColorBy: {},
      linkOpacity: {
        "default": 0.2
      },
      linkWidth: {},
      // Rounded to nearest decimal. For falsy values use dimensionless line with 1px regardless of distance.
      linkResolution: {
        "default": 6
      },
      // how many radial segments in each line tube's geometry
      linkCurvature: {
        "default": 0,
        triggerUpdate: false
      },
      // line curvature radius (0: straight, 1: semi-circle)
      linkCurveRotation: {
        "default": 0,
        triggerUpdate: false
      },
      // line curve rotation along the line axis (0: interection with XY plane, PI: upside down)
      linkMaterial: {},
      linkThreeObject: {},
      linkThreeObjectExtend: {
        "default": false
      },
      linkPositionUpdate: {
        triggerUpdate: false
      },
      // custom function to call for updating the link's position. Signature: (threeObj, { start: { x, y, z},  end: { x, y, z }}, link). If the function returns a truthy value, the regular link position update will not run.
      linkDirectionalArrowLength: {
        "default": 0
      },
      linkDirectionalArrowColor: {},
      linkDirectionalArrowRelPos: {
        "default": 0.5,
        triggerUpdate: false
      },
      // value between 0<>1 indicating the relative pos along the (exposed) line
      linkDirectionalArrowResolution: {
        "default": 8
      },
      // how many slice segments in the arrow's conic circumference
      linkDirectionalParticles: {
        "default": 0
      },
      // animate photons travelling in the link direction
      linkDirectionalParticleSpeed: {
        "default": 0.01,
        triggerUpdate: false
      },
      // in link length ratio per frame
      linkDirectionalParticleWidth: {
        "default": 0.5
      },
      linkDirectionalParticleColor: {},
      linkDirectionalParticleResolution: {
        "default": 4
      },
      // how many slice segments in the particle sphere's circumference
      forceEngine: {
        "default": 'd3'
      },
      // d3 or ngraph
      d3AlphaMin: {
        "default": 0
      },
      d3AlphaDecay: {
        "default": 0.0228,
        triggerUpdate: false,
        onChange: function onChange(alphaDecay, state) {
          state.d3ForceLayout.alphaDecay(alphaDecay);
        }
      },
      d3AlphaTarget: {
        "default": 0,
        triggerUpdate: false,
        onChange: function onChange(alphaTarget, state) {
          state.d3ForceLayout.alphaTarget(alphaTarget);
        }
      },
      d3VelocityDecay: {
        "default": 0.4,
        triggerUpdate: false,
        onChange: function onChange(velocityDecay, state) {
          state.d3ForceLayout.velocityDecay(velocityDecay);
        }
      },
      ngraphPhysics: {
        "default": {
          // defaults from https://github.com/anvaka/ngraph.physics.simulator/blob/master/index.js
          timeStep: 20,
          gravity: -1.2,
          theta: 0.8,
          springLength: 30,
          springCoefficient: 0.0008,
          dragCoefficient: 0.02
        }
      },
      warmupTicks: {
        "default": 0,
        triggerUpdate: false
      },
      // how many times to tick the force engine at init before starting to render
      cooldownTicks: {
        "default": Infinity,
        triggerUpdate: false
      },
      cooldownTime: {
        "default": 15000,
        triggerUpdate: false
      },
      // ms
      onLoading: {
        "default": function _default() {},
        triggerUpdate: false
      },
      onFinishLoading: {
        "default": function _default() {},
        triggerUpdate: false
      },
      onUpdate: {
        "default": function _default() {},
        triggerUpdate: false
      },
      onFinishUpdate: {
        "default": function _default() {},
        triggerUpdate: false
      },
      onEngineTick: {
        "default": function _default() {},
        triggerUpdate: false
      },
      onEngineStop: {
        "default": function _default() {},
        triggerUpdate: false
      }
    },
    methods: {
      refresh: function refresh(state) {
        state._flushObjects = true;
        state._rerender();
        return this;
      },
      // Expose d3 forces for external manipulation
      d3Force: function d3Force(state, forceName, forceFn) {
        if (forceFn === undefined) {
          return state.d3ForceLayout.force(forceName); // Force getter
        }
        state.d3ForceLayout.force(forceName, forceFn); // Force setter
        return this;
      },
      d3ReheatSimulation: function d3ReheatSimulation(state) {
        state.d3ForceLayout.alpha(1);
        this.resetCountdown();
        return this;
      },
      // reset cooldown state
      resetCountdown: function resetCountdown(state) {
        state.cntTicks = 0;
        state.startTickTime = new Date();
        state.engineRunning = true;
        return this;
      },
      tickFrame: function tickFrame(state) {
        var isD3Sim = state.forceEngine !== 'ngraph';
        if (state.engineRunning) {
          layoutTick();
        }
        updateArrows();
        updatePhotons();
        return this;

        //

        function layoutTick() {
          if (++state.cntTicks > state.cooldownTicks || new Date() - state.startTickTime > state.cooldownTime || isD3Sim && state.d3AlphaMin > 0 && state.d3ForceLayout.alpha() < state.d3AlphaMin) {
            state.engineRunning = false; // Stop ticking graph
            state.onEngineStop();
          } else {
            state.layout[isD3Sim ? 'tick' : 'step'](); // Tick it
            state.onEngineTick();
          }
          var nodeThreeObjectExtendAccessor = index(state.nodeThreeObjectExtend);

          // Update nodes position
          state.nodeDataMapper.entries().forEach(function (_ref) {
            var _ref2 = _slicedToArray(_ref, 2),
              node = _ref2[0],
              obj = _ref2[1];
            if (!obj) return;
            var pos = isD3Sim ? node : state.layout.getNodePosition(node[state.nodeId]);
            var extendedObj = nodeThreeObjectExtendAccessor(node);
            if (!state.nodePositionUpdate || !state.nodePositionUpdate(extendedObj ? obj.children[0] : obj, {
              x: pos.x,
              y: pos.y,
              z: pos.z
            }, node) // pass child custom object if extending the default
            || extendedObj) {
              obj.position.x = pos.x;
              obj.position.y = pos.y || 0;
              obj.position.z = pos.z || 0;
            }
          });

          // Update links position
          var linkWidthAccessor = index(state.linkWidth);
          var linkCurvatureAccessor = index(state.linkCurvature);
          var linkCurveRotationAccessor = index(state.linkCurveRotation);
          var linkThreeObjectExtendAccessor = index(state.linkThreeObjectExtend);
          state.linkDataMapper.entries().forEach(function (_ref3) {
            var _ref4 = _slicedToArray(_ref3, 2),
              link = _ref4[0],
              lineObj = _ref4[1];
            if (!lineObj) return;
            var pos = isD3Sim ? link : state.layout.getLinkPosition(state.layout.graph.getLink(link.source, link.target).id);
            var start = pos[isD3Sim ? 'source' : 'from'];
            var end = pos[isD3Sim ? 'target' : 'to'];
            if (!start || !end || !start.hasOwnProperty('x') || !end.hasOwnProperty('x')) return; // skip invalid link

            calcLinkCurve(link); // calculate link curve for all links, including custom replaced, so it can be used in directional functionality

            var extendedObj = linkThreeObjectExtendAccessor(link);
            if (state.linkPositionUpdate && state.linkPositionUpdate(extendedObj ? lineObj.children[1] : lineObj,
            // pass child custom object if extending the default
            {
              start: {
                x: start.x,
                y: start.y,
                z: start.z
              },
              end: {
                x: end.x,
                y: end.y,
                z: end.z
              }
            }, link) && !extendedObj) {
              // exit if successfully custom updated position of non-extended obj
              return;
            }
            var curveResolution = 30; // # line segments
            var curve = link.__curve;

            // select default line obj if it's an extended group
            var line = lineObj.children.length ? lineObj.children[0] : lineObj;
            if (line.type === 'Line') {
              // Update line geometry
              if (!curve) {
                // straight line
                var linePos = line.geometry.getAttribute('position');
                if (!linePos || !linePos.array || linePos.array.length !== 6) {
                  line.geometry[setAttributeFn]('position', linePos = new three$1.BufferAttribute(new Float32Array(2 * 3), 3));
                }
                linePos.array[0] = start.x;
                linePos.array[1] = start.y || 0;
                linePos.array[2] = start.z || 0;
                linePos.array[3] = end.x;
                linePos.array[4] = end.y || 0;
                linePos.array[5] = end.z || 0;
                linePos.needsUpdate = true;
              } else {
                // bezier curve line
                var curvePnts = curve.getPoints(curveResolution);
                // resize buffer if needed
                if (line.geometry.getAttribute('position').array.length !== curvePnts.length * 3) {
                  line.geometry[setAttributeFn]('position', new three$1.BufferAttribute(new Float32Array(curvePnts.length * 3), 3));
                }
                line.geometry.setFromPoints(curvePnts);
              }
              line.geometry.computeBoundingSphere();
            } else if (line.type === 'Mesh') {
              // Update cylinder geometry

              if (!curve) {
                // straight tube
                if (!line.geometry.type.match(/^Cylinder(Buffer)?Geometry$/)) {
                  var linkWidth = Math.ceil(linkWidthAccessor(link) * 10) / 10;
                  var r = linkWidth / 2;
                  var geometry = new three$1.CylinderGeometry(r, r, 1, state.linkResolution, 1, false);
                  geometry[applyMatrix4Fn](new three$1.Matrix4().makeTranslation(0, 1 / 2, 0));
                  geometry[applyMatrix4Fn](new three$1.Matrix4().makeRotationX(Math.PI / 2));
                  line.geometry.dispose();
                  line.geometry = geometry;
                }
                var vStart = new three$1.Vector3(start.x, start.y || 0, start.z || 0);
                var vEnd = new three$1.Vector3(end.x, end.y || 0, end.z || 0);
                var distance = vStart.distanceTo(vEnd);
                line.position.x = vStart.x;
                line.position.y = vStart.y;
                line.position.z = vStart.z;
                line.scale.z = distance;
                line.parent.localToWorld(vEnd); // lookAt requires world coords
                line.lookAt(vEnd);
              } else {
                // curved tube
                if (!line.geometry.type.match(/^Tube(Buffer)?Geometry$/)) {
                  // reset object positioning
                  line.position.set(0, 0, 0);
                  line.rotation.set(0, 0, 0);
                  line.scale.set(1, 1, 1);
                }
                var _linkWidth = Math.ceil(linkWidthAccessor(link) * 10) / 10;
                var _r = _linkWidth / 2;
                var _geometry = new three$1.TubeGeometry(curve, curveResolution, _r, state.linkResolution, false);
                line.geometry.dispose();
                line.geometry = _geometry;
              }
            }
          });

          //

          function calcLinkCurve(link) {
            var pos = isD3Sim ? link : state.layout.getLinkPosition(state.layout.graph.getLink(link.source, link.target).id);
            var start = pos[isD3Sim ? 'source' : 'from'];
            var end = pos[isD3Sim ? 'target' : 'to'];
            if (!start || !end || !start.hasOwnProperty('x') || !end.hasOwnProperty('x')) return; // skip invalid link

            var curvature = linkCurvatureAccessor(link);
            if (!curvature) {
              link.__curve = null; // Straight line
            } else {
              // bezier curve line (only for line types)
              var vStart = new three$1.Vector3(start.x, start.y || 0, start.z || 0);
              var vEnd = new three$1.Vector3(end.x, end.y || 0, end.z || 0);
              var l = vStart.distanceTo(vEnd); // line length

              var curve;
              var curveRotation = linkCurveRotationAccessor(link);
              if (l > 0) {
                var dx = end.x - start.x;
                var dy = end.y - start.y || 0;
                var vLine = new three$1.Vector3().subVectors(vEnd, vStart);
                var cp = vLine.clone().multiplyScalar(curvature).cross(dx !== 0 || dy !== 0 ? new three$1.Vector3(0, 0, 1) : new three$1.Vector3(0, 1, 0)) // avoid cross-product of parallel vectors (prefer Z, fallback to Y)
                .applyAxisAngle(vLine.normalize(), curveRotation) // rotate along line axis according to linkCurveRotation
                .add(new three$1.Vector3().addVectors(vStart, vEnd).divideScalar(2));
                curve = new three$1.QuadraticBezierCurve3(vStart, cp, vEnd);
              } else {
                // Same point, draw a loop
                var d = curvature * 70;
                var endAngle = -curveRotation; // Rotate clockwise (from Z angle perspective)
                var startAngle = endAngle + Math.PI / 2;
                curve = new three$1.CubicBezierCurve3(vStart, new three$1.Vector3(d * Math.cos(startAngle), d * Math.sin(startAngle), 0).add(vStart), new three$1.Vector3(d * Math.cos(endAngle), d * Math.sin(endAngle), 0).add(vStart), vEnd);
              }
              link.__curve = curve;
            }
          }
        }
        function updateArrows() {
          // update link arrow position
          var arrowRelPosAccessor = index(state.linkDirectionalArrowRelPos);
          var arrowLengthAccessor = index(state.linkDirectionalArrowLength);
          var nodeValAccessor = index(state.nodeVal);
          state.arrowDataMapper.entries().forEach(function (_ref5) {
            var _ref6 = _slicedToArray(_ref5, 2),
              link = _ref6[0],
              arrowObj = _ref6[1];
            if (!arrowObj) return;
            var pos = isD3Sim ? link : state.layout.getLinkPosition(state.layout.graph.getLink(link.source, link.target).id);
            var start = pos[isD3Sim ? 'source' : 'from'];
            var end = pos[isD3Sim ? 'target' : 'to'];
            if (!start || !end || !start.hasOwnProperty('x') || !end.hasOwnProperty('x')) return; // skip invalid link

            var startR = Math.cbrt(Math.max(0, nodeValAccessor(start) || 1)) * state.nodeRelSize;
            var endR = Math.cbrt(Math.max(0, nodeValAccessor(end) || 1)) * state.nodeRelSize;
            var arrowLength = arrowLengthAccessor(link);
            var arrowRelPos = arrowRelPosAccessor(link);
            var getPosAlongLine = link.__curve ? function (t) {
              return link.__curve.getPoint(t);
            } // interpolate along bezier curve
            : function (t) {
              // straight line: interpolate linearly
              var iplt = function iplt(dim, start, end, t) {
                return start[dim] + (end[dim] - start[dim]) * t || 0;
              };
              return {
                x: iplt('x', start, end, t),
                y: iplt('y', start, end, t),
                z: iplt('z', start, end, t)
              };
            };
            var lineLen = link.__curve ? link.__curve.getLength() : Math.sqrt(['x', 'y', 'z'].map(function (dim) {
              return Math.pow((end[dim] || 0) - (start[dim] || 0), 2);
            }).reduce(function (acc, v) {
              return acc + v;
            }, 0));
            var posAlongLine = startR + arrowLength + (lineLen - startR - endR - arrowLength) * arrowRelPos;
            var arrowHead = getPosAlongLine(posAlongLine / lineLen);
            var arrowTail = getPosAlongLine((posAlongLine - arrowLength) / lineLen);
            ['x', 'y', 'z'].forEach(function (dim) {
              return arrowObj.position[dim] = arrowTail[dim];
            });
            var headVec = _construct$1(three$1.Vector3, _toConsumableArray(['x', 'y', 'z'].map(function (c) {
              return arrowHead[c];
            })));
            arrowObj.parent.localToWorld(headVec); // lookAt requires world coords
            arrowObj.lookAt(headVec);
          });
        }
        function updatePhotons() {
          // update link particle positions
          var particleSpeedAccessor = index(state.linkDirectionalParticleSpeed);
          state.graphData.links.forEach(function (link) {
            var photonsObj = state.particlesDataMapper.getObj(link);
            var cyclePhotons = photonsObj && photonsObj.children;
            var singleHopPhotons = link.__singleHopPhotonsObj && link.__singleHopPhotonsObj.children;
            if ((!singleHopPhotons || !singleHopPhotons.length) && (!cyclePhotons || !cyclePhotons.length)) return;
            var pos = isD3Sim ? link : state.layout.getLinkPosition(state.layout.graph.getLink(link.source, link.target).id);
            var start = pos[isD3Sim ? 'source' : 'from'];
            var end = pos[isD3Sim ? 'target' : 'to'];
            if (!start || !end || !start.hasOwnProperty('x') || !end.hasOwnProperty('x')) return; // skip invalid link

            var particleSpeed = particleSpeedAccessor(link);
            var getPhotonPos = link.__curve ? function (t) {
              return link.__curve.getPoint(t);
            } // interpolate along bezier curve
            : function (t) {
              // straight line: interpolate linearly
              var iplt = function iplt(dim, start, end, t) {
                return start[dim] + (end[dim] - start[dim]) * t || 0;
              };
              return {
                x: iplt('x', start, end, t),
                y: iplt('y', start, end, t),
                z: iplt('z', start, end, t)
              };
            };
            var photons = [].concat(_toConsumableArray(cyclePhotons || []), _toConsumableArray(singleHopPhotons || []));
            photons.forEach(function (photon, idx) {
              var singleHop = photon.parent.__linkThreeObjType === 'singleHopPhotons';
              if (!photon.hasOwnProperty('__progressRatio')) {
                photon.__progressRatio = singleHop ? 0 : idx / cyclePhotons.length;
              }
              photon.__progressRatio += particleSpeed;
              if (photon.__progressRatio >= 1) {
                if (!singleHop) {
                  photon.__progressRatio = photon.__progressRatio % 1;
                } else {
                  // remove particle
                  photon.parent.remove(photon);
                  emptyObject(photon);
                  return;
                }
              }
              var photonPosRatio = photon.__progressRatio;
              var pos = getPhotonPos(photonPosRatio);
              ['x', 'y', 'z'].forEach(function (dim) {
                return photon.position[dim] = pos[dim];
              });
            });
          });
        }
      },
      emitParticle: function emitParticle(state, link) {
        if (link && state.graphData.links.includes(link)) {
          if (!link.__singleHopPhotonsObj) {
            var obj = new three$1.Group();
            obj.__linkThreeObjType = 'singleHopPhotons';
            link.__singleHopPhotonsObj = obj;
            state.graphScene.add(obj);
          }
          var particleWidthAccessor = index(state.linkDirectionalParticleWidth);
          var photonR = Math.ceil(particleWidthAccessor(link) * 10) / 10 / 2;
          var numSegments = state.linkDirectionalParticleResolution;
          var particleGeometry = new three$1.SphereGeometry(photonR, numSegments, numSegments);
          var linkColorAccessor = index(state.linkColor);
          var particleColorAccessor = index(state.linkDirectionalParticleColor);
          var photonColor = particleColorAccessor(link) || linkColorAccessor(link) || '#f0f0f0';
          var materialColor = new three$1.Color(colorStr2Hex(photonColor));
          var opacity = state.linkOpacity * 3;
          var particleMaterial = new three$1.MeshLambertMaterial({
            color: materialColor,
            transparent: true,
            opacity: opacity
          });

          // add a single hop particle
          link.__singleHopPhotonsObj.add(new three$1.Mesh(particleGeometry, particleMaterial));
        }
        return this;
      },
      getGraphBbox: function getGraphBbox(state) {
        var nodeFilter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {
          return true;
        };
        if (!state.initialised) return null;

        // recursively collect all nested geometries bboxes
        var bboxes = function getBboxes(obj) {
          var bboxes = [];
          if (obj.geometry) {
            obj.geometry.computeBoundingBox();
            var box = new three$1.Box3();
            box.copy(obj.geometry.boundingBox).applyMatrix4(obj.matrixWorld);
            bboxes.push(box);
          }
          return bboxes.concat.apply(bboxes, _toConsumableArray((obj.children || []).filter(function (obj) {
            return !obj.hasOwnProperty('__graphObjType') || obj.__graphObjType === 'node' && nodeFilter(obj.__data);
          } // exclude filtered out nodes
          ).map(getBboxes)));
        }(state.graphScene);
        if (!bboxes.length) return null;

        // extract global x,y,z min/max
        return Object.assign.apply(Object, _toConsumableArray(['x', 'y', 'z'].map(function (c) {
          return _defineProperty({}, c, [min(bboxes, function (bb) {
            return bb.min[c];
          }), max(bboxes, function (bb) {
            return bb.max[c];
          })]);
        })));
      }
    },
    stateInit: function stateInit() {
      return {
        d3ForceLayout: forceSimulation().force('link', forceLink()).force('charge', forceManyBody()).force('center', forceCenter()).force('dagRadial', null).stop(),
        engineRunning: false
      };
    },
    init: function init(threeObj, state) {
      // Main three object to manipulate
      state.graphScene = threeObj;
      state.nodeDataMapper = new ThreeDigest(threeObj, {
        objBindAttr: '__threeObj'
      });
      state.linkDataMapper = new ThreeDigest(threeObj, {
        objBindAttr: '__lineObj'
      });
      state.arrowDataMapper = new ThreeDigest(threeObj, {
        objBindAttr: '__arrowObj'
      });
      state.particlesDataMapper = new ThreeDigest(threeObj, {
        objBindAttr: '__photonsObj'
      });
    },
    update: function update(state, changedProps) {
      var hasAnyPropChanged = function hasAnyPropChanged(propList) {
        return propList.some(function (p) {
          return changedProps.hasOwnProperty(p);
        });
      };
      state.engineRunning = false; // pause simulation
      typeof state.onUpdate === "function" && state.onUpdate();
      if (state.nodeAutoColorBy !== null && hasAnyPropChanged(['nodeAutoColorBy', 'graphData', 'nodeColor'])) {
        // Auto add color to uncolored nodes
        autoColorObjects(state.graphData.nodes, index(state.nodeAutoColorBy), state.nodeColor);
      }
      if (state.linkAutoColorBy !== null && hasAnyPropChanged(['linkAutoColorBy', 'graphData', 'linkColor'])) {
        // Auto add color to uncolored links
        autoColorObjects(state.graphData.links, index(state.linkAutoColorBy), state.linkColor);
      }

      // Digest nodes WebGL objects
      if (state._flushObjects || hasAnyPropChanged(['graphData', 'nodeThreeObject', 'nodeThreeObjectExtend', 'nodeVal', 'nodeColor', 'nodeVisibility', 'nodeRelSize', 'nodeResolution', 'nodeOpacity'])) {
        var customObjectAccessor = index(state.nodeThreeObject);
        var customObjectExtendAccessor = index(state.nodeThreeObjectExtend);
        var valAccessor = index(state.nodeVal);
        var colorAccessor = index(state.nodeColor);
        var visibilityAccessor = index(state.nodeVisibility);
        var sphereGeometries = {}; // indexed by node value
        var sphereMaterials = {}; // indexed by color

        if (state._flushObjects || hasAnyPropChanged([
        // recreate objects if any of these props have changed
        'nodeThreeObject', 'nodeThreeObjectExtend'])) state.nodeDataMapper.clear();
        state.nodeDataMapper.onCreateObj(function (node) {
          var customObj = customObjectAccessor(node);
          var extendObj = customObjectExtendAccessor(node);
          if (customObj && state.nodeThreeObject === customObj) {
            // clone object if it's a shared object among all nodes
            customObj = customObj.clone();
          }
          var obj;
          if (customObj && !extendObj) {
            obj = customObj;
          } else {
            // Add default object (sphere mesh)
            obj = new three$1.Mesh();
            obj.__graphDefaultObj = true;
            if (customObj && extendObj) {
              obj.add(customObj); // extend default with custom
            }
          }
          obj.__graphObjType = 'node'; // Add object type

          return obj;
        }).onUpdateObj(function (obj, node) {
          if (obj.__graphDefaultObj) {
            // bypass internal updates for custom node objects
            var val = valAccessor(node) || 1;
            var radius = Math.cbrt(val) * state.nodeRelSize;
            var numSegments = state.nodeResolution;
            if (!obj.geometry.type.match(/^Sphere(Buffer)?Geometry$/) || obj.geometry.parameters.radius !== radius || obj.geometry.parameters.widthSegments !== numSegments) {
              if (!sphereGeometries.hasOwnProperty(val)) {
                sphereGeometries[val] = new three$1.SphereGeometry(radius, numSegments, numSegments);
              }
              obj.geometry.dispose();
              obj.geometry = sphereGeometries[val];
            }
            var color = colorAccessor(node);
            var materialColor = new three$1.Color(colorStr2Hex(color || '#ffffaa'));
            var opacity = state.nodeOpacity * colorAlpha(color);
            if (obj.material.type !== 'MeshLambertMaterial' || !obj.material.color.equals(materialColor) || obj.material.opacity !== opacity) {
              if (!sphereMaterials.hasOwnProperty(color)) {
                sphereMaterials[color] = new three$1.MeshLambertMaterial({
                  color: materialColor,
                  transparent: true,
                  opacity: opacity
                });
              }
              obj.material.dispose();
              obj.material = sphereMaterials[color];
            }
          }
        }).digest(state.graphData.nodes.filter(visibilityAccessor));
      }

      // Digest links WebGL objects
      if (state._flushObjects || hasAnyPropChanged(['graphData', 'linkThreeObject', 'linkThreeObjectExtend', 'linkMaterial', 'linkColor', 'linkWidth', 'linkVisibility', 'linkResolution', 'linkOpacity', 'linkDirectionalArrowLength', 'linkDirectionalArrowColor', 'linkDirectionalArrowResolution', 'linkDirectionalParticles', 'linkDirectionalParticleWidth', 'linkDirectionalParticleColor', 'linkDirectionalParticleResolution'])) {
        var _customObjectAccessor = index(state.linkThreeObject);
        var _customObjectExtendAccessor = index(state.linkThreeObjectExtend);
        var customMaterialAccessor = index(state.linkMaterial);
        var _visibilityAccessor = index(state.linkVisibility);
        var _colorAccessor = index(state.linkColor);
        var widthAccessor = index(state.linkWidth);
        var cylinderGeometries = {}; // indexed by link width
        var lambertLineMaterials = {}; // for cylinder objects, indexed by link color
        var basicLineMaterials = {}; // for line objects, indexed by link color

        var visibleLinks = state.graphData.links.filter(_visibilityAccessor);

        // lines digest cycle
        if (state._flushObjects || hasAnyPropChanged([
        // recreate objects if any of these props have changed
        'linkThreeObject', 'linkThreeObjectExtend', 'linkWidth'])) state.linkDataMapper.clear();
        state.linkDataMapper.onRemoveObj(function (obj) {
          // remove trailing single photons
          var singlePhotonsObj = obj.__data && obj.__data.__singleHopPhotonsObj;
          if (singlePhotonsObj) {
            singlePhotonsObj.parent.remove(singlePhotonsObj);
            emptyObject(singlePhotonsObj);
            delete obj.__data.__singleHopPhotonsObj;
          }
        }).onCreateObj(function (link) {
          var customObj = _customObjectAccessor(link);
          var extendObj = _customObjectExtendAccessor(link);
          if (customObj && state.linkThreeObject === customObj) {
            // clone object if it's a shared object among all links
            customObj = customObj.clone();
          }
          var defaultObj;
          if (!customObj || extendObj) {
            // construct default line obj
            var useCylinder = !!widthAccessor(link);
            if (useCylinder) {
              defaultObj = new three$1.Mesh();
            } else {
              // Use plain line (constant width)
              var lineGeometry = new three$1.BufferGeometry();
              lineGeometry[setAttributeFn]('position', new three$1.BufferAttribute(new Float32Array(2 * 3), 3));
              defaultObj = new three$1.Line(lineGeometry);
            }
          }
          var obj;
          if (!customObj) {
            obj = defaultObj;
            obj.__graphDefaultObj = true;
          } else {
            if (!extendObj) {
              // use custom object
              obj = customObj;
            } else {
              // extend default with custom in a group
              obj = new three$1.Group();
              obj.__graphDefaultObj = true;
              obj.add(defaultObj);
              obj.add(customObj);
            }
          }
          obj.renderOrder = 10; // Prevent visual glitches of dark lines on top of nodes by rendering them last

          obj.__graphObjType = 'link'; // Add object type

          return obj;
        }).onUpdateObj(function (updObj, link) {
          if (updObj.__graphDefaultObj) {
            // bypass internal updates for custom link objects
            // select default object if it's an extended group
            var obj = updObj.children.length ? updObj.children[0] : updObj;
            var linkWidth = Math.ceil(widthAccessor(link) * 10) / 10;
            var useCylinder = !!linkWidth;
            if (useCylinder) {
              var r = linkWidth / 2;
              var numSegments = state.linkResolution;
              if (!obj.geometry.type.match(/^Cylinder(Buffer)?Geometry$/) || obj.geometry.parameters.radiusTop !== r || obj.geometry.parameters.radialSegments !== numSegments) {
                if (!cylinderGeometries.hasOwnProperty(linkWidth)) {
                  var geometry = new three$1.CylinderGeometry(r, r, 1, numSegments, 1, false);
                  geometry[applyMatrix4Fn](new three$1.Matrix4().makeTranslation(0, 1 / 2, 0));
                  geometry[applyMatrix4Fn](new three$1.Matrix4().makeRotationX(Math.PI / 2));
                  cylinderGeometries[linkWidth] = geometry;
                }
                obj.geometry.dispose();
                obj.geometry = cylinderGeometries[linkWidth];
              }
            }
            var customMaterial = customMaterialAccessor(link);
            if (customMaterial) {
              obj.material = customMaterial;
            } else {
              var color = _colorAccessor(link);
              var materialColor = new three$1.Color(colorStr2Hex(color || '#f0f0f0'));
              var opacity = state.linkOpacity * colorAlpha(color);
              var materialType = useCylinder ? 'MeshLambertMaterial' : 'LineBasicMaterial';
              if (obj.material.type !== materialType || !obj.material.color.equals(materialColor) || obj.material.opacity !== opacity) {
                var lineMaterials = useCylinder ? lambertLineMaterials : basicLineMaterials;
                if (!lineMaterials.hasOwnProperty(color)) {
                  lineMaterials[color] = new three$1[materialType]({
                    color: materialColor,
                    transparent: opacity < 1,
                    opacity: opacity,
                    depthWrite: opacity >= 1 // Prevent transparency issues
                  });
                }
                obj.material.dispose();
                obj.material = lineMaterials[color];
              }
            }
          }
        }).digest(visibleLinks);

        // Arrows digest cycle
        if (state.linkDirectionalArrowLength || changedProps.hasOwnProperty('linkDirectionalArrowLength')) {
          var arrowLengthAccessor = index(state.linkDirectionalArrowLength);
          var arrowColorAccessor = index(state.linkDirectionalArrowColor);
          state.arrowDataMapper.onCreateObj(function () {
            var obj = new three$1.Mesh(undefined, new three$1.MeshLambertMaterial({
              transparent: true
            }));
            obj.__linkThreeObjType = 'arrow'; // Add object type

            return obj;
          }).onUpdateObj(function (obj, link) {
            var arrowLength = arrowLengthAccessor(link);
            var numSegments = state.linkDirectionalArrowResolution;
            if (!obj.geometry.type.match(/^Cone(Buffer)?Geometry$/) || obj.geometry.parameters.height !== arrowLength || obj.geometry.parameters.radialSegments !== numSegments) {
              var coneGeometry = new three$1.ConeGeometry(arrowLength * 0.25, arrowLength, numSegments);
              // Correct orientation
              coneGeometry.translate(0, arrowLength / 2, 0);
              coneGeometry.rotateX(Math.PI / 2);
              obj.geometry.dispose();
              obj.geometry = coneGeometry;
            }
            var arrowColor = arrowColorAccessor(link) || _colorAccessor(link) || '#f0f0f0';
            obj.material.color = new three$1.Color(colorStr2Hex(arrowColor));
            obj.material.opacity = state.linkOpacity * 3 * colorAlpha(arrowColor);
          }).digest(visibleLinks.filter(arrowLengthAccessor));
        }

        // Photon particles digest cycle
        if (state.linkDirectionalParticles || changedProps.hasOwnProperty('linkDirectionalParticles')) {
          var particlesAccessor = index(state.linkDirectionalParticles);
          var particleWidthAccessor = index(state.linkDirectionalParticleWidth);
          var particleColorAccessor = index(state.linkDirectionalParticleColor);
          var particleMaterials = {}; // indexed by link color
          var particleGeometries = {}; // indexed by particle width

          state.particlesDataMapper.onCreateObj(function () {
            var obj = new three$1.Group();
            obj.__linkThreeObjType = 'photons'; // Add object type

            obj.__photonDataMapper = new ThreeDigest(obj);
            return obj;
          }).onUpdateObj(function (obj, link) {
            var numPhotons = Math.round(Math.abs(particlesAccessor(link)));
            var curPhoton = !!obj.children.length && obj.children[0];
            var photonR = Math.ceil(particleWidthAccessor(link) * 10) / 10 / 2;
            var numSegments = state.linkDirectionalParticleResolution;
            var particleGeometry;
            if (curPhoton && curPhoton.geometry.parameters.radius === photonR && curPhoton.geometry.parameters.widthSegments === numSegments) {
              particleGeometry = curPhoton.geometry;
            } else {
              if (!particleGeometries.hasOwnProperty(photonR)) {
                particleGeometries[photonR] = new three$1.SphereGeometry(photonR, numSegments, numSegments);
              }
              particleGeometry = particleGeometries[photonR];
              curPhoton && curPhoton.geometry.dispose();
            }
            var photonColor = particleColorAccessor(link) || _colorAccessor(link) || '#f0f0f0';
            var materialColor = new three$1.Color(colorStr2Hex(photonColor));
            var opacity = state.linkOpacity * 3;
            var particleMaterial;
            if (curPhoton && curPhoton.material.color.equals(materialColor) && curPhoton.material.opacity === opacity) {
              particleMaterial = curPhoton.material;
            } else {
              if (!particleMaterials.hasOwnProperty(photonColor)) {
                particleMaterials[photonColor] = new three$1.MeshLambertMaterial({
                  color: materialColor,
                  transparent: true,
                  opacity: opacity
                });
              }
              particleMaterial = particleMaterials[photonColor];
              curPhoton && curPhoton.material.dispose();
            }

            // digest cycle for each photon
            obj.__photonDataMapper.id(function (d) {
              return d.idx;
            }).onCreateObj(function () {
              return new three$1.Mesh(particleGeometry, particleMaterial);
            }).onUpdateObj(function (obj) {
              obj.geometry = particleGeometry;
              obj.material = particleMaterial;
            }).digest(_toConsumableArray(new Array(numPhotons)).map(function (_, idx) {
              return {
                idx: idx
              };
            }));
          }).digest(visibleLinks.filter(particlesAccessor));
        }
      }
      state._flushObjects = false; // reset objects refresh flag

      // simulation engine
      if (hasAnyPropChanged(['graphData', 'nodeId', 'linkSource', 'linkTarget', 'numDimensions', 'forceEngine', 'dagMode', 'dagNodeFilter', 'dagLevelDistance'])) {
        state.engineRunning = false; // Pause simulation

        // parse links
        state.graphData.links.forEach(function (link) {
          link.source = link[state.linkSource];
          link.target = link[state.linkTarget];
        });

        // Feed data to force-directed layout
        var isD3Sim = state.forceEngine !== 'ngraph';
        var layout;
        if (isD3Sim) {
          // D3-force
          (layout = state.d3ForceLayout).stop().alpha(1) // re-heat the simulation
          .numDimensions(state.numDimensions).nodes(state.graphData.nodes);

          // add links (if link force is still active)
          var linkForce = state.d3ForceLayout.force('link');
          if (linkForce) {
            linkForce.id(function (d) {
              return d[state.nodeId];
            }).links(state.graphData.links);
          }

          // setup dag force constraints
          var nodeDepths = state.dagMode && getDagDepths(state.graphData, function (node) {
            return node[state.nodeId];
          }, {
            nodeFilter: state.dagNodeFilter,
            onLoopError: state.onDagError || undefined
          });
          var maxDepth = Math.max.apply(Math, _toConsumableArray(Object.values(nodeDepths || [])));
          var dagLevelDistance = state.dagLevelDistance || state.graphData.nodes.length / (maxDepth || 1) * DAG_LEVEL_NODE_RATIO * (['radialin', 'radialout'].indexOf(state.dagMode) !== -1 ? 0.7 : 1);

          // Reset relevant f* when swapping dag modes
          if (['lr', 'rl', 'td', 'bu', 'zin', 'zout'].includes(changedProps.dagMode)) {
            var resetProp = ['lr', 'rl'].includes(changedProps.dagMode) ? 'fx' : ['td', 'bu'].includes(changedProps.dagMode) ? 'fy' : 'fz';
            state.graphData.nodes.filter(state.dagNodeFilter).forEach(function (node) {
              return delete node[resetProp];
            });
          }

          // Fix nodes to x,y,z for dag mode
          if (['lr', 'rl', 'td', 'bu', 'zin', 'zout'].includes(state.dagMode)) {
            var invert = ['rl', 'td', 'zout'].includes(state.dagMode);
            var fixFn = function fixFn(node) {
              return (nodeDepths[node[state.nodeId]] - maxDepth / 2) * dagLevelDistance * (invert ? -1 : 1);
            };
            var _resetProp = ['lr', 'rl'].includes(state.dagMode) ? 'fx' : ['td', 'bu'].includes(state.dagMode) ? 'fy' : 'fz';
            state.graphData.nodes.filter(state.dagNodeFilter).forEach(function (node) {
              return node[_resetProp] = fixFn(node);
            });
          }

          // Use radial force for radial dags
          state.d3ForceLayout.force('dagRadial', ['radialin', 'radialout'].indexOf(state.dagMode) !== -1 ? forceRadial(function (node) {
            var nodeDepth = nodeDepths[node[state.nodeId]] || -1;
            return (state.dagMode === 'radialin' ? maxDepth - nodeDepth : nodeDepth) * dagLevelDistance;
          }).strength(function (node) {
            return state.dagNodeFilter(node) ? 1 : 0;
          }) : null);
        } else {
          // ngraph
          var _graph = ngraph.graph();
          state.graphData.nodes.forEach(function (node) {
            _graph.addNode(node[state.nodeId]);
          });
          state.graphData.links.forEach(function (link) {
            _graph.addLink(link.source, link.target);
          });
          layout = ngraph.forcelayout(_graph, _objectSpread2({
            dimensions: state.numDimensions
          }, state.ngraphPhysics));
          layout.graph = _graph; // Attach graph reference to layout
        }
        for (var i = 0; i < state.warmupTicks && !(isD3Sim && state.d3AlphaMin > 0 && state.d3ForceLayout.alpha() < state.d3AlphaMin); i++) {
          layout[isD3Sim ? "tick" : "step"]();
        } // Initial ticks before starting to render

        state.layout = layout;
        this.resetCountdown();
      }
      state.engineRunning = true; // resume simulation

      state.onFinishUpdate();
    }
  });

  function fromKapsule (kapsule) {
    var baseClass = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Object;
    var initKapsuleWithSelf = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var ForceGraph = /*#__PURE__*/function (_baseClass) {
      function ForceGraph() {
        var _this;
        _classCallCheck(this, ForceGraph);
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        _this = _callSuper(this, ForceGraph, [].concat(args));
        _this.__kapsuleInstance = _construct$1(kapsule, [].concat(_toConsumableArray(initKapsuleWithSelf ? [_this] : []), args));
        return _this;
      }
      _inherits(ForceGraph, _baseClass);
      return _createClass(ForceGraph);
    }(baseClass); // attach kapsule props/methods to class prototype
    Object.keys(kapsule()).forEach(function (m) {
      return ForceGraph.prototype[m] = function () {
        var _this$__kapsuleInstan;
        var returnVal = (_this$__kapsuleInstan = this.__kapsuleInstance)[m].apply(_this$__kapsuleInstan, arguments);
        return returnVal === this.__kapsuleInstance ? this // chain based on this class, not the kapsule obj
        : returnVal;
      };
    });
    return ForceGraph;
  }

  var three = window.THREE ? window.THREE : {
    Group: three$2.Group
  }; // Prefer consumption from global THREE, if exists
  var threeForcegraph = fromKapsule(ForceGraph, three.Group, true);

  /* global AFRAME */
  if (typeof AFRAME === 'undefined') {
    throw new Error('Component attempted to register before AFRAME was available.');
  }
  var parseJson = function parseJson(prop) {
    return typeof prop === 'string' ? JSON.parse(prop) : prop; // already parsed
  };
  var parseFn = function parseFn(prop) {
    if (typeof prop === 'function') return prop; // already a function
    var geval = eval; // Avoid using eval directly https://github.com/rollup/rollup/wiki/Troubleshooting#avoiding-eval
    try {
      var evalled = geval('(' + prop + ')');
      return evalled;
    } catch (e) {} // Can't eval, not a function
    return null;
  };
  var parseAccessor = function parseAccessor(prop) {
    if (!isNaN(parseFloat(prop))) {
      return parseFloat(prop);
    } // parse numbers
    if (parseFn(prop)) {
      return parseFn(prop);
    } // parse functions
    return prop; // strings
  };

  /**
   * 3D Force-Directed Graph component for A-Frame.
   */
  if (!AFRAME.components.hasOwnProperty('forcegraph')) {
    AFRAME.registerComponent('forcegraph', {
      schema: {
        jsonUrl: {
          type: 'string',
          "default": ''
        },
        nodes: {
          parse: parseJson,
          "default": []
        },
        links: {
          parse: parseJson,
          "default": []
        },
        numDimensions: {
          type: 'number',
          "default": 3
        },
        dagMode: {
          type: 'string',
          "default": ''
        },
        dagLevelDistance: {
          type: 'number',
          "default": 0
        },
        dagNodeFilter: {
          parse: parseFn,
          "default": function _default() {
            return true;
          }
        },
        onDagError: {
          parse: parseFn,
          "default": undefined
        },
        nodeRelSize: {
          type: 'number',
          "default": 4
        },
        // volume per val unit
        nodeId: {
          type: 'string',
          "default": 'id'
        },
        nodeVal: {
          parse: parseAccessor,
          "default": 'val'
        },
        nodeResolution: {
          type: 'number',
          "default": 8
        },
        // how many slice segments in the sphere's circumference
        nodeVisibility: {
          parse: parseAccessor,
          "default": true
        },
        nodeColor: {
          parse: parseAccessor,
          "default": 'color'
        },
        nodeAutoColorBy: {
          parse: parseAccessor,
          "default": ''
        },
        // color nodes with the same field equally
        nodeOpacity: {
          type: 'number',
          "default": 0.75
        },
        nodeThreeObject: {
          parse: parseAccessor,
          "default": null
        },
        nodeThreeObjectExtend: {
          parse: parseAccessor,
          "default": false
        },
        linkSource: {
          type: 'string',
          "default": 'source'
        },
        linkTarget: {
          type: 'string',
          "default": 'target'
        },
        linkVisibility: {
          parse: parseAccessor,
          "default": true
        },
        linkColor: {
          parse: parseAccessor,
          "default": 'color'
        },
        linkAutoColorBy: {
          parse: parseAccessor,
          "default": ''
        },
        // color links with the same field equally
        linkOpacity: {
          type: 'number',
          "default": 0.2
        },
        linkWidth: {
          parse: parseAccessor,
          "default": 0
        },
        linkResolution: {
          type: 'number',
          "default": 6
        },
        // how many radial segments in each line cylinder's geometry
        linkCurvature: {
          parse: parseAccessor,
          "default": 0
        },
        linkCurveRotation: {
          parse: parseAccessor,
          "default": 0
        },
        linkMaterial: {
          parse: parseAccessor,
          "default": null
        },
        linkThreeObject: {
          parse: parseAccessor,
          "default": null
        },
        linkThreeObjectExtend: {
          parse: parseAccessor,
          "default": false
        },
        linkPositionUpdate: {
          parse: parseFn,
          "default": null
        },
        linkDirectionalArrowLength: {
          parse: parseAccessor,
          "default": 0
        },
        linkDirectionalArrowColor: {
          parse: parseAccessor,
          "default": null
        },
        linkDirectionalArrowRelPos: {
          parse: parseAccessor,
          "default": 0.5
        },
        // value between 0<>1 indicating the relative pos along the (exposed) line
        linkDirectionalArrowResolution: {
          type: 'number',
          "default": 8
        },
        // how many slice segments in the arrow's conic circumference
        linkDirectionalParticles: {
          parse: parseAccessor,
          "default": 0
        },
        // animate photons travelling in the link direction
        linkDirectionalParticleSpeed: {
          parse: parseAccessor,
          "default": 0.01
        },
        // in link length ratio per frame
        linkDirectionalParticleWidth: {
          parse: parseAccessor,
          "default": 0.5
        },
        linkDirectionalParticleColor: {
          parse: parseAccessor,
          "default": null
        },
        linkDirectionalParticleResolution: {
          type: 'number',
          "default": 4
        },
        // how many slice segments in the particle sphere's circumference
        onNodeHover: {
          parse: parseFn,
          "default": function _default() {}
        },
        onLinkHover: {
          parse: parseFn,
          "default": function _default() {}
        },
        onNodeClick: {
          parse: parseFn,
          "default": function _default() {}
        },
        onLinkClick: {
          parse: parseFn,
          "default": function _default() {}
        },
        forceEngine: {
          type: 'string',
          "default": 'd3'
        },
        // 'd3' or 'ngraph'
        d3AlphaMin: {
          type: 'number',
          "default": 0
        },
        d3AlphaDecay: {
          type: 'number',
          "default": 0.0228
        },
        d3VelocityDecay: {
          type: 'number',
          "default": 0.4
        },
        ngraphPhysics: {
          parse: parseJson,
          "default": null
        },
        warmupTicks: {
          type: 'int',
          "default": 0
        },
        // how many times to tick the force engine at init before starting to render
        cooldownTicks: {
          type: 'int',
          "default": 1e18
        },
        // Simulate infinity (int parser doesn't accept Infinity object)
        cooldownTime: {
          type: 'int',
          "default": 15000
        },
        // ms
        onEngineTick: {
          parse: parseFn,
          "default": function _default() {}
        },
        onEngineStop: {
          parse: parseFn,
          "default": function _default() {}
        }
      },
      // Bind component methods
      getGraphBbox: function getGraphBbox(nodeFilterFn) {
        if (!this.forceGraph) {
          // Got here before component init -> initialize forceGraph
          this.forceGraph = new threeForcegraph();
        }
        return this.forceGraph.getGraphBbox(nodeFilterFn);
      },
      emitParticle: function emitParticle() {
        if (!this.forceGraph) {
          // Got here before component init -> initialize forceGraph
          this.forceGraph = new threeForcegraph();
        }
        var forceGraph = this.forceGraph;
        var returnVal = forceGraph.emitParticle.apply(forceGraph, arguments);
        return returnVal === forceGraph ? this // return self, not the inner forcegraph component
        : returnVal;
      },
      d3Force: function d3Force() {
        if (!this.forceGraph) {
          // Got here before component init -> initialize forceGraph
          this.forceGraph = new threeForcegraph();
        }
        var forceGraph = this.forceGraph;
        var returnVal = forceGraph.d3Force.apply(forceGraph, arguments);
        return returnVal === forceGraph ? this // return self, not the inner forcegraph component
        : returnVal;
      },
      d3ReheatSimulation: function d3ReheatSimulation() {
        this.forceGraph && this.forceGraph.d3ReheatSimulation();
        return this;
      },
      refresh: function refresh() {
        this.forceGraph && this.forceGraph.refresh();
        return this;
      },
      init: function init() {
        var _this = this;
        var state = this.state = {}; // Internal state

        // Add info msg
        state.infoEl = document.createElement('a-text');
        state.infoEl.setAttribute('position', '0 -0.1 -1'); // Canvas center
        state.infoEl.setAttribute('width', 1);
        state.infoEl.setAttribute('align', 'center');
        state.infoEl.setAttribute('color', 'lavender');

        // Get camera dom element and attach fixed view elements to camera
        var cameraEl = document.querySelector('a-entity[camera], a-camera');
        cameraEl.appendChild(state.infoEl);

        // Keep reference to Three camera object
        state.cameraObj = cameraEl.object3D.children.filter(function (child) {
          return child.type === 'PerspectiveCamera';
        })[0];

        // On camera switch
        this.el.sceneEl.addEventListener('camera-set-active', function (evt) {
          // Switch camera reference
          state.cameraObj = evt.detail.cameraEl.components.camera.camera;
        });

        // setup FG object
        if (!this.forceGraph) this.forceGraph = new threeForcegraph(); // initialize forceGraph if it doesn't exist yet
        this.forceGraph.onFinishUpdate(function () {
          return _this.el.setObject3D('forcegraphGroup', _this.forceGraph);
        }) // Bind forcegraph to elem
        .onLoading(function () {
          return state.infoEl.setAttribute('value', 'Loading...');
        }) // Add loading msg
        .onFinishLoading(function () {
          return state.infoEl.setAttribute('value', '');
        });

        // prefer raycaster events over mouseenter/mouseleave because they expose immediately available intersection data via detail.getIntersection()
        this.el.addEventListener('raycaster-intersected', function (ev) {
          return state.hoverDetail = ev.detail;
        });
        this.el.addEventListener('raycaster-intersected-cleared', function (ev) {
          return state.hoverDetail = ev.detail;
        });
        this.el.addEventListener('click', function () {
          return state.hoverObj && _this.data['on' + (state.hoverObj.__graphObjType === 'node' ? 'Node' : 'Link') + 'Click'](state.hoverObj.__data);
        });
      },
      remove: function remove() {
        // Clean-up elems
        this.state.infoEl.remove();
        this.el.removeObject3D('forcegraphGroup');
      },
      update: function update(oldData) {
        var comp = this;
        var elData = this.data;
        var diff = AFRAME.utils.diff(elData, oldData);
        var fgProps = ['jsonUrl', 'numDimensions', 'dagMode', 'dagLevelDistance', 'dagNodeFilter', 'onDagError', 'nodeRelSize', 'nodeId', 'nodeVal', 'nodeResolution', 'nodeVisibility', 'nodeColor', 'nodeAutoColorBy', 'nodeOpacity', 'nodeThreeObject', 'nodeThreeObjectExtend', 'linkSource', 'linkTarget', 'linkVisibility', 'linkColor', 'linkAutoColorBy', 'linkOpacity', 'linkWidth', 'linkResolution', 'linkCurvature', 'linkCurveRotation', 'linkMaterial', 'linkThreeObject', 'linkThreeObjectExtend', 'linkPositionUpdate', 'linkDirectionalArrowLength', 'linkDirectionalArrowColor', 'linkDirectionalArrowRelPos', 'linkDirectionalArrowResolution', 'linkDirectionalParticles', 'linkDirectionalParticleSpeed', 'linkDirectionalParticleWidth', 'linkDirectionalParticleColor', 'linkDirectionalParticleResolution', 'forceEngine', 'd3AlphaMin', 'd3AphaDecay', 'd3VelocityDecay', 'ngraphPhysics', 'warmupTicks', 'cooldownTicks', 'cooldownTime', 'onEngineTick', 'onEngineStop'];
        fgProps.filter(function (p) {
          return p in diff;
        }).forEach(function (p) {
          comp.forceGraph[p](elData[p] !== '' ? elData[p] : null);
        }); // Convert blank values into nulls

        if ('nodes' in diff || 'links' in diff) {
          comp.forceGraph.graphData({
            nodes: elData.nodes,
            links: elData.links
          });
        }
      },
      tick: function tick(t, td) {
        var state = this.state;
        var props = this.data;

        // Update hover (intersected) object
        var intersection = state.hoverDetail ? state.hoverDetail.getIntersection ? state.hoverDetail.getIntersection(this.el) // available in raycaster-intersected events
        : state.hoverDetail.intersection || undefined // available in mouseenter/mouseleave events (with delayed update)
        : undefined;

        // Note:
        // Unfortunately we only have access to the intersected object closer to the camera (1st element in the raycaster intersectObjects result),
        // there is no ".getIntersections()" method available in the event details. Therefore, we can't prioritize hover on nodes over links, or even exclude
        // objects that are neither nodes or links. This makes the interaction a bit erratic if nodes have a lot of links in front.
        // Configuring the raycaster.params.Line.threshold might help with this somewhat, but that config is also not available via the a-frame raycaster component.

        // recurse up until forcegraph obj is found
        var topObject = intersection ? intersection.object : undefined;
        while (topObject && !topObject.hasOwnProperty('__graphObjType')) topObject = topObject.parent;
        if (topObject !== state.hoverObj) {
          var prevObjType = state.hoverObj ? state.hoverObj.__graphObjType : null;
          var prevObjData = state.hoverObj ? state.hoverObj.__data : null;
          var objType = topObject ? topObject.__graphObjType : null;
          var objData = topObject ? topObject.__data : null;
          if (prevObjType && prevObjType !== objType) {
            // Hover out
            props['on' + (prevObjType === 'node' ? 'Node' : 'Link') + 'Hover'](null, prevObjData);
          }
          if (objType) {
            // Hover in
            props['on' + (objType === 'node' ? 'Node' : 'Link') + 'Hover'](objData, prevObjType === objType ? prevObjData : null);
          }
          state.hoverObj = topObject;
        }

        // Run force-graph ticker
        this.forceGraph.tickFrame();
      }
    });
  }

  function _extends() {
    return _extends = Object.assign ? Object.assign.bind() : function (n) {
      for (var e = 1; e < arguments.length; e++) {
        var t = arguments[e];
        for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
      }
      return n;
    }, _extends.apply(null, arguments);
  }

  function _assertThisInitialized(e) {
    if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    return e;
  }

  function _setPrototypeOf(t, e) {
    return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) {
      return t.__proto__ = e, t;
    }, _setPrototypeOf(t, e);
  }

  function _inheritsLoose(t, o) {
    t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
  }

  function _getPrototypeOf(t) {
    return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) {
      return t.__proto__ || Object.getPrototypeOf(t);
    }, _getPrototypeOf(t);
  }

  function _isNativeFunction(t) {
    try {
      return -1 !== Function.toString.call(t).indexOf("[native code]");
    } catch (n) {
      return "function" == typeof t;
    }
  }

  function _isNativeReflectConstruct() {
    try {
      var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    } catch (t) {}
    return (_isNativeReflectConstruct = function _isNativeReflectConstruct() {
      return !!t;
    })();
  }

  function _construct(t, e, r) {
    if (_isNativeReflectConstruct()) return Reflect.construct.apply(null, arguments);
    var o = [null];
    o.push.apply(o, e);
    var p = new (t.bind.apply(t, o))();
    return r && _setPrototypeOf(p, r.prototype), p;
  }

  function _wrapNativeSuper(t) {
    var r = "function" == typeof Map ? new Map() : void 0;
    return _wrapNativeSuper = function _wrapNativeSuper(t) {
      if (null === t || !_isNativeFunction(t)) return t;
      if ("function" != typeof t) throw new TypeError("Super expression must either be null or a function");
      if (void 0 !== r) {
        if (r.has(t)) return r.get(t);
        r.set(t, Wrapper);
      }
      function Wrapper() {
        return _construct(t, arguments, _getPrototypeOf(this).constructor);
      }
      return Wrapper.prototype = Object.create(t.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true
        }
      }), _setPrototypeOf(Wrapper, t);
    }, _wrapNativeSuper(t);
  }

  // based on https://github.com/styled-components/styled-components/blob/fcf6f3804c57a14dd7984dfab7bc06ee2edca044/src/utils/error.js
  /**
   * Parse errors.md and turn it into a simple hash of code: message
   * @private
   */
  var ERRORS = {
    "1": "Passed invalid arguments to hsl, please pass multiple numbers e.g. hsl(360, 0.75, 0.4) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75 }).\n\n",
    "2": "Passed invalid arguments to hsla, please pass multiple numbers e.g. hsla(360, 0.75, 0.4, 0.7) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75, alpha: 0.7 }).\n\n",
    "3": "Passed an incorrect argument to a color function, please pass a string representation of a color.\n\n",
    "4": "Couldn't generate valid rgb string from %s, it returned %s.\n\n",
    "5": "Couldn't parse the color string. Please provide the color as a string in hex, rgb, rgba, hsl or hsla notation.\n\n",
    "6": "Passed invalid arguments to rgb, please pass multiple numbers e.g. rgb(255, 205, 100) or an object e.g. rgb({ red: 255, green: 205, blue: 100 }).\n\n",
    "7": "Passed invalid arguments to rgba, please pass multiple numbers e.g. rgb(255, 205, 100, 0.75) or an object e.g. rgb({ red: 255, green: 205, blue: 100, alpha: 0.75 }).\n\n",
    "8": "Passed invalid argument to toColorString, please pass a RgbColor, RgbaColor, HslColor or HslaColor object.\n\n",
    "9": "Please provide a number of steps to the modularScale helper.\n\n",
    "10": "Please pass a number or one of the predefined scales to the modularScale helper as the ratio.\n\n",
    "11": "Invalid value passed as base to modularScale, expected number or em string but got \"%s\"\n\n",
    "12": "Expected a string ending in \"px\" or a number passed as the first argument to %s(), got \"%s\" instead.\n\n",
    "13": "Expected a string ending in \"px\" or a number passed as the second argument to %s(), got \"%s\" instead.\n\n",
    "14": "Passed invalid pixel value (\"%s\") to %s(), please pass a value like \"12px\" or 12.\n\n",
    "15": "Passed invalid base value (\"%s\") to %s(), please pass a value like \"12px\" or 12.\n\n",
    "16": "You must provide a template to this method.\n\n",
    "17": "You passed an unsupported selector state to this method.\n\n",
    "18": "minScreen and maxScreen must be provided as stringified numbers with the same units.\n\n",
    "19": "fromSize and toSize must be provided as stringified numbers with the same units.\n\n",
    "20": "expects either an array of objects or a single object with the properties prop, fromSize, and toSize.\n\n",
    "21": "expects the objects in the first argument array to have the properties `prop`, `fromSize`, and `toSize`.\n\n",
    "22": "expects the first argument object to have the properties `prop`, `fromSize`, and `toSize`.\n\n",
    "23": "fontFace expects a name of a font-family.\n\n",
    "24": "fontFace expects either the path to the font file(s) or a name of a local copy.\n\n",
    "25": "fontFace expects localFonts to be an array.\n\n",
    "26": "fontFace expects fileFormats to be an array.\n\n",
    "27": "radialGradient requries at least 2 color-stops to properly render.\n\n",
    "28": "Please supply a filename to retinaImage() as the first argument.\n\n",
    "29": "Passed invalid argument to triangle, please pass correct pointingDirection e.g. 'right'.\n\n",
    "30": "Passed an invalid value to `height` or `width`. Please provide a pixel based unit.\n\n",
    "31": "The animation shorthand only takes 8 arguments. See the specification for more information: http://mdn.io/animation\n\n",
    "32": "To pass multiple animations please supply them in arrays, e.g. animation(['rotate', '2s'], ['move', '1s'])\nTo pass a single animation please supply them in simple values, e.g. animation('rotate', '2s')\n\n",
    "33": "The animation shorthand arrays can only have 8 elements. See the specification for more information: http://mdn.io/animation\n\n",
    "34": "borderRadius expects a radius value as a string or number as the second argument.\n\n",
    "35": "borderRadius expects one of \"top\", \"bottom\", \"left\" or \"right\" as the first argument.\n\n",
    "36": "Property must be a string value.\n\n",
    "37": "Syntax Error at %s.\n\n",
    "38": "Formula contains a function that needs parentheses at %s.\n\n",
    "39": "Formula is missing closing parenthesis at %s.\n\n",
    "40": "Formula has too many closing parentheses at %s.\n\n",
    "41": "All values in a formula must have the same unit or be unitless.\n\n",
    "42": "Please provide a number of steps to the modularScale helper.\n\n",
    "43": "Please pass a number or one of the predefined scales to the modularScale helper as the ratio.\n\n",
    "44": "Invalid value passed as base to modularScale, expected number or em/rem string but got %s.\n\n",
    "45": "Passed invalid argument to hslToColorString, please pass a HslColor or HslaColor object.\n\n",
    "46": "Passed invalid argument to rgbToColorString, please pass a RgbColor or RgbaColor object.\n\n",
    "47": "minScreen and maxScreen must be provided as stringified numbers with the same units.\n\n",
    "48": "fromSize and toSize must be provided as stringified numbers with the same units.\n\n",
    "49": "Expects either an array of objects or a single object with the properties prop, fromSize, and toSize.\n\n",
    "50": "Expects the objects in the first argument array to have the properties prop, fromSize, and toSize.\n\n",
    "51": "Expects the first argument object to have the properties prop, fromSize, and toSize.\n\n",
    "52": "fontFace expects either the path to the font file(s) or a name of a local copy.\n\n",
    "53": "fontFace expects localFonts to be an array.\n\n",
    "54": "fontFace expects fileFormats to be an array.\n\n",
    "55": "fontFace expects a name of a font-family.\n\n",
    "56": "linearGradient requries at least 2 color-stops to properly render.\n\n",
    "57": "radialGradient requries at least 2 color-stops to properly render.\n\n",
    "58": "Please supply a filename to retinaImage() as the first argument.\n\n",
    "59": "Passed invalid argument to triangle, please pass correct pointingDirection e.g. 'right'.\n\n",
    "60": "Passed an invalid value to `height` or `width`. Please provide a pixel based unit.\n\n",
    "61": "Property must be a string value.\n\n",
    "62": "borderRadius expects a radius value as a string or number as the second argument.\n\n",
    "63": "borderRadius expects one of \"top\", \"bottom\", \"left\" or \"right\" as the first argument.\n\n",
    "64": "The animation shorthand only takes 8 arguments. See the specification for more information: http://mdn.io/animation.\n\n",
    "65": "To pass multiple animations please supply them in arrays, e.g. animation(['rotate', '2s'], ['move', '1s'])\\nTo pass a single animation please supply them in simple values, e.g. animation('rotate', '2s').\n\n",
    "66": "The animation shorthand arrays can only have 8 elements. See the specification for more information: http://mdn.io/animation.\n\n",
    "67": "You must provide a template to this method.\n\n",
    "68": "You passed an unsupported selector state to this method.\n\n",
    "69": "Expected a string ending in \"px\" or a number passed as the first argument to %s(), got %s instead.\n\n",
    "70": "Expected a string ending in \"px\" or a number passed as the second argument to %s(), got %s instead.\n\n",
    "71": "Passed invalid pixel value %s to %s(), please pass a value like \"12px\" or 12.\n\n",
    "72": "Passed invalid base value %s to %s(), please pass a value like \"12px\" or 12.\n\n",
    "73": "Please provide a valid CSS variable.\n\n",
    "74": "CSS variable not found and no default was provided.\n\n",
    "75": "important requires a valid style object, got a %s instead.\n\n",
    "76": "fromSize and toSize must be provided as stringified numbers with the same units as minScreen and maxScreen.\n\n",
    "77": "remToPx expects a value in \"rem\" but you provided it in \"%s\".\n\n",
    "78": "base must be set in \"px\" or \"%\" but you set it in \"%s\".\n"
  };

  /**
   * super basic version of sprintf
   * @private
   */
  function format() {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    var a = args[0];
    var b = [];
    var c;
    for (c = 1; c < args.length; c += 1) {
      b.push(args[c]);
    }
    b.forEach(function (d) {
      a = a.replace(/%[a-z]/, d);
    });
    return a;
  }

  /**
   * Create an error file out of errors.md for development and a simple web link to the full errors
   * in production mode.
   * @private
   */
  var PolishedError = /*#__PURE__*/function (_Error) {
    _inheritsLoose(PolishedError, _Error);
    function PolishedError(code) {
      var _this;
      if (process.env.NODE_ENV === 'production') {
        _this = _Error.call(this, "An error occurred. See https://github.com/styled-components/polished/blob/main/src/internalHelpers/errors.md#" + code + " for more information.") || this;
      } else {
        for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }
        _this = _Error.call(this, format.apply(void 0, [ERRORS[code]].concat(args))) || this;
      }
      return _assertThisInitialized(_this);
    }
    return PolishedError;
  }( /*#__PURE__*/_wrapNativeSuper(Error));

  function colorToInt(color) {
    return Math.round(color * 255);
  }
  function convertToInt(red, green, blue) {
    return colorToInt(red) + "," + colorToInt(green) + "," + colorToInt(blue);
  }
  function hslToRgb(hue, saturation, lightness, convert) {
    if (convert === void 0) {
      convert = convertToInt;
    }
    if (saturation === 0) {
      // achromatic
      return convert(lightness, lightness, lightness);
    }

    // formulae from https://en.wikipedia.org/wiki/HSL_and_HSV
    var huePrime = (hue % 360 + 360) % 360 / 60;
    var chroma = (1 - Math.abs(2 * lightness - 1)) * saturation;
    var secondComponent = chroma * (1 - Math.abs(huePrime % 2 - 1));
    var red = 0;
    var green = 0;
    var blue = 0;
    if (huePrime >= 0 && huePrime < 1) {
      red = chroma;
      green = secondComponent;
    } else if (huePrime >= 1 && huePrime < 2) {
      red = secondComponent;
      green = chroma;
    } else if (huePrime >= 2 && huePrime < 3) {
      green = chroma;
      blue = secondComponent;
    } else if (huePrime >= 3 && huePrime < 4) {
      green = secondComponent;
      blue = chroma;
    } else if (huePrime >= 4 && huePrime < 5) {
      red = secondComponent;
      blue = chroma;
    } else if (huePrime >= 5 && huePrime < 6) {
      red = chroma;
      blue = secondComponent;
    }
    var lightnessModification = lightness - chroma / 2;
    var finalRed = red + lightnessModification;
    var finalGreen = green + lightnessModification;
    var finalBlue = blue + lightnessModification;
    return convert(finalRed, finalGreen, finalBlue);
  }

  var namedColorMap = {
    aliceblue: 'f0f8ff',
    antiquewhite: 'faebd7',
    aqua: '00ffff',
    aquamarine: '7fffd4',
    azure: 'f0ffff',
    beige: 'f5f5dc',
    bisque: 'ffe4c4',
    black: '000',
    blanchedalmond: 'ffebcd',
    blue: '0000ff',
    blueviolet: '8a2be2',
    brown: 'a52a2a',
    burlywood: 'deb887',
    cadetblue: '5f9ea0',
    chartreuse: '7fff00',
    chocolate: 'd2691e',
    coral: 'ff7f50',
    cornflowerblue: '6495ed',
    cornsilk: 'fff8dc',
    crimson: 'dc143c',
    cyan: '00ffff',
    darkblue: '00008b',
    darkcyan: '008b8b',
    darkgoldenrod: 'b8860b',
    darkgray: 'a9a9a9',
    darkgreen: '006400',
    darkgrey: 'a9a9a9',
    darkkhaki: 'bdb76b',
    darkmagenta: '8b008b',
    darkolivegreen: '556b2f',
    darkorange: 'ff8c00',
    darkorchid: '9932cc',
    darkred: '8b0000',
    darksalmon: 'e9967a',
    darkseagreen: '8fbc8f',
    darkslateblue: '483d8b',
    darkslategray: '2f4f4f',
    darkslategrey: '2f4f4f',
    darkturquoise: '00ced1',
    darkviolet: '9400d3',
    deeppink: 'ff1493',
    deepskyblue: '00bfff',
    dimgray: '696969',
    dimgrey: '696969',
    dodgerblue: '1e90ff',
    firebrick: 'b22222',
    floralwhite: 'fffaf0',
    forestgreen: '228b22',
    fuchsia: 'ff00ff',
    gainsboro: 'dcdcdc',
    ghostwhite: 'f8f8ff',
    gold: 'ffd700',
    goldenrod: 'daa520',
    gray: '808080',
    green: '008000',
    greenyellow: 'adff2f',
    grey: '808080',
    honeydew: 'f0fff0',
    hotpink: 'ff69b4',
    indianred: 'cd5c5c',
    indigo: '4b0082',
    ivory: 'fffff0',
    khaki: 'f0e68c',
    lavender: 'e6e6fa',
    lavenderblush: 'fff0f5',
    lawngreen: '7cfc00',
    lemonchiffon: 'fffacd',
    lightblue: 'add8e6',
    lightcoral: 'f08080',
    lightcyan: 'e0ffff',
    lightgoldenrodyellow: 'fafad2',
    lightgray: 'd3d3d3',
    lightgreen: '90ee90',
    lightgrey: 'd3d3d3',
    lightpink: 'ffb6c1',
    lightsalmon: 'ffa07a',
    lightseagreen: '20b2aa',
    lightskyblue: '87cefa',
    lightslategray: '789',
    lightslategrey: '789',
    lightsteelblue: 'b0c4de',
    lightyellow: 'ffffe0',
    lime: '0f0',
    limegreen: '32cd32',
    linen: 'faf0e6',
    magenta: 'f0f',
    maroon: '800000',
    mediumaquamarine: '66cdaa',
    mediumblue: '0000cd',
    mediumorchid: 'ba55d3',
    mediumpurple: '9370db',
    mediumseagreen: '3cb371',
    mediumslateblue: '7b68ee',
    mediumspringgreen: '00fa9a',
    mediumturquoise: '48d1cc',
    mediumvioletred: 'c71585',
    midnightblue: '191970',
    mintcream: 'f5fffa',
    mistyrose: 'ffe4e1',
    moccasin: 'ffe4b5',
    navajowhite: 'ffdead',
    navy: '000080',
    oldlace: 'fdf5e6',
    olive: '808000',
    olivedrab: '6b8e23',
    orange: 'ffa500',
    orangered: 'ff4500',
    orchid: 'da70d6',
    palegoldenrod: 'eee8aa',
    palegreen: '98fb98',
    paleturquoise: 'afeeee',
    palevioletred: 'db7093',
    papayawhip: 'ffefd5',
    peachpuff: 'ffdab9',
    peru: 'cd853f',
    pink: 'ffc0cb',
    plum: 'dda0dd',
    powderblue: 'b0e0e6',
    purple: '800080',
    rebeccapurple: '639',
    red: 'f00',
    rosybrown: 'bc8f8f',
    royalblue: '4169e1',
    saddlebrown: '8b4513',
    salmon: 'fa8072',
    sandybrown: 'f4a460',
    seagreen: '2e8b57',
    seashell: 'fff5ee',
    sienna: 'a0522d',
    silver: 'c0c0c0',
    skyblue: '87ceeb',
    slateblue: '6a5acd',
    slategray: '708090',
    slategrey: '708090',
    snow: 'fffafa',
    springgreen: '00ff7f',
    steelblue: '4682b4',
    tan: 'd2b48c',
    teal: '008080',
    thistle: 'd8bfd8',
    tomato: 'ff6347',
    turquoise: '40e0d0',
    violet: 'ee82ee',
    wheat: 'f5deb3',
    white: 'fff',
    whitesmoke: 'f5f5f5',
    yellow: 'ff0',
    yellowgreen: '9acd32'
  };

  /**
   * Checks if a string is a CSS named color and returns its equivalent hex value, otherwise returns the original color.
   * @private
   */
  function nameToHex(color) {
    if (typeof color !== 'string') return color;
    var normalizedColorName = color.toLowerCase();
    return namedColorMap[normalizedColorName] ? "#" + namedColorMap[normalizedColorName] : color;
  }

  var hexRegex = /^#[a-fA-F0-9]{6}$/;
  var hexRgbaRegex = /^#[a-fA-F0-9]{8}$/;
  var reducedHexRegex = /^#[a-fA-F0-9]{3}$/;
  var reducedRgbaHexRegex = /^#[a-fA-F0-9]{4}$/;
  var rgbRegex = /^rgb\(\s*(\d{1,3})\s*(?:,)?\s*(\d{1,3})\s*(?:,)?\s*(\d{1,3})\s*\)$/i;
  var rgbaRegex = /^rgb(?:a)?\(\s*(\d{1,3})\s*(?:,)?\s*(\d{1,3})\s*(?:,)?\s*(\d{1,3})\s*(?:,|\/)\s*([-+]?\d*[.]?\d+[%]?)\s*\)$/i;
  var hslRegex = /^hsl\(\s*(\d{0,3}[.]?[0-9]+(?:deg)?)\s*(?:,)?\s*(\d{1,3}[.]?[0-9]?)%\s*(?:,)?\s*(\d{1,3}[.]?[0-9]?)%\s*\)$/i;
  var hslaRegex = /^hsl(?:a)?\(\s*(\d{0,3}[.]?[0-9]+(?:deg)?)\s*(?:,)?\s*(\d{1,3}[.]?[0-9]?)%\s*(?:,)?\s*(\d{1,3}[.]?[0-9]?)%\s*(?:,|\/)\s*([-+]?\d*[.]?\d+[%]?)\s*\)$/i;

  /**
   * Returns an RgbColor or RgbaColor object. This utility function is only useful
   * if want to extract a color component. With the color util `toColorString` you
   * can convert a RgbColor or RgbaColor object back to a string.
   *
   * @example
   * // Assigns `{ red: 255, green: 0, blue: 0 }` to color1
   * const color1 = parseToRgb('rgb(255, 0, 0)');
   * // Assigns `{ red: 92, green: 102, blue: 112, alpha: 0.75 }` to color2
   * const color2 = parseToRgb('hsla(210, 10%, 40%, 0.75)');
   */
  function parseToRgb(color) {
    if (typeof color !== 'string') {
      throw new PolishedError(3);
    }
    var normalizedColor = nameToHex(color);
    if (normalizedColor.match(hexRegex)) {
      return {
        red: parseInt("" + normalizedColor[1] + normalizedColor[2], 16),
        green: parseInt("" + normalizedColor[3] + normalizedColor[4], 16),
        blue: parseInt("" + normalizedColor[5] + normalizedColor[6], 16)
      };
    }
    if (normalizedColor.match(hexRgbaRegex)) {
      var alpha = parseFloat((parseInt("" + normalizedColor[7] + normalizedColor[8], 16) / 255).toFixed(2));
      return {
        red: parseInt("" + normalizedColor[1] + normalizedColor[2], 16),
        green: parseInt("" + normalizedColor[3] + normalizedColor[4], 16),
        blue: parseInt("" + normalizedColor[5] + normalizedColor[6], 16),
        alpha: alpha
      };
    }
    if (normalizedColor.match(reducedHexRegex)) {
      return {
        red: parseInt("" + normalizedColor[1] + normalizedColor[1], 16),
        green: parseInt("" + normalizedColor[2] + normalizedColor[2], 16),
        blue: parseInt("" + normalizedColor[3] + normalizedColor[3], 16)
      };
    }
    if (normalizedColor.match(reducedRgbaHexRegex)) {
      var _alpha = parseFloat((parseInt("" + normalizedColor[4] + normalizedColor[4], 16) / 255).toFixed(2));
      return {
        red: parseInt("" + normalizedColor[1] + normalizedColor[1], 16),
        green: parseInt("" + normalizedColor[2] + normalizedColor[2], 16),
        blue: parseInt("" + normalizedColor[3] + normalizedColor[3], 16),
        alpha: _alpha
      };
    }
    var rgbMatched = rgbRegex.exec(normalizedColor);
    if (rgbMatched) {
      return {
        red: parseInt("" + rgbMatched[1], 10),
        green: parseInt("" + rgbMatched[2], 10),
        blue: parseInt("" + rgbMatched[3], 10)
      };
    }
    var rgbaMatched = rgbaRegex.exec(normalizedColor.substring(0, 50));
    if (rgbaMatched) {
      return {
        red: parseInt("" + rgbaMatched[1], 10),
        green: parseInt("" + rgbaMatched[2], 10),
        blue: parseInt("" + rgbaMatched[3], 10),
        alpha: parseFloat("" + rgbaMatched[4]) > 1 ? parseFloat("" + rgbaMatched[4]) / 100 : parseFloat("" + rgbaMatched[4])
      };
    }
    var hslMatched = hslRegex.exec(normalizedColor);
    if (hslMatched) {
      var hue = parseInt("" + hslMatched[1], 10);
      var saturation = parseInt("" + hslMatched[2], 10) / 100;
      var lightness = parseInt("" + hslMatched[3], 10) / 100;
      var rgbColorString = "rgb(" + hslToRgb(hue, saturation, lightness) + ")";
      var hslRgbMatched = rgbRegex.exec(rgbColorString);
      if (!hslRgbMatched) {
        throw new PolishedError(4, normalizedColor, rgbColorString);
      }
      return {
        red: parseInt("" + hslRgbMatched[1], 10),
        green: parseInt("" + hslRgbMatched[2], 10),
        blue: parseInt("" + hslRgbMatched[3], 10)
      };
    }
    var hslaMatched = hslaRegex.exec(normalizedColor.substring(0, 50));
    if (hslaMatched) {
      var _hue = parseInt("" + hslaMatched[1], 10);
      var _saturation = parseInt("" + hslaMatched[2], 10) / 100;
      var _lightness = parseInt("" + hslaMatched[3], 10) / 100;
      var _rgbColorString = "rgb(" + hslToRgb(_hue, _saturation, _lightness) + ")";
      var _hslRgbMatched = rgbRegex.exec(_rgbColorString);
      if (!_hslRgbMatched) {
        throw new PolishedError(4, normalizedColor, _rgbColorString);
      }
      return {
        red: parseInt("" + _hslRgbMatched[1], 10),
        green: parseInt("" + _hslRgbMatched[2], 10),
        blue: parseInt("" + _hslRgbMatched[3], 10),
        alpha: parseFloat("" + hslaMatched[4]) > 1 ? parseFloat("" + hslaMatched[4]) / 100 : parseFloat("" + hslaMatched[4])
      };
    }
    throw new PolishedError(5);
  }

  function rgbToHsl(color) {
    // make sure rgb are contained in a set of [0, 255]
    var red = color.red / 255;
    var green = color.green / 255;
    var blue = color.blue / 255;
    var max = Math.max(red, green, blue);
    var min = Math.min(red, green, blue);
    var lightness = (max + min) / 2;
    if (max === min) {
      // achromatic
      if (color.alpha !== undefined) {
        return {
          hue: 0,
          saturation: 0,
          lightness: lightness,
          alpha: color.alpha
        };
      } else {
        return {
          hue: 0,
          saturation: 0,
          lightness: lightness
        };
      }
    }
    var hue;
    var delta = max - min;
    var saturation = lightness > 0.5 ? delta / (2 - max - min) : delta / (max + min);
    switch (max) {
      case red:
        hue = (green - blue) / delta + (green < blue ? 6 : 0);
        break;
      case green:
        hue = (blue - red) / delta + 2;
        break;
      default:
        // blue case
        hue = (red - green) / delta + 4;
        break;
    }
    hue *= 60;
    if (color.alpha !== undefined) {
      return {
        hue: hue,
        saturation: saturation,
        lightness: lightness,
        alpha: color.alpha
      };
    }
    return {
      hue: hue,
      saturation: saturation,
      lightness: lightness
    };
  }

  /**
   * Returns an HslColor or HslaColor object. This utility function is only useful
   * if want to extract a color component. With the color util `toColorString` you
   * can convert a HslColor or HslaColor object back to a string.
   *
   * @example
   * // Assigns `{ hue: 0, saturation: 1, lightness: 0.5 }` to color1
   * const color1 = parseToHsl('rgb(255, 0, 0)');
   * // Assigns `{ hue: 128, saturation: 1, lightness: 0.5, alpha: 0.75 }` to color2
   * const color2 = parseToHsl('hsla(128, 100%, 50%, 0.75)');
   */
  function parseToHsl(color) {
    // Note: At a later stage we can optimize this function as right now a hsl
    // color would be parsed converted to rgb values and converted back to hsl.
    return rgbToHsl(parseToRgb(color));
  }

  /**
   * Reduces hex values if possible e.g. #ff8866 to #f86
   * @private
   */
  var reduceHexValue = function reduceHexValue(value) {
    if (value.length === 7 && value[1] === value[2] && value[3] === value[4] && value[5] === value[6]) {
      return "#" + value[1] + value[3] + value[5];
    }
    return value;
  };
  var reduceHexValue$1 = reduceHexValue;

  function numberToHex(value) {
    var hex = value.toString(16);
    return hex.length === 1 ? "0" + hex : hex;
  }

  function colorToHex(color) {
    return numberToHex(Math.round(color * 255));
  }
  function convertToHex(red, green, blue) {
    return reduceHexValue$1("#" + colorToHex(red) + colorToHex(green) + colorToHex(blue));
  }
  function hslToHex(hue, saturation, lightness) {
    return hslToRgb(hue, saturation, lightness, convertToHex);
  }

  /**
   * Returns a string value for the color. The returned result is the smallest possible hex notation.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: hsl(359, 0.75, 0.4),
   *   background: hsl({ hue: 360, saturation: 0.75, lightness: 0.4 }),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${hsl(359, 0.75, 0.4)};
   *   background: ${hsl({ hue: 360, saturation: 0.75, lightness: 0.4 })};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "#b3191c";
   *   background: "#b3191c";
   * }
   */
  function hsl(value, saturation, lightness) {
    if (typeof value === 'object' && saturation === undefined && lightness === undefined) {
      return hslToHex(value.hue, value.saturation, value.lightness);
    }
    throw new PolishedError(1);
  }

  /**
   * Returns a string value for the color. The returned result is the smallest possible rgba or hex notation.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: hsla(359, 0.75, 0.4, 0.7),
   *   background: hsla({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0,7 }),
   *   background: hsla(359, 0.75, 0.4, 1),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${hsla(359, 0.75, 0.4, 0.7)};
   *   background: ${hsla({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0,7 })};
   *   background: ${hsla(359, 0.75, 0.4, 1)};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "rgba(179,25,28,0.7)";
   *   background: "rgba(179,25,28,0.7)";
   *   background: "#b3191c";
   * }
   */
  function hsla(value, saturation, lightness, alpha) {
    if (typeof value === 'object' && saturation === undefined && lightness === undefined && alpha === undefined) {
      return value.alpha >= 1 ? hslToHex(value.hue, value.saturation, value.lightness) : "rgba(" + hslToRgb(value.hue, value.saturation, value.lightness) + "," + value.alpha + ")";
    }
    throw new PolishedError(2);
  }

  /**
   * Returns a string value for the color. The returned result is the smallest possible hex notation.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: rgb(255, 205, 100),
   *   background: rgb({ red: 255, green: 205, blue: 100 }),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${rgb(255, 205, 100)};
   *   background: ${rgb({ red: 255, green: 205, blue: 100 })};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "#ffcd64";
   *   background: "#ffcd64";
   * }
   */
  function rgb(value, green, blue) {
    if (typeof value === 'number' && typeof green === 'number' && typeof blue === 'number') {
      return reduceHexValue$1("#" + numberToHex(value) + numberToHex(green) + numberToHex(blue));
    } else if (typeof value === 'object' && green === undefined && blue === undefined) {
      return reduceHexValue$1("#" + numberToHex(value.red) + numberToHex(value.green) + numberToHex(value.blue));
    }
    throw new PolishedError(6);
  }

  /**
   * Returns a string value for the color. The returned result is the smallest possible rgba or hex notation.
   *
   * Can also be used to fade a color by passing a hex value or named CSS color along with an alpha value.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: rgba(255, 205, 100, 0.7),
   *   background: rgba({ red: 255, green: 205, blue: 100, alpha: 0.7 }),
   *   background: rgba(255, 205, 100, 1),
   *   background: rgba('#ffffff', 0.4),
   *   background: rgba('black', 0.7),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${rgba(255, 205, 100, 0.7)};
   *   background: ${rgba({ red: 255, green: 205, blue: 100, alpha: 0.7 })};
   *   background: ${rgba(255, 205, 100, 1)};
   *   background: ${rgba('#ffffff', 0.4)};
   *   background: ${rgba('black', 0.7)};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "rgba(255,205,100,0.7)";
   *   background: "rgba(255,205,100,0.7)";
   *   background: "#ffcd64";
   *   background: "rgba(255,255,255,0.4)";
   *   background: "rgba(0,0,0,0.7)";
   * }
   */
  function rgba(firstValue, secondValue, thirdValue, fourthValue) {
    if (typeof firstValue === 'object' && secondValue === undefined && thirdValue === undefined && fourthValue === undefined) {
      return firstValue.alpha >= 1 ? rgb(firstValue.red, firstValue.green, firstValue.blue) : "rgba(" + firstValue.red + "," + firstValue.green + "," + firstValue.blue + "," + firstValue.alpha + ")";
    }
    throw new PolishedError(7);
  }

  var isRgb = function isRgb(color) {
    return typeof color.red === 'number' && typeof color.green === 'number' && typeof color.blue === 'number' && (typeof color.alpha !== 'number' || typeof color.alpha === 'undefined');
  };
  var isRgba = function isRgba(color) {
    return typeof color.red === 'number' && typeof color.green === 'number' && typeof color.blue === 'number' && typeof color.alpha === 'number';
  };
  var isHsl = function isHsl(color) {
    return typeof color.hue === 'number' && typeof color.saturation === 'number' && typeof color.lightness === 'number' && (typeof color.alpha !== 'number' || typeof color.alpha === 'undefined');
  };
  var isHsla = function isHsla(color) {
    return typeof color.hue === 'number' && typeof color.saturation === 'number' && typeof color.lightness === 'number' && typeof color.alpha === 'number';
  };

  /**
   * Converts a RgbColor, RgbaColor, HslColor or HslaColor object to a color string.
   * This util is useful in case you only know on runtime which color object is
   * used. Otherwise we recommend to rely on `rgb`, `rgba`, `hsl` or `hsla`.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: toColorString({ red: 255, green: 205, blue: 100 }),
   *   background: toColorString({ red: 255, green: 205, blue: 100, alpha: 0.72 }),
   *   background: toColorString({ hue: 240, saturation: 1, lightness: 0.5 }),
   *   background: toColorString({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0.72 }),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${toColorString({ red: 255, green: 205, blue: 100 })};
   *   background: ${toColorString({ red: 255, green: 205, blue: 100, alpha: 0.72 })};
   *   background: ${toColorString({ hue: 240, saturation: 1, lightness: 0.5 })};
   *   background: ${toColorString({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0.72 })};
   * `
   *
   * // CSS in JS Output
   * element {
   *   background: "#ffcd64";
   *   background: "rgba(255,205,100,0.72)";
   *   background: "#00f";
   *   background: "rgba(179,25,25,0.72)";
   * }
   */

  function toColorString(color) {
    if (typeof color !== 'object') throw new PolishedError(8);
    if (isRgba(color)) return rgba(color);
    if (isRgb(color)) return rgb(color);
    if (isHsla(color)) return hsla(color);
    if (isHsl(color)) return hsl(color);
    throw new PolishedError(8);
  }

  // Type definitions taken from https://github.com/gcanti/flow-static-land/blob/master/src/Fun.js
  // eslint-disable-next-line no-unused-vars
  // eslint-disable-next-line no-unused-vars
  // eslint-disable-next-line no-redeclare
  function curried(f, length, acc) {
    return function fn() {
      // eslint-disable-next-line prefer-rest-params
      var combined = acc.concat(Array.prototype.slice.call(arguments));
      return combined.length >= length ? f.apply(this, combined) : curried(f, length, combined);
    };
  }

  // eslint-disable-next-line no-redeclare
  function curry(f) {
    // eslint-disable-line no-redeclare
    return curried(f, f.length, []);
  }

  /**
   * Changes the hue of the color. Hue is a number between 0 to 360. The first
   * argument for adjustHue is the amount of degrees the color is rotated around
   * the color wheel, always producing a positive hue value.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: adjustHue(180, '#448'),
   *   background: adjustHue('180', 'rgba(101,100,205,0.7)'),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${adjustHue(180, '#448')};
   *   background: ${adjustHue('180', 'rgba(101,100,205,0.7)')};
   * `
   *
   * // CSS in JS Output
   * element {
   *   background: "#888844";
   *   background: "rgba(136,136,68,0.7)";
   * }
   */
  function adjustHue(degree, color) {
    if (color === 'transparent') return color;
    var hslColor = parseToHsl(color);
    return toColorString(_extends({}, hslColor, {
      hue: hslColor.hue + parseFloat(degree)
    }));
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(adjustHue);

  function guard(lowerBoundary, upperBoundary, value) {
    return Math.max(lowerBoundary, Math.min(upperBoundary, value));
  }

  /**
   * Returns a string value for the darkened color.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: darken(0.2, '#FFCD64'),
   *   background: darken('0.2', 'rgba(255,205,100,0.7)'),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${darken(0.2, '#FFCD64')};
   *   background: ${darken('0.2', 'rgba(255,205,100,0.7)')};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "#ffbd31";
   *   background: "rgba(255,189,49,0.7)";
   * }
   */
  function darken(amount, color) {
    if (color === 'transparent') return color;
    var hslColor = parseToHsl(color);
    return toColorString(_extends({}, hslColor, {
      lightness: guard(0, 1, hslColor.lightness - parseFloat(amount))
    }));
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(darken);

  /**
   * Decreases the intensity of a color. Its range is between 0 to 1. The first
   * argument of the desaturate function is the amount by how much the color
   * intensity should be decreased.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: desaturate(0.2, '#CCCD64'),
   *   background: desaturate('0.2', 'rgba(204,205,100,0.7)'),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${desaturate(0.2, '#CCCD64')};
   *   background: ${desaturate('0.2', 'rgba(204,205,100,0.7)')};
   * `
   *
   * // CSS in JS Output
   * element {
   *   background: "#b8b979";
   *   background: "rgba(184,185,121,0.7)";
   * }
   */
  function desaturate(amount, color) {
    if (color === 'transparent') return color;
    var hslColor = parseToHsl(color);
    return toColorString(_extends({}, hslColor, {
      saturation: guard(0, 1, hslColor.saturation - parseFloat(amount))
    }));
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(desaturate);

  /**
   * Returns a string value for the lightened color.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: lighten(0.2, '#CCCD64'),
   *   background: lighten('0.2', 'rgba(204,205,100,0.7)'),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${lighten(0.2, '#FFCD64')};
   *   background: ${lighten('0.2', 'rgba(204,205,100,0.7)')};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "#e5e6b1";
   *   background: "rgba(229,230,177,0.7)";
   * }
   */
  function lighten(amount, color) {
    if (color === 'transparent') return color;
    var hslColor = parseToHsl(color);
    return toColorString(_extends({}, hslColor, {
      lightness: guard(0, 1, hslColor.lightness + parseFloat(amount))
    }));
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(lighten);

  /**
   * Mixes the two provided colors together by calculating the average of each of the RGB components weighted to the first color by the provided weight.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: mix(0.5, '#f00', '#00f')
   *   background: mix(0.25, '#f00', '#00f')
   *   background: mix('0.5', 'rgba(255, 0, 0, 0.5)', '#00f')
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${mix(0.5, '#f00', '#00f')};
   *   background: ${mix(0.25, '#f00', '#00f')};
   *   background: ${mix('0.5', 'rgba(255, 0, 0, 0.5)', '#00f')};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "#7f007f";
   *   background: "#3f00bf";
   *   background: "rgba(63, 0, 191, 0.75)";
   * }
   */
  function mix(weight, color, otherColor) {
    if (color === 'transparent') return otherColor;
    if (otherColor === 'transparent') return color;
    if (weight === 0) return otherColor;
    var parsedColor1 = parseToRgb(color);
    var color1 = _extends({}, parsedColor1, {
      alpha: typeof parsedColor1.alpha === 'number' ? parsedColor1.alpha : 1
    });
    var parsedColor2 = parseToRgb(otherColor);
    var color2 = _extends({}, parsedColor2, {
      alpha: typeof parsedColor2.alpha === 'number' ? parsedColor2.alpha : 1
    });

    // The formula is copied from the original Sass implementation:
    // http://sass-lang.com/documentation/Sass/Script/Functions.html#mix-instance_method
    var alphaDelta = color1.alpha - color2.alpha;
    var x = parseFloat(weight) * 2 - 1;
    var y = x * alphaDelta === -1 ? x : x + alphaDelta;
    var z = 1 + x * alphaDelta;
    var weight1 = (y / z + 1) / 2.0;
    var weight2 = 1 - weight1;
    var mixedColor = {
      red: Math.floor(color1.red * weight1 + color2.red * weight2),
      green: Math.floor(color1.green * weight1 + color2.green * weight2),
      blue: Math.floor(color1.blue * weight1 + color2.blue * weight2),
      alpha: color1.alpha * parseFloat(weight) + color2.alpha * (1 - parseFloat(weight))
    };
    return rgba(mixedColor);
  }

  // prettier-ignore
  var curriedMix = curry /* ::<number | string, string, string, string> */(mix);
  var mix$1 = curriedMix;

  /**
   * Increases the opacity of a color. Its range for the amount is between 0 to 1.
   *
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: opacify(0.1, 'rgba(255, 255, 255, 0.9)');
   *   background: opacify(0.2, 'hsla(0, 0%, 100%, 0.5)'),
   *   background: opacify('0.5', 'rgba(255, 0, 0, 0.2)'),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${opacify(0.1, 'rgba(255, 255, 255, 0.9)')};
   *   background: ${opacify(0.2, 'hsla(0, 0%, 100%, 0.5)')},
   *   background: ${opacify('0.5', 'rgba(255, 0, 0, 0.2)')},
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "#fff";
   *   background: "rgba(255,255,255,0.7)";
   *   background: "rgba(255,0,0,0.7)";
   * }
   */
  function opacify(amount, color) {
    if (color === 'transparent') return color;
    var parsedColor = parseToRgb(color);
    var alpha = typeof parsedColor.alpha === 'number' ? parsedColor.alpha : 1;
    var colorWithAlpha = _extends({}, parsedColor, {
      alpha: guard(0, 1, (alpha * 100 + parseFloat(amount) * 100) / 100)
    });
    return rgba(colorWithAlpha);
  }

  // prettier-ignore
  var curriedOpacify = curry /* ::<number | string, string, string> */(opacify);
  var curriedOpacify$1 = curriedOpacify;

  /**
   * Increases the intensity of a color. Its range is between 0 to 1. The first
   * argument of the saturate function is the amount by how much the color
   * intensity should be increased.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: saturate(0.2, '#CCCD64'),
   *   background: saturate('0.2', 'rgba(204,205,100,0.7)'),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${saturate(0.2, '#FFCD64')};
   *   background: ${saturate('0.2', 'rgba(204,205,100,0.7)')};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "#e0e250";
   *   background: "rgba(224,226,80,0.7)";
   * }
   */
  function saturate(amount, color) {
    if (color === 'transparent') return color;
    var hslColor = parseToHsl(color);
    return toColorString(_extends({}, hslColor, {
      saturation: guard(0, 1, hslColor.saturation + parseFloat(amount))
    }));
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(saturate);

  /**
   * Sets the hue of a color to the provided value. The hue range can be
   * from 0 and 359.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: setHue(42, '#CCCD64'),
   *   background: setHue('244', 'rgba(204,205,100,0.7)'),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${setHue(42, '#CCCD64')};
   *   background: ${setHue('244', 'rgba(204,205,100,0.7)')};
   * `
   *
   * // CSS in JS Output
   * element {
   *   background: "#cdae64";
   *   background: "rgba(107,100,205,0.7)";
   * }
   */
  function setHue(hue, color) {
    if (color === 'transparent') return color;
    return toColorString(_extends({}, parseToHsl(color), {
      hue: parseFloat(hue)
    }));
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(setHue);

  /**
   * Sets the lightness of a color to the provided value. The lightness range can be
   * from 0 and 1.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: setLightness(0.2, '#CCCD64'),
   *   background: setLightness('0.75', 'rgba(204,205,100,0.7)'),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${setLightness(0.2, '#CCCD64')};
   *   background: ${setLightness('0.75', 'rgba(204,205,100,0.7)')};
   * `
   *
   * // CSS in JS Output
   * element {
   *   background: "#4d4d19";
   *   background: "rgba(223,224,159,0.7)";
   * }
   */
  function setLightness(lightness, color) {
    if (color === 'transparent') return color;
    return toColorString(_extends({}, parseToHsl(color), {
      lightness: parseFloat(lightness)
    }));
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(setLightness);

  /**
   * Sets the saturation of a color to the provided value. The saturation range can be
   * from 0 and 1.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: setSaturation(0.2, '#CCCD64'),
   *   background: setSaturation('0.75', 'rgba(204,205,100,0.7)'),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${setSaturation(0.2, '#CCCD64')};
   *   background: ${setSaturation('0.75', 'rgba(204,205,100,0.7)')};
   * `
   *
   * // CSS in JS Output
   * element {
   *   background: "#adad84";
   *   background: "rgba(228,229,76,0.7)";
   * }
   */
  function setSaturation(saturation, color) {
    if (color === 'transparent') return color;
    return toColorString(_extends({}, parseToHsl(color), {
      saturation: parseFloat(saturation)
    }));
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(setSaturation);

  /**
   * Shades a color by mixing it with black. `shade` can produce
   * hue shifts, where as `darken` manipulates the luminance channel and therefore
   * doesn't produce hue shifts.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: shade(0.25, '#00f')
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${shade(0.25, '#00f')};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "#00003f";
   * }
   */

  function shade(percentage, color) {
    if (color === 'transparent') return color;
    return mix$1(parseFloat(percentage), 'rgb(0, 0, 0)', color);
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(shade);

  /**
   * Tints a color by mixing it with white. `tint` can produce
   * hue shifts, where as `lighten` manipulates the luminance channel and therefore
   * doesn't produce hue shifts.
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: tint(0.25, '#00f')
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${tint(0.25, '#00f')};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "#bfbfff";
   * }
   */

  function tint(percentage, color) {
    if (color === 'transparent') return color;
    return mix$1(parseFloat(percentage), 'rgb(255, 255, 255)', color);
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(tint);

  /**
   * Decreases the opacity of a color. Its range for the amount is between 0 to 1.
   *
   *
   * @example
   * // Styles as object usage
   * const styles = {
   *   background: transparentize(0.1, '#fff'),
   *   background: transparentize(0.2, 'hsl(0, 0%, 100%)'),
   *   background: transparentize('0.5', 'rgba(255, 0, 0, 0.8)'),
   * }
   *
   * // styled-components usage
   * const div = styled.div`
   *   background: ${transparentize(0.1, '#fff')};
   *   background: ${transparentize(0.2, 'hsl(0, 0%, 100%)')};
   *   background: ${transparentize('0.5', 'rgba(255, 0, 0, 0.8)')};
   * `
   *
   * // CSS in JS Output
   *
   * element {
   *   background: "rgba(255,255,255,0.9)";
   *   background: "rgba(255,255,255,0.8)";
   *   background: "rgba(255,0,0,0.3)";
   * }
   */
  function transparentize(amount, color) {
    if (color === 'transparent') return color;
    var parsedColor = parseToRgb(color);
    var alpha = typeof parsedColor.alpha === 'number' ? parsedColor.alpha : 1;
    var colorWithAlpha = _extends({}, parsedColor, {
      alpha: guard(0, 1, +(alpha * 100 - parseFloat(amount) * 100).toFixed(2) / 100)
    });
    return rgba(colorWithAlpha);
  }

  // prettier-ignore
  curry /* ::<number | string, string, string> */(transparentize);

  //

  var _3dForceGraphVr = index$1({
    props: {
      width: {
        "default": window.innerWidth,
        triggerUpdate: false,
        onChange: function onChange(width, state) {
          if (state.container) state.container.style.width = "".concat(width, "px");
        }
      },
      height: {
        "default": window.innerHeight,
        triggerUpdate: false,
        onChange: function onChange(height, state) {
          if (state.container) state.container.style.height = "".concat(height, "px");
        }
      },
      jsonUrl: {},
      graphData: {
        "default": {
          nodes: [],
          links: []
        }
      },
      numDimensions: {
        "default": 3
      },
      dagMode: {},
      dagLevelDistance: {},
      dagNodeFilter: {
        "default": function _default() {
          return true;
        }
      },
      onDagError: {
        "default": undefined
      },
      backgroundColor: {
        "default": '#002'
      },
      showNavInfo: {
        "default": true
      },
      nodeRelSize: {
        "default": 4
      },
      // volume per val unit
      nodeId: {
        "default": 'id'
      },
      nodeLabel: {
        "default": 'name'
      },
      nodeDesc: {
        "default": 'desc'
      },
      onNodeHover: {},
      onNodeClick: {},
      nodeVal: {
        "default": 'val'
      },
      nodeResolution: {
        "default": 8
      },
      // how many slice segments in the sphere's circumference
      nodeVisibility: {
        "default": true
      },
      nodeColor: {
        "default": 'color'
      },
      nodeAutoColorBy: {},
      nodeOpacity: {
        "default": 0.75
      },
      nodeThreeObject: {},
      nodeThreeObjectExtend: {
        "default": false
      },
      linkSource: {
        "default": 'source'
      },
      linkTarget: {
        "default": 'target'
      },
      linkLabel: {
        "default": 'name'
      },
      linkDesc: {
        "default": 'desc'
      },
      onLinkHover: {},
      onLinkClick: {},
      linkVisibility: {
        "default": true
      },
      linkColor: {
        "default": 'color'
      },
      linkAutoColorBy: {},
      linkOpacity: {
        "default": 0.2
      },
      linkWidth: {
        "default": 0
      },
      linkResolution: {
        "default": 6
      },
      // how many radial segments in each line cylinder's geometry
      linkCurvature: {
        "default": 0
      },
      linkCurveRotation: {
        "default": 0
      },
      linkMaterial: {},
      linkThreeObject: {},
      linkThreeObjectExtend: {
        "default": false
      },
      linkPositionUpdate: {},
      linkDirectionalArrowLength: {
        "default": 0
      },
      linkDirectionalArrowColor: {},
      linkDirectionalArrowRelPos: {
        "default": 0.5
      },
      // value between 0<>1 indicating the relative pos along the (exposed) line
      linkDirectionalArrowResolution: {
        "default": 8
      },
      // how many slice segments in the arrow's conic circumference
      linkDirectionalParticles: {
        "default": 0
      },
      // animate photons travelling in the link direction
      linkDirectionalParticleSpeed: {
        "default": 0.01
      },
      // in link length ratio per frame
      linkDirectionalParticleWidth: {
        "default": 0.5
      },
      linkDirectionalParticleColor: {},
      linkDirectionalParticleResolution: {
        "default": 4
      },
      // how many slice segments in the particle sphere's circumference
      forceEngine: {
        "default": 'd3'
      },
      // d3 or ngraph
      d3AlphaMin: {
        "default": 0
      },
      d3AlphaDecay: {
        "default": 0.0228
      },
      d3VelocityDecay: {
        "default": 0.4
      },
      ngraphPhysics: {},
      warmupTicks: {
        "default": 0
      },
      // how many times to tick the force engine at init before starting to render
      cooldownTicks: {},
      cooldownTime: {
        "default": 15000
      },
      // ms
      onEngineTick: {},
      onEngineStop: {}
    },
    methods: _objectSpread2$1(_objectSpread2$1({}, Object.assign.apply(Object, [{}].concat(_toConsumableArray$2(['getGraphBbox', 'emitParticle', 'd3Force', 'd3ReheatSimulation', 'refresh'].map(function (method) {
      return _defineProperty$1({}, method, function (state) {
        var aframeComp = state.forcegraph.components.forcegraph;
        for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }
        var returnVal = aframeComp[method].apply(aframeComp, args);
        return returnVal === aframeComp ? this // chain based on this object, not the inner aframe component
        : returnVal;
      });
    }))))), {}, {
      _destructor: function _destructor() {
        this.graphData({
          nodes: [],
          links: []
        });
      }
    }),
    init: function init(domNode, state) {
      // Wipe DOM
      domNode.innerHTML = '';
      state.container = document.createElement('div');
      domNode.appendChild(state.container);
      state.container.style.position = 'relative';
      state.container.style.width = "".concat(state.width, "px");
      state.container.style.height = "".concat(state.height, "px");

      // Add nav info section
      state.container.appendChild(state.navInfo = document.createElement('div'));
      state.navInfo.className = 'graph-nav-info';
      state.navInfo.textContent = 'Mouse drag: look, gamepad/arrow/wasd keys: move';

      // Create scene
      var scene = document.createElement('a-scene');
      scene.setAttribute('embedded', '');
      //scene.setAttribute('stats', null);

      scene.appendChild(state.sky = document.createElement('a-sky'));
      state.sky.setAttribute('radius', 3000);

      // Add camera
      var cameraG;
      scene.appendChild(cameraG = document.createElement('a-entity'));
      cameraG.setAttribute('position', '0 0 300');
      cameraG.setAttribute('movement-controls', 'controls: gamepad, touch; fly: true; speed: 7');
      var camera;
      cameraG.appendChild(camera = document.createElement('a-entity'));
      camera.setAttribute('camera', '');
      camera.setAttribute('position', '0 0 0');
      camera.setAttribute('look-controls', 'pointerLockEnabled: false');
      camera.setAttribute('wasd-controls', 'fly: true; acceleration: 700');

      // display cursor in middle of screen
      // let cursor;
      // camera.appendChild(cursor = document.createElement('a-cursor'));
      // cursor.setAttribute('color', 'lavender');
      // cursor.setAttribute('opacity', 0.5);
      // cursor.setAttribute('raycaster', 'objects: ----none----'); // disable cursor raycaster

      // Setup tooltip
      var tooltipEl;
      camera.appendChild(tooltipEl = document.createElement('a-text'));
      tooltipEl.setAttribute('position', '0 -0.3 -1');
      tooltipEl.setAttribute('width', 2);
      tooltipEl.setAttribute('align', 'center');
      tooltipEl.setAttribute('color', 'lavender');
      tooltipEl.setAttribute('value', '');

      // Setup sub-tooltip
      var subTooltipEl;
      camera.appendChild(subTooltipEl = document.createElement('a-text'));
      subTooltipEl.setAttribute('position', '0 -0.4 -1');
      subTooltipEl.setAttribute('width', 1.3);
      subTooltipEl.setAttribute('align', 'center');
      subTooltipEl.setAttribute('color', 'lavender');
      subTooltipEl.setAttribute('value', '');

      // Setup mouse cursor and laser raycasting controls
      state.raycasterEls = [];
      var mouseCursor;
      scene.appendChild(mouseCursor = document.createElement('a-entity'));
      mouseCursor.setAttribute('cursor', 'rayOrigin: mouse; mouseCursorStylesEnabled: true');
      mouseCursor.setAttribute('raycaster', 'objects: [forcegraph]; interval: 100');
      state.raycasterEls.push(mouseCursor);
      ['left', 'right'].forEach(function (hand) {
        var laser;
        cameraG.appendChild(laser = document.createElement('a-entity'));
        laser.setAttribute('laser-controls', "hand: ".concat(hand, "; model: false;")); // Oculus touch offsets are slightly off
        laser.setAttribute('raycaster', 'objects: [forcegraph]; interval: 100; lineColor: steelblue; lineOpacity: 0.85');
        state.raycasterEls.push(laser);
      });

      // Add forcegraph entity
      scene.appendChild(state.forcegraph = document.createElement('a-entity'));
      state.forcegraph.setAttribute('forcegraph', null);

      // attach scene
      state.container.appendChild(scene);

      // update tooltips
      state.forcegraph.setAttribute('forcegraph', Object.assign.apply(Object, _toConsumableArray$2(['node', 'link'].map(function (t) {
        var cct = {
          node: 'Node',
          link: 'Link'
        }[t]; // camel-case version
        return _defineProperty$1({}, "on".concat(cct, "Hover"), function onHover(obj, prevObj) {
          var label = obj ? index(state["".concat(t, "Label")])(obj) || '' : '';
          var subLabel = obj ? index(state["".concat(t, "Desc")])(obj) || '' : '';
          tooltipEl.setAttribute('value', label);
          subTooltipEl.setAttribute('value', subLabel);
          state["on".concat(cct, "Hover")] && state["on".concat(cct, "Hover")](obj, prevObj);
        });
      }))));
    },
    update: function update(state, changedProps) {
      if (changedProps.hasOwnProperty('backgroundColor')) {
        var alpha = parseToRgb(state.backgroundColor).alpha;
        if (alpha === undefined) alpha = 1;
        state.sky.setAttribute('color', curriedOpacify$1(1, state.backgroundColor));
        state.sky.setAttribute('opacity', alpha);
      }
      changedProps.hasOwnProperty('showNavInfo') && (state.navInfo.style.display = state.showNavInfo ? null : 'none');

      // deactivate raycasting against the forcegraph if no interaction props are set
      var isInteractive = ['onNodeHover', 'onLinkHover', 'onNodeClick', 'onLinkClick'].some(function (p) {
        return state[p];
      }) || ['nodeLabel', 'linkLabel'].some(function (p) {
        return state[p] !== 'name';
      }) || ['nodeDesc', 'linkDesc'].some(function (p) {
        return state[p] !== 'desc';
      });
      state.raycasterEls.forEach(function (el) {
        return el.setAttribute('raycaster', isInteractive ? 'objects: [forcegraph]; interval: 100' : 'objects: __none__');
      });
      var passThroughProps = ['jsonUrl', 'numDimensions', 'dagMode', 'dagLevelDistance', 'dagNodeFilter', 'onDagError', 'nodeRelSize', 'nodeId', 'onNodeClick', 'nodeVal', 'nodeResolution', 'nodeVisibility', 'nodeColor', 'nodeAutoColorBy', 'nodeOpacity', 'nodeThreeObject', 'nodeThreeObjectExtend', 'linkSource', 'linkTarget', 'onLinkClick', 'linkVisibility', 'linkColor', 'linkAutoColorBy', 'linkOpacity', 'linkWidth', 'linkResolution', 'linkCurvature', 'linkCurveRotation', 'linkMaterial', 'linkThreeObject', 'linkThreeObjectExtend', 'linkPositionUpdate', 'linkDirectionalArrowLength', 'linkDirectionalArrowColor', 'linkDirectionalArrowRelPos', 'linkDirectionalArrowResolution', 'linkDirectionalParticles', 'linkDirectionalParticleSpeed', 'linkDirectionalParticleWidth', 'linkDirectionalParticleColor', 'linkDirectionalParticleResolution', 'forceEngine', 'd3AlphaMin', 'd3AlphaDecay', 'd3VelocityDecay', 'ngraphPhysics', 'warmupTicks', 'cooldownTicks', 'cooldownTime', 'onEngineTick', 'onEngineStop'];
      var newProps = Object.assign.apply(Object, [{}].concat(_toConsumableArray$2(Object.entries(state).filter(function (_ref3) {
        var _ref4 = _slicedToArray$3(_ref3, 2),
          prop = _ref4[0],
          val = _ref4[1];
        return changedProps.hasOwnProperty(prop) && passThroughProps.indexOf(prop) !== -1 && val !== undefined && val !== null;
      }).map(function (_ref5) {
        var _ref6 = _slicedToArray$3(_ref5, 2),
          key = _ref6[0],
          val = _ref6[1];
        return _defineProperty$1({}, key, val);
      })), _toConsumableArray$2(Object.entries(state.graphData).map(function (_ref8) {
        var _ref9 = _slicedToArray$3(_ref8, 2),
          key = _ref9[0],
          val = _ref9[1];
        return _defineProperty$1({}, key, val);
      }))));
      state.forcegraph.setAttribute('forcegraph', newProps);
    }
  });

  return _3dForceGraphVr;

}));
//# sourceMappingURL=3d-force-graph-vr.js.map
